require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_FCNTL)) {
    eval 'sub _H_FCNTL () {1;}' unless defined(&_H_FCNTL);
    unless(defined(&_H_STANDARDS)) {
	require 'standards.ph';
    }
    unless(defined(&_H_TYPES)) {
	require 'sys/types.ph';
    }
    eval 'sub _FREAD () {0x1;}' unless defined(&_FREAD);
    eval 'sub _FWRITE () {0x2;}' unless defined(&_FWRITE);
    eval 'sub _FNONBLOCK () {0x4;}' unless defined(&_FNONBLOCK);
    eval 'sub _FAPPEND () {0x8;}' unless defined(&_FAPPEND);
    eval 'sub _FSYNC () {0x10;}' unless defined(&_FSYNC);
    eval 'sub _FEXEC () {0x20;}' unless defined(&_FEXEC);
    eval 'sub _FBIT6 () {0x40;}' unless defined(&_FBIT6);
    eval 'sub _FBIT7 () {0x80;}' unless defined(&_FBIT7);
    eval 'sub _FCREAT () {0x100;}' unless defined(&_FCREAT);
    eval 'sub _FTRUNC () {0x200;}' unless defined(&_FTRUNC);
    eval 'sub _FEXCL () {0x400;}' unless defined(&_FEXCL);
    eval 'sub _FNOCTTY () {0x800;}' unless defined(&_FNOCTTY);
    eval 'sub _FRSHARE () {0x1000;}' unless defined(&_FRSHARE);
    eval 'sub _FDEFER () {0x2000;}' unless defined(&_FDEFER);
    eval 'sub _FDELAY () {0x4000;}' unless defined(&_FDELAY);
    eval 'sub _FNDELAY () {0x8000;}' unless defined(&_FNDELAY);
    eval 'sub _FNSHARE () {0x10000;}' unless defined(&_FNSHARE);
    eval 'sub _FASYNC () {0x20000;}' unless defined(&_FASYNC);
    eval 'sub _FMOUNT () {0x40000;}' unless defined(&_FMOUNT);
    eval 'sub _FSYNCALL () {0x80000;}' unless defined(&_FSYNCALL);
    eval 'sub _FNOCACHE () {0x100000;}' unless defined(&_FNOCACHE);
    eval 'sub _FREADSYNC () {0x200000;}' unless defined(&_FREADSYNC);
    eval 'sub _FDATASYNC () {0x400000;}' unless defined(&_FDATASYNC);
    eval 'sub _FDEFERIND () {0x800000;}' unless defined(&_FDEFERIND);
    eval 'sub _FDATAFLUSH () {0x1000000;}' unless defined(&_FDATAFLUSH);
    eval 'sub _FCLREAD () {0x2000000;}' unless defined(&_FCLREAD);
    eval 'sub _FLARGEFILE () {0x4000000;}' unless defined(&_FLARGEFILE);
    eval 'sub _FDIRECT () {0x8000000;}' unless defined(&_FDIRECT);
    eval 'sub _FDOCLONE () {0x10000000;}' unless defined(&_FDOCLONE);
    eval 'sub _FBIT29 () {0x20000000;}' unless defined(&_FBIT29);
    eval 'sub _FKERNEL () {0x40000000;}' unless defined(&_FKERNEL);
    eval 'sub _FMSYNC () {0x80000000;}' unless defined(&_FMSYNC);
    eval 'sub _FMPX () {0;}' unless defined(&_FMPX);
    if(defined(&_POSIX_SOURCE)) {
	unless(defined(&_H_FLOCK)) {
	    require 'sys/flock.ph';
	}
	if(defined(&_LARGE_FILES)) {
	    eval 'sub open () { &open64;}' unless defined(&open);
	    eval 'sub creat () { &creat64;}' unless defined(&creat);
	}
	if(defined(&_NO_PROTO)) {
	} else {
	    unless(defined(&_KERNEL)) {
		if(defined(&_LARGE_FILE_API)) {
		}
	    }
	}
	eval 'sub O_RDONLY () {0;}' unless defined(&O_RDONLY);
	eval 'sub O_WRONLY () {1;}' unless defined(&O_WRONLY);
	eval 'sub O_RDWR () {2;}' unless defined(&O_RDWR);
	eval 'sub O_ACCMODE () {3;}' unless defined(&O_ACCMODE);
	eval 'sub O_NONBLOCK () { &_FNONBLOCK;}' unless defined(&O_NONBLOCK);
	eval 'sub O_APPEND () { &_FAPPEND;}' unless defined(&O_APPEND);
	eval 'sub O_CREAT () { &_FCREAT;}' unless defined(&O_CREAT);
	eval 'sub O_TRUNC () { &_FTRUNC;}' unless defined(&O_TRUNC);
	eval 'sub O_EXCL () { &_FEXCL;}' unless defined(&O_EXCL);
	eval 'sub O_NOCTTY () { &_FNOCTTY;}' unless defined(&O_NOCTTY);
	if(defined(&_LARGE_FILE_API)) {
	    eval 'sub O_LARGEFILE () { &_FLARGEFILE;}' unless defined(&O_LARGEFILE);
	}
	eval 'sub F_DUPFD () {0;}' unless defined(&F_DUPFD);
	eval 'sub F_GETFD () {1;}' unless defined(&F_GETFD);
	eval 'sub F_SETFD () {2;}' unless defined(&F_SETFD);
	eval 'sub F_GETFL () {3;}' unless defined(&F_GETFL);
	eval 'sub F_SETFL () {4;}' unless defined(&F_SETFL);
	if(defined( &__64BIT_KERNEL) || !(defined( &_LARGE_FILES) || defined( &__64BIT__))) {
	    eval 'sub F_GETLK () {5;}' unless defined(&F_GETLK);
	    eval 'sub F_SETLK () {6;}' unless defined(&F_SETLK);
	    eval 'sub F_SETLKW () {7;}' unless defined(&F_SETLKW);
	}
	eval 'sub F_GETLK64 () {11;}' unless defined(&F_GETLK64);
	eval 'sub F_SETLK64 () {12;}' unless defined(&F_SETLK64);
	eval 'sub F_SETLKW64 () {13;}' unless defined(&F_SETLKW64);
	if(!defined( &__64BIT_KERNEL)  && (defined( &_LARGE_FILES) || defined( &__64BIT__))) {
	    eval 'sub F_GETLK () { &F_GETLK64;}' unless defined(&F_GETLK);
	    eval 'sub F_SETLK () { &F_SETLK64;}' unless defined(&F_SETLK);
	    eval 'sub F_SETLKW () { &F_SETLKW64;}' unless defined(&F_SETLKW);
	}
	eval 'sub FD_CLOEXEC () {1;}' unless defined(&FD_CLOEXEC);
    }
    if(defined(&_XOPEN_SOURCE)) {
	unless(defined(&_H_UNISTD)) {
	    require 'unistd.ph';
	}
	unless(defined(&_H_STAT)) {
	    require 'sys/stat.ph';
	}
	eval 'sub O_SYNC () { &_FSYNC;}' unless defined(&O_SYNC);
    }
    if((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0) == 1) {
	eval 'sub F_GETOWN () {8;}' unless defined(&F_GETOWN);
	eval 'sub F_SETOWN () {9;}' unless defined(&F_SETOWN);
    }
    if((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0) == 500) {
	eval 'sub O_DSYNC () { &_FDATASYNC;}' unless defined(&O_DSYNC);
	eval 'sub O_RSYNC () { &_FREADSYNC;}' unless defined(&O_RSYNC);
    }
    if(defined(&_ALL_SOURCE)) {
	if(defined(&_NO_PROTO)) {
	} else {
	    unless(defined(&_KERNEL)) {
		unless(defined(&__64BIT__)) {
		} else {
		}
	    }
	}
	eval 'sub O_NONE () {3;}' unless defined(&O_NONE);
	eval 'sub O_EXEC () { &_FEXEC;}' unless defined(&O_EXEC);
	eval 'sub O_RSHARE () { &_FRSHARE;}' unless defined(&O_RSHARE);
	eval 'sub O_DEFER () { &_FDEFER;}' unless defined(&O_DEFER);
	eval 'sub O_DELAY () { &_FDELAY;}' unless defined(&O_DELAY);
	eval 'sub O_NDELAY () { &_FNDELAY;}' unless defined(&O_NDELAY);
	eval 'sub O_NSHARE () { &_FNSHARE;}' unless defined(&O_NSHARE);
	eval 'sub O_NOCACHE () { &_FNOCACHE;}' unless defined(&O_NOCACHE);
	eval 'sub O_DIRECT () { &_FDIRECT;}' unless defined(&O_DIRECT);
	eval 'sub F_CLOSEM () {10;}' unless defined(&F_CLOSEM);
	unless(defined(&_KERNEL)) {
	    if(defined(&_BSD)) {
		eval 'sub FNDELAY () { &_FNONBLOCK;}' unless defined(&FNDELAY);
		undef(&O_NDELAY) if defined(&O_NDELAY);
		eval 'sub O_NDELAY () { &_FNONBLOCK;}' unless defined(&O_NDELAY);
	    } else {
		eval 'sub FNDELAY () { &_FNDELAY;}' unless defined(&FNDELAY);
	    }
	}
	eval 'sub FNONBLOCK () { &_FNONBLOCK;}' unless defined(&FNONBLOCK);
	eval 'sub FAPPEND () { &_FAPPEND;}' unless defined(&FAPPEND);
	eval 'sub FSYNC () { &_FSYNC;}' unless defined(&FSYNC);
	eval 'sub FASYNC () { &_FASYNC;}' unless defined(&FASYNC);
	eval 'sub FSYNCALL () { &_FSYNCALL;}' unless defined(&FSYNCALL);
	eval 'sub FOPEN () {(-1);}' unless defined(&FOPEN);
	eval 'sub FREAD () { &_FREAD;}' unless defined(&FREAD);
	eval 'sub FWRITE () { &_FWRITE;}' unless defined(&FWRITE);
	if(defined(&_KERNEL)) {
	    eval 'sub FMPX () { &_FMPX;}' unless defined(&FMPX);
	    eval 'sub FFCNTL () {( &FNONBLOCK| &FNDELAY| &FAPPEND| &FSYNC| &FASYNC| &FLARGEFILE|  &FDATASYNC| &FREADSYNC| &FNOCACHE);}' unless defined(&FFCNTL);
	    eval 'sub FCREAT () { &_FCREAT;}' unless defined(&FCREAT);
	    eval 'sub FTRUNC () { &_FTRUNC;}' unless defined(&FTRUNC);
	    eval 'sub FEXCL () { &_FEXCL;}' unless defined(&FEXCL);
	    eval 'sub FRSHARE () { &_FRSHARE;}' unless defined(&FRSHARE);
	    eval 'sub FDEFER () { &_FDEFER;}' unless defined(&FDEFER);
	    eval 'sub FDELAY () { &_FDELAY;}' unless defined(&FDELAY);
	    eval 'sub FNDELAY () { &_FNDELAY;}' unless defined(&FNDELAY);
	    eval 'sub FNSHARE () { &_FNSHARE;}' unless defined(&FNSHARE);
	    eval 'sub FLARGEFILE () { &_FLARGEFILE;}' unless defined(&FLARGEFILE);
	    eval 'sub FREADSYNC () { &_FREADSYNC;}' unless defined(&FREADSYNC);
	    eval 'sub FNOCACHE () { &_FNOCACHE;}' unless defined(&FNOCACHE);
	    eval 'sub FDIRECT () { &_FDIRECT;}' unless defined(&FDIRECT);
	    eval 'sub FEXEC () { &_FEXEC;}' unless defined(&FEXEC);
	    eval 'sub FNOCTTY () { &_FNOCTTY;}' unless defined(&FNOCTTY);
	    eval 'sub FMOUNT () { &_FMOUNT;}' unless defined(&FMOUNT);
	    eval 'sub FKERNEL () { &_FKERNEL;}' unless defined(&FKERNEL);
	    eval 'sub FDOCLONE () { &_FDOCLONE;}' unless defined(&FDOCLONE);
	    eval 'sub FFILESYNC () { &_FSYNC;}' unless defined(&FFILESYNC);
	    eval 'sub FDATASYNC () { &_FDATASYNC;}' unless defined(&FDATASYNC);
	    eval 'sub FDEFERIND () { &_FDEFERIND;}' unless defined(&FDEFERIND);
	    eval 'sub FDATAFLUSH () { &_FDATAFLUSH;}' unless defined(&FDATAFLUSH);
	    eval 'sub FCLREAD () { &_FCLREAD;}' unless defined(&FCLREAD);
	    eval 'sub FMSYNC () { &_FMSYNC;}' unless defined(&FMSYNC);
	    eval 'sub FNOWRBEHIND () { &_FCLREAD;}' unless defined(&FNOWRBEHIND);
	    eval 'sub FMASK () {( &FREAD| &FWRITE| &FNONBLOCK| &FAPPEND| &FSYNC| &FEXEC| &FNOCTTY|  &FRSHARE| &FDEFER| &FDELAY| &FNDELAY| &FNSHARE| &FLARGEFILE| &FDATASYNC|  &FREADSYNC| &FNOCACHE| &FDIRECT);}' unless defined(&FMASK);
	}
    }
}
1;
