require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_FLOAT)) {
    eval 'sub _H_FLOAT () {1;}' unless defined(&_H_FLOAT);
    unless(defined(&_H_STANDARDS)) {
	require 'standards.ph';
    }
    if(defined(&_ANSI_C_SOURCE)) {
	unless(defined(&FLT_MAX)) {
	    eval 'sub FLT_MAX () {3.4028234663852886e+38;}' unless defined(&FLT_MAX);
	}
	unless(defined(&FLT_MIN)) {
	    eval 'sub FLT_MIN () {1.1754943508222875e-38;}' unless defined(&FLT_MIN);
	}
	unless(defined(&FLT_DIG)) {
	    eval 'sub FLT_DIG () {6;}' unless defined(&FLT_DIG);
	}
	unless(defined(&DBL_MAX)) {
	    eval 'sub DBL_MAX () {1.7976931348623158e+308;}' unless defined(&DBL_MAX);
	}
	unless(defined(&DBL_MIN)) {
	    eval 'sub DBL_MIN () {2.2250738585072014e-308;}' unless defined(&DBL_MIN);
	}
	unless(defined(&DBL_DIG)) {
	    eval 'sub DBL_DIG () {15;}' unless defined(&DBL_DIG);
	}
	eval 'sub FLT_ROUNDS () {(  &fp_read_rnd() );}' unless defined(&FLT_ROUNDS);
	eval 'sub FLT_RADIX () {2;}' unless defined(&FLT_RADIX);
	eval 'sub FLT_MANT_DIG () {24;}' unless defined(&FLT_MANT_DIG);
	eval 'sub FLT_EPSILON () {1.1920928955078125e-7;}' unless defined(&FLT_EPSILON);
	eval 'sub FLT_MIN_EXP () {-125;}' unless defined(&FLT_MIN_EXP);
	eval 'sub FLT_MIN_10_EXP () {-37;}' unless defined(&FLT_MIN_10_EXP);
	eval 'sub FLT_MAX_EXP () {128;}' unless defined(&FLT_MAX_EXP);
	eval 'sub FLT_MAX_10_EXP () {38;}' unless defined(&FLT_MAX_10_EXP);
	eval 'sub DBL_MANT_DIG () {53;}' unless defined(&DBL_MANT_DIG);
	eval 'sub DBL_EPSILON () {2.2204460492503131e-16;}' unless defined(&DBL_EPSILON);
	eval 'sub DBL_MIN_EXP () {-1021;}' unless defined(&DBL_MIN_EXP);
	eval 'sub DBL_MIN_10_EXP () {-307;}' unless defined(&DBL_MIN_10_EXP);
	eval 'sub DBL_MAX_EXP () {1024;}' unless defined(&DBL_MAX_EXP);
	eval 'sub DBL_MAX_10_EXP () {308;}' unless defined(&DBL_MAX_10_EXP);
	if(defined(&__LONGDOUBLE128)) {
	    eval 'sub LDBL_MANT_DIG () {106;}' unless defined(&LDBL_MANT_DIG);
	    eval 'sub LDBL_EPSILON () {0.24651903288156618919116517665087070E-31;}' unless defined(&LDBL_EPSILON);
	    eval 'sub LDBL_DIG () {31;}' unless defined(&LDBL_DIG);
	    eval 'sub LDBL_MIN_EXP () { &DBL_MIN_EXP;}' unless defined(&LDBL_MIN_EXP);
	    eval 'sub LDBL_MIN () {(  &DBL_MIN);}' unless defined(&LDBL_MIN);
	    eval 'sub LDBL_MIN_10_EXP () { &DBL_MIN_10_EXP;}' unless defined(&LDBL_MIN_10_EXP);
	    eval 'sub LDBL_MAX_EXP () { &DBL_MAX_EXP;}' unless defined(&LDBL_MAX_EXP);
	    eval 'sub LDBL_MAX () {0.1797693134862315807937289714053023E+309;}' unless defined(&LDBL_MAX);
	    eval 'sub LDBL_MAX_10_EXP () { &DBL_MAX_10_EXP;}' unless defined(&LDBL_MAX_10_EXP);
	}
 elsif(defined( &__LONGDOUBLE80)) {
	    eval 'sub LDBL_MANT_DIG () {64;}' unless defined(&LDBL_MANT_DIG);
	    eval 'sub LDBL_EPSILON () {1.0842021724855044340075E-19;}' unless defined(&LDBL_EPSILON);
	    eval 'sub LDBL_DIG () {18;}' unless defined(&LDBL_DIG);
	    eval 'sub LDBL_MIN_EXP () {(-16381);}' unless defined(&LDBL_MIN_EXP);
	    eval 'sub LDBL_MIN () {3.36210314311209350626e-4932;}' unless defined(&LDBL_MIN);
	    eval 'sub LDBL_MIN_10_EXP () {(-4931);}' unless defined(&LDBL_MIN_10_EXP);
	    eval 'sub LDBL_MAX_EXP () {16384;}' unless defined(&LDBL_MAX_EXP);
	    eval 'sub LDBL_MAX () {1.18973149535723176502e+4932;}' unless defined(&LDBL_MAX);
	    eval 'sub LDBL_MAX_10_EXP () {4932;}' unless defined(&LDBL_MAX_10_EXP);
	} else {
	    eval 'sub LDBL_MANT_DIG () { &DBL_MANT_DIG;}' unless defined(&LDBL_MANT_DIG);
	    eval 'sub LDBL_EPSILON () { &DBL_EPSILON;}' unless defined(&LDBL_EPSILON);
	    eval 'sub LDBL_DIG () { &DBL_DIG;}' unless defined(&LDBL_DIG);
	    eval 'sub LDBL_MIN_EXP () { &DBL_MIN_EXP;}' unless defined(&LDBL_MIN_EXP);
	    eval 'sub LDBL_MIN () { &DBL_MIN;}' unless defined(&LDBL_MIN);
	    eval 'sub LDBL_MIN_10_EXP () { &DBL_MIN_10_EXP;}' unless defined(&LDBL_MIN_10_EXP);
	    eval 'sub LDBL_MAX_EXP () { &DBL_MAX_EXP;}' unless defined(&LDBL_MAX_EXP);
	    eval 'sub LDBL_MAX () { &DBL_MAX;}' unless defined(&LDBL_MAX);
	    eval 'sub LDBL_MAX_10_EXP () { &DBL_MAX_10_EXP;}' unless defined(&LDBL_MAX_10_EXP);
	}
    }
    if(defined(&_ALL_SOURCE)) {
	unless(defined(&_H_LIMITS)) {
	    require 'sys/limits.ph';
	}
	eval 'sub DINFINITY () { &_DBLINF;}' unless defined(&DINFINITY);
	eval 'sub FLT_INFINITY () {(*( ( &SINFINITY)));}' unless defined(&FLT_INFINITY);
	eval 'sub DBL_INFINITY () {(*( ( &_DBLINF)));}' unless defined(&DBL_INFINITY);
	eval 'sub LDBL_INFINITY () { &DBL_INFINITY;}' unless defined(&LDBL_INFINITY);
	eval 'sub FLT_QNAN () {(*( ( &SQNAN)));}' unless defined(&FLT_QNAN);
	eval 'sub DBL_QNAN () {(*( ( &DQNAN)));}' unless defined(&DBL_QNAN);
	eval 'sub FLT_SNAN () {(*( ( &SSNAN)));}' unless defined(&FLT_SNAN);
	eval 'sub DBL_SNAN () {(*( ( &DSNAN)));}' unless defined(&DBL_SNAN);
	eval 'sub FP_RND_RZ () {0;}' unless defined(&FP_RND_RZ);
	eval 'sub FP_RND_RN () {1;}' unless defined(&FP_RND_RN);
	eval 'sub FP_RND_RP () {2;}' unless defined(&FP_RND_RP);
	eval 'sub FP_RND_RM () {3;}' unless defined(&FP_RND_RM);
	if(defined(&_NO_PROTO)) {
	} else {
	}
	eval 'sub FP_PLUS_NORM () {0;}' unless defined(&FP_PLUS_NORM);
	eval 'sub FP_MINUS_NORM () {1;}' unless defined(&FP_MINUS_NORM);
	eval 'sub FP_PLUS_ZERO () {2;}' unless defined(&FP_PLUS_ZERO);
	eval 'sub FP_MINUS_ZERO () {3;}' unless defined(&FP_MINUS_ZERO);
	eval 'sub FP_PLUS_INF () {4;}' unless defined(&FP_PLUS_INF);
	eval 'sub FP_MINUS_INF () {5;}' unless defined(&FP_MINUS_INF);
	eval 'sub FP_PLUS_DENORM () {6;}' unless defined(&FP_PLUS_DENORM);
	eval 'sub FP_MINUS_DENORM () {7;}' unless defined(&FP_MINUS_DENORM);
	eval 'sub FP_SNAN () {8;}' unless defined(&FP_SNAN);
	eval 'sub FP_QNAN () {9;}' unless defined(&FP_QNAN);
    }
}
1;
