require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&RSCAN_USHORT)) {
    sub RSCAN_USHORT {
	my( $val ) = @_;
	eval q(( ( (($val). ($RISC_value->{upper_value})) << 8) | ( (($val). ($RISC_value->{lower_value})) )));
    }
}
unless(defined(&RSCAN_PS2)) {
    sub RSCAN_PS2 () {	 &rom_scan_ps2_header_t;}
}
unless(defined(&RSCAN_PS2_SIZE)) {
    sub RSCAN_PS2_SIZE () {	( $sizeof{  &rom_scan_ps2_header_t} );}
}
unless(defined(&RSCAN_PS2_id_hex55)) {
    sub RSCAN_PS2_id_hex55 {
	my($ptr) = @_;
	eval q((($ptr) ->  &id_hex55));
    }
}
unless(defined(&RSCAN_PS2_id_hexAA)) {
    sub RSCAN_PS2_id_hexAA {
	my($ptr) = @_;
	eval q((($ptr) ->  &id_hexAA));
    }
}
unless(defined(&RSCAN_PS2_Blength)) {
    sub RSCAN_PS2_Blength {
	my($ptr) = @_;
	eval q((($ptr) ->  &rom_length_in_512B_blocks));
    }
}
unless(defined(&RSCAN_PS2_flag)) {
    sub RSCAN_PS2_flag {
	my($ptr) = @_;
	eval q((($ptr) ->  &dynamic_rom_flag));
    }
}
unless(defined(&RSCAN_PS2_dynamic_rom_length)) {
    sub RSCAN_PS2_dynamic_rom_length {
	my($ptr) = @_;
	eval q( &RSCAN_USHORT( ($ptr)-> &length_of_dynamic_rom ));
    }
}
unless(defined(&RSCAN_PS2_dynamic_rom_head)) {
    sub RSCAN_PS2_dynamic_rom_head {
	my($ptr) = @_;
	eval q( &RSCAN_USHORT( ($ptr)-> &head_of_dynamic_rom ));
    }
}
unless(defined(&RSCAN_ROMBLK_next)) {
    sub RSCAN_ROMBLK_next {
	my($ptr) = @_;
	eval q( &RSCAN_USHORT( ($ptr)-> &offset_to_next_block ));
    }
}
unless(defined(&RSCAN_ROMBLK_class)) {
    sub RSCAN_ROMBLK_class {
	my($ptr) = @_;
	eval q( &RSCAN_USHORT( ($ptr)-> &block_class ));
    }
}
unless(defined(&RSCAN_ROMBLK)) {
    sub RSCAN_ROMBLK () {	 &rom_scan_R2_block_t;}
}
unless(defined(&RSCAN_ROMBLK_SIZE)) {
    sub RSCAN_ROMBLK_SIZE () {	( $sizeof{  &rom_scan_R2_block_t} );}
}
unless(defined(&RSCAN_ROMBLK_id)) {
    sub RSCAN_ROMBLK_id {
	my($ptr) = @_;
	eval q((($ptr) ->  &R2_id_field));
    }
}
unless(defined(&RSCAN_6000_BLK_next)) {
    sub RSCAN_6000_BLK_next {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_next( $ptr ));
    }
}
unless(defined(&RSCAN_6000_BLK_class)) {
    sub RSCAN_6000_BLK_class {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_class( $ptr ));
    }
}
unless(defined(&RSCAN_6000_BLK)) {
    sub RSCAN_6000_BLK () {	 &rom_scan_R2_6000_block_t;}
}
unless(defined(&RSCAN_6000_BLK_SIZE)) {
    sub RSCAN_6000_BLK_SIZE () {	( $sizeof{  &rom_scan_R2_6000_block_t} );}
}
unless(defined(&RSCAN_6000_BLK_id)) {
    sub RSCAN_6000_BLK_id {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_id( $ptr ));
    }
}
unless(defined(&RSCAN_6000_BLK_rom_addr)) {
    sub RSCAN_6000_BLK_rom_addr {
	my($ptr) = @_;
	eval q((($ptr) ->  &R2_rom_busmem_addr));
    }
}
unless(defined(&RSCAN_6000_BLK_pos2_val)) {
    sub RSCAN_6000_BLK_pos2_val {
	my($ptr) = @_;
	eval q((($ptr) ->  &pos2_value));
    }
}
unless(defined(&RSCAN_6000_BLK_pos3_val)) {
    sub RSCAN_6000_BLK_pos3_val {
	my($ptr) = @_;
	eval q((($ptr) ->  &pos3_value));
    }
}
unless(defined(&RSCAN_6000_BLK_pos4_val)) {
    sub RSCAN_6000_BLK_pos4_val {
	my($ptr) = @_;
	eval q((($ptr) ->  &pos4_value));
    }
}
unless(defined(&RSCAN_6000_BLK_pos5_val)) {
    sub RSCAN_6000_BLK_pos5_val {
	my($ptr) = @_;
	eval q((($ptr) ->  &pos5_value));
    }
}
unless(defined(&RSCAN_6001_BLK_next)) {
    sub RSCAN_6001_BLK_next {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_next( $ptr ));
    }
}
unless(defined(&RSCAN_6001_BLK_class)) {
    sub RSCAN_6001_BLK_class {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_class( $ptr ));
    }
}
unless(defined(&RSCAN_6001_BLK)) {
    sub RSCAN_6001_BLK () {	 &rom_scan_R2_6001_block_t;}
}
unless(defined(&RSCAN_6001_BLK_SIZE)) {
    sub RSCAN_6001_BLK_SIZE () {	( $sizeof{  &rom_scan_R2_6001_block_t} );}
}
unless(defined(&RSCAN_6001_BLK_id)) {
    sub RSCAN_6001_BLK_id {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_id( $ptr ));
    }
}
unless(defined(&RSCAN_6001_BLK_rom_addr)) {
    sub RSCAN_6001_BLK_rom_addr {
	my($ptr) = @_;
	eval q((($ptr) ->  &R2_rom_busmem_addr));
    }
}
unless(defined(&RSCAN_6001_BLK_pos_val)) {
    sub RSCAN_6001_BLK_pos_val {
	my($ptr,$i) = @_;
	eval q((($ptr) ->  ($pos[&(i)]->{val})));
    }
}
unless(defined(&RSCAN_6001_BLK_pos_reg)) {
    sub RSCAN_6001_BLK_pos_reg {
	my($ptr,$i) = @_;
	eval q((($ptr) ->  ($pos[&(i)]->{reg})));
    }
}
unless(defined(&RSCAN_6001_BLK_num_pos_vals)) {
    sub RSCAN_6001_BLK_num_pos_vals {
	my($ptr) = @_;
	eval q((($ptr) ->  &num_pos_vals));
    }
}
unless(defined(&RSCAN_6001_BLK_sw_version)) {
    sub RSCAN_6001_BLK_sw_version {
	my($ptr) = @_;
	eval q((($ptr) ->  &sw_version));
    }
}
unless(defined(&RSCAN_6002_BLK_next)) {
    sub RSCAN_6002_BLK_next {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_next( $ptr ));
    }
}
unless(defined(&RSCAN_6002_BLK_class)) {
    sub RSCAN_6002_BLK_class {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_class( $ptr ));
    }
}
unless(defined(&RSCAN_6002_BLK)) {
    sub RSCAN_6002_BLK () {	 &rom_scan_R2_6002_block_t;}
}
unless(defined(&RSCAN_6002_BLK_SIZE)) {
    sub RSCAN_6002_BLK_SIZE () {	( $sizeof{  &rom_scan_R2_6002_block_t} );}
}
unless(defined(&RSCAN_6002_BLK_id)) {
    sub RSCAN_6002_BLK_id {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_id( $ptr ));
    }
}
unless(defined(&RSCAN_6002_BLK_rom_addr)) {
    sub RSCAN_6002_BLK_rom_addr {
	my($ptr) = @_;
	eval q((($ptr) ->  &R2_rom_busmem_addr));
    }
}
unless(defined(&RSCAN_6002_BLK_cfg_reg_index)) {
    sub RSCAN_6002_BLK_cfg_reg_index {
	my($ptr,$i) = @_;
	eval q((($ptr) ->  $cfg_reg_index[ ($i) ]));
    }
}
unless(defined(&RSCAN_6002_BLK_cfg_reg_value)) {
    sub RSCAN_6002_BLK_cfg_reg_value {
	my($ptr,$i) = @_;
	eval q((($ptr) ->  $cfg_reg_value[ ($i) ]));
    }
}
unless(defined(&RSCAN_6002_BLK_num_cfg_regs)) {
    sub RSCAN_6002_BLK_num_cfg_regs {
	my($ptr) = @_;
	eval q((($ptr) ->  &num_cfg_regs));
    }
}
unless(defined(&RSCAN_6002_BLK_sw_version)) {
    sub RSCAN_6002_BLK_sw_version {
	my($ptr) = @_;
	eval q((($ptr) ->  &sw_version));
    }
}
unless(defined(&RSCAN_6003_BLK_next)) {
    sub RSCAN_6003_BLK_next {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_next($ptr));
    }
}
unless(defined(&RSCAN_6003_BLK_class)) {
    sub RSCAN_6003_BLK_class {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_class($ptr));
    }
}
unless(defined(&RSCAN_6003_BLK)) {
    sub RSCAN_6003_BLK () {	 &rom_scan_R2_6003_block_t;}
}
unless(defined(&RSCAN_6003_BLK_SIZE)) {
    sub RSCAN_6003_BLK_SIZE () {	( $sizeof{ &rom_scan_R2_6003_block_t} );}
}
unless(defined(&RSCAN_6003_BLK_id)) {
    sub RSCAN_6003_BLK_id {
	my($ptr) = @_;
	eval q( &RSCAN_ROMBLK_id($ptr));
    }
}
unless(defined(&RSCAN_6003_BLK_rom_addr)) {
    sub RSCAN_6003_BLK_rom_addr {
	my($ptr) = @_;
	eval q(( ($ptr)-> &R2_rom_busmem_addr ));
    }
}
unless(defined(&RSCAN_R2_HEAD)) {
    sub RSCAN_R2_HEAD () {	 &rom_scan_R2_head_t;}
}
unless(defined(&RSCAN_R2_HEAD_rom_Blength)) {
    sub RSCAN_R2_HEAD_rom_Blength {
	my($ptr) = @_;
	eval q((($ptr) ->  &rom_length_in_512B_blocks));
    }
}
unless(defined(&RSCAN_R2_HEAD_residue)) {
    sub RSCAN_R2_HEAD_residue {
	my($ptr) = @_;
	eval q((($ptr) ->  &rom_CRC_residue));
    }
}
unless(defined(&RSCAN_R2_HEAD_rom_type)) {
    sub RSCAN_R2_HEAD_rom_type {
	my($ptr) = @_;
	eval q((($ptr) ->  &rom_type));
    }
}
1;
