require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MANIFEST_)) {
    eval 'sub _MANIFEST_ () {1;}' unless defined(&_MANIFEST_);
    eval 'sub ISODE () {68;}' unless defined(&ISODE);
    unless(defined(&_CONFIG_)) {
	require 'isode/config.ph';
    }
    if(defined(&BSD42)) {
	undef(&SYS5NLY) if defined(&SYS5NLY);
	eval 'sub BSDSIGS () {1;}' unless defined(&BSDSIGS);
    }
    if(defined(&ROS)) {
	undef(&SYS5NLY) if defined(&SYS5NLY);
	eval 'sub BSDSIGS () {1;}' unless defined(&BSDSIGS);
	unless(defined(&BSD42)) {
	    eval 'sub BSD42 () {1;}' unless defined(&BSD42);
	}
    }
    if(defined(&SYS5)) {
	eval 'sub SYS5NLY () {1;}' unless defined(&SYS5NLY);
	undef(&BSDSIGS) if defined(&BSDSIGS);
	if(defined(&OSX)) {
	    undef(&SYS5NLY) if defined(&SYS5NLY);
	}
	if(defined(&XOS_2)) {
	    undef(&SYS5NLY) if defined(&SYS5NLY);
	    eval 'sub SIGEMT () { &SIGSEGV;}' unless defined(&SIGEMT);
	}
	if(defined( &WIN) || defined ( &WINTLI)) {
	    undef(&SYS5NLY) if defined(&SYS5NLY);
	}
	if(defined(&sun)) {
	    undef(&SYS5NLY) if defined(&SYS5NLY);
	}
	if(defined(&sgi)) {
	    undef(&SYS5NLY) if defined(&SYS5NLY);
	}
	if(defined(&HPUX)) {
	    undef(&SYS5NLY) if defined(&SYS5NLY);
	    eval 'sub BSDSIGS () {1;}' unless defined(&BSDSIGS);
	    undef(&SIGPOLL) if defined(&SIGPOLL);
	}
	if(defined( &AIX) || defined( &_AIX)) {
	    undef(&SYS5NLY) if defined(&SYS5NLY);
	    eval 'sub BSDSIGS () {1;}' unless defined(&BSDSIGS);
	    if(defined(&RT)) {
		eval 'sub SIGEMT () { &SIGUSR1;}' unless defined(&SIGEMT);
		eval 'sub signal () { &_signal;}' unless defined(&signal);
	    }
	}
	if(defined(&AUX)) {
	    undef(&SYS5NLY) if defined(&SYS5NLY);
	    eval 'sub BSDSIGS () {1;}' unless defined(&BSDSIGS);
	}
    }
    if(defined(&NSIG)) {
	unless(defined(&sigmask)) {
	    eval 'sub sigmask {
	        my($s) = @_;
    		eval q((1<< (($s) - 1)));
	    }' unless defined(&sigmask);
	}
	if(defined(&XOS_2)) {
	    eval 'sub _SIGIO () { &SIGEMT;}' unless defined(&_SIGIO);
	} else {
	    if(defined(&SIGPOLL)) {
		eval 'sub _SIGIO () { &SIGPOLL;}' unless defined(&_SIGIO);
	    } else {
		if(defined(&SIGUSR1)) {
		    eval 'sub _SIGIO () { &SIGUSR1;}' unless defined(&_SIGIO);
		} else {
		    eval 'sub _SIGIO () { &SIGEMT;}' unless defined(&_SIGIO);
		}
	    }
	}
	unless(defined(&lint)) {
	    eval 'sub sigioblock () {
	        eval q(( &_iosignals_set ?  &sigblock ( &sigmask ( &_SIGIO)) : 0));
	    }' unless defined(&sigioblock);
	    eval 'sub sigiomask {
	        my($s) = @_;
    		eval q(( &_iosignals_set ?  &sigsetmask ($s) : 0));
	    }' unless defined(&sigiomask);
	} else {
	    eval 'sub sigioblock () {
	        eval q( &sigblock ( &sigmask ( &_SIGIO)));
	    }' unless defined(&sigioblock);
	    eval 'sub sigiomask {
	        my($s) = @_;
    		eval q( &sigsetmask ($s));
	    }' unless defined(&sigiomask);
	}
	eval 'sub siginblock () {
	    eval q( &sigblock ( &sigmask ( &SIGINT)));
	}' unless defined(&siginblock);
	eval 'sub siginmask {
	    my($s) = @_;
    	    eval q( &sigsetmask ($s));
	}' unless defined(&siginmask);
    }
    unless(defined(&NOTOK)) {
	eval 'sub NOTOK () {(-1);}' unless defined(&NOTOK);
	eval 'sub OK () {0;}' unless defined(&OK);
	eval 'sub DONE () {1;}' unless defined(&DONE);
	eval 'sub CONNECTING_1 () { &OK;}' unless defined(&CONNECTING_1);
	eval 'sub CONNECTING_2 () {2;}' unless defined(&CONNECTING_2);
    }
    unless(defined(&NULLCP)) {
	eval 'sub NULLCP () {( 0);}' unless defined(&NULLCP);
	eval 'sub NULLVP () {( 0);}' unless defined(&NULLVP);
    }
    unless(defined(&INTDEF)) {
	eval 'sub INTDEF () {\'int\';}' unless defined(&INTDEF);
    }
    eval 'sub NULLINT () {(( &integer) 0);}' unless defined(&NULLINT);
    eval 'sub NULLINTP () {(( &integer *) 0);}' unless defined(&NULLINTP);
    unless(defined(&makedev)) {
	require 'sys/types.ph';
	if(defined( &WIN) || defined( &WINTLI)) {
	    require 'sys/inet.ph';
	    unless(defined(&NFDBITS)) {
	    }
	}
	if(defined(&SYS5NLY)) {
	}
    }
    unless(defined(&FD_SET)) {
	eval 'sub FD_SETSIZE () {($sizeof{ &fd_set} * 8);}' unless defined(&FD_SETSIZE);
	eval 'sub FD_SET {
	    my($f,$s) = @_;
    	    eval q((($s)-> $fds_bits[0] |= (1<< ($f))));
	}' unless defined(&FD_SET);
	eval 'sub FD_CLR {
	    my($f,$s) = @_;
    	    eval q((($s)-> $fds_bits[0] &= ~(1<< ($f))));
	}' unless defined(&FD_CLR);
	eval 'sub FD_ISSET {
	    my($f,$s) = @_;
    	    eval q((($s)-> $fds_bits[0] & (1<< ($f))));
	}' unless defined(&FD_ISSET);
	eval 'sub FD_ZERO {
	    my($s) = @_;
    	    eval q((($s)-> $fds_bits[0] = 0));
	}' unless defined(&FD_ZERO);
    }
    eval 'sub NULLFD () {(( &fd_set *) 0);}' unless defined(&NULLFD);
    undef(&IP) if defined(&IP);
    eval 'sub NULLIP () {(( &IP) 0);}' unless defined(&NULLIP);
    eval 'sub NULLIFP () {(( &IFP) 0);}' unless defined(&NULLIFP);
    eval 'sub NULLVFP () {(( &VFP) 0);}' unless defined(&NULLVFP);
    unless(defined(&SFD)) {
	if(!defined( &SVR3)  && !defined( &SUNOS4)  && !defined( &BSD44)  && !defined( &ultrix)  && !defined( &ps2)) {
	    eval 'sub SFD () {\'int\';}' unless defined(&SFD);
	    eval 'sub SFP () { &IFP;}' unless defined(&SFP);
	    eval 'sub SFDINT () {1;}' unless defined(&SFDINT);
	} else {
	    eval 'sub SFD () { &void;}' unless defined(&SFD);
	    eval 'sub SFP () { &VFP;}' unless defined(&SFP);
	    if(defined(&SFDINT)) {
		undef(&SFDINT) if defined(&SFDINT);
	    }
	}
    }
    eval 'sub QBFREE {
        my($qb) = @_;
	    eval q({  &register \'struct qbuf\' * &QB, * &QP;  &for ( &QB = ->  &qb_forw;  &QB != ;  &QB =  &QP) {  &QP =  &QB ->  &qb_forw;  &remque ;  &free (  &QB); } });
    }' unless defined(&QBFREE);
    unless(defined(&min)) {
	eval 'sub min {
	    my($a, $b) = @_;
    	    eval q((($a) < ($b) ? ($a) : ($b)));
	}' unless defined(&min);
	eval 'sub max {
	    my($a, $b) = @_;
    	    eval q((($a) > ($b) ? ($a) : ($b)));
	}' unless defined(&max);
    }
    if(defined(&SYS5)) {
	if(!defined( &WINTLI)  && !defined( &WIN)) {
	    unless(defined(&sun)) {
		eval 'sub getdtablesize () {
		    eval q( &_NFILE);
		}' unless defined(&getdtablesize);
	    }
	} else {
	    eval 'sub getdtablesize () {
	        eval q(( &_NFILE - 1));
	    }' unless defined(&getdtablesize);
	}
    }
    if(defined( &RT) || defined ( &HPUX)) {
	eval 'sub ntohs {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&ntohs);
	eval 'sub htons {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&htons);
	eval 'sub ntohl {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&ntohl);
	eval 'sub htonl {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&htonl);
    }
    unless(defined(&SETSID)) {
	if(defined( &SUNOS41) || defined( &BSD44)) {
	    eval 'sub SETSID () {1;}' unless defined(&SETSID);
	}
    }
}
1;
