require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SSAP_)) {
    eval 'sub _SSAP_ () {1;}' unless defined(&_SSAP_);
    unless(defined(&_MANIFEST_)) {
	require 'isode/manifest.ph';
    }
    unless(defined(&_GENERAL_)) {
	require 'isode/general.ph';
    }
    unless(defined(&_ISOADDRS_)) {
	require 'isode/isoaddrs.ph';
    }
    eval 'sub SID_DATA_SIZE () {6;}' unless defined(&SID_DATA_SIZE);
    eval 'sub SREF_USER_SIZE () {64;}' unless defined(&SREF_USER_SIZE);
    eval 'sub SREF_COMM_SIZE () {64;}' unless defined(&SREF_COMM_SIZE);
    eval 'sub SREF_ADDT_SIZE () {4;}' unless defined(&SREF_ADDT_SIZE);
    eval 'sub sr_calling () { &sr_udata;}' unless defined(&sr_calling);
    eval 'sub sr_calling_len () { &sr_ulen;}' unless defined(&sr_calling_len);
    eval 'sub sr_called () { &sr_vdata;}' unless defined(&sr_called);
    eval 'sub sr_called_len () { &sr_vlen;}' unless defined(&sr_called_len);
    eval 'sub SS_SIZE () {512;}' unless defined(&SS_SIZE);
    eval 'sub SSFREE {
        my($ss) = @_;
	    eval q({  &if (($ss) ->  &ss_data)  &free (($ss) ->  &ss_data), ($ss) ->  &ss_data =  &NULL; });
    }' unless defined(&SSFREE);
    eval 'sub SC_ACCEPT () {(-1);}' unless defined(&SC_ACCEPT);
    eval 'sub SC_BASE () {0x80;}' unless defined(&SC_BASE);
    eval 'sub SC_SSAPID () {( &SC_BASE + 1);}' unless defined(&SC_SSAPID);
    eval 'sub SC_SSUSER () {( &SC_BASE + 2);}' unless defined(&SC_SSUSER);
    eval 'sub SC_CONGEST () {( &SC_BASE + 3);}' unless defined(&SC_CONGEST);
    eval 'sub SC_VERSION () {( &SC_BASE + 4);}' unless defined(&SC_VERSION);
    eval 'sub SC_ADDRESS () {( &SC_BASE + 5);}' unless defined(&SC_ADDRESS);
    eval 'sub SC_REFUSED () {( &SC_BASE + 6);}' unless defined(&SC_REFUSED);
    eval 'sub SC_TRANSPORT () {( &SC_BASE + 7);}' unless defined(&SC_TRANSPORT);
    eval 'sub SC_ABORT () {( &SC_BASE + 8);}' unless defined(&SC_ABORT);
    eval 'sub SC_PROTOCOL () {( &SC_BASE + 9);}' unless defined(&SC_PROTOCOL);
    eval 'sub SC_PARAMETER () {( &SC_BASE + 10);}' unless defined(&SC_PARAMETER);
    eval 'sub SC_OPERATION () {( &SC_BASE + 11);}' unless defined(&SC_OPERATION);
    eval 'sub SC_TIMER () {( &SC_BASE + 12);}' unless defined(&SC_TIMER);
    eval 'sub SC_WAITING () {( &SC_BASE + 13);}' unless defined(&SC_WAITING);
    eval 'sub SC_NOTSPECIFIED () {0;}' unless defined(&SC_NOTSPECIFIED);
    eval 'sub SC_CONGESTION () {1;}' unless defined(&SC_CONGESTION);
    eval 'sub SC_REJECTED () {2;}' unless defined(&SC_REJECTED);
    if(defined(&notdef)) {
	eval 'sub SC_FATAL {
	    my($r) = @_;
    	    eval q((($r) <  &SC_BASE || ($r) <  &SC_PARAMETER));
	}' unless defined(&SC_FATAL);
	eval 'sub SC_OFFICIAL {
	    my($r) = @_;
    	    eval q((($r) <  &SC_BASE || ($r) <  &SC_ADDRESS));
	}' unless defined(&SC_OFFICIAL);
    } else {
	eval 'sub SC_FATAL {
	    my($r) = @_;
    	    eval q((($r) <  &SC_PARAMETER));
	}' unless defined(&SC_FATAL);
	eval 'sub SC_OFFICIAL {
	    my($r) = @_;
    	    eval q((($r) <  &SC_ADDRESS));
	}' unless defined(&SC_OFFICIAL);
    }
    if(defined(&HPUX)) {
	undef(&SC_SIZE) if defined(&SC_SIZE);
    }
    eval 'sub SC_SIZE () {512;}' unless defined(&SC_SIZE);
    eval 'sub SCFREE {
        my($sc) = @_;
	    eval q({  &if (($sc) ->  &sc_realdata)  &free (($sc) ->  &sc_realdata), ($sc) ->  &sc_realdata = ($sc) ->  &sc_data =  &NULL;  &else  &if (($sc) ->  &sc_data)  &free (($sc) ->  &sc_data), ($sc) ->  &sc_data =  &NULL; });
    }' unless defined(&SCFREE);
    eval 'sub SR_HALFDUPLEX () {0x1;}' unless defined(&SR_HALFDUPLEX);
    eval 'sub SR_DUPLEX () {0x2;}' unless defined(&SR_DUPLEX);
    eval 'sub SR_EXPEDITED () {0x4;}' unless defined(&SR_EXPEDITED);
    eval 'sub SR_MINORSYNC () {0x8;}' unless defined(&SR_MINORSYNC);
    eval 'sub SR_MAJORSYNC () {0x10;}' unless defined(&SR_MAJORSYNC);
    eval 'sub SR_RESYNC () {0x20;}' unless defined(&SR_RESYNC);
    eval 'sub SR_ACTIVITY () {0x40;}' unless defined(&SR_ACTIVITY);
    eval 'sub SR_NEGOTIATED () {0x80;}' unless defined(&SR_NEGOTIATED);
    eval 'sub SR_CAPABILITY () {0x100;}' unless defined(&SR_CAPABILITY);
    eval 'sub SR_EXCEPTIONS () {0x200;}' unless defined(&SR_EXCEPTIONS);
    eval 'sub SR_TYPEDATA () {0x400;}' unless defined(&SR_TYPEDATA);
    eval 'sub SR_SYMMETRIC () {0x800;}' unless defined(&SR_SYMMETRIC);
    eval 'sub SR_RLS_EXISTS () { &SR_NEGOTIATED;}' unless defined(&SR_RLS_EXISTS);
    eval 'sub SR_MAJ_EXISTS () {( &SR_MAJORSYNC |  &SR_ACTIVITY);}' unless defined(&SR_MAJ_EXISTS);
    eval 'sub SR_ACT_EXISTS () { &SR_ACTIVITY;}' unless defined(&SR_ACT_EXISTS);
    eval 'sub SR_MIN_EXISTS () { &SR_MINORSYNC;}' unless defined(&SR_MIN_EXISTS);
    eval 'sub SR_DAT_EXISTS () { &SR_HALFDUPLEX;}' unless defined(&SR_DAT_EXISTS);
    eval 'sub SR_TOKENS () {( &SR_RLS_EXISTS |  &SR_MAJ_EXISTS |  &SR_ACT_EXISTS |  &SR_MIN_EXISTS |  &SR_DAT_EXISTS);}' unless defined(&SR_TOKENS);
    eval 'sub SR_BASUBSET () {( &SR_HALFDUPLEX |  &SR_TYPEDATA |  &SR_CAPABILITY |  &SR_MINORSYNC |  &SR_EXCEPTIONS |  &SR_ACTIVITY);}' unless defined(&SR_BASUBSET);
    eval 'sub SR_BCSUBSET () {( &SR_HALFDUPLEX |  &SR_DUPLEX);}' unless defined(&SR_BCSUBSET);
    eval 'sub SR_BSSUBSET () {( &SR_NEGOTIATED |  &SR_HALFDUPLEX |  &SR_DUPLEX |  &SR_TYPEDATA |  &SR_MINORSYNC |  &SR_MAJORSYNC |  &SR_RESYNC);}' unless defined(&SR_BSSUBSET);
    eval 'sub SR_MYREQUIRE () {( &SR_BASUBSET |  &SR_BCSUBSET |  &SR_BSSUBSET |  &SR_EXPEDITED);}' unless defined(&SR_MYREQUIRE);
    eval 'sub SR_DEFAULT () {( &SR_HALFDUPLEX |  &SR_MINORSYNC |  &SR_ACTIVITY |  &SR_CAPABILITY |  &SR_EXCEPTIONS);}' unless defined(&SR_DEFAULT);
    eval 'sub ST_INIT_VALUE () {0x;}' unless defined(&ST_INIT_VALUE);
    eval 'sub ST_RESP_VALUE () {0x1;}' unless defined(&ST_RESP_VALUE);
    eval 'sub ST_CALL_VALUE () {0x2;}' unless defined(&ST_CALL_VALUE);
    eval 'sub ST_RSVD_VALUE () {0x3;}' unless defined(&ST_RSVD_VALUE);
    eval 'sub ST_MASK () {0x3;}' unless defined(&ST_MASK);
    eval 'sub ST_RLS_SHIFT () {6;}' unless defined(&ST_RLS_SHIFT);
    eval 'sub ST_MAJ_SHIFT () {4;}' unless defined(&ST_MAJ_SHIFT);
    eval 'sub ST_ACT_SHIFT () { &ST_MAJ_SHIFT;}' unless defined(&ST_ACT_SHIFT);
    eval 'sub ST_MIN_SHIFT () {2;}' unless defined(&ST_MIN_SHIFT);
    eval 'sub ST_DAT_SHIFT () {0;}' unless defined(&ST_DAT_SHIFT);
    eval 'sub dotokens () {
        eval q({  &dotoken ( &SR_RLS_EXISTS,  &ST_RLS_SHIFT,  &ST_RLS_TOKEN, \\"release\\");  &dotoken ( &SR_MAJ_EXISTS,  &ST_MAJ_SHIFT,  &ST_MAJ_TOKEN, \\"majorsync\\");  &dotoken ( &SR_MIN_EXISTS,  &ST_MIN_SHIFT,  &ST_MIN_TOKEN, \\"minorsync\\");  &dotoken ( &SR_DAT_EXISTS,  &ST_DAT_SHIFT,  &ST_DAT_TOKEN, \\"data\\"); });
    }' unless defined(&dotokens);
    eval 'sub SX_NORMAL () {0x;}' unless defined(&SX_NORMAL);
    eval 'sub SX_EXPEDITED () {0x1;}' unless defined(&SX_EXPEDITED);
    eval 'sub SX_TYPED () {0x2;}' unless defined(&SX_TYPED);
    eval 'sub SX_CAPDIND () {0x3;}' unless defined(&SX_CAPDIND);
    eval 'sub SX_CAPDCNF () {0x4;}' unless defined(&SX_CAPDCNF);
    eval 'sub SX_EXSIZE () {14;}' unless defined(&SX_EXSIZE);
    eval 'sub SX_CDSIZE () {512;}' unless defined(&SX_CDSIZE);
    eval 'sub SX_CDASIZE () {512;}' unless defined(&SX_CDASIZE);
    eval 'sub SXFREE {
        my($sx) = @_;
	    eval q( &QBFREE ((($sx) ->  &sx_qbuf)));
    }' unless defined(&SXFREE);
    eval 'sub ST_GIVE () {0x;}' unless defined(&ST_GIVE);
    eval 'sub ST_PLEASE () {0x1;}' unless defined(&ST_PLEASE);
    eval 'sub ST_CONTROL () {0x2;}' unless defined(&ST_CONTROL);
    eval 'sub ST_RLS_TOKEN () {(0x1 <<  &ST_RLS_SHIFT);}' unless defined(&ST_RLS_TOKEN);
    eval 'sub ST_MAJ_TOKEN () {(0x1 <<  &ST_MAJ_SHIFT);}' unless defined(&ST_MAJ_TOKEN);
    eval 'sub ST_ACT_TOKEN () {(0x1 <<  &ST_ACT_SHIFT);}' unless defined(&ST_ACT_TOKEN);
    eval 'sub ST_MIN_TOKEN () {(0x1 <<  &ST_MIN_SHIFT);}' unless defined(&ST_MIN_TOKEN);
    eval 'sub ST_DAT_TOKEN () {(0x1 <<  &ST_DAT_SHIFT);}' unless defined(&ST_DAT_TOKEN);
    eval 'sub ST_SIZE () {512;}' unless defined(&ST_SIZE);
    eval 'sub STFREE {
        my($st) = @_;
	    eval q({  &if (($st) ->  &st_data)  &free (($st) ->  &st_data), ($st) ->  &st_data =  &NULL; });
    }' unless defined(&STFREE);
    eval 'sub SN_MAJORIND () {0x;}' unless defined(&SN_MAJORIND);
    eval 'sub SN_MAJORCNF () {0x1;}' unless defined(&SN_MAJORCNF);
    eval 'sub SN_MINORIND () {0x2;}' unless defined(&SN_MINORIND);
    eval 'sub SN_MINORCNF () {0x3;}' unless defined(&SN_MINORCNF);
    eval 'sub SN_RESETIND () {0x4;}' unless defined(&SN_RESETIND);
    eval 'sub SN_RESETCNF () {0x5;}' unless defined(&SN_RESETCNF);
    eval 'sub SYNC_CONFIRM () {1;}' unless defined(&SYNC_CONFIRM);
    eval 'sub SYNC_NOCONFIRM () {0;}' unless defined(&SYNC_NOCONFIRM);
    eval 'sub SYNC_RESTART () {0;}' unless defined(&SYNC_RESTART);
    eval 'sub SYNC_ABANDON () {1;}' unless defined(&SYNC_ABANDON);
    eval 'sub SYNC_SET () {2;}' unless defined(&SYNC_SET);
    eval 'sub SERIAL_NONE () {(-1);}' unless defined(&SERIAL_NONE);
    eval 'sub SERIAL_MIN () {000000;}' unless defined(&SERIAL_MIN);
    eval 'sub SERIAL_MAX () {999998;}' unless defined(&SERIAL_MAX);
    eval 'sub SN_SIZE () {512;}' unless defined(&SN_SIZE);
    eval 'sub SNFREE {
        my($sn) = @_;
	    eval q({  &if (($sn) ->  &sn_data)  &free (($sn) ->  &sn_data), ($sn) ->  &sn_data =  &NULL; });
    }' unless defined(&SNFREE);
    eval 'sub SV_START () {0x;}' unless defined(&SV_START);
    eval 'sub SV_RESUME () {0x1;}' unless defined(&SV_RESUME);
    eval 'sub SV_INTRIND () {0x2;}' unless defined(&SV_INTRIND);
    eval 'sub SV_INTRCNF () {0x3;}' unless defined(&SV_INTRCNF);
    eval 'sub SV_DISCIND () {0x4;}' unless defined(&SV_DISCIND);
    eval 'sub SV_DISCCNF () {0x5;}' unless defined(&SV_DISCCNF);
    eval 'sub SV_ENDIND () {0x6;}' unless defined(&SV_ENDIND);
    eval 'sub SV_ENDCNF () {0x7;}' unless defined(&SV_ENDCNF);
    eval 'sub SV_SIZE () {512;}' unless defined(&SV_SIZE);
    eval 'sub SVFREE {
        my($sv) = @_;
	    eval q({  &if (($sv) ->  &sv_data)  &free (($sv) ->  &sv_data), ($sv) ->  &sv_data =  &NULL; });
    }' unless defined(&SVFREE);
    eval 'sub SP_NOREASON () {0;}' unless defined(&SP_NOREASON);
    eval 'sub SP_JEOPARDY () {1;}' unless defined(&SP_JEOPARDY);
    eval 'sub SP_RSVD1 () {2;}' unless defined(&SP_RSVD1);
    eval 'sub SP_SEQUENCE () {3;}' unless defined(&SP_SEQUENCE);
    eval 'sub SP_RSVD2 () {4;}' unless defined(&SP_RSVD2);
    eval 'sub SP_LOCAL () {5;}' unless defined(&SP_LOCAL);
    eval 'sub SP_PROCEDURAL () {6;}' unless defined(&SP_PROCEDURAL);
    eval 'sub SP_DEMAND () {128;}' unless defined(&SP_DEMAND);
    eval 'sub SP_PROTOCOL () {(-1);}' unless defined(&SP_PROTOCOL);
    eval 'sub SP_SIZE () {512;}' unless defined(&SP_SIZE);
    eval 'sub SPFREE {
        my($sp) = @_;
	    eval q({  &if (($sp) ->  &sp_data)  &free (($sp) ->  &sp_data), ($sp) ->  &sp_data =  &NULL; });
    }' unless defined(&SPFREE);
    eval 'sub SF_SIZE () {512;}' unless defined(&SF_SIZE);
    eval 'sub SFFREE {
        my($sf) = @_;
	    eval q({  &if (($sf) ->  &sf_data)  &free (($sf) ->  &sf_data), ($sf) ->  &sf_data =  &NULL; });
    }' unless defined(&SFFREE);
    eval 'sub SR_SIZE () {512;}' unless defined(&SR_SIZE);
    eval 'sub SRFREE {
        my($sr) = @_;
	    eval q({  &if (($sr) ->  &sr_data)  &free (($sr) ->  &sr_data), ($sr) ->  &sr_data =  &NULL; });
    }' unless defined(&SRFREE);
    eval 'sub SA_SIZE () {512;}' unless defined(&SA_SIZE);
    eval 'sub SAFREE {
        my($sa) = @_;
	    eval q({  &if (($sa) ->  &sa_realinfo)  &free (($sa) ->  &sa_realinfo), ($sa) ->  &sa_realinfo =  &NULL; });
    }' unless defined(&SAFREE);
    eval 'sub SI_DATA () {0x;}' unless defined(&SI_DATA);
    eval 'sub SI_TOKEN () {0x1;}' unless defined(&SI_TOKEN);
    eval 'sub SI_SYNC () {0x2;}' unless defined(&SI_SYNC);
    eval 'sub SI_ACTIVITY () {0x3;}' unless defined(&SI_ACTIVITY);
    eval 'sub SI_REPORT () {0x4;}' unless defined(&SI_REPORT);
    eval 'sub SI_FINISH () {0x5;}' unless defined(&SI_FINISH);
    eval 'sub SI_ABORT () {0x6;}' unless defined(&SI_ABORT);
    eval 'sub si_data () { ($si_un->{si_un_data});}' unless defined(&si_data);
    eval 'sub si_token () { ($si_un->{si_un_token});}' unless defined(&si_token);
    eval 'sub si_sync () { ($si_un->{si_un_sync});}' unless defined(&si_sync);
    eval 'sub si_activity () { ($si_un->{si_un_activity});}' unless defined(&si_activity);
    eval 'sub si_report () { ($si_un->{si_un_report});}' unless defined(&si_report);
    eval 'sub si_finish () { ($si_un->{si_un_finish});}' unless defined(&si_finish);
    eval 'sub si_abort () { ($si_un->{si_un_abort});}' unless defined(&si_abort);
    eval 'sub SConnRequest {
        my($a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$a10,$a11) = @_;
	    eval q( &SAsynConnRequest ($a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$a10,$a11,0));
    }' unless defined(&SConnRequest);
    eval 'sub SLocalHostName () { &getlocalhost;}' unless defined(&SLocalHostName);
}
1;
