require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_J2_TYPES)) {
    eval 'sub _H_J2_TYPES () {1;}' unless defined(&_H_J2_TYPES);
    eval 'sub _H_JFS_FILSYS () {1;}' unless defined(&_H_JFS_FILSYS);
    eval 'sub _H_JFS_INODE () {1;}' unless defined(&_H_JFS_INODE);
    eval 'sub _H_JFS_INO () {1;}' unless defined(&_H_JFS_INO);
    eval 'sub _H_JFS_DIR () {1;}' unless defined(&_H_JFS_DIR);
    require 'sys/types.ph';
    require 'sys/sysmacros.ph';
    if(defined(&_J2_UNICODE)) {
	unless(defined(&_ULS_UNICHAR_DEFINED)) {
	    eval 'sub _ULS_UNICHAR_DEFINED () {1;}' unless defined(&_ULS_UNICHAR_DEFINED);
	}
    } else {
	eval 'sub UniChar () {\'unsigned char\';}' unless defined(&UniChar);
    }
    eval 'sub ALIGNMENT_OFFSET () {7;}' unless defined(&ALIGNMENT_OFFSET);
    eval 'sub DEV64 {
        my($_devno) = @_;
	    eval q((( &dev64_t) (((( &uint64)$_devno) &  &DEVNO64) ? $_devno : ((($_devno & ( &uint64)0xffff0000) << 16) | ($_devno & 0xffff) |  &DEVNO64))));
    }' unless defined(&DEV64);
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub DEV64TODEVT {
	    my($_devno) = @_;
    	    eval q(($_devno));
	}' unless defined(&DEV64TODEVT);
    } else {
	eval 'sub DEV64TODEVT {
	    my($_devno) = @_;
    	    eval q((( &dev_t) ((($_devno & 281470681743360) >> 16) | ($_devno & 0xffff))));
	}' unless defined(&DEV64TODEVT);
    }
    undef(&MIN) if defined(&MIN);
    eval 'sub MIN {
        my($a,$b) = @_;
	    eval q(((($a)<($b))?($a):($b)));
    }' unless defined(&MIN);
    undef(&MAX) if defined(&MAX);
    eval 'sub MAX {
        my($a,$b) = @_;
	    eval q(((($a)>($b))?($a):($b)));
    }' unless defined(&MAX);
    undef(&ROUNDUP) if defined(&ROUNDUP);
    eval 'sub ROUNDUP {
        my($x, $y) = @_;
	    eval q(( (($x) + (($y) - 1)) & ~(($y) - 1) ));
    }' unless defined(&ROUNDUP);
    eval 'sub CircularLength {
        my($delta, $to, $from, $circle) = @_;
	    eval q({ $delta = ($to) - ($from);  &if ($delta < 0) $delta += ($circle);});
    }' unless defined(&CircularLength);
    eval 'sub LEFTMOSTONE () {0x80000000;}' unless defined(&LEFTMOSTONE);
    eval 'sub HIGHORDER () {0x80000000;}' unless defined(&HIGHORDER);
    eval 'sub ONES () {0xffffffff;}' unless defined(&ONES);
    eval 'sub BITSPERINT32 () {32;}' unless defined(&BITSPERINT32);
    eval 'sub BITSPERINT64 () {64;}' unless defined(&BITSPERINT64);
    if(defined(&_notdef_)) {
	eval 'sub XDlength {
	    my($xd, $length32) = @_;
    	    eval q(( ($xd)-> &len = $length32 ));
	}' unless defined(&XDlength);
	eval 'sub XDaddress {
	    my($xd, $address64) = @_;
    	    eval q({ ($xd)-> &addr1 = ($address64) >> 32; ($xd)-> &addr2 = ($address64) & 0xffffffff;});
	}' unless defined(&XDaddress);
	eval 'sub lengthXD {
	    my($xd) = @_;
    	    eval q(( ($xd)-> &len ));
	}' unless defined(&lengthXD);
	eval 'sub addressXD {
	    my($xd) = @_;
    	    eval q(( (( &int64)(($xd)-> &addr1)) << 32| ($xd)-> &addr2 ));
	}' unless defined(&addressXD);
	eval 'sub LXDlength {
	    my($lxd, $length32) = @_;
    	    eval q(( ($lxd)-> &len = $length32 ));
	}' unless defined(&LXDlength);
	eval 'sub LXDoffset {
	    my($lxd, $offset64) = @_;
    	    eval q({ ($lxd)-> &off1 = ($offset64) >> 32; ($lxd)-> &off2 = ($offset64) & 0xffffffff;});
	}' unless defined(&LXDoffset);
	eval 'sub lengthLXD {
	    my($lxd) = @_;
    	    eval q(( ($lxd)-> &len ));
	}' unless defined(&lengthLXD);
	eval 'sub offsetLXD {
	    my($lxd) = @_;
    	    eval q(( (( &int64)(($lxd)-> &off1)) << 32| ($lxd)-> &off2 ));
	}' unless defined(&offsetLXD);
    }
    eval 'sub PXDlength {
        my($pxd, $length32) = @_;
	    eval q(( ($pxd)-> &len = $length32 ));
    }' unless defined(&PXDlength);
    eval 'sub PXDaddress {
        my($pxd, $address64) = @_;
	    eval q({ ($pxd)-> &addr1 = ($address64) >> 32; ($pxd)-> &addr2 = ($address64) & 0xffffffff;});
    }' unless defined(&PXDaddress);
    eval 'sub lengthPXD {
        my($pxd) = @_;
	    eval q(( ($pxd)-> &len ));
    }' unless defined(&lengthPXD);
    eval 'sub addressPXD {
        my($pxd) = @_;
	    eval q(( (( &int64)(($pxd)-> &addr1)) << 32| ($pxd)-> &addr2 ));
    }' unless defined(&addressPXD);
    eval 'sub EADlength {
        my($ead, $length8) = @_;
	    eval q(( ($ead)-> &len = $length8 ));
    }' unless defined(&EADlength);
    eval 'sub EADaddress {
        my($ead, $address64) = @_;
	    eval q({ ($ead)-> &addr1 = ($address64) >> 32; ($ead)-> &addr2 = ($address64) & 0xffffffff;});
    }' unless defined(&EADaddress);
    eval 'sub lengthEAD {
        my($ead) = @_;
	    eval q(( ($ead)-> &len ));
    }' unless defined(&lengthEAD);
    eval 'sub addressEAD {
        my($ead) = @_;
	    eval q(( (( &int64)(($ead)-> &addr1)) << 32| ($ead)-> &addr2 ));
    }' unless defined(&addressEAD);
    eval 'sub DXD_INDEX () {0x80;}' unless defined(&DXD_INDEX);
    eval 'sub DXD_INLINE () {0x40;}' unless defined(&DXD_INLINE);
    eval 'sub DXD_EXTENT () {0x20;}' unless defined(&DXD_EXTENT);
    eval 'sub DXD_FILE () {0x10;}' unless defined(&DXD_FILE);
    eval 'sub DXD_CORRUPT () {0x8;}' unless defined(&DXD_CORRUPT);
    eval 'sub DXDlength {
        my($dxd, $length32) = @_;
	    eval q(( ($dxd)-> &len = $length32 ));
    }' unless defined(&DXDlength);
    eval 'sub DXDaddress {
        my($dxd, $address64) = @_;
	    eval q({ ($dxd)-> &addr1 = ($address64) >> 32; ($dxd)-> &addr2 = ($address64) & 0xffffffff;});
    }' unless defined(&DXDaddress);
    eval 'sub lengthDXD {
        my($dxd) = @_;
	    eval q(( ($dxd)-> &len ));
    }' unless defined(&lengthDXD);
    eval 'sub addressDXD {
        my($dxd) = @_;
	    eval q(( (( &int64)(($dxd)-> &addr1)) << 32| ($dxd)-> &addr2 ));
    }' unless defined(&addressDXD);
    if(defined(&_notdef_)) {
    }
    eval 'sub CDLL_HEADER {
        my($type) = @_;
	    eval q(\'struct struct\' { \'struct type\' * &head; \'struct type\' * &tail;});
    }' unless defined(&CDLL_HEADER);
    eval 'sub CDLL_ENTRY {
        my($type) = @_;
	    eval q(\'struct struct\' { \'struct type\' * &next; \'struct type\' * &prev;});
    }' unless defined(&CDLL_ENTRY);
    eval 'sub CDLL_INIT {
        my($header) = @_;
	    eval q({ ($header)-> &head = ( &void *)($header); ($header)-> &tail = ( &void *)($header);});
    }' unless defined(&CDLL_INIT);
    eval 'sub CDLL_INSERT_HEAD {
        my($header, $elm, $field) = @_;
	    eval q({ ($elm)-> ($field->{next}) = ($header)-> &head; ($elm)-> ($field->{prev}) = ( &void *)($header);  &if (($header)-> &tail == ( &void *)($header)) ($header)-> &tail = ($elm);  &else ($header)-> ($head->{field}->{prev}) = ($elm); ($header)-> &head = ($elm);});
    }' unless defined(&CDLL_INSERT_HEAD);
    eval 'sub CDLL_INSERT_TAIL {
        my($header, $elm, $field) = @_;
	    eval q({ ($elm)-> ($field->{next}) = ( &void *)($header); ($elm)-> ($field->{prev}) = ($header)-> &tail;  &if (($header)-> &head == ( &void *)($header)) ($header)-> &head = ($elm);  &else ($header)-> ($tail->{field}->{next}) = ($elm); ($header)-> &tail = ($elm);});
    }' unless defined(&CDLL_INSERT_TAIL);
    eval 'sub CDLL_INSERT_AFTER {
        my($header, $listelm, $elm, $field) = @_;
	    eval q({ ($elm)-> ($field->{next}) = ($listelm)-> ($field->{next}); ($elm)-> ($field->{prev}) = ($listelm);  &if (($listelm)-> ($field->{next}) == ( &void *)($header)) ($header)-> &tail = ($elm);  &else ($listelm)-> ($field->{next}->{field}->{prev}) = ($elm); ($listelm)-> ($field->{next}) = ($elm);});
    }' unless defined(&CDLL_INSERT_AFTER);
    eval 'sub CDLL_INSERT_BEFORE {
        my($header, $listelm, $elm, $field) = @_;
	    eval q({ ($elm)-> ($field->{next}) = ($listelm); ($elm)-> ($field->{prev}) = ($listelm)-> ($field->{prev});  &if (($listelm)-> ($field->{prev}) == ( &void *)($header)) ($header)-> &head = ($elm);  &else ($listelm)-> ($field->{prev}->{field}->{next}) = ($elm); ($listelm)-> ($field->{prev}) = ($elm);});
    }' unless defined(&CDLL_INSERT_BEFORE);
    eval 'sub CDLL_REMOVE {
        my($header, $elm, $field) = @_;
	    eval q({  &if (($elm)-> ($field->{next}) == ( &void *)($header)) ($header)-> &tail = ($elm)-> ($field->{prev});  &else ($elm)-> ($field->{next}->{field}->{prev}) = ($elm)-> ($field->{prev});  &if (($elm)-> ($field->{prev}) == ( &void *)($header)) ($header)-> &head = ($elm)-> ($field->{next});  &else ($elm)-> ($field->{prev}->{field}->{next}) = ($elm)-> ($field->{next});});
    }' unless defined(&CDLL_REMOVE);
    eval 'sub CDLL_MOVE_TO_HEAD {
        my($header, $elm, $field) = @_;
	    eval q({  &if (($elm)-> ($field->{prev}) != ( &void *)($header)) {  &if (($elm)-> ($field->{next}) == ( &void *)($header)) ($header)-> &tail = ($elm)-> ($field->{prev});  &else ($elm)-> ($field->{next}->{field}->{prev}) = ($elm)-> ($field->{prev}); ($elm)-> ($field->{prev}->{field}->{next}) = ($elm)-> ($field->{next}); ($elm)-> ($field->{next}) = ($header)-> &head; ($elm)-> ($field->{prev}) = ( &void *)($header); ($header)-> ($head->{field}->{prev}) = ($elm); ($header)-> &head = ($elm); }});
    }' unless defined(&CDLL_MOVE_TO_HEAD);
    eval 'sub CDLL_MOVE_TO_TAIL {
        my($header, $elm, $field) = @_;
	    eval q({  &if (($elm)-> ($field->{next}) != ( &void *)($header)) { ($elm)-> ($field->{next}->{field}->{prev}) = ($elm)-> ($field->{prev});  &if (($elm)-> ($field->{prev}) == ( &void *)($header)) ($header)-> &head = ($elm)-> ($field->{next});  &else ($elm)-> ($field->{prev}->{field}->{next}) = ($elm)-> ($field->{next}); ($elm)-> ($field->{next}) = ( &void *)($header); ($elm)-> ($field->{prev}) = ($header)-> &tail; ($header)-> ($tail->{field}->{next}) = ($elm); ($header)-> &tail = ($elm); }});
    }' unless defined(&CDLL_MOVE_TO_TAIL);
    eval 'sub CDLL_SELF {
        my($elm, $field) = @_;
	    eval q(($elm)-> ($field->{next}) = ($elm)-> ($field->{prev}) = ($elm););
    }' unless defined(&CDLL_SELF);
    eval 'sub LIST_HEADER {
        my($type) = @_;
	    eval q(\'struct struct\' { \'struct type\' * &head;});
    }' unless defined(&LIST_HEADER);
    eval 'sub LIST_ENTRY {
        my($type) = @_;
	    eval q(\'struct struct\' { \'struct type\' * &next; \'struct type\' ** &prev;});
    }' unless defined(&LIST_ENTRY);
    eval 'sub LIST_INIT {
        my($header) = @_;
	    eval q({ ($header)-> &head =  &NULL; });
    }' unless defined(&LIST_INIT);
    eval 'sub LIST_INSERT_HEAD {
        my($header, $elm, $field) = @_;
	    eval q({  &if ((($elm)-> ($field->{next}) = ($header)-> &head) !=  &NULL) ($header)-> ($head->{field}->{prev}) = ($elm)-> ($field->{next}); ($header)-> &head = ($elm); ($elm)-> ($field->{prev}) = ($header)-> &head;});
    }' unless defined(&LIST_INSERT_HEAD);
    eval 'sub LIST_INSERT_AFTER {
        my($listelm, $elm, $field) = @_;
	    eval q({  &if ((($elm)-> ($field->{next}) = ($listelm)-> ($field->{next})) !=  &NULL) ($listelm)-> ($field->{next}->{field}->{prev}) = ($elm)-> ($field->{next}); ($listelm)-> ($field->{next}) = ($elm); ($elm)-> ($field->{prev}) = ($listelm)-> ($field->{next});});
    }' unless defined(&LIST_INSERT_AFTER);
    eval 'sub LIST_REMOVE {
        my($elm, $field) = @_;
	    eval q({  &if (($elm)-> ($field->{next}) !=  &NULL) ($elm)-> ($field->{next}->{field}->{prev}) = ($elm)-> ($field->{prev}); *($elm)-> ($field->{prev}) = ($elm)-> ($field->{next});});
    }' unless defined(&LIST_REMOVE);
    eval 'sub LIST_SELF {
        my($elm, $field) = @_;
	    eval q({ ($elm)-> ($field->{next}) =  &NULL; ($elm)-> ($field->{prev}) = ($elm)-> ($field->{next});});
    }' unless defined(&LIST_SELF);
}
1;
