require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_JFS_QUOTA)) {
    eval 'sub _H_JFS_QUOTA () {1;}' unless defined(&_H_JFS_QUOTA);
    require 'sys/types.ph';
    require 'sys/param.ph';
    require 'sys/vmuser.ph';
    eval 'sub MAX_IQ_TIME () {(7*24*60*60);}' unless defined(&MAX_IQ_TIME);
    eval 'sub MAX_DQ_TIME () {(7*24*60*60);}' unless defined(&MAX_DQ_TIME);
    eval 'sub MAXQUOTAS () {2;}' unless defined(&MAXQUOTAS);
    eval 'sub USRQUOTA () {0;}' unless defined(&USRQUOTA);
    eval 'sub GRPQUOTA () {1;}' unless defined(&GRPQUOTA);
    eval 'sub MINDQID () {0;}' unless defined(&MINDQID);
    eval 'sub MAXDQID () {(( &MAXFSIZE / $sizeof{\'struct dqblk\'}) - 1);}' unless defined(&MAXDQID);
    eval 'sub INITQFNAMES () {{ "user", "group", "undefined", };;}' unless defined(&INITQFNAMES);
    unless(defined(&_KERNEL)) {
    }
    eval 'sub SUBCMDMASK () {0xff;}' unless defined(&SUBCMDMASK);
    eval 'sub SUBCMDSHIFT () {8;}' unless defined(&SUBCMDSHIFT);
    eval 'sub QCMD {
        my($cmd, $type) = @_;
	    eval q(((($cmd) <<  &SUBCMDSHIFT) | (($type) &  &SUBCMDMASK)));
    }' unless defined(&QCMD);
    eval 'sub Q_QUOTAON () {0x100;}' unless defined(&Q_QUOTAON);
    eval 'sub Q_QUOTAOFF () {0x200;}' unless defined(&Q_QUOTAOFF);
    eval 'sub Q_GETQUOTA () {0x300;}' unless defined(&Q_GETQUOTA);
    unless(defined(&_LINUX_SOURCE_COMPAT)) {
	eval 'sub Q_SETQUOTA () {0x400;}' unless defined(&Q_SETQUOTA);
	eval 'sub Q_SETQLIM () { &Q_SETQUOTA;}' unless defined(&Q_SETQLIM);
    } else {
	eval 'sub Q_SETQLIM () {0x400;}' unless defined(&Q_SETQLIM);
	eval 'sub Q_SETQUOTA () {0x700;}' unless defined(&Q_SETQUOTA);
    }
    eval 'sub Q_SETUSE () {0x500;}' unless defined(&Q_SETUSE);
    eval 'sub Q_SYNC () {0x600;}' unless defined(&Q_SYNC);
    if(defined(&__64BIT_KERNEL)) {
    } else {
    }
    eval 'sub DQBSIZE () {1024;}' unless defined(&DQBSIZE);
    eval 'sub DQCBIT () {0x80000000;}' unless defined(&DQCBIT);
    eval 'sub DQCARRY {
        my($c) = @_;
	    eval q((($c) >> 31));
    }' unless defined(&DQCARRY);
    eval 'sub DQBTIME {
        my($t) = @_;
	    eval q((($t) & (~ &DQCBIT)));
    }' unless defined(&DQBTIME);
    eval 'sub DQSBTIME {
        my($c,$t) = @_;
	    eval q((( << 31) | (($t) & (~ &DQCBIT))));
    }' unless defined(&DQSBTIME);
    if(defined(&_KERNEL)) {
	require 'jfs/jfsmount.ph';
	require 'jfs/fsparam.ph';
	eval 'sub DQ_LOCK () {0x1;}' unless defined(&DQ_LOCK);
	eval 'sub DQ_WANT () {0x2;}' unless defined(&DQ_WANT);
	eval 'sub DQ_MOD () {0x4;}' unless defined(&DQ_MOD);
	eval 'sub DQ_FAKE () {0x8;}' unless defined(&DQ_FAKE);
	eval 'sub DQ_BLKS () {0x10;}' unless defined(&DQ_BLKS);
	eval 'sub DQ_INODS () {0x20;}' unless defined(&DQ_INODS);
	eval 'sub DQ_QFLOCK () {0x40;}' unless defined(&DQ_QFLOCK);
	eval 'sub DQ_QFWANT () {0x80;}' unless defined(&DQ_QFWANT);
	eval 'sub DQ_IOERROR () {0x100;}' unless defined(&DQ_IOERROR);
	eval 'sub dq_bhardlimit () { ($dq_dqb->{dqb_bhardlimit});}' unless defined(&dq_bhardlimit);
	eval 'sub dq_bsoftlimit () { ($dq_dqb->{dqb_bsoftlimit});}' unless defined(&dq_bsoftlimit);
	eval 'sub dq_curblocks () { ($dq_dqb->{dqb_curblocks});}' unless defined(&dq_curblocks);
	eval 'sub dq_ihardlimit () { ($dq_dqb->{dqb_ihardlimit});}' unless defined(&dq_ihardlimit);
	eval 'sub dq_isoftlimit () { ($dq_dqb->{dqb_isoftlimit});}' unless defined(&dq_isoftlimit);
	eval 'sub dq_curinodes () { ($dq_dqb->{dqb_curinodes});}' unless defined(&dq_curinodes);
	eval 'sub dq_btime () { ($dq_dqb->{dqb_btime});}' unless defined(&dq_btime);
	eval 'sub dq_itime () { ($dq_dqb->{dqb_itime});}' unless defined(&dq_itime);
	eval 'sub NODQUOT () {( 0);}' unless defined(&NODQUOT);
	eval 'sub JFSTODQ {
	    my($BLKS) = @_;
    	    eval q((($BLKS) * ( &BSIZE/ &DQBSIZE)));
	}' unless defined(&JFSTODQ);
	eval 'sub NHDQUOT () { &PAGESIZE/$sizeof{\'struct hdquot\'};}' unless defined(&NHDQUOT);
	eval 'sub DQHASH {
	    my($DEV,$ID) = @_;
    	    eval q(( $hdquot[((()) + ((($ID)))) & ( &NHDQUOT-1)]));
	}' unless defined(&DQHASH);
	eval 'sub DQVALID {
	    my($ID) = @_;
    	    eval q(((()) >=  &MINDQID  && ((($ID))) <=  &MAXDQID ? 1: 0));
	}' unless defined(&DQVALID);
    }
}
1;
