require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NET_GLOBALS_H_)) {
    eval 'sub _NET_GLOBALS_H_ () {1;}' unless defined(&_NET_GLOBALS_H_);
    require 'sys/lock_def.ph';
    if(defined(&_KERNEL)) {
	require 'sys/sleep.ph';
	require 'sys/user.ph';
	require 'net/spl.ph';
	require 'sys/syspest.ph';
	require 'sys/lockname.ph';
	require 'sys/lock_alloc.ph';
	require 'strings.ph';
    }
    if(defined(&simple_lock_data_t)) {
	undef(&simple_lock_data_t) if defined(&simple_lock_data_t);
    }
    if(defined(&lock_data_t)) {
	undef(&lock_data_t) if defined(&lock_data_t);
    }
    eval 'sub lock_init2 {
        my($lp, $s, $type) = @_;
	    eval q( &lock_init($lp, $s));
    }' unless defined(&lock_init2);
    eval 'sub NETNHSQUE () {128;}' unless defined(&NETNHSQUE);
    eval 'sub netsqhash {
        my($X) = @_;
	    eval q(( $nethsque[( ( >> 12) + ( >> 8) + ($X) ) & ( &NETNHSQUE-1)]));
    }' unless defined(&netsqhash);
    eval 'sub assert_wait {
        my($addr, $intr) = @_;
	    eval q( &e_assert_wait( &netsqhash($addr), $intr));
    }' unless defined(&assert_wait);
    eval 'sub assert_wait_mesg {
        my($addr, $intr, $msg) = @_;
	    eval q( &e_assert_wait( &netsqhash($addr), $intr));
    }' unless defined(&assert_wait_mesg);
    eval 'sub clear_wait {
        my($thread, $result, $flag) = @_;
	    eval q( &e_clear_wait(($thread)-> &t_tid, $result));
    }' unless defined(&clear_wait);
    eval 'sub wakeup_one {
        my($addr) = @_;
	    eval q( &e_wakeup_one( &netsqhash($addr)));
    }' unless defined(&wakeup_one);
    eval 'sub wakeup {
        my($addr) = @_;
	    eval q( &e_wakeup( &netsqhash($addr)));
    }' unless defined(&wakeup);
    eval 'sub thread_wakeup {
        my($addr) = @_;
	    eval q( &e_wakeup( &netsqhash($addr)));
    }' unless defined(&thread_wakeup);
    eval 'sub current_thread () {
        eval q(( &curthread));
    }' unless defined(&current_thread);
    eval 'sub thread_block () {
        eval q( &e_block_thread());
    }' unless defined(&thread_block);
    eval 'sub thread_swappable {
        my($a, $b) = @_;
	    eval q();
    }' unless defined(&thread_swappable);
    eval 'sub PAGE_SIZE () {4096;}' unless defined(&PAGE_SIZE);
    eval 'sub MAXALLOCSAVE () {(4*  &PAGE_SIZE);}' unless defined(&MAXALLOCSAVE);
    eval 'sub THEWALL_MAX_64BIT () {( &MAXNETKMEM<< &SEGSHIFT);}' unless defined(&THEWALL_MAX_64BIT);
    eval 'sub THEWALL_MAX_4SEG () {(4*256*1024*1024);}' unless defined(&THEWALL_MAX_4SEG);
    eval 'sub THEWALL_MAX_1SEG () {(256*1024*1024);}' unless defined(&THEWALL_MAX_1SEG);
    eval 'sub THEWALL_MAX () {(128*1024*1024);}' unless defined(&THEWALL_MAX);
    eval 'sub MAX_INITIAL_PIN () {((512*1024)/  &MAXALLOCSAVE);}' unless defined(&MAX_INITIAL_PIN);
    eval 'sub NNETTHREADS () {4;}' unless defined(&NNETTHREADS);
    eval 'sub MAXHUGESIZE () {(128*1024);}' unless defined(&MAXHUGESIZE);
    unless(defined(&NET_ALIGN4)) {
	eval 'sub NET_ALIGN4_SIZE () {$sizeof{\'int\'};}' unless defined(&NET_ALIGN4_SIZE);
	eval 'sub NET_ALIGN4_ALIGNMENT {
	    my($p) = @_;
    	    eval q((($p) %  &NET_ALIGN4_SIZE));
	}' unless defined(&NET_ALIGN4_ALIGNMENT);
	eval 'sub NET_ALIGN4 {
	    my($p) = @_;
    	    eval q(( +  &NET_ALIGN4_SIZE - 1-  &NET_ALIGN4_ALIGNMENT(($p) +  &NET_ALIGN4_SIZE - 1)));
	}' unless defined(&NET_ALIGN4);
    }
    unless(defined(&IP_MULTICAST)) {
	eval 'sub IP_MULTICAST () {1;}' unless defined(&IP_MULTICAST);
    }
    eval 'sub LTYPE_RAW () {1;}' unless defined(&LTYPE_RAW);
    eval 'sub LTYPE_ROUTE () {2;}' unless defined(&LTYPE_ROUTE);
    eval 'sub LTYPE_SOCKET () {3;}' unless defined(&LTYPE_SOCKET);
    eval 'sub LTYPE_SOCKBUF () {4;}' unless defined(&LTYPE_SOCKBUF);
    eval 'sub LTYPE_DOMAIN () {5;}' unless defined(&LTYPE_DOMAIN);
    eval 'sub LTYPE_ARPTAB () {6;}' unless defined(&LTYPE_ARPTAB);
    eval 'sub STATS_ACTION {
        my($lock, $action) = @_;
	    eval q($action);
    }' unless defined(&STATS_ACTION);
    eval 'sub queue_init {
        my($q) = @_;
	    eval q((($q)-> &next = ($q)-> &prev = $q));
    }' unless defined(&queue_init);
    eval 'sub pfind {
        my($pgid) = @_;
	    eval q(($pgid));
    }' unless defined(&pfind);
    eval 'sub gsignal {
        my($pgid, $sig) = @_;
	    eval q( &pgsignal(($pgid), ($sig)));
    }' unless defined(&gsignal);
    eval 'sub psignal {
        my($p, $sig) = @_;
	    eval q( &pidsig(($p), ($sig)));
    }' unless defined(&psignal);
    eval 'sub psignal_inthread {
        my($p, $sig) = @_;
	    eval q( &pidsig(($p), ($sig)));
    }' unless defined(&psignal_inthread);
    eval 'sub BM {
        my($x) = @_;
	    eval q($x);
    }' unless defined(&BM);
    eval 'sub P_UNREF {
        my($p) = @_;
	    eval q();
    }' unless defined(&P_UNREF);
    eval 'sub NETNCPUS () { &NCPUS;}' unless defined(&NETNCPUS);
    eval 'sub NETSYNC_LOCK () {1;}' unless defined(&NETSYNC_LOCK);
    eval 'sub NETSYNC_SPL () {! &NETSYNC_LOCK;}' unless defined(&NETSYNC_SPL);
    eval 'sub NETISR_THREAD () {( &NETSYNC_LOCK || ( &NETNCPUS > 1) || ( &NNETTHREADS > 0));}' unless defined(&NETISR_THREAD);
    eval 'sub LOCK_ASSERTL_DECL () {1;}' unless defined(&LOCK_ASSERTL_DECL);
    if(defined(&DEBUG)) {
	eval 'sub LOCK_ASSERT {
	    my($string, $cond) = @_;
    	    eval q( &assert($cond));
	}' unless defined(&LOCK_ASSERT);
    } else {
	eval 'sub LOCK_ASSERT {
	    my($string, $cond) = @_;
    	    eval q();
	}' unless defined(&LOCK_ASSERT);
    }
    eval 'sub NETSYNC_LOCKTEST () { &DEBUG;}' unless defined(&NETSYNC_LOCKTEST);
    eval 'sub LOCK_NETSTATS () {0;}' unless defined(&LOCK_NETSTATS);
    eval 'sub LOCK_FREE {
        my($lp) = @_;
	    eval q( &lock_free($lp));
    }' unless defined(&LOCK_FREE);
    eval 'sub NETSPL_DECL {
        my($s) = @_;
	    eval q( &spl_t $s;);
    }' unless defined(&NETSPL_DECL);
    eval 'sub NETSPL {
        my($s,$level) = @_;
	    eval q($s =  &spl$level());
    }' unless defined(&NETSPL);
    eval 'sub NETSPLX {
        my($s) = @_;
	    eval q( &splx($s));
    }' unless defined(&NETSPLX);
    if((defined(&LOCK_NETSTATS) ? &LOCK_NETSTATS : 0)) {
	eval 'sub NETSTAT_LOCK_DECL () {
	    eval q(\'int\'  &_stats;);
	}' unless defined(&NETSTAT_LOCK_DECL);
	eval 'sub NETSTAT_LOCKINIT {
	    my($lockp) = @_;
    	    eval q({  &lock_alloc($lockp,  &LOCK_ALLOC_PIN,  &IF_SLOCK, $lockp);  &simple_lock_init($lockp); });
	}' unless defined(&NETSTAT_LOCKINIT);
	eval 'sub NETSTAT_LOCK {
	    my($lockp) = @_;
    	    eval q( &_stats =  &disable_lock( &PL_IMP, $lockp));
	}' unless defined(&NETSTAT_LOCK);
	eval 'sub NETSTAT_UNLOCK {
	    my($lockp) = @_;
    	    eval q( &unlock_enable( &_stats, $lockp));
	}' unless defined(&NETSTAT_UNLOCK);
    } else {
	eval 'sub NETSTAT_LOCK_DECL () {
	    eval q();
	}' unless defined(&NETSTAT_LOCK_DECL);
	eval 'sub NETSTAT_LOCKINIT {
	    my($lockp) = @_;
    	    eval q();
	}' unless defined(&NETSTAT_LOCKINIT);
	eval 'sub NETSTAT_LOCK {
	    my($lockp) = @_;
    	    eval q();
	}' unless defined(&NETSTAT_LOCK);
	eval 'sub NETSTAT_UNLOCK {
	    my($lockp) = @_;
    	    eval q();
	}' unless defined(&NETSTAT_UNLOCK);
    }
    unless(defined(&CONST)) {
	eval 'sub CONST () { &const;}' unless defined(&CONST);
    }
    unless(defined(&VOLATILE)) {
	eval 'sub VOLATILE () { &volatile;}' unless defined(&VOLATILE);
    }
    if(defined(&__64BIT_KERNEL)) {
    } else {
    }
    require 'sys/types.ph';
    require 'net/proto_net.ph';
    require 'net/proto_uipc.ph';
    if(defined(&_KERNEL)) {
	eval 'sub RTO_DFLT_LOW () {1;}' unless defined(&RTO_DFLT_LOW);
	eval 'sub RTO_DFLT_HIGH () {64;}' unless defined(&RTO_DFLT_HIGH);
	eval 'sub RTO_DFLT_LIMIT () {7;}' unless defined(&RTO_DFLT_LIMIT);
	eval 'sub RTO_DFLT_LENGTH () {13;}' unless defined(&RTO_DFLT_LENGTH);
	eval 'sub RTO_DFLT_SHIFT () {7;}' unless defined(&RTO_DFLT_SHIFT);
	if(defined(&__ia64)) {
	    eval 'sub INET_STACK_DFLT () {32;}' unless defined(&INET_STACK_DFLT);
	} else {
	    eval 'sub INET_STACK_DFLT () {16;}' unless defined(&INET_STACK_DFLT);
	}
    }
    eval 'sub TCP_NDEBUG () {100;}' unless defined(&TCP_NDEBUG);
    eval 'sub IF_SIZE () {8;}' unless defined(&IF_SIZE);
    if(defined(&_KERNEL)) {
    } else {
	unless(defined(&etherbroadcastaddr)) {
	}
	unless(defined(&ie5_broadcastaddr)) {
	}
	unless(defined(&fddi_broadcastaddr)) {
	}
    }
    eval 'sub RW_LOCKINIT {
        my($lock, $size, $type, $malloc_flags, $lock_flags, $class, $occurrence) = @_;
	    eval q({  &NET_MALLOC(($lock), \'struct rw_lock\' *, ($size), ($type), ($malloc_flags));  &lock_alloc((($lock)-> &simple_lock), ($lock_flags), ($class), ($occurrence));  &simple_lock_init((($lock)-> &simple_lock)); ($lock)-> &read_cnt = 0; });
    }' unless defined(&RW_LOCKINIT);
    eval 'sub RW_WRITE_LOCK {
        my($lock, $old_pri, $new_pri) = @_;
	    eval q({ ($old_pri) =  &disable_lock(($new_pri), (($lock)-> &simple_lock)); {  &volatile \'int\' * &myvalptr = ($lock)-> &read_cnt;  &while (* &myvalptr); } });
    }' unless defined(&RW_WRITE_LOCK);
    eval 'sub RW_WRITE_UNLOCK {
        my($lock, $old_pri) = @_;
	    eval q( &unlock_enable(($old_pri), (($lock)-> &simple_lock)););
    }' unless defined(&RW_WRITE_UNLOCK);
    eval 'sub RW_READ_LOCK {
        my($lock, $old_pri, $new_pri, $read_pri) = @_;
	    eval q({ ($read_pri) =  &i_disable($new_pri); ($old_pri) =  &disable_lock(($new_pri), (($lock)-> &simple_lock));  &fetch_and_add((($lock)-> &read_cnt), 1);  &unlock_enable(($old_pri), (($lock)-> &simple_lock)); });
    }' unless defined(&RW_READ_LOCK);
    eval 'sub RW_READ_UNLOCK {
        my($lock, $old_pri) = @_;
	    eval q({  &fetch_and_add((($lock)-> &read_cnt), -1);  &i_enable($old_pri); });
    }' unless defined(&RW_READ_UNLOCK);
    eval 'sub RW_READ_UNLOCK_TEMP {
        my($lock) = @_;
	    eval q( &fetch_and_add((($lock)-> &read_cnt), -1););
    }' unless defined(&RW_READ_UNLOCK_TEMP);
}
1;
