require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_IF_FDDI_H)) {
    eval 'sub _NETINET_IF_FDDI_H () {1;}' unless defined(&_NETINET_IF_FDDI_H);
    unless(defined(&_SYS_CDLI_H)) {
	require 'sys/cdli.ph';
    }
    unless(defined(&_NET_ND_LAN_H)) {
	require 'net/nd_lan.ph';
    }
    eval 'sub FCF_FDDI () {0x50;}' unless defined(&FCF_FDDI);
    eval 'sub FCF_FDDI_IPV6 () {0x51;}' unless defined(&FCF_FDDI_IPV6);
    eval 'sub FDDI_ADDRLEN () {6;}' unless defined(&FDDI_ADDRLEN);
    eval 'sub FDDI_FRAMECHARS () {7;}' unless defined(&FDDI_FRAMECHARS);
    eval 'sub TRCHKFDDI () {1;}' unless defined(&TRCHKFDDI);
    eval 'sub RCF_ALL_BROADCAST () {0x8000;}' unless defined(&RCF_ALL_BROADCAST);
    eval 'sub RCF_LOCAL_BROADCAST () {0x4000;}' unless defined(&RCF_LOCAL_BROADCAST);
    eval 'sub RCF_DIRECTION () {0x80;}' unless defined(&RCF_DIRECTION);
    eval 'sub RI_PRESENT () {0x80;}' unless defined(&RI_PRESENT);
    eval 'sub route_bytes_f {
        my($mac) = @_;
	    eval q((( &ntohs(($mac)-> &mac_rcf_f) >> 8) & 0x1f));
    }' unless defined(&route_bytes_f);
    eval 'sub has_route_f {
        my($mac) = @_;
	    eval q((($mac)-> $mac_src_f[0] &  &RI_PRESENT));
    }' unless defined(&has_route_f);
    eval 'sub is_broadcast_f {
        my($mac) = @_;
	    eval q(( &has_route_f($mac)  && ( &ntohs(($mac)-> &mac_rcf_f) & ( &RCF_LOCAL_BROADCAST |  &RCF_ALL_BROADCAST))));
    }' unless defined(&is_broadcast_f);
    eval 'sub mac_fcf_f () { ($_First->{Mac_fcf});}' unless defined(&mac_fcf_f);
    eval 'sub mac_dst_f () { ($_First->{Mac_dst});}' unless defined(&mac_dst_f);
    eval 'sub mac_src_f () { ($_First->{Mac_src});}' unless defined(&mac_src_f);
    eval 'sub mac_rcf_f () { ($_Variable->{Mac_rcf});}' unless defined(&mac_rcf_f);
    eval 'sub mac_seg_f () { ($_Variable->{Mac_seg});}' unless defined(&mac_seg_f);
    eval 'sub mac_to_llc_f {
        my($mac) = @_;
	    eval q( (( ($mac)) +  &mac_size_f($mac)));
    }' unless defined(&mac_to_llc_f);
    eval 'sub mac_size_f {
        my($mac) = @_;
	    eval q(($sizeof{($mac)-> &_First} + ( &has_route_f(($mac)) ?  &route_bytes_f(($mac)) : 0)));
    }' unless defined(&mac_size_f);
    eval 'sub _FDDI_TYPE_IP () { &SNAP_TYPE_IP;}' unless defined(&_FDDI_TYPE_IP);
    eval 'sub _FDDI_TYPE_ARP () { &SNAP_TYPE_ARP;}' unless defined(&_FDDI_TYPE_ARP);
    eval 'sub DSAP_NETWARE_FDDI () { &DSAP_APPLETALK;}' unless defined(&DSAP_NETWARE_FDDI);
    eval 'sub SSAP_NETWARE_FDDI () { &DSAP_APPLETALK;}' unless defined(&SSAP_NETWARE_FDDI);
    eval 'sub _FDDI_MTU () {4352;}' unless defined(&_FDDI_MTU);
    eval 'sub arp_hrd () { ($ea_hdr->{ar_hrd});}' unless defined(&arp_hrd);
    eval 'sub arp_pro () { ($ea_hdr->{ar_pro});}' unless defined(&arp_pro);
    eval 'sub arp_hln () { ($ea_hdr->{ar_hln});}' unless defined(&arp_hln);
    eval 'sub arp_pln () { ($ea_hdr->{ar_pln});}' unless defined(&arp_pln);
    eval 'sub arp_op () { ($ea_hdr->{ar_op});}' unless defined(&arp_op);
    if(defined(&_KERNEL)) {
	if(defined(&IP_MULTICAST)) {
	    eval 'sub FDDI_MAP_IP_MULTICAST {
	        my($ipaddr, $fdaddr) = @_;
    		eval q({ [0] = 0x80; [1] = 0x; [2] = 0x7a; [3] =  $bit_reverse[[1]] & 0xfe; [4] =  $bit_reverse[[2]]; [5] =  $bit_reverse[($ipaddr)[3]]; });
	    }' unless defined(&FDDI_MAP_IP_MULTICAST);
	}
	eval 'sub FDDI_FILLIN_HDR_IPV6 {
	    my($macp, $srcp, $destp, $rcf, $segp) = @_;
    	    eval q({ *(\'struct char6\' {\'char\'  $x[6];}*)($macp)-> &mac_dst_f = *($destp); *($macp)-> &mac_src_f = *; -> &mac_fcf_f =  &FCF_FDDI_IPV6;  &if () { -> $mac_src_f[0] |=  &RI_PRESENT; -> &mac_rcf_f = ;  &if ()  &bcopy(, -> &mac_seg_f,  &mac_size_f());  &else  &bzero(-> &mac_seg_f,  &mac_size_f()); }  &else -> $mac_src_f[0] &= ~ &RI_PRESENT;  &ie2_llc((($macp))+ &mac_size_f(($macp)),  &htons( &ETHERTYPE_IPV6)); });
	}' unless defined(&FDDI_FILLIN_HDR_IPV6);
	eval 'sub FDDI_FILLIN_HDR {
	    my($macp, $srcp, $destp, $rcf, $segp) = @_;
    	    eval q({ *(\'struct char6\' {\'char\'  $x[6];}*)($macp)-> &mac_dst_f = *($destp); *($macp)-> &mac_src_f = *; -> &mac_fcf_f =  &FCF_FDDI;  &if () { -> $mac_src_f[0] |=  &RI_PRESENT; -> &mac_rcf_f = ;  &if ()  &bcopy(, -> &mac_seg_f,  &mac_size_f());  &else  &bzero(-> &mac_seg_f,  &mac_size_f()); }  &else -> $mac_src_f[0] &= ~ &RI_PRESENT;  &ie2_llc((($macp))+ &mac_size_f(($macp)),  &htons( &_FDDI_TYPE_IP)); });
	}' unless defined(&FDDI_FILLIN_HDR);
    }
}
1;
