require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_IN_VAR_H_)) {
    eval 'sub _IN_VAR_H_ () {1;}' unless defined(&_IN_VAR_H_);
    eval 'sub ia_ifp () { ($ia_ifa->{ifa_ifp});}' unless defined(&ia_ifp);
    eval 'sub ia_flags () { ($ia_ifa->{ifa_flags});}' unless defined(&ia_flags);
    eval 'sub ia_broadaddr () { &ia_dstaddr;}' unless defined(&ia_broadaddr);
    eval 'sub ifra_dstaddr () { &ifra_broadaddr;}' unless defined(&ifra_dstaddr);
    eval 'sub IA_SIN {
        my($ia) = @_;
	    eval q((((($ia))-> &ia_addr)));
    }' unless defined(&IA_SIN);
    if(defined(&_KERNEL)) {
	if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
	    eval 'sub INIFADDR_LOCKINIT () {
	        eval q( &RW_LOCKINIT( &inifaddr_lock, 128,  &M_LOCKF,  &M_WAITOK,  &LOCK_ALLOC_PIN,  &INIFADDR_LOCK_FAMILY, -1););
	    }' unless defined(&INIFADDR_LOCKINIT);
	    eval 'sub INIFADDR_LOCK_DECL () {
	        eval q(\'int\'  &_inifl,  &_inifrl;);
	    }' unless defined(&INIFADDR_LOCK_DECL);
	    eval 'sub INIFADDR_WRITE_LOCK () {
	        eval q( &RW_WRITE_LOCK( &inifaddr_lock,  &_inifl,  &PL_IMP));
	    }' unless defined(&INIFADDR_WRITE_LOCK);
	    eval 'sub INIFADDR_WRITE_UNLOCK () {
	        eval q( &RW_WRITE_UNLOCK( &inifaddr_lock,  &_inifl));
	    }' unless defined(&INIFADDR_WRITE_UNLOCK);
	    eval 'sub INIFADDR_READ_LOCK () {
	        eval q( &RW_READ_LOCK( &inifaddr_lock,  &_inifl,  &PL_IMP,  &_inifrl));
	    }' unless defined(&INIFADDR_READ_LOCK);
	    eval 'sub INIFADDR_READ_UNLOCK () {
	        eval q( &RW_READ_UNLOCK( &inifaddr_lock,  &_inifrl));
	    }' unless defined(&INIFADDR_READ_UNLOCK);
	} else {
	    eval 'sub INIFADDR_LOCKINIT () {
	        eval q();
	    }' unless defined(&INIFADDR_LOCKINIT);
	    eval 'sub INIFADDR_WRITE_LOCK () {
	        eval q();
	    }' unless defined(&INIFADDR_WRITE_LOCK);
	    eval 'sub INIFADDR_READ_LOCK () {
	        eval q();
	    }' unless defined(&INIFADDR_READ_LOCK);
	    eval 'sub INIFADDR_WRITE_UNLOCK () {
	        eval q();
	    }' unless defined(&INIFADDR_WRITE_UNLOCK);
	    eval 'sub INIFADDR_READ_UNLOCK () {
	        eval q();
	    }' unless defined(&INIFADDR_READ_UNLOCK);
	}
    }
    if(defined(&IP_MULTICAST)) {
	if(defined(&_KERNEL)) {
	    eval 'sub INADDR_TO_IFP {
	        my($addr, $ifp) = @_;
    		eval q({  &register \'struct in_ifaddr\' * &ia;  &INIFADDR_READ_LOCK();  &for ( &ia =  &in_ifaddr;  &ia !=  &NULL  &&  &IA_SIN( &ia)-> ($sin_addr->{s_addr}) != ($addr). &s_addr;  &ia =  ($ia->{ia_next})); ($ifp) = ( &ia ==  &NULL) ?  &NULL :  ($ia->{ia_ifp});  &INIFADDR_READ_UNLOCK(); });
	    }' unless defined(&INADDR_TO_IFP);
	    eval 'sub IFP_TO_IA {
	        my($ifp, $ia) = @_;
    		eval q({  &INIFADDR_READ_LOCK();  &for (($ia) =  &in_ifaddr; ($ia) !=  &NULL  && ($ia)-> &ia_ifp != ($ifp); ($ia) = ($ia)-> &ia_next);  &INIFADDR_READ_UNLOCK(); });
	    }' unless defined(&IFP_TO_IA);
	    if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
		eval 'sub IN_LOOKUP_MULTI {
		    my($addr, $ifp, $inm) = @_;
    		    eval q({  &IFMULTI_LOCK($ifp);  &for (($inm) =  ($ifp->{if_multiaddrs}); ($inm) !=  &NULL  && ($inm)-> ($inm_addr->{s_addr}) != ($addr). &s_addr; ($inm) =  ($inm->{inm_next}));  &IFMULTI_UNLOCK($ifp); });
		}' unless defined(&IN_LOOKUP_MULTI);
	    } else {
		eval 'sub IN_LOOKUP_MULTI {
		    my($addr, $ifp, $inm) = @_;
    		    eval q({  &for (($inm) =  ($ifp->{if_multiaddrs}); ($inm) !=  &NULL  && ($inm)-> ($inm_addr->{s_addr}) != ($addr). &s_addr; ($inm) =  ($inm->{inm_next})); });
		}' unless defined(&IN_LOOKUP_MULTI);
	    }
	    eval 'sub IN_LOOKUP_MULTI_NOLOCK {
	        my($addr, $ifp, $inm) = @_;
    		eval q({  &for (($inm) =  ($ifp->{if_multiaddrs}); ($inm) !=  &NULL  && ($inm)-> ($inm_addr->{s_addr}) != ($addr). &s_addr; ($inm) =  ($inm->{inm_next})); });
	    }' unless defined(&IN_LOOKUP_MULTI_NOLOCK);
	    if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
		eval 'sub UNLOCK_LAST_MULTI {
		    my($step) = @_;
    		    eval q( &if(($step). &i_lastif)  &IFMULTI_UNLOCK_RECURSIVE(($step). &i_lastif));
		}' unless defined(&UNLOCK_LAST_MULTI);
	    } else {
		eval 'sub UNLOCK_LAST_MULTI {
		    my($step) = @_;
    		    eval q();
		}' unless defined(&UNLOCK_LAST_MULTI);
	    }
	    eval 'sub IN_NEXT_MULTI {
	        my($step, $inm) = @_;
    		eval q({  &if ((($inm) = ($step). &i_inm) !=  &NULL) { ($step). &i_inm = ($inm)-> &inm_next; }  &else  &while (($step). &i_if !=  &NULL) {  &UNLOCK_LAST_MULTI($step);  &IFMULTI_LOCK_RECURSIVE(($step). &i_if); ($inm) = ($step). ($i_if->{if_multiaddrs}); ($step). &i_lastif = ($step). &i_if; ($step). &i_if = ($step). ($i_if->{if_next});  &if (($inm) !=  &NULL) { ($step). &i_inm = ($inm)-> &inm_next;  &break; } } });
	    }' unless defined(&IN_NEXT_MULTI);
	    eval 'sub IN_FIRST_MULTI {
	        my($step, $inm) = @_;
    		eval q({ ($step). &i_if =  &ifnet; ($step). &i_inm =  &NULL; ($step). &i_lastif =  &NULL;  &IN_NEXT_MULTI(($step), ($inm)); });
	    }' unless defined(&IN_FIRST_MULTI);
	}
    }
    eval 'sub INADDR_HASHSZ () {229;}' unless defined(&INADDR_HASHSZ);
    eval 'sub INADDR_HASH2 {
        my($addr) = @_;
	    eval q((($addr) %  &INADDR_HASHSZ));
    }' unless defined(&INADDR_HASH2);
    eval 'sub IAH_VALID () {0x1;}' unless defined(&IAH_VALID);
    eval 'sub IAH_BROADCAST () {0x2;}' unless defined(&IAH_BROADCAST);
    eval 'sub INADDR_HASH_LOCK_DECL () {
        eval q(\'int\'  &_iahl;);
    }' unless defined(&INADDR_HASH_LOCK_DECL);
    eval 'sub INADDR_HASH_LOCK_INIT () {
        eval q({  &lock_alloc( &in_addr_hash_lock,  &LOCK_ALLOC_PIN,  &INADDR_HASH_LOCK_FAMILY, -1);  &simple_lock_init( &in_addr_hash_lock); });
    }' unless defined(&INADDR_HASH_LOCK_INIT);
    eval 'sub INADDR_HASH_READ_LOCK () {
        eval q();
    }' unless defined(&INADDR_HASH_READ_LOCK);
    eval 'sub INADDR_HASH_WRITE_LOCK () {
        eval q( &_iahl =  &disable_lock( &PL_IMP,  &in_addr_hash_lock));
    }' unless defined(&INADDR_HASH_WRITE_LOCK);
    eval 'sub INADDR_HASH_READ_UNLOCK () {
        eval q();
    }' unless defined(&INADDR_HASH_READ_UNLOCK);
    eval 'sub INADDR_HASH_WRITE_UNLOCK () {
        eval q( &unlock_enable( &_iahl,  &in_addr_hash_lock));
    }' unless defined(&INADDR_HASH_WRITE_UNLOCK);
}
1;
