require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&icmp_pptr)) {
    sub icmp_pptr () {	 ($icmp_hun->{ih_pptr});}
}
unless(defined(&icmp_gwaddr)) {
    sub icmp_gwaddr () {	 ($icmp_hun->{ih_gwaddr});}
}
unless(defined(&icmp_id)) {
    sub icmp_id () {	 ($icmp_hun->{ih_idseq}->{icd_id});}
}
unless(defined(&icmp_seq)) {
    sub icmp_seq () {	 ($icmp_hun->{ih_idseq}->{icd_seq});}
}
unless(defined(&icmp_void)) {
    sub icmp_void () {	 ($icmp_hun->{ih_void});}
}
unless(defined(&icmp_pmvoid)) {
    sub icmp_pmvoid () {	 ($icmp_hun->{ih_pmtu}->{ipm_void});}
}
unless(defined(&icmp_nextmtu)) {
    sub icmp_nextmtu () {	 ($icmp_hun->{ih_pmtu}->{ipm_nextmtu});}
}
unless(defined(&icmp_otime)) {
    sub icmp_otime () {	 ($icmp_dun->{id_ts}->{its_otime});}
}
unless(defined(&icmp_rtime)) {
    sub icmp_rtime () {	 ($icmp_dun->{id_ts}->{its_rtime});}
}
unless(defined(&icmp_ttime)) {
    sub icmp_ttime () {	 ($icmp_dun->{id_ts}->{its_ttime});}
}
unless(defined(&icmp_ip)) {
    sub icmp_ip () {	 ($icmp_dun->{id_ip}->{idi_ip});}
}
unless(defined(&icmp_mask)) {
    sub icmp_mask () {	 ($icmp_dun->{id_mask});}
}
unless(defined(&icmp_data)) {
    sub icmp_data () {	 ($icmp_dun->{id_data});}
}
unless(defined(&icmp_magic_number)) {
    sub icmp_magic_number () {	 ($icmp_dun->{ip_extid}->{magic_number});}
}
unless(defined(&icmp_subid)) {
    sub icmp_subid () {	 ($icmp_dun->{ip_extid}->{subid});}
}
unless(defined(&icmp_pktid)) {
    sub icmp_pktid () {	 ($icmp_dun->{ip_extid}->{pktid});}
}
unless(defined(&ICMP_MAGIC_NUMBER)) {
    sub ICMP_MAGIC_NUMBER () {	0x7676;}
}
unless(defined(&ICMP_EXTID)) {
    sub ICMP_EXTID () {	(1);}
}
unless(defined(&ICMP_ECH_PING)) {
    sub ICMP_ECH_PING () {	(1);}
}
unless(defined(&ICMP_MINLEN)) {
    sub ICMP_MINLEN () {	8;}
}
unless(defined(&ICMP_MAXLEN)) {
    sub ICMP_MAXLEN () {	65515;}
}
unless(defined(&ICMP_TSLEN)) {
    sub ICMP_TSLEN () {	(8+ 3* $sizeof{ &n_time});}
}
unless(defined(&ICMP_MASKLEN)) {
    sub ICMP_MASKLEN () {	12;}
}
unless(defined(&ICMP_ADVLENMIN)) {
    sub ICMP_ADVLENMIN () {	(8+ $sizeof{'struct ip'} + 8);}
}
unless(defined(&ICMP_ADVLEN)) {
    sub ICMP_ADVLEN {
	my($p) = @_;
	eval q((8+ ((($p)-> ($icmp_ip->{i$p_vhl}) & 0xf) << 2) + 8));
    }
}
unless(defined(&ICMP_ECHOREPLY)) {
    sub ICMP_ECHOREPLY () {	0;}
}
unless(defined(&ICMP_UNREACH)) {
    sub ICMP_UNREACH () {	3;}
}
unless(defined(&ICMP_UNREACH_NET)) {
    sub ICMP_UNREACH_NET () {	0;}
}
unless(defined(&ICMP_UNREACH_HOST)) {
    sub ICMP_UNREACH_HOST () {	1;}
}
unless(defined(&ICMP_UNREACH_PROTOCOL)) {
    sub ICMP_UNREACH_PROTOCOL () {	2;}
}
unless(defined(&ICMP_UNREACH_PORT)) {
    sub ICMP_UNREACH_PORT () {	3;}
}
unless(defined(&ICMP_UNREACH_NEEDFRAG)) {
    sub ICMP_UNREACH_NEEDFRAG () {	4;}
}
unless(defined(&ICMP_UNREACH_SRCFAIL)) {
    sub ICMP_UNREACH_SRCFAIL () {	5;}
}
unless(defined(&ICMP_SOURCEQUENCH)) {
    sub ICMP_SOURCEQUENCH () {	4;}
}
unless(defined(&ICMP_REDIRECT)) {
    sub ICMP_REDIRECT () {	5;}
}
unless(defined(&ICMP_REDIRECT_NET)) {
    sub ICMP_REDIRECT_NET () {	0;}
}
unless(defined(&ICMP_REDIRECT_HOST)) {
    sub ICMP_REDIRECT_HOST () {	1;}
}
unless(defined(&ICMP_REDIRECT_TOSNET)) {
    sub ICMP_REDIRECT_TOSNET () {	2;}
}
unless(defined(&ICMP_REDIRECT_TOSHOST)) {
    sub ICMP_REDIRECT_TOSHOST () {	3;}
}
unless(defined(&ICMP_ECHO)) {
    sub ICMP_ECHO () {	8;}
}
unless(defined(&ICMP_TIMXCEED)) {
    sub ICMP_TIMXCEED () {	11;}
}
unless(defined(&ICMP_TIMXCEED_INTRANS)) {
    sub ICMP_TIMXCEED_INTRANS () {	0;}
}
unless(defined(&ICMP_TIMXCEED_REASS)) {
    sub ICMP_TIMXCEED_REASS () {	1;}
}
unless(defined(&ICMP_PARAMPROB)) {
    sub ICMP_PARAMPROB () {	12;}
}
unless(defined(&ICMP_TSTAMP)) {
    sub ICMP_TSTAMP () {	13;}
}
unless(defined(&ICMP_TSTAMPREPLY)) {
    sub ICMP_TSTAMPREPLY () {	14;}
}
unless(defined(&ICMP_IREQ)) {
    sub ICMP_IREQ () {	15;}
}
unless(defined(&ICMP_IREQREPLY)) {
    sub ICMP_IREQREPLY () {	16;}
}
unless(defined(&ICMP_MASKREQ)) {
    sub ICMP_MASKREQ () {	17;}
}
unless(defined(&ICMP_MASKREPLY)) {
    sub ICMP_MASKREPLY () {	18;}
}
unless(defined(&ICMP_MAXTYPE)) {
    sub ICMP_MAXTYPE () {	18;}
}
unless(defined(&ICMP_INFOTYPE)) {
    sub ICMP_INFOTYPE {
	my($type) = @_;
	eval q((($type) ==  &ICMP_ECHOREPLY || ($type) ==  &ICMP_ECHO || ($type) ==  &ICMP_TSTAMP || ($type) ==  &ICMP_TSTAMPREPLY || ($type) ==  &ICMP_IREQ || ($type) ==  &ICMP_IREQREPLY || ($type) ==  &ICMP_MASKREQ || ($type) ==  &ICMP_MASKREPLY));
    }
}
1;
