require '_h2ph_pre.ph';

no warnings 'redefine';

require 'netinet/tcpip.ph';
unless(defined(&_TCP_VAR_H_)) {
    eval 'sub _TCP_VAR_H_ () {1;}' unless defined(&_TCP_VAR_H_);
    eval 'sub INI_SACK_BLOCKS () {10;}' unless defined(&INI_SACK_BLOCKS);
    eval 'sub SEGS_ACKED {
        my($len, $tp) = @_;
	    eval q((($len)/($tp)-> &t_maxseg+((($len)%($tp)-> &t_maxseg)?1:0)));
    }' unless defined(&SEGS_ACKED);
    eval 'sub INI_SACK_HOLES () {9;}' unless defined(&INI_SACK_HOLES);
    eval 'sub seg_next () { ($tcpcb_next->{seg_next_4});}' unless defined(&seg_next);
    eval 'sub seg_next6 () { ($tcpcb_next->{seg_next_6});}' unless defined(&seg_next6);
    eval 'sub seg_prev () { ($tcpcb_prev->{seg_prev_4});}' unless defined(&seg_prev);
    eval 'sub seg_prev6 () { ($tcpcb_prev->{seg_prev_6});}' unless defined(&seg_prev6);
    eval 'sub TF_ACKNOW () {0x1;}' unless defined(&TF_ACKNOW);
    eval 'sub TF_DELACK () {0x2;}' unless defined(&TF_DELACK);
    eval 'sub TF_NODELAY () {0x4;}' unless defined(&TF_NODELAY);
    eval 'sub TF_NOOPT () {0x8;}' unless defined(&TF_NOOPT);
    eval 'sub TF_SENTFIN () {0x10;}' unless defined(&TF_SENTFIN);
    eval 'sub TF_RFC1323 () {0x20;}' unless defined(&TF_RFC1323);
    eval 'sub TF_SENT_WS () {0x40;}' unless defined(&TF_SENT_WS);
    eval 'sub TF_RCVD_WS () {0x80;}' unless defined(&TF_RCVD_WS);
    eval 'sub TF_SENT_TS () {0x100;}' unless defined(&TF_SENT_TS);
    eval 'sub TF_RCVD_TS () {0x200;}' unless defined(&TF_RCVD_TS);
    eval 'sub TF_STDURG () {0x400;}' unless defined(&TF_STDURG);
    eval 'sub TF_DELAY_ACK () {0x800;}' unless defined(&TF_DELAY_ACK);
    eval 'sub TF_FASTRXMT_PHASE () {0x1000;}' unless defined(&TF_FASTRXMT_PHASE);
    eval 'sub TF_NEWRENO_RXMT () {0x2000;}' unless defined(&TF_NEWRENO_RXMT);
    eval 'sub TF_SACK_PROCESS () {0x4000;}' unless defined(&TF_SACK_PROCESS);
    eval 'sub TF_SACK_GENERATE () {0x8000;}' unless defined(&TF_SACK_GENERATE);
    eval 'sub TF_ECN () {0x10000;}' unless defined(&TF_ECN);
    eval 'sub TF_SEND_ECHO () {0x20000;}' unless defined(&TF_SEND_ECHO);
    eval 'sub TF_SEND_CWR () {0x40000;}' unless defined(&TF_SEND_CWR);
    eval 'sub TF_LARGESEND () {0x80000;}' unless defined(&TF_LARGESEND);
    eval 'sub TF_COPYFLAGS () {( &TF_NODELAY| &TF_RFC1323| &TF_STDURG);}' unless defined(&TF_COPYFLAGS);
    eval 'sub TCPOOB_HAVEDATA () {0x1;}' unless defined(&TCPOOB_HAVEDATA);
    eval 'sub TCPOOB_HADDATA () {0x2;}' unless defined(&TCPOOB_HADDATA);
    eval 'sub SACKGenerateEnabled {
        my($tp) = @_;
	    eval q((($tp)-> &t_flags &  &TF_SACK_GENERATE));
    }' unless defined(&SACKGenerateEnabled);
    eval 'sub SACKProcessEnabled {
        my($tp) = @_;
	    eval q((($tp)-> &t_flags &  &TF_SACK_PROCESS));
    }' unless defined(&SACKProcessEnabled);
    eval 'sub SPLICE_EOF () {1;}' unless defined(&SPLICE_EOF);
    eval 'sub SPLICED_SOCK1 () {2;}' unless defined(&SPLICED_SOCK1);
    eval 'sub HasSACKInfo {
        my($tp) = @_;
	    eval q((($tp)-> &sack_data !=  &NULL));
    }' unless defined(&HasSACKInfo);
    eval 'sub SACKBlocksP {
        my($tp) = @_;
	    eval q(((($tp)-> ($sack_data->{sack_blocks[0]}))));
    }' unless defined(&SACKBlocksP);
    eval 'sub MaxSACKBlocks {
        my($tp) = @_;
	    eval q((($tp)-> ($sack_data->{max_sack_blocks})));
    }' unless defined(&MaxSACKBlocks);
    eval 'sub UsedSACKBlocks {
        my($tp) = @_;
	    eval q((($tp)-> ($sack_data->{used_sack_blocks})));
    }' unless defined(&UsedSACKBlocks);
    eval 'sub FirstSACKBlock {
        my($tp) = @_;
	    eval q((($tp)-> ($sack_data->{last_sack_block_updated})));
    }' unless defined(&FirstSACKBlock);
    eval 'sub NextSACKBlock {
        my($tp) = @_;
	    eval q((($tp)-> ($sack_data->{next_sack_block2send})));
    }' unless defined(&NextSACKBlock);
    eval 'sub HighestUnSACKed {
        my($tp) = @_;
	    eval q((($tp)-> ($sack_data->{highest_sacked})));
    }' unless defined(&HighestUnSACKed);
    eval 'sub SACKHolesP {
        my($tp) = @_;
	    eval q((( &SackHole *)(($tp)-> ($sack_data->{sack_blocks[MaxSACKBlocks($tp)]}))));
    }' unless defined(&SACKHolesP);
    eval 'sub MaxSACKHoles {
        my($tp) = @_;
	    eval q((($tp)-> ($sack_data->{max_sack_holes})));
    }' unless defined(&MaxSACKHoles);
    eval 'sub UsedSACKHoles {
        my($tp) = @_;
	    eval q((($tp)-> ($sack_data->{used_sack_holes})));
    }' unless defined(&UsedSACKHoles);
    eval 'sub intotcpcb {
        my($ip) = @_;
	    eval q((($ip)-> &inp_ppcb));
    }' unless defined(&intotcpcb);
    eval 'sub sototcpcb {
        my($so) = @_;
	    eval q(( &intotcpcb( &sotoinpcb($so))));
    }' unless defined(&sototcpcb);
    if(defined(&MEMSAVE)) {
	eval 'sub inp2tcpcb {
	    my($inp) = @_;
    	    eval q( (($inp) + 1));
	}' unless defined(&inp2tcpcb);
    }
    eval 'sub TCP_RTT_SCALE () {8;}' unless defined(&TCP_RTT_SCALE);
    eval 'sub TCP_RTT_SHIFT () {3;}' unless defined(&TCP_RTT_SHIFT);
    eval 'sub TCP_RTTVAR_SCALE () {4;}' unless defined(&TCP_RTTVAR_SCALE);
    eval 'sub TCP_RTTVAR_SHIFT () {2;}' unless defined(&TCP_RTTVAR_SHIFT);
    eval 'sub TCP_REXMTVAL {
        my($tp) = @_;
	    eval q(((($tp)-> &t_srtt >>  &TCP_RTT_SHIFT) + ($tp)-> &t_rttvar));
    }' unless defined(&TCP_REXMTVAL);
    eval 'sub TCP_INITIAL_WINDOW {
        my($init_window, $mss) = @_;
	    eval q(((($init_window) == 0) ? ( &MIN(4* ($mss),  &MAX(2* ($mss), 4380))) : (($mss) * ($init_window))));
    }' unless defined(&TCP_INITIAL_WINDOW);
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub REASS_MBUF {
	    my($ti) = @_;
    	    eval q((*(($ti)-> &ti_t)));
	}' unless defined(&REASS_MBUF);
    }
    if(defined( &_KERNEL)  && (defined(&LOCK_NETSTATS) ? &LOCK_NETSTATS : 0)) {
    }
    if(defined( &_KERNEL)  && (defined(&LOCK_NETSTATS) ? &LOCK_NETSTATS : 0)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub TIMESTAMP_RECEIVED () {1;}' unless defined(&TIMESTAMP_RECEIVED);
	eval 'sub TCPAH_RECEIVED () {2;}' unless defined(&TCPAH_RECEIVED);
	eval 'sub SACK_RECEIVED () {4;}' unless defined(&SACK_RECEIVED);
	eval 'sub TCPACL_LOCKINIT () {
	    eval q({  &lock_alloc( ($tcpacl->{tcpa_lock}),  &LOCK_ALLOC_PIN,  &TCPMISC_LOCK_FAMILY,-1);  &simple_lock_init( ($tcpacl->{tcpa_lock})); });
	}' unless defined(&TCPACL_LOCKINIT);
	eval 'sub TCPACL_LOCK_DECL () {
	    eval q(\'int\'  &_tcpal;);
	}' unless defined(&TCPACL_LOCK_DECL);
	eval 'sub TCPACL_LOCK () {
	    eval q( &simple_lock( ($tcpacl->{tcpa_lock})));
	}' unless defined(&TCPACL_LOCK);
	eval 'sub TCPACL_UNLOCK () {
	    eval q( &simple_unlock( ($tcpacl->{tcpa_lock})));
	}' unless defined(&TCPACL_UNLOCK);
	if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
	    eval 'sub TCPMISC_LOCKINIT () {
	        eval q({  &lock_alloc( &misc_tcp_lock,  &LOCK_ALLOC_PIN,  &TCPMISC_LOCK_FAMILY, -1);  &simple_lock_init( &misc_tcp_lock); });
	    }' unless defined(&TCPMISC_LOCKINIT);
	    eval 'sub TCPMISC_LOCK_DECL () {
	        eval q(\'int\'  &_tcpml;);
	    }' unless defined(&TCPMISC_LOCK_DECL);
	    eval 'sub TCPMISC_LOCK () {
	        eval q( &_tcpml =  &disable_lock( &PL_IMP,  &misc_tcp_lock));
	    }' unless defined(&TCPMISC_LOCK);
	    eval 'sub TCPMISC_UNLOCK () {
	        eval q( &unlock_enable( &_tcpml,  &misc_tcp_lock));
	    }' unless defined(&TCPMISC_UNLOCK);
	} else {
	    eval 'sub TCPMISC_LOCKINIT () {
	        eval q();
	    }' unless defined(&TCPMISC_LOCKINIT);
	    eval 'sub TCPMISC_LOCK () {
	        eval q();
	    }' unless defined(&TCPMISC_LOCK);
	    eval 'sub TCPMISC_UNLOCK () {
	        eval q();
	    }' unless defined(&TCPMISC_UNLOCK);
	}
	eval 'sub TCP_EPHEMERAL_LOW_DFLT () {32768;}' unless defined(&TCP_EPHEMERAL_LOW_DFLT);
	eval 'sub TCP_EPHEMERAL_HIGH_DFLT () {65535;}' unless defined(&TCP_EPHEMERAL_HIGH_DFLT);
	eval 'sub TCP_NAGLE_LIMIT () {65535;}' unless defined(&TCP_NAGLE_LIMIT);
    }
}
1;
