require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&_ONCPLUS)) {
    require 'oncplus/nfs/nfs.ph';
} else {
    unless(defined(&__NFS_HEADER__)) {
	eval 'sub __NFS_HEADER__ () {1;}' unless defined(&__NFS_HEADER__);
	eval 'sub NFS_MAXDATA () {8192;}' unless defined(&NFS_MAXDATA);
	eval 'sub NFS_MAXNAMLEN () {255;}' unless defined(&NFS_MAXNAMLEN);
	eval 'sub NFS_MAXPATHLEN () {1024;}' unless defined(&NFS_MAXPATHLEN);
	eval 'sub NFS_TIMEO () {11;}' unless defined(&NFS_TIMEO);
	eval 'sub NFS_RETRIES () {5;}' unless defined(&NFS_RETRIES);
	eval 'sub ECTSIZE () {4096;}' unless defined(&ECTSIZE);
	eval 'sub IETSIZE () {8192;}' unless defined(&IETSIZE);
	eval 'sub NFS_SOCKET_SZ_DEFAULT () {60000;}' unless defined(&NFS_SOCKET_SZ_DEFAULT);
	eval 'sub NFS_WRGATHER_SZ_DEFAULT () {4096;}' unless defined(&NFS_WRGATHER_SZ_DEFAULT);
	eval 'sub NFS_PORTMON_DEFAULT () {0;}' unless defined(&NFS_PORTMON_DEFAULT);
	eval 'sub NFS_SETATTR_ERR_DEFAULT () {0;}' unless defined(&NFS_SETATTR_ERR_DEFAULT);
	eval 'sub NFS_CHKSUM_DEFAULT () {1;}' unless defined(&NFS_CHKSUM_DEFAULT);
	eval 'sub NFS_REPEAT_MSG_DEFAULT () {0;}' unless defined(&NFS_REPEAT_MSG_DEFAULT);
	eval 'sub NFS_DUPCACHE_SIZE_DEFAULT () {1000;}' unless defined(&NFS_DUPCACHE_SIZE_DEFAULT);
	eval 'sub NFS_DEFAULT_BASE_PRIORITY () {65;}' unless defined(&NFS_DEFAULT_BASE_PRIORITY);
	eval 'sub NFS_DYNAMIC_RETRANS_DEFAULT () {1;}' unless defined(&NFS_DYNAMIC_RETRANS_DEFAULT);
	eval 'sub NFS_CLIENT_IOPACE_PAGES () {32;}' unless defined(&NFS_CLIENT_IOPACE_PAGES);
	eval("sub NFS_OK () { 0; }") unless defined(&NFS_OK);
	eval("sub NFSERR_PERM () { EPERM; }") unless defined(&NFSERR_PERM);
	eval("sub NFSERR_NOENT () { ENOENT; }") unless defined(&NFSERR_NOENT);
	eval("sub NFSERR_IO () { EIO; }") unless defined(&NFSERR_IO);
	eval("sub NFSERR_NXIO () { ENXIO; }") unless defined(&NFSERR_NXIO);
	eval("sub NFSERR_ACCES () { EACCES; }") unless defined(&NFSERR_ACCES);
	eval("sub NFSERR_EXIST () { EEXIST; }") unless defined(&NFSERR_EXIST);
	eval("sub NFSERR_NODEV () { ENODEV; }") unless defined(&NFSERR_NODEV);
	eval("sub NFSERR_NOTDIR () { ENOTDIR; }") unless defined(&NFSERR_NOTDIR);
	eval("sub NFSERR_ISDIR () { EISDIR; }") unless defined(&NFSERR_ISDIR);
	eval("sub NFSERR_FBIG () { EFBIG; }") unless defined(&NFSERR_FBIG);
	eval("sub NFSERR_NOSPC () { ENOSPC; }") unless defined(&NFSERR_NOSPC);
	eval("sub NFSERR_ROFS () { EROFS; }") unless defined(&NFSERR_ROFS);
	eval("sub NFSERR_NAMETOOLONG () { ENAMETOOLONG; }") unless defined(&NFSERR_NAMETOOLONG);
	eval("sub NFSERR_NOTEMPTY () { ENOTEMPTY; }") unless defined(&NFSERR_NOTEMPTY);
	eval("sub NFSERR_DQUOT () { EDQUOT; }") unless defined(&NFSERR_DQUOT);
	eval("sub NFSERR_STALE () { ESTALE; }") unless defined(&NFSERR_STALE);
	eval("sub NFSERR_WFLUSH () { 1; }") unless defined(&NFSERR_WFLUSH);
	eval 'sub NFS_ELLIMIT () {34;}' unless defined(&NFS_ELLIMIT);
	eval 'sub NFS_EULIMIT () {99;}' unless defined(&NFS_EULIMIT);
	eval 'sub puterrno {
	    my($error) = @_;
    	    eval q((( &enum  &nfsstat)(($error) >  &NFS_ELLIMIT  && ($error) <  &NFS_EULIMIT ?  $_puterrno[($error) -  &NFS_ELLIMIT] : ($error))));
	}' unless defined(&puterrno);
	eval 'sub geterrno {
	    my($status) = @_;
    	    eval q(((($status) >  &NFS_ELLIMIT  && ($status) <  &NFS_EULIMIT ?  $_geterrno[($status) -  &NFS_ELLIMIT] : ((($status) &&((($status)&0xff)==0))?5:($status)))));
	}' unless defined(&geterrno);
	eval("sub NFNON () { 0; }") unless defined(&NFNON);
	eval("sub NFREG () { 1; }") unless defined(&NFREG);
	eval("sub NFDIR () { 2; }") unless defined(&NFDIR);
	eval("sub NFBLK () { 3; }") unless defined(&NFBLK);
	eval("sub NFCHR () { 4; }") unless defined(&NFCHR);
	eval("sub NFLNK () { 5; }") unless defined(&NFLNK);
	eval 'sub NFS_FIFO_TYPE () { &NFCHR;}' unless defined(&NFS_FIFO_TYPE);
	eval 'sub NFS_FIFO_MODE () { &S_IFCHR;}' unless defined(&NFS_FIFO_MODE);
	eval 'sub NFS_FIFO_DEV () {(~0);}' unless defined(&NFS_FIFO_DEV);
	eval 'sub NA_ISFIFO {
	    my($NA) = @_;
    	    eval q(((($NA)-> &na_type ==  &NFS_FIFO_TYPE)  && (($NA)-> &na_rdev ==  &NFS_FIFO_DEV)));
	}' unless defined(&NA_ISFIFO);
	eval 'sub NA_SETFIFO {
	    my($NA) = @_;
    	    eval q({ ($NA)-> &na_type =  &NFS_FIFO_TYPE; ($NA)-> &na_rdev =  &NFS_FIFO_DEV; ($NA)-> &na_mode = (($NA)-> &na_mode&~ &S_IFMT)| &NFS_FIFO_MODE; });
	}' unless defined(&NA_SETFIFO);
	eval 'sub NFS_FHSIZE () {32;}' unless defined(&NFS_FHSIZE);
	if(defined(&NFSSERVER)) {
	    eval 'sub NFS_FHMAXDATA () {(( &NFS_FHSIZE - $sizeof{\'struct fhsize\'} + 8) / 2);}' unless defined(&NFS_FHMAXDATA);
	    undef(&fh_len) if defined(&fh_len);
	} else {
	}
	eval 'sub fhandle_t () { &fhandl_t;}' unless defined(&fhandle_t);
	eval 'sub n2v_type {
	    my($x) = @_;
    	    eval q(( &NA_ISFIFO($x) ?  &VFIFO : ( &enum  &vtype)(($x)-> &na_type)));
	}' unless defined(&n2v_type);
	eval 'sub n2v_rdev {
	    my($x) = @_;
    	    eval q(( &NA_ISFIFO($x) ? 0: ($x)-> &na_rdev));
	}' unless defined(&n2v_rdev);
	eval 'sub rr_ok () { ($rr_u->{rr_ok_u});}' unless defined(&rr_ok);
	eval 'sub rr_attr () { ($rr_u->{rr_ok_u}->{rrok_attr});}' unless defined(&rr_attr);
	eval 'sub rr_count () { ($rr_u->{rr_ok_u}->{rrok_count});}' unless defined(&rr_count);
	eval 'sub rr_data () { ($rr_u->{rr_ok_u}->{rrok_data});}' unless defined(&rr_data);
	eval 'sub rr_bp () { ($rr_u->{rr_ok_u}->{rrok_bp});}' unless defined(&rr_bp);
	eval 'sub rr_vp () { ($rr_u->{rr_ok_u}->{rrok_vp});}' unless defined(&rr_vp);
	eval 'sub ns_attr () { ($ns_u->{ns_attr_u});}' unless defined(&ns_attr);
	eval 'sub rl_srok () { ($rl_u->{rl_srok_u});}' unless defined(&rl_srok);
	eval 'sub rl_count () { ($rl_u->{rl_srok_u}->{srok_count});}' unless defined(&rl_count);
	eval 'sub rl_data () { ($rl_u->{rl_srok_u}->{srok_data});}' unless defined(&rl_data);
	eval 'sub rd_rdok () { ($rd_u->{rd_rdok_u});}' unless defined(&rd_rdok);
	eval 'sub rd_offset () { ($rd_u->{rd_rdok_u}->{rdok_offset});}' unless defined(&rd_offset);
	eval 'sub rd_size () { ($rd_u->{rd_rdok_u}->{rdok_size});}' unless defined(&rd_size);
	eval 'sub rd_eof () { ($rd_u->{rd_rdok_u}->{rdok_eof});}' unless defined(&rd_eof);
	eval 'sub rd_entries () { ($rd_u->{rd_rdok_u}->{rdok_entries});}' unless defined(&rd_entries);
	eval 'sub dr_drok () { ($dr_u->{dr_drok_u});}' unless defined(&dr_drok);
	eval 'sub dr_fhandle () { ($dr_u->{dr_drok_u}->{drok_fhandle});}' unless defined(&dr_fhandle);
	eval 'sub dr_attr () { ($dr_u->{dr_drok_u}->{drok_attr});}' unless defined(&dr_attr);
	eval 'sub fs_fsok () { ($fs_u->{fs_fsok_u});}' unless defined(&fs_fsok);
	eval 'sub fs_tsize () { ($fs_u->{fs_fsok_u}->{fsok_tsize});}' unless defined(&fs_tsize);
	eval 'sub fs_bsize () { ($fs_u->{fs_fsok_u}->{fsok_bsize});}' unless defined(&fs_bsize);
	eval 'sub fs_blocks () { ($fs_u->{fs_fsok_u}->{fsok_blocks});}' unless defined(&fs_blocks);
	eval 'sub fs_bfree () { ($fs_u->{fs_fsok_u}->{fsok_bfree});}' unless defined(&fs_bfree);
	eval 'sub fs_bavail () { ($fs_u->{fs_fsok_u}->{fsok_bavail});}' unless defined(&fs_bavail);
	eval 'sub RFS_NULL () {0;}' unless defined(&RFS_NULL);
	eval 'sub RFS_GETATTR () {1;}' unless defined(&RFS_GETATTR);
	eval 'sub RFS_SETATTR () {2;}' unless defined(&RFS_SETATTR);
	eval 'sub RFS_ROOT () {3;}' unless defined(&RFS_ROOT);
	eval 'sub RFS_LOOKUP () {4;}' unless defined(&RFS_LOOKUP);
	eval 'sub RFS_READLINK () {5;}' unless defined(&RFS_READLINK);
	eval 'sub RFS_READ () {6;}' unless defined(&RFS_READ);
	eval 'sub RFS_WRITECACHE () {7;}' unless defined(&RFS_WRITECACHE);
	eval 'sub RFS_WRITE () {8;}' unless defined(&RFS_WRITE);
	eval 'sub RFS_CREATE () {9;}' unless defined(&RFS_CREATE);
	eval 'sub RFS_REMOVE () {10;}' unless defined(&RFS_REMOVE);
	eval 'sub RFS_RENAME () {11;}' unless defined(&RFS_RENAME);
	eval 'sub RFS_LINK () {12;}' unless defined(&RFS_LINK);
	eval 'sub RFS_SYMLINK () {13;}' unless defined(&RFS_SYMLINK);
	eval 'sub RFS_MKDIR () {14;}' unless defined(&RFS_MKDIR);
	eval 'sub RFS_RMDIR () {15;}' unless defined(&RFS_RMDIR);
	eval 'sub RFS_READDIR () {16;}' unless defined(&RFS_READDIR);
	eval 'sub RFS_STATFS () {17;}' unless defined(&RFS_STATFS);
	eval 'sub RFS_NPROC () {18;}' unless defined(&RFS_NPROC);
	eval 'sub NFS_PROGRAM () {(100003);}' unless defined(&NFS_PROGRAM);
	eval 'sub NFS_VERSION () {(2);}' unless defined(&NFS_VERSION);
	eval 'sub NFS_PORT () {2049;}' unless defined(&NFS_PORT);
	eval 'sub isrofile {
	    my($vp) = @_;
    	    eval q(( ($vp->{v_type}) !=  &VCHR  &&  ($vp->{v_type}) !=  &VBLK  &&  ($vp->{v_type}) !=  &VFIFO  && ( ($vp->{v_vfsp}->{vfs_flag}) &  &VFS_RDONLY)));
	}' unless defined(&isrofile);
	if(defined(&_KERNEL)) {
	    unless(defined(&dprint)) {
		eval 'sub dprint () { &if ( &nfsdebug > 2)  &__dprint__;}' unless defined(&dprint);
	    }
	    eval 'sub printf () { &console_printf;}' unless defined(&printf);
	}
    }
}
1;
