require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&_ONCPLUS)) {
    require 'oncplus/nfs/nfs_clnt.ph';
} else {
    unless(defined(&__NFS_CLNT_HEADER__)) {
	eval 'sub __NFS_CLNT_HEADER__ () {1;}' unless defined(&__NFS_CLNT_HEADER__);
	eval 'sub vftomi {
	    my($vfsp) = @_;
    	    eval q(((($vfsp)-> &vfs_data)));
	}' unless defined(&vftomi);
	eval 'sub vtomi {
	    my($vp) = @_;
    	    eval q((((($vp)-> &v_vfsp)-> &vfs_data)));
	}' unless defined(&vtomi);
	eval 'sub vtoblksz {
	    my($vp) = @_;
    	    eval q(( &vtomi($vp)-> &mi_bsize));
	}' unless defined(&vtoblksz);
	eval 'sub HOSTNAMESZ () {32;}' unless defined(&HOSTNAMESZ);
	eval 'sub ACREGMIN () {3;}' unless defined(&ACREGMIN);
	eval 'sub ACREGMAX () {60;}' unless defined(&ACREGMAX);
	eval 'sub ACDIRMIN () {30;}' unless defined(&ACDIRMIN);
	eval 'sub ACDIRMAX () {60;}' unless defined(&ACDIRMAX);
	eval 'sub ACMINMAX () {3600;}' unless defined(&ACMINMAX);
	eval 'sub ACMAXMAX () {36000;}' unless defined(&ACMAXMAX);
	eval 'sub NFS_CALLTYPES () {3;}' unless defined(&NFS_CALLTYPES);
	eval 'sub ENFS_TRYAGAIN () {999;}' unless defined(&ENFS_TRYAGAIN);
	eval 'sub PURGE_ATTRCACHE {
	    my($vp) = @_;
    	    eval q({  &curtime( &vtor($vp)-> &r_attrtime);  &vtor($vp)-> ($r_attrtime->{tv_usec}) /=  &NS_PER_uS;  &vtor($vp)-> &r_flags |= ( &RACLINVALID |  &RPCLINVALID); });
	}' unless defined(&PURGE_ATTRCACHE);
	eval 'sub INVAL_ATTRCACHE {
	    my($vp) = @_;
    	    eval q({  &vtor($vp)-> ($r_attrtime->{tv_sec}) = 0;  &vtor($vp)-> &r_flags |= ( &RACLINVALID |  &RPCLINVALID); });
	}' unless defined(&INVAL_ATTRCACHE);
	eval 'sub PURGE_STALE_FH {
	    my($errno, $vp) = @_;
    	    eval q( &if (($errno) ==  &ESTALE) { &btrash($vp);  &nfs_purge_caches($vp);});
	}' unless defined(&PURGE_STALE_FH);
	eval 'sub CACHE_VALID {
	    my($rp, $mtime, $fsize) = @_;
    	    eval q((( &rtov($rp)-> &v_flag &  &VISSWAP) ==  &VISSWAP || ($rp)-> ($r_attrtime->{tv_sec}) == 0|| ((($mtime). &tv_sec == ($rp)-> ($r_attr->{va_mtime}->{tv_sec})  && ($mtime). &tv_usec == ($rp)-> ($r_attr->{va_mtime}->{tv_nsec}))  && (($fsize) == ($rp)-> ($r_attr->{va_size})))));
	}' unless defined(&CACHE_VALID);
	eval 'sub time_in_hz {
	    my($time) = @_;
    	    eval q(( ($time->{tv_sec})* &hz +  ($time->{tv_usec})/(1000000/ &hz)));
	}' unless defined(&time_in_hz);
	eval 'sub SQUISH_DEV {
	    my($devno) = @_;
    	    eval q(((($devno & 0xff0000) >> 8) | ($devno & 0xff)));
	}' unless defined(&SQUISH_DEV);
	eval 'sub EXPAND_DEV {
	    my($devno) = @_;
    	    eval q(((($devno & 0xff00) << 8) | ($devno & 0xff)));
	}' unless defined(&EXPAND_DEV);
	eval 'sub MUNGDEVMAJOR {
	    my($devno) = @_;
    	    eval q(( &major($devno) | 0x8000));
	}' unless defined(&MUNGDEVMAJOR);
	eval 'sub MUNGDEVMINOR {
	    my($devno) = @_;
    	    eval q(( &minor($devno)));
	}' unless defined(&MUNGDEVMINOR);
	eval 'sub UNMUNGEDEV {
	    my($major,$minor) = @_;
    	    eval q(((($major & 0x7fff) << 16) | ($minor)));
	}' unless defined(&UNMUNGEDEV);
	eval 'sub IS_BIG_DEV {
	    my($devno) = @_;
    	    eval q(($devno & 0xff80ff00));
	}' unless defined(&IS_BIG_DEV);
	eval 'sub IS_NFSDEV {
	    my($na_type) = @_;
    	    eval q((($na_type) & ( &VCHR |  &VBLK |  &VMPC)));
	}' unless defined(&IS_NFSDEV);
	eval 'sub IS_MUNGED_DEV {
	    my($devno) = @_;
    	    eval q(($devno & 0x8000));
	}' unless defined(&IS_MUNGED_DEV);
	eval 'sub CLIENTHANDLES () {10;}' unless defined(&CLIENTHANDLES);
	eval 'sub MAX_CLIENTHANDLES () {32;}' unless defined(&MAX_CLIENTHANDLES);
	eval 'sub AUTHTABLESIZEDES () {8;}' unless defined(&AUTHTABLESIZEDES);
	eval 'sub AUTHTABLESIZEUNIX () {8;}' unless defined(&AUTHTABLESIZEUNIX);
	if(defined(&_KERNEL)) {
	    eval 'sub NFS_CLIENT_LOCK () {
	        eval q( &lock_write( &nfs_client_lock));
	    }' unless defined(&NFS_CLIENT_LOCK);
	    eval 'sub NFS_CLIENT_UNLOCK () {
	        eval q( &lock_done( &nfs_client_lock));
	    }' unless defined(&NFS_CLIENT_UNLOCK);
	}
    }
}
1;
