require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&_AIX_TIRPC)) {
    require 'tirpc/rpc/types.ph';
} else {
    unless(defined(&__RPC_TYPES_H)) {
	eval 'sub __RPC_TYPES_H () {1;}' unless defined(&__RPC_TYPES_H);
	eval 'sub bool_t () {\'int\';}' unless defined(&bool_t);
	eval 'sub enum_t () {\'int\';}' unless defined(&enum_t);
	eval 'sub __dontcare__ () {-1;}' unless defined(&__dontcare__);
	if(defined( &_KERNEL) || !defined( &__64BIT__)) {
	} else {
	}
	unless(defined(&FALSE)) {
	    eval 'sub FALSE () {(0);}' unless defined(&FALSE);
	}
	unless(defined(&TRUE)) {
	    eval 'sub TRUE () {(1);}' unless defined(&TRUE);
	}
	unless(defined(&NULL)) {
	    eval 'sub NULL () {0;}' unless defined(&NULL);
	}
	unless(defined(&_KERNEL)) {
	    eval 'sub mem_alloc {
	        my($bsize) = @_;
    		eval q( &malloc($bsize));
	    }' unless defined(&mem_alloc);
	    eval 'sub mem_free {
	        my($ptr, $bsize) = @_;
    		eval q( &free($ptr));
	    }' unless defined(&mem_free);
	} else {
	    unless(defined(&__cplusplus)) {
		require 'sys/malloc.ph';
		eval 'sub kmem_alloc {
		    my($bsize) = @_;
    		    eval q( &xmalloc($bsize, 2,  &kernel_heap));
		}' unless defined(&kmem_alloc);
		eval 'sub kmem_free {
		    my($ptr, $bsize) = @_;
    		    eval q( &xmfree($ptr,  &kernel_heap));
		}' unless defined(&kmem_free);
		eval 'sub mem_alloc {
		    my($bsize) = @_;
    		    eval q( &xmalloc($bsize, 2,  &kernel_heap));
		}' unless defined(&mem_alloc);
		eval 'sub mem_free {
		    my($ptr, $bsize) = @_;
    		    eval q( &xmfree($ptr,  &kernel_heap));
		}' unless defined(&mem_free);
	    } else {
		eval 'sub mem_alloc {
		    my($bsize) = @_;
    		    eval q( &mem_getbytes($bsize));
		}' unless defined(&mem_alloc);
		eval 'sub mem_free {
		    my($ptr, $bsize) = @_;
    		    eval q( &mem_freebytes(($ptr)));
		}' unless defined(&mem_free);
	    }
	}
	require 'sys/types.ph';
	require 'sys/time.ph';
    }
}
1;
