require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_DEVICE)) {
    eval 'sub _H_DEVICE () {1;}' unless defined(&_H_DEVICE);
    require 'sys/types.ph';
    require 'sys/file.ph';
    require 'sys/sysmacros.ph';
    require 'sys/lockl.ph';
    require 'sys/intr.ph';
    require 'sys/low.ph';
    require 'sys/syspest.ph';
    if(defined(&_POWER_MP)) {
	require 'sys/processor.ph';
	if(defined(&_KERNSYS)) {
	    require 'sys/m_types.ph';
	    require 'sys/ppda.ph';
	    require 'sys/proc.ph';
	}
    }
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub DEVCNT () {512;}' unless defined(&DEVCNT);
    } else {
	eval 'sub DEVCNT () {1024;}' unless defined(&DEVCNT);
    }
    eval 'sub DEV_NOT_DEFINED () {0x;}' unless defined(&DEV_NOT_DEFINED);
    eval 'sub DEV_DEFINED () {0x2;}' unless defined(&DEV_DEFINED);
    eval 'sub CONS_DEFINED () {0x4;}' unless defined(&CONS_DEFINED);
    eval 'sub DEV_MPSAFE () {0x8;}' unless defined(&DEV_MPSAFE);
    unless(defined(&DEV_64BIT)) {
	eval 'sub DEV_64BIT () {0x10;}' unless defined(&DEV_64BIT);
    }
    if(defined(&__ia64)) {
	eval 'sub DEV_64L () { &DEV_64BIT;}' unless defined(&DEV_64L);
    } else {
	eval 'sub DEV_64L () {0x20;}' unless defined(&DEV_64L);
    }
    eval 'sub DEV_MEM () {0x40;}' unless defined(&DEV_MEM);
    eval 'sub DEV_LAZYTIMES () {0x80;}' unless defined(&DEV_LAZYTIMES);
    eval 'sub DSW_UNDEFINED () {0x;}' unless defined(&DSW_UNDEFINED);
    eval 'sub DSW_CREAD () {0x1;}' unless defined(&DSW_CREAD);
    eval 'sub DSW_CWRITE () {0x2;}' unless defined(&DSW_CWRITE);
    eval 'sub DSW_BLOCK () {0x4;}' unless defined(&DSW_BLOCK);
    eval 'sub DSW_TTY () {0x8;}' unless defined(&DSW_TTY);
    eval 'sub DSW_SELECT () {0x10;}' unless defined(&DSW_SELECT);
    eval 'sub DSW_DUMP () {0x20;}' unless defined(&DSW_DUMP);
    eval 'sub DSW_MPX () {0x40;}' unless defined(&DSW_MPX);
    eval 'sub DSW_TCPATH () {0x80;}' unless defined(&DSW_TCPATH);
    eval 'sub DSW_OPENED () {0x100;}' unless defined(&DSW_OPENED);
    eval 'sub DSW_DEFINED () {0x200;}' unless defined(&DSW_DEFINED);
    eval 'sub DSW_CONSOLE () {0x400;}' unless defined(&DSW_CONSOLE);
    eval 'sub DSW_CONFIG () {0x800;}' unless defined(&DSW_CONFIG);
    eval 'sub DSW_MEM () {0x1000;}' unless defined(&DSW_MEM);
    eval 'sub DSW_LAZYTIMES () {0x2000;}' unless defined(&DSW_LAZYTIMES);
    eval 'sub CFG_INIT () {0x1;}' unless defined(&CFG_INIT);
    eval 'sub CFG_TERM () {0x2;}' unless defined(&CFG_TERM);
    eval 'sub CFG_QVPD () {0x3;}' unless defined(&CFG_QVPD);
    eval 'sub CFG_UCODE () {0x4;}' unless defined(&CFG_UCODE);
    eval 'sub CFG_PARTITIONS () {0x5;}' unless defined(&CFG_PARTITIONS);
    eval 'sub DKERNEL () { &FKERNEL;}' unless defined(&DKERNEL);
    eval 'sub DREAD () { &FREAD;}' unless defined(&DREAD);
    eval 'sub DWRITE () { &FWRITE;}' unless defined(&DWRITE);
    eval 'sub DAPPEND () { &FAPPEND;}' unless defined(&DAPPEND);
    eval 'sub DNDELAY () {( &FNDELAY| &FNONBLOCK);}' unless defined(&DNDELAY);
    eval 'sub DMOUNT () { &FMOUNT;}' unless defined(&DMOUNT);
    eval 'sub DNOCTTY () { &FNOCTTY;}' unless defined(&DNOCTTY);
    eval 'sub DDOCLONE () { &FDOCLONE;}' unless defined(&DDOCLONE);
    eval 'sub DMASK () {( &DKERNEL| &DREAD| &DWRITE| &DAPPEND| &DNDELAY| &DNOCTTY);}' unless defined(&DMASK);
    eval 'sub DUMPINIT () {0x1;}' unless defined(&DUMPINIT);
    eval 'sub DUMPSTART () {0x2;}' unless defined(&DUMPSTART);
    eval 'sub DUMPWRITE () {0x3;}' unless defined(&DUMPWRITE);
    eval 'sub DUMPEND () {0x4;}' unless defined(&DUMPEND);
    eval 'sub DUMPTERM () {0x5;}' unless defined(&DUMPTERM);
    eval 'sub DUMPQUERY () {0x6;}' unless defined(&DUMPQUERY);
    eval 'sub DUMPREAD () {0x7;}' unless defined(&DUMPREAD);
    eval 'sub IPRI_BASE () {0;}' unless defined(&IPRI_BASE);
    eval 'sub IPRI_OTHER () {1;}' unless defined(&IPRI_OTHER);
    eval 'sub IPRI_NOPREMPT () {2;}' unless defined(&IPRI_NOPREMPT);
    eval 'sub DD_SETJMP () {3;}' unless defined(&DD_SETJMP);
    if(defined(&_KERNSYS)) {
	unless(defined(&_POWER_MP)) {
	    eval 'sub FUNNEL_START {
	        my($major,$flag) = @_;
    		eval q();
	    }' unless defined(&FUNNEL_START);
	    eval 'sub FUNNEL_END {
	        my($major) = @_;
    		eval q();
	    }' unless defined(&FUNNEL_END);
	} else {
	    eval 'sub FUNNEL_START {
	        my($major,$flag) = @_;
    		eval q({  &label_t  &funnel_jmpb; \'int\'  &rv; \'int\'  &setfunnel; \'int\'  &setjmpset;  &volatile \'int\'  &wasfunneled=0;  &setfunnel = (!( ($devsw[&(major)]->{d_opts}) &  &DEV_MPSAFE)  && ( ($curcsa->{prev}) ==  &NULL)  && ( ($curcsa->{intpri}) ==  &INTBASE));  &if ( &setfunnel)  &wasfunneled =  &switch_cpu( &MP_MASTER,  &SET_PROCESSOR_ID);  &setjmpset = (($flag &  &DD_SETJMP)  &&  &setfunnel);  &if ( &setjmpset) {  &if (  &rv =  &setjmpx( &funnel_jmpb)) {  &if ( &setfunnel  && ! &wasfunneled)  &switch_cpu(0, &RESET_PROCESSOR_ID);  &longjmpx( &rv); } };);
	    }' unless defined(&FUNNEL_START);
	    eval 'sub FUNNEL_END {
	        my($major) = @_;
    		eval q( &if ( &setjmpset) {  &clrjmpx( &funnel_jmpb); };  &if ( &setfunnel  && ! &wasfunneled) {  &switch_cpu(0,  &RESET_PROCESSOR_ID); } });
	    }' unless defined(&FUNNEL_END);
	}
	eval 'sub DD_ENT {
	    my($rc,$ddcall,$flag,$major) = @_;
    	    eval q({  &void  &specfs_intsdisabled(\'int\', \'int\', \'char\' *); \'int\'  &waslocked; \'int\'  &tmpipri,  &tmprc; \'struct kmstsave\' * &curcsa;  &curcsa =  &CSA;  &if ( &waslocked = (( ($curcsa->{prev}) ==  &NULL)  &&  &IS_LOCKED( &kernel_lock)  && !($flag &  &IPRI_NOPREMPT)))  &unlockl( &kernel_lock);  &if ($flag &  &IPRI_OTHER) {  &tmpipri =  ($curcsa->{intpri}); }  &else {  &tmpipri =  &INTBASE;  &ASSERT( ($curcsa->{intpri}) ==  &INTBASE); };  &FUNNEL_START($major,$flag)  &tmprc = $ddcall; $rc  &tmprc;  &FUNNEL_END($major)  &if (( ($curcsa->{intpri}) !=  &tmpipri)) {  &specfs_intsdisabled($major, &tmprc,$ddcall); }  &if ( &waslocked)  &lockl( &kernel_lock,  &LOCK_SHORT); });
	}' unless defined(&DD_ENT);
    }
    unless(defined(&_NO_PROTO)) {
    } else {
    }
    if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
    }
}
1;
