require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&EEH_ENABLE)) {
    sub EEH_ENABLE () {	0x;}
}
unless(defined(&EEH_DISABLE)) {
    sub EEH_DISABLE () {	0x1;}
}
unless(defined(&EEH_DEACTIVE)) {
    sub EEH_DEACTIVE () {	0x;}
}
unless(defined(&EEH_ACTIVE)) {
    sub EEH_ACTIVE () {	0x1;}
}
unless(defined(&EEH_CHECK_SLOT)) {
    sub EEH_CHECK_SLOT () {	0x2;}
}
unless(defined(&EEH_RESET_TEMP)) {
    sub EEH_RESET_TEMP () {	0x1;}
}
unless(defined(&EEH_RESET_PERM)) {
    sub EEH_RESET_PERM () {	0x2;}
}
unless(defined(&EEH_INTERNAL_FAIL)) {
    sub EEH_INTERNAL_FAIL () {	0x80;}
}
unless(defined(&EEH_FAIL)) {
    sub EEH_FAIL () {	-1;}
}
unless(defined(&EEH_NO_SUPPORT)) {
    sub EEH_NO_SUPPORT () {	0x;}
}
unless(defined(&EEH_SUCC)) {
    sub EEH_SUCC () {	0x1;}
}
unless(defined(&EEH_SLOT_ACTIVE)) {
    sub EEH_SLOT_ACTIVE () {	0x2;}
}
unless(defined(&EEH_SLOT_FREE)) {
    sub EEH_SLOT_FREE () {	0x3;}
}
unless(defined(&EEH_BUSY)) {
    sub EEH_BUSY () {	0x4;}
}
unless(defined(&EEH_NSTOPPED_RST_DEA)) {
    sub EEH_NSTOPPED_RST_DEA () {	0x;}
}
unless(defined(&EEH_NSTOPPED_RST_ACT)) {
    sub EEH_NSTOPPED_RST_ACT () {	0x1;}
}
unless(defined(&EEH_STOPPED_LS_DIS)) {
    sub EEH_STOPPED_LS_DIS () {	0x2;}
}
unless(defined(&EEH_STOPPED_LS_ENA)) {
    sub EEH_STOPPED_LS_ENA () {	0x4;}
}
unless(defined(&EEH_UNAVAILABLE)) {
    sub EEH_UNAVAILABLE () {	0x5;}
}
unless(defined(&NORMAL_EEH_STATE)) {
    sub NORMAL_EEH_STATE () {	0x;}
}
unless(defined(&SUSPEND_STATE)) {
    sub SUSPEND_STATE () {	0x1;}
}
unless(defined(&DEBUG_STATE)) {
    sub DEBUG_STATE () {	0x2;}
}
unless(defined(&ACTIVATE_STATE)) {
    sub ACTIVATE_STATE () {	0x3;}
}
unless(defined(&DEACTIVATE_STATE)) {
    sub DEACTIVATE_STATE () {	0x4;}
}
unless(defined(&DEAD_STATE)) {
    sub DEAD_STATE () {	0x5;}
}
unless(defined(&BUSY_EEH_STATE)) {
    sub BUSY_EEH_STATE () {	0x6;}
}
unless(defined(&RESUME_EEH_STATE)) {
    sub RESUME_EEH_STATE () {	0x7;}
}
unless(defined(&BUSY_DEAD_STATE)) {
    sub BUSY_DEAD_STATE () {	0x8;}
}
unless(defined(&RESUME_DEAD_STATE)) {
    sub RESUME_DEAD_STATE () {	0x9;}
}
unless(defined(&EEH_MASTER)) {
    sub EEH_MASTER () {	0x1;}
}
unless(defined(&EEH_DD_PIO_ENABLED)) {
    sub EEH_DD_PIO_ENABLED () {	0x40;}
}
unless(defined(&EEH_DD_DMA_ENABLED)) {
    sub EEH_DD_DMA_ENABLED () {	0x80;}
}
unless(defined(&EEH_DD_RESUME)) {
    sub EEH_DD_RESUME () {	0x800000;}
}
unless(defined(&EEH_DD_DEACTIVE)) {
    sub EEH_DD_DEACTIVE () {	0x1000000;}
}
unless(defined(&EEH_DD_DEBUG)) {
    sub EEH_DD_DEBUG () {	0x2000000;}
}
unless(defined(&EEH_DD_ACTIVE)) {
    sub EEH_DD_ACTIVE () {	0x4000000;}
}
unless(defined(&EEH_DD_SUSPEND)) {
    sub EEH_DD_SUSPEND () {	0x8000000;}
}
unless(defined(&EEH_DD_DEAD)) {
    sub EEH_DD_DEAD () {	0x80000000;}
}
unless(defined(&NMULTIDD)) {
    sub NMULTIDD () {	7;}
}
unless(defined(&EEH_SAFE)) {
    sub EEH_SAFE () {	0x2;}
}
unless(defined(&EEH_CONFIGURE)) {
    sub EEH_CONFIGURE () {	0x3;}
}
unless(defined(&EEH_INIT)) {
    sub EEH_INIT {
	my($bid, $slot, $flag) = @_;
	eval q( &eeh_init($bid, $slot, $flag));
    }
}
unless(defined(&EEH_INIT_MULTIFUNC)) {
    sub EEH_INIT_MULTIFUNC {
	my($bid, $bid2, $slot, $flag, $delay_seconds, $callback_ptr, $dds_ptr) = @_;
	eval q( &eeh_init_multifunc($bid, $bid2, $slot, $flag, $delay_seconds, $callback_ptr, $dds_ptr));
    }
}
unless(defined(&EEH_CLEAR)) {
    sub EEH_CLEAR {
	my($handle) = @_;
	eval q(( ($handle->{eeh_clear}))($handle));
    }
}
unless(defined(&EEH_ENABLE_PIO)) {
    sub EEH_ENABLE_PIO {
	my($handle) = @_;
	eval q(( ($handle->{eeh_enable_pio}))($handle));
    }
}
unless(defined(&EEH_ENABLE_DMA)) {
    sub EEH_ENABLE_DMA {
	my($handle) = @_;
	eval q(( ($handle->{eeh_enable_dma}))($handle));
    }
}
unless(defined(&EEH_RESET_SLOT)) {
    sub EEH_RESET_SLOT {
	my($handle, $flag) = @_;
	eval q(( ($handle->{eeh_reset_slot}))($handle, $flag));
    }
}
unless(defined(&EEH_SLOT_ERROR)) {
    sub EEH_SLOT_ERROR {
	my($handle, $flag, $dd_buf, $dd_buf_length) = @_;
	eval q(( ($handle->{eeh_slot_error}))($handle, $flag, $dd_buf, $dd_buf_length));
    }
}
unless(defined(&EEH_ENABLE_SLOT)) {
    sub EEH_ENABLE_SLOT {
	my($handle) = @_;
	eval q(( ($handle->{eeh_enable_slot}))($handle));
    }
}
unless(defined(&EEH_DISABLE_SLOT)) {
    sub EEH_DISABLE_SLOT {
	my($handle) = @_;
	eval q(( ($handle->{eeh_disable_slot}))($handle));
    }
}
unless(defined(&EEH_READ_SLOT_STATE)) {
    sub EEH_READ_SLOT_STATE {
	my($handle, $state, $support) = @_;
	eval q(( ($handle->{eeh_read_slot_state}))($handle, $state, $support));
    }
}
unless(defined(&EEH_BROADCAST)) {
    sub EEH_BROADCAST {
	my($handle, $msg) = @_;
	eval q(( ($handle->{eeh_broadcast}))($handle, $msg));
    }
}
unless(defined(&_NO_PROTO)) {
} else {
}
1;
