require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_LIMITS)) {
    eval 'sub _H_LIMITS () {1;}' unless defined(&_H_LIMITS);
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_H_STANDARDS)) {
	require 'standards.ph';
    }
    if(defined(&_ANSI_C_SOURCE)) {
	eval 'sub CHAR_BIT () {(8);}' unless defined(&CHAR_BIT);
	if(defined( &__ia64)  && !defined( &_CHAR_UNSIGNED)) {
	    eval 'sub CHAR_MAX () {127;}' unless defined(&CHAR_MAX);
	    eval 'sub CHAR_MIN () {(-128);}' unless defined(&CHAR_MIN);
	} else {
	    eval 'sub CHAR_MAX () { &UCHAR_MAX;}' unless defined(&CHAR_MAX);
	    eval 'sub CHAR_MIN () {(0);}' unless defined(&CHAR_MIN);
	}
	eval 'sub INT_MAX () {(2147483647);}' unless defined(&INT_MAX);
	eval 'sub INT_MIN () {(- &INT_MAX - 1);}' unless defined(&INT_MIN);
	if(defined(&__64BIT__)) {
	    eval 'sub LONG_MAX () {(9223372036854775807);}' unless defined(&LONG_MAX);
	    eval 'sub LONG_MIN () {(- &LONG_MAX - 1);}' unless defined(&LONG_MIN);
	    eval 'sub ULONG_MAX () {(18446744073709551615);}' unless defined(&ULONG_MAX);
	} else {
	    eval 'sub LONG_MAX () { &INT_MAX;}' unless defined(&LONG_MAX);
	    eval 'sub LONG_MIN () { &INT_MIN;}' unless defined(&LONG_MIN);
	    eval 'sub ULONG_MAX () {( &UINT_MAX);}' unless defined(&ULONG_MAX);
	}
	eval 'sub SCHAR_MAX () {(127);}' unless defined(&SCHAR_MAX);
	eval 'sub SCHAR_MIN () {(- &SCHAR_MAX - 1);}' unless defined(&SCHAR_MIN);
	eval 'sub SHRT_MAX () {(32767);}' unless defined(&SHRT_MAX);
	eval 'sub SHRT_MIN () {(- &SHRT_MAX - 1);}' unless defined(&SHRT_MIN);
	eval 'sub UCHAR_MAX () {(255);}' unless defined(&UCHAR_MAX);
	eval 'sub UINT_MAX () {(4294967295);}' unless defined(&UINT_MAX);
	eval 'sub USHRT_MAX () {(65535);}' unless defined(&USHRT_MAX);
	eval 'sub MB_LEN_MAX () {4;}' unless defined(&MB_LEN_MAX);
    }
    if(defined(&_POSIX_SOURCE)) {
	eval 'sub _POSIX_ARG_MAX () {4096;}' unless defined(&_POSIX_ARG_MAX);
	eval 'sub _POSIX_CHILD_MAX () {6;}' unless defined(&_POSIX_CHILD_MAX);
	eval 'sub _POSIX_LINK_MAX () {8;}' unless defined(&_POSIX_LINK_MAX);
	eval 'sub _POSIX_MAX_CANON () {255;}' unless defined(&_POSIX_MAX_CANON);
	eval 'sub _POSIX_NAME_MAX () {14;}' unless defined(&_POSIX_NAME_MAX);
	eval 'sub _POSIX_NGROUPS_MAX () {0;}' unless defined(&_POSIX_NGROUPS_MAX);
	eval 'sub _POSIX_MAX_INPUT () {255;}' unless defined(&_POSIX_MAX_INPUT);
	eval 'sub _POSIX_OPEN_MAX () {16;}' unless defined(&_POSIX_OPEN_MAX);
	eval 'sub _POSIX_PATH_MAX () {255;}' unless defined(&_POSIX_PATH_MAX);
	eval 'sub _POSIX_PIPE_BUF () {512;}' unless defined(&_POSIX_PIPE_BUF);
	eval 'sub _POSIX_SSIZE_MAX () {32767;}' unless defined(&_POSIX_SSIZE_MAX);
	eval 'sub _POSIX_STREAM_MAX () {8;}' unless defined(&_POSIX_STREAM_MAX);
	eval 'sub _POSIX_THREAD_KEYS_MAX () {128;}' unless defined(&_POSIX_THREAD_KEYS_MAX);
	eval 'sub _POSIX_THREAD_DATAKEYS_MAX () { &_POSIX_THREAD_KEYS_MAX;}' unless defined(&_POSIX_THREAD_DATAKEYS_MAX);
	eval 'sub _POSIX_THREAD_THREADS_MAX () {64;}' unless defined(&_POSIX_THREAD_THREADS_MAX);
	eval 'sub _POSIX_TZNAME_MAX () {3;}' unless defined(&_POSIX_TZNAME_MAX);
	eval 'sub _POSIX_LOGIN_NAME_MAX () {9;}' unless defined(&_POSIX_LOGIN_NAME_MAX);
	eval 'sub _POSIX_TTY_NAME_MAX () {9;}' unless defined(&_POSIX_TTY_NAME_MAX);
	eval 'sub _POSIX_THREAD_DESTRUCTOR_ITERATIONS () {4;}' unless defined(&_POSIX_THREAD_DESTRUCTOR_ITERATIONS);
	eval 'sub _POSIX_CLOCKRES_MIN () {20000000;}' unless defined(&_POSIX_CLOCKRES_MIN);
	eval 'sub _POSIX_AIO_LISTIO_MAX () {2;}' unless defined(&_POSIX_AIO_LISTIO_MAX);
	eval 'sub _POSIX_AIO_MAX () {1;}' unless defined(&_POSIX_AIO_MAX);
	eval 'sub _POSIX_DELAYTIMER_MAX () {32;}' unless defined(&_POSIX_DELAYTIMER_MAX);
	eval 'sub _POSIX_MQ_OPEN_MAX () {8;}' unless defined(&_POSIX_MQ_OPEN_MAX);
	eval 'sub _POSIX_MQ_PRIO_MAX () {32;}' unless defined(&_POSIX_MQ_PRIO_MAX);
	eval 'sub _POSIX_RTSIG_MAX () {8;}' unless defined(&_POSIX_RTSIG_MAX);
	eval 'sub _POSIX_SEM_NSEMS_MAX () {256;}' unless defined(&_POSIX_SEM_NSEMS_MAX);
	eval 'sub _POSIX_SEM_VALUE_MAX () {32767;}' unless defined(&_POSIX_SEM_VALUE_MAX);
	eval 'sub _POSIX_SIGQUEUE_MAX () {32;}' unless defined(&_POSIX_SIGQUEUE_MAX);
	eval 'sub _POSIX_TIMER_MAX () {32;}' unless defined(&_POSIX_TIMER_MAX);
	eval 'sub _POSIX2_BC_BASE_MAX () {99;}' unless defined(&_POSIX2_BC_BASE_MAX);
	eval 'sub _POSIX2_BC_DIM_MAX () {2048;}' unless defined(&_POSIX2_BC_DIM_MAX);
	eval 'sub _POSIX2_BC_SCALE_MAX () {99;}' unless defined(&_POSIX2_BC_SCALE_MAX);
	eval 'sub _POSIX2_BC_STRING_MAX () {1000;}' unless defined(&_POSIX2_BC_STRING_MAX);
	eval 'sub _POSIX2_EQUIV_CLASS_MAX () {2;}' unless defined(&_POSIX2_EQUIV_CLASS_MAX);
	eval 'sub _POSIX2_COLL_WEIGHTS_MAX () {2;}' unless defined(&_POSIX2_COLL_WEIGHTS_MAX);
	eval 'sub _POSIX2_EXPR_NEST_MAX () {32;}' unless defined(&_POSIX2_EXPR_NEST_MAX);
	eval 'sub _POSIX2_LINE_MAX () {2048;}' unless defined(&_POSIX2_LINE_MAX);
	eval 'sub _POSIX2_RE_DUP_MAX () {255;}' unless defined(&_POSIX2_RE_DUP_MAX);
	eval 'sub BC_BASE_MAX () { &_POSIX2_BC_BASE_MAX;}' unless defined(&BC_BASE_MAX);
	eval 'sub BC_DIM_MAX () { &_POSIX2_BC_DIM_MAX;}' unless defined(&BC_DIM_MAX);
	eval 'sub BC_SCALE_MAX () { &_POSIX2_BC_SCALE_MAX;}' unless defined(&BC_SCALE_MAX);
	eval 'sub BC_STRING_MAX () {2048;}' unless defined(&BC_STRING_MAX);
	eval 'sub EQUIV_CLASS_MAX () {4;}' unless defined(&EQUIV_CLASS_MAX);
	eval 'sub COLL_WEIGHTS_MAX () {4;}' unless defined(&COLL_WEIGHTS_MAX);
	eval 'sub EXPR_NEST_MAX () { &_POSIX2_EXPR_NEST_MAX;}' unless defined(&EXPR_NEST_MAX);
	eval 'sub LINE_MAX () { &_POSIX2_LINE_MAX;}' unless defined(&LINE_MAX);
	unless(defined(&RE_DUP_MAX)) {
	    eval 'sub RE_DUP_MAX () { &_POSIX2_RE_DUP_MAX;}' unless defined(&RE_DUP_MAX);
	}
	eval 'sub MAX_INPUT () {512;}' unless defined(&MAX_INPUT);
	eval 'sub NGROUPS_MAX () {64;}' unless defined(&NGROUPS_MAX);
	eval 'sub SSIZE_MAX () { &LONG_MAX;}' unless defined(&SSIZE_MAX);
	eval 'sub _SSIZE_MAX () { &LONG_MAX;}' unless defined(&_SSIZE_MAX);
	eval 'sub ARG_MAX () {24576;}' unless defined(&ARG_MAX);
	eval 'sub MAX_CANON () {256;}' unless defined(&MAX_CANON);
	eval 'sub CHILD_MAX () {128;}' unless defined(&CHILD_MAX);
	eval 'sub OPEN_MAX () {32767;}' unless defined(&OPEN_MAX);
	eval 'sub STREAM_MAX () {32767;}' unless defined(&STREAM_MAX);
	eval 'sub PTHREAD_KEYS_MAX () {450;}' unless defined(&PTHREAD_KEYS_MAX);
	if(defined(&_LARGE_THREADS)) {
	    eval 'sub PTHREAD_THREADS_MAX () {32767;}' unless defined(&PTHREAD_THREADS_MAX);
	} else {
	    eval 'sub PTHREAD_THREADS_MAX () {512;}' unless defined(&PTHREAD_THREADS_MAX);
	}
	if(defined(&_ALL_SOURCE)) {
	    eval 'sub PTHREAD_DATAKEYS_MAX () { &PTHREAD_KEYS_MAX;}' unless defined(&PTHREAD_DATAKEYS_MAX);
	}
	eval 'sub TZNAME_MAX () {255;}' unless defined(&TZNAME_MAX);
	eval 'sub TTY_NAME_MAX () { &PATH_MAX;}' unless defined(&TTY_NAME_MAX);
	eval 'sub AIO_LISTIO_MAX () {4096;}' unless defined(&AIO_LISTIO_MAX);
	eval 'sub AIO_MAX () {4096;}' unless defined(&AIO_MAX);
	eval 'sub AIO_PRIO_DELTA_MAX () {0;}' unless defined(&AIO_PRIO_DELTA_MAX);
	eval 'sub DELAYTIMER_MAX () { &_POSIX_DELAYTIMER_MAX;}' unless defined(&DELAYTIMER_MAX);
	eval 'sub MQ_OPEN_MAX () { &_POSIX_MQ_OPEN_MAX;}' unless defined(&MQ_OPEN_MAX);
	eval 'sub MQ_PRIO_MAX () { &_POSIX_MQ_PRIO_MAX;}' unless defined(&MQ_PRIO_MAX);
	eval 'sub RTSIG_MAX () { &_POSIX_RTSIG_MAX;}' unless defined(&RTSIG_MAX);
	eval 'sub SEM_NSEMS_MAX () { &_POSIX_SEM_NSEMS_MAX;}' unless defined(&SEM_NSEMS_MAX);
	eval 'sub SEM_VALUE_MAX () { &_POSIX_SEM_VALUE_MAX;}' unless defined(&SEM_VALUE_MAX);
	eval 'sub SIGQUEUE_MAX () { &_POSIX_SIGQUEUE_MAX;}' unless defined(&SIGQUEUE_MAX);
	eval 'sub TIMER_MAX () { &_POSIX_TIMER_MAX;}' unless defined(&TIMER_MAX);
	undef(&NAME_MAX) if defined(&NAME_MAX);
	eval 'sub PATH_MAX () {1023;}' unless defined(&PATH_MAX);
	eval 'sub LINK_MAX () { &SHRT_MAX;}' unless defined(&LINK_MAX);
	eval 'sub LOGIN_NAME_MAX () {9;}' unless defined(&LOGIN_NAME_MAX);
	eval 'sub PIPE_BUF () {32768;}' unless defined(&PIPE_BUF);
    }
    if(defined(&_XOPEN_SOURCE)) {
	if(defined(&_ALL_SOURCE)) {
	    unless(defined(&_H_FLOAT)) {
		require 'float.ph';
	    }
	} else {
	    unless(defined(&DBL_DIG)) {
		eval 'sub DBL_DIG () {15;}' unless defined(&DBL_DIG);
	    }
	    unless(defined(&FLT_DIG)) {
		eval 'sub FLT_DIG () {6;}' unless defined(&FLT_DIG);
	    }
	    unless(defined(&DBL_MAX)) {
		eval 'sub DBL_MAX () {1.7976931348623158e+308;}' unless defined(&DBL_MAX);
	    }
	    unless(defined(&FLT_MAX)) {
		eval 'sub FLT_MAX () {3.4028234663852886e+38;}' unless defined(&FLT_MAX);
	    }
	    if(((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0) != 500)) {
		unless(defined(&DBL_MIN)) {
		    eval 'sub DBL_MIN () {2.2250738585072014e-308;}' unless defined(&DBL_MIN);
		}
		unless(defined(&FLT_MIN)) {
		    eval 'sub FLT_MIN () {1.1754943508222875e-38;}' unless defined(&FLT_MIN);
		}
	    }
	}
	unless(defined(&TMP_MAX)) {
	    eval 'sub TMP_MAX () {16384;}' unless defined(&TMP_MAX);
	}
	eval 'sub NL_ARGMAX () {9;}' unless defined(&NL_ARGMAX);
	eval 'sub NL_MSGMAX () {65535;}' unless defined(&NL_MSGMAX);
	eval 'sub NL_SETMAX () {65535;}' unless defined(&NL_SETMAX);
	eval 'sub NL_TEXTMAX () {8192;}' unless defined(&NL_TEXTMAX);
	eval 'sub PASS_MAX () {32;}' unless defined(&PASS_MAX);
	eval 'sub NL_LANGMAX () {14;}' unless defined(&NL_LANGMAX);
	eval 'sub NL_NMAX () {10;}' unless defined(&NL_NMAX);
	unless(defined(&NZERO)) {
	    eval 'sub NZERO () {20;}' unless defined(&NZERO);
	}
	if(defined(&__64BIT__)) {
	    eval 'sub LONG_BIT () {64;}' unless defined(&LONG_BIT);
	} else {
	    eval 'sub LONG_BIT () {32;}' unless defined(&LONG_BIT);
	}
	eval 'sub WORD_BIT () {32;}' unless defined(&WORD_BIT);
	eval 'sub CHARCLASS_NAME_MAX () {14;}' unless defined(&CHARCLASS_NAME_MAX);
	if((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0)==1) {
	    eval 'sub ATEXIT_MAX () {2048;}' unless defined(&ATEXIT_MAX);
	    eval 'sub _XOPEN_IOV_MAX () {16;}' unless defined(&_XOPEN_IOV_MAX);
	    unless(defined(&IOV_MAX)) {
		eval 'sub IOV_MAX () { &_XOPEN_IOV_MAX;}' unless defined(&IOV_MAX);
	    }
	    eval 'sub PAGE_SIZE () {4096;}' unless defined(&PAGE_SIZE);
	    eval 'sub PAGESIZE () { &PAGE_SIZE;}' unless defined(&PAGESIZE);
	    if((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0)==500) {
		undef(&FILESIZEBITS) if defined(&FILESIZEBITS);
		unless(defined(&PTHREAD_STACK_MIN)) {
		    if(defined(&_AIX_PTHREADS_D7)) {
			eval 'sub PTHREAD_STACK_MIN () {(  &PAGESIZE * 24);}' unless defined(&PTHREAD_STACK_MIN);
		    } else {
			if(defined(&__64BIT__)) {
			    eval 'sub PTHREAD_STACK_MIN () {( 2*  &PAGESIZE * 2);}' unless defined(&PTHREAD_STACK_MIN);
			} else {
			    eval 'sub PTHREAD_STACK_MIN () {(  &PAGESIZE * 2);}' unless defined(&PTHREAD_STACK_MIN);
			}
		    }
		}
		eval 'sub PTHREAD_DESTRUCTOR_ITERATIONS () { &_POSIX_THREAD_DESTRUCTOR_ITERATIONS;}' unless defined(&PTHREAD_DESTRUCTOR_ITERATIONS);
	    }
	}
    }
    if(defined(&_ALL_SOURCE)) {
	eval 'sub AIO_PRIO_DFL () {1;}' unless defined(&AIO_PRIO_DFL);
	eval 'sub AIO_PRIO_MAX () {1;}' unless defined(&AIO_PRIO_MAX);
	eval 'sub AIO_PRIO_MIN () {1;}' unless defined(&AIO_PRIO_MIN);
	eval 'sub AIO_LISTIO_MAX_SIZE () { &AIO_LISTIO_MAX;}' unless defined(&AIO_LISTIO_MAX_SIZE);
	eval 'sub PID_MAX () { &INT_MAX;}' unless defined(&PID_MAX);
	eval 'sub UID_MAX () { &UINT_MAX;}' unless defined(&UID_MAX);
	if(defined(&_LONG_LONG)) {
	    eval 'sub LONGLONG_MAX () {(9.22337203685478e+18);}' unless defined(&LONGLONG_MAX);
	    eval 'sub LONGLONG_MIN () {(- &LONGLONG_MAX - 1);}' unless defined(&LONGLONG_MIN);
	    eval 'sub ULONGLONG_MAX () {(1.84467440737096e+19);}' unless defined(&ULONGLONG_MAX);
	    if(defined(&__64BIT_KERNEL)) {
		eval 'sub DEV_OFF_MAX () { &LONGLONG_MAX;}' unless defined(&DEV_OFF_MAX);
	    } else {
		eval 'sub DEV_OFF_MAX () {1099511627775;}' unless defined(&DEV_OFF_MAX);
	    }
	}
	eval 'sub OFF_MAX () {0x7fffffff;}' unless defined(&OFF_MAX);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
