require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_MACHINE)) {
    eval 'sub _H_MACHINE () {1;}' unless defined(&_H_MACHINE);
    eval 'sub LITTLE_ENDIAN () {1234;}' unless defined(&LITTLE_ENDIAN);
    eval 'sub BIG_ENDIAN () {4321;}' unless defined(&BIG_ENDIAN);
    eval 'sub PDP_ENDIAN () {3412;}' unless defined(&PDP_ENDIAN);
    eval 'sub BYTE_ORDER () { &BIG_ENDIAN;}' unless defined(&BYTE_ORDER);
    eval 'sub DEFAULT_GPR () {0xdeadbeef;}' unless defined(&DEFAULT_GPR);
    eval 'sub MSR_EE () {0x8000;}' unless defined(&MSR_EE);
    eval 'sub MSR_PR () {0x4000;}' unless defined(&MSR_PR);
    eval 'sub MSR_FP () {0x2000;}' unless defined(&MSR_FP);
    eval 'sub MSR_ME () {0x1000;}' unless defined(&MSR_ME);
    eval 'sub MSR_FE () {0x800;}' unless defined(&MSR_FE);
    eval 'sub MSR_FE0 () {0x800;}' unless defined(&MSR_FE0);
    eval 'sub MSR_SE () {0x400;}' unless defined(&MSR_SE);
    eval 'sub MSR_BE () {0x200;}' unless defined(&MSR_BE);
    eval 'sub MSR_IE () {0x100;}' unless defined(&MSR_IE);
    eval 'sub MSR_FE1 () {0x100;}' unless defined(&MSR_FE1);
    eval 'sub MSR_AL () {0x80;}' unless defined(&MSR_AL);
    eval 'sub MSR_IP () {0x40;}' unless defined(&MSR_IP);
    eval 'sub MSR_IR () {0x20;}' unless defined(&MSR_IR);
    eval 'sub MSR_DR () {0x10;}' unless defined(&MSR_DR);
    eval 'sub MSR_PM () {0x4;}' unless defined(&MSR_PM);
    eval 'sub MSR_RI () {0x2;}' unless defined(&MSR_RI);
    eval 'sub MSR_HYPERVISOR () {1.15292150460685e+18;}' unless defined(&MSR_HYPERVISOR);
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub MSR_SF () {9.22337203685478e+18;}' unless defined(&MSR_SF);
	eval 'sub MSR_ISF () {2.30584300921369e+18;}' unless defined(&MSR_ISF);
	eval 'sub DEFAULT_MSR () {( &MSR_SF| &MSR_ISF| &MSR_EE| &MSR_ME| &MSR_IR| &MSR_DR| &MSR_RI);}' unless defined(&DEFAULT_MSR);
	eval 'sub DEFAULT_USER_MSR () {( &MSR_ISF| &MSR_PR| &MSR_EE| &MSR_ME| &MSR_IR| &MSR_DR| &MSR_RI);}' unless defined(&DEFAULT_USER_MSR);
	eval 'sub MSR_SF_H () {0xa0000000;}' unless defined(&MSR_SF_H);
    } else {
	eval 'sub DEFAULT_MSR () {( &MSR_EE| &MSR_ME| &MSR_AL| &MSR_IR| &MSR_DR| &MSR_RI);}' unless defined(&DEFAULT_MSR);
	eval 'sub DEFAULT_USER_MSR () {( &DEFAULT_MSR |  &MSR_PR);}' unless defined(&DEFAULT_USER_MSR);
	eval 'sub MSR_SF_H () {0x80000000;}' unless defined(&MSR_SF_H);
    }
    eval 'sub CR_LT () {0x80000000;}' unless defined(&CR_LT);
    eval 'sub CR_GT () {0x40000000;}' unless defined(&CR_GT);
    eval 'sub CR_EQ () {0x20000000;}' unless defined(&CR_EQ);
    eval 'sub CR_SO () {0x10000000;}' unless defined(&CR_SO);
    eval 'sub CR_FX () {0x8000000;}' unless defined(&CR_FX);
    eval 'sub CR_FEX () {0x4000000;}' unless defined(&CR_FEX);
    eval 'sub CR_VX () {0x2000000;}' unless defined(&CR_VX);
    eval 'sub CR_OX () {0x1000000;}' unless defined(&CR_OX);
    eval 'sub CR_FIELD {
        my($n,$cr) = @_;
	    eval q((($cr << ($n << 2)) & 0xf0000000));
    }' unless defined(&CR_FIELD);
    eval 'sub XER_SO () {0x80000000;}' unless defined(&XER_SO);
    eval 'sub XER_OV () {0x40000000;}' unless defined(&XER_OV);
    eval 'sub XER_CA () {0x20000000;}' unless defined(&XER_CA);
    eval 'sub XER_COMP_BYTE {
        my($xer) = @_;
	    eval q((($xer >> 8) & 0xff));
    }' unless defined(&XER_COMP_BYTE);
    eval 'sub XER_LENGTH {
        my($xer) = @_;
	    eval q(($xer & 0x7f));
    }' unless defined(&XER_LENGTH);
    eval 'sub DSISR_IO () {0x80000000;}' unless defined(&DSISR_IO);
    eval 'sub DSISR_PFT () {0x40000000;}' unless defined(&DSISR_PFT);
    eval 'sub DSISR_LOCK () {0x20000000;}' unless defined(&DSISR_LOCK);
    eval 'sub DSISR_FPIO () {0x10000000;}' unless defined(&DSISR_FPIO);
    eval 'sub DSISR_PROT () {0x8000000;}' unless defined(&DSISR_PROT);
    eval 'sub DSISR_LOOP () {0x4000000;}' unless defined(&DSISR_LOOP);
    eval 'sub DSISR_DRST () {0x4000000;}' unless defined(&DSISR_DRST);
    eval 'sub DSISR_ST () {0x2000000;}' unless defined(&DSISR_ST);
    eval 'sub DSISR_SEGB () {0x1000000;}' unless defined(&DSISR_SEGB);
    eval 'sub DSISR_DABR () {0x400000;}' unless defined(&DSISR_DABR);
    eval 'sub DSISR_STAB () {0x200000;}' unless defined(&DSISR_STAB);
    eval 'sub DSISR_EAR () {0x100000;}' unless defined(&DSISR_EAR);
    eval 'sub SRR_IS_PFT () {0x40000000;}' unless defined(&SRR_IS_PFT);
    eval 'sub SRR_IS_ISPEC () {0x20000000;}' unless defined(&SRR_IS_ISPEC);
    eval 'sub SRR_IS_IIO () {0x10000000;}' unless defined(&SRR_IS_IIO);
    eval 'sub SRR_IS_GUARD () {0x10000000;}' unless defined(&SRR_IS_GUARD);
    eval 'sub SRR_IS_PROT () {0x8000000;}' unless defined(&SRR_IS_PROT);
    eval 'sub SRR_IS_LOOP () {0x4000000;}' unless defined(&SRR_IS_LOOP);
    eval 'sub SRR_PR_FPEN () {0x100000;}' unless defined(&SRR_PR_FPEN);
    eval 'sub SRR_PR_INVAL () {0x80000;}' unless defined(&SRR_PR_INVAL);
    eval 'sub SRR_PR_PRIV () {0x40000;}' unless defined(&SRR_PR_PRIV);
    eval 'sub SRR_PR_TRAP () {0x20000;}' unless defined(&SRR_PR_TRAP);
    eval 'sub SRR_PR_IMPRE () {0x10000;}' unless defined(&SRR_PR_IMPRE);
    if(defined(&_KERNEL)) {
	eval 'sub MACH_RS1 () {
	    eval q((!( &mach_model & 0x6000000)));
	}' unless defined(&MACH_RS1);
	eval 'sub MACH_RSC () {
	    eval q(( &mach_model & 0x2000000));
	}' unless defined(&MACH_RSC);
	eval 'sub FP_IE_IMPL () {( &fp_ie_impl != 0);}' unless defined(&FP_IE_IMPL);
    }
    if(defined(&_KERNSYS)) {
	if(defined(&_POWER_PC)) {
	    if(defined(&_POWER_601)) {
		eval 'sub BUID_7F_SRVAL {
		    my($raddr) = @_;
    		    eval q((0x87f00000 | ((($raddr)) >> 28)));
		}' unless defined(&BUID_7F_SRVAL);
	    }
	    eval 'sub BT_256M () {0x1ffc;}' unless defined(&BT_256M);
	    eval 'sub BT_128M () {0xffc;}' unless defined(&BT_128M);
	    eval 'sub BT_64M () {0x7fc;}' unless defined(&BT_64M);
	    eval 'sub BT_32M () {0x3fc;}' unless defined(&BT_32M);
	    eval 'sub BT_16M () {0x1fc;}' unless defined(&BT_16M);
	    eval 'sub BT_8M () {0xfc;}' unless defined(&BT_8M);
	    eval 'sub BT_4M () {0x7c;}' unless defined(&BT_4M);
	    eval 'sub BT_2M () {0x3c;}' unless defined(&BT_2M);
	    eval 'sub BT_1M () {0x1c;}' unless defined(&BT_1M);
	    eval 'sub BT_512K () {0xc;}' unless defined(&BT_512K);
	    eval 'sub BT_256K () {0x4;}' unless defined(&BT_256K);
	    eval 'sub BT_128K () {0x;}' unless defined(&BT_128K);
	    eval 'sub BT_NOACCESS () {0x;}' unless defined(&BT_NOACCESS);
	    eval 'sub BT_RDONLY () {0x1;}' unless defined(&BT_RDONLY);
	    eval 'sub BT_WRITE () {0x2;}' unless defined(&BT_WRITE);
	    eval 'sub BT_VS () {0x2;}' unless defined(&BT_VS);
	    eval 'sub BT_VP () {0x1;}' unless defined(&BT_VP);
	    eval 'sub DBATU {
	        my($eaddr, $size, $val) = @_;
    		eval q(((($eaddr) & 0xfffe0000) | ($size) | ($val)));
	    }' unless defined(&DBATU);
	    eval 'sub DBATL {
	        my($raddr, $wimg, $pp) = @_;
    		eval q(((($raddr) & 0xfffe0000) | (($wimg) << 3) | ($pp)));
	    }' unless defined(&DBATL);
	    eval 'sub DBATU_D {
	        my($eaddr, $size, $val) = @_;
    		eval q((( & 1.84467440737094e+19) | | ($val)));
	    }' unless defined(&DBATU_D);
	    eval 'sub DBATL_D {
	        my($raddr, $wimg, $pp) = @_;
    		eval q((((( & )) | ( << 3) | (($pp)))));
	    }' unless defined(&DBATL_D);
	    eval 'sub BAT_ESEG {
	        my($dbatu) = @_;
    		eval q(((($dbatu) >> 28)));
	    }' unless defined(&BAT_ESEG);
	    eval 'sub MIN_BAT_SIZE () {0x20000;}' unless defined(&MIN_BAT_SIZE);
	    eval 'sub MAX_BAT_SIZE () {0x10000000;}' unless defined(&MAX_BAT_SIZE);
	    eval 'sub ASR_VALID () {(1);}' unless defined(&ASR_VALID);
	    unless(defined(&__64BIT_KERNEL)) {
		eval 'sub USER_SLB_START () {16;}' unless defined(&USER_SLB_START);
		eval 'sub SLBR_TESID () {1;}' unless defined(&SLBR_TESID);
	    } else {
		eval 'sub MAX_SLB_INDEX () {63;}' unless defined(&MAX_SLB_INDEX);
		eval 'sub SLB_NUM_MASK () {0xcff;}' unless defined(&SLB_NUM_MASK);
		eval 'sub SLB_VALID () {0x8000000;}' unless defined(&SLB_VALID);
		eval 'sub SLB_E_RSVD () {0x7fffc00;}' unless defined(&SLB_E_RSVD);
		eval 'sub SLB_C () {0x80;}' unless defined(&SLB_C);
		eval 'sub SLBE {
		    my($_esid, $_index) = @_;
    		    eval q((($_esid)| &SLB_VALID|($_index)));
		}' unless defined(&SLBE);
		eval 'sub VALID_HANDLE_SSLB {
		    my($_handle) = @_;
    		    eval q((!(($_handle) & 0xff)));
		}' unless defined(&VALID_HANDLE_SSLB);
		eval 'sub HANDLE_CLASS_SSLB () {0x80;}' unless defined(&HANDLE_CLASS_SSLB);
		eval 'sub SLB_TEMP0_INDEX () {3;}' unless defined(&SLB_TEMP0_INDEX);
		eval 'sub SLB_TEMP1_INDEX () {4;}' unless defined(&SLB_TEMP1_INDEX);
		eval 'sub SLB_TEMP2_INDEX () {5;}' unless defined(&SLB_TEMP2_INDEX);
		eval 'sub SLB_TEMP3_INDEX () {6;}' unless defined(&SLB_TEMP3_INDEX);
		eval 'sub SLB_TEMP0_ESID () {68719476720;}' unless defined(&SLB_TEMP0_ESID);
		eval 'sub SLB_TEMP1_ESID () {68719476721;}' unless defined(&SLB_TEMP1_ESID);
		eval 'sub SLB_TEMP2_ESID () {68719476722;}' unless defined(&SLB_TEMP2_ESID);
		eval 'sub SLB_TEMP3_ESID () {68719476723;}' unless defined(&SLB_TEMP3_ESID);
		eval 'sub SLB_ESID_LSHIFT () {28;}' unless defined(&SLB_ESID_LSHIFT);
		eval 'sub SLBIE_SLB_CLASS () {0x8000000;}' unless defined(&SLBIE_SLB_CLASS);
	    }
	}
    }
    eval 'sub __INTPAD {
        my($nm) = @_;
	    eval q();
    }' unless defined(&__INTPAD);
}
1;
