require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_MODE)) {
    eval 'sub _H_MODE () {1;}' unless defined(&_H_MODE);
    require 'standards.ph';
    if(defined(&_POSIX_SOURCE)) {
	eval 'sub _S_IFMT () {0170000;}' unless defined(&_S_IFMT);
	eval 'sub _S_IFREG () {0100000;}' unless defined(&_S_IFREG);
	eval 'sub _S_IFDIR () {0040000;}' unless defined(&_S_IFDIR);
	eval 'sub _S_IFBLK () {0060000;}' unless defined(&_S_IFBLK);
	eval 'sub _S_IFCHR () {0020000;}' unless defined(&_S_IFCHR);
	eval 'sub _S_IFIFO () {0010000;}' unless defined(&_S_IFIFO);
	eval 'sub S_ISUID () {0004000;}' unless defined(&S_ISUID);
	eval 'sub S_ISGID () {0002000;}' unless defined(&S_ISGID);
	eval 'sub S_IRWXU () {0000700;}' unless defined(&S_IRWXU);
	eval 'sub S_IRUSR () {0000400;}' unless defined(&S_IRUSR);
	eval 'sub S_IWUSR () {0000200;}' unless defined(&S_IWUSR);
	eval 'sub S_IXUSR () {0000100;}' unless defined(&S_IXUSR);
	eval 'sub S_IRWXG () {0000070;}' unless defined(&S_IRWXG);
	eval 'sub S_IRGRP () {0000040;}' unless defined(&S_IRGRP);
	eval 'sub S_IWGRP () {0000020;}' unless defined(&S_IWGRP);
	eval 'sub S_IXGRP () {0000010;}' unless defined(&S_IXGRP);
	eval 'sub S_IRWXO () {0000007;}' unless defined(&S_IRWXO);
	eval 'sub S_IROTH () {0000004;}' unless defined(&S_IROTH);
	eval 'sub S_IWOTH () {0000002;}' unless defined(&S_IWOTH);
	eval 'sub S_IXOTH () {0000001;}' unless defined(&S_IXOTH);
	eval 'sub S_ISFIFO {
	    my($m) = @_;
    	    eval q(((($m)( &_S_IFMT)) == ( &_S_IFIFO)));
	}' unless defined(&S_ISFIFO);
	eval 'sub S_ISDIR {
	    my($m) = @_;
    	    eval q(((($m)( &_S_IFMT)) == ( &_S_IFDIR)));
	}' unless defined(&S_ISDIR);
	eval 'sub S_ISCHR {
	    my($m) = @_;
    	    eval q(((($m)( &_S_IFMT)) == ( &_S_IFCHR)));
	}' unless defined(&S_ISCHR);
	eval 'sub S_ISBLK {
	    my($m) = @_;
    	    eval q(((($m)( &_S_IFMT)) == ( &_S_IFBLK)));
	}' unless defined(&S_ISBLK);
	eval 'sub S_ISREG {
	    my($m) = @_;
    	    eval q(((($m)( &_S_IFMT)) == ( &_S_IFREG)));
	}' unless defined(&S_ISREG);
    }
    if(defined(&_XOPEN_SOURCE)) {
	eval 'sub S_ISVTX () {0001000;}' unless defined(&S_ISVTX);
	eval 'sub S_IFMT () { &_S_IFMT;}' unless defined(&S_IFMT);
	eval 'sub S_IFREG () { &_S_IFREG;}' unless defined(&S_IFREG);
	eval 'sub S_IFDIR () { &_S_IFDIR;}' unless defined(&S_IFDIR);
	eval 'sub S_IFBLK () { &_S_IFBLK;}' unless defined(&S_IFBLK);
	eval 'sub S_IFCHR () { &_S_IFCHR;}' unless defined(&S_IFCHR);
	eval 'sub S_IFIFO () { &_S_IFIFO;}' unless defined(&S_IFIFO);
    }
    if((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0) == 1) {
	eval 'sub S_IFLNK () {0120000;}' unless defined(&S_IFLNK);
	eval 'sub S_IFSOCK () {0140000;}' unless defined(&S_IFSOCK);
	eval 'sub S_ISLNK {
	    my($m) = @_;
    	    eval q(((($m)( &S_IFMT)) == ( &S_IFLNK)));
	}' unless defined(&S_ISLNK);
	eval 'sub S_ISSOCK {
	    my($m) = @_;
    	    eval q(((($m)( &S_IFMT)) == ( &S_IFSOCK)));
	}' unless defined(&S_ISSOCK);
    }
    if(defined(&_ALL_SOURCE)) {
	eval 'sub S_IREAD () {0000400;}' unless defined(&S_IREAD);
	eval 'sub S_IWRITE () {0000200;}' unless defined(&S_IWRITE);
	eval 'sub S_IEXEC () {0000100;}' unless defined(&S_IEXEC);
	eval 'sub S_ENFMT () { &S_ISGID;}' unless defined(&S_ENFMT);
	eval 'sub S_IFMPX () {( &S_IFCHR| &S_ISVTX);}' unless defined(&S_IFMPX);
	eval 'sub S_ISMPX {
	    my($m) = @_;
    	    eval q(((($m)( &S_IFMT| &S_ISVTX)) == ( &S_IFMPX)));
	}' unless defined(&S_ISMPX);
	eval 'sub IFMT () { &S_IFMT;}' unless defined(&IFMT);
	eval 'sub IFDIR () { &S_IFDIR;}' unless defined(&IFDIR);
	eval 'sub IFCHR () { &S_IFCHR;}' unless defined(&IFCHR);
	eval 'sub IFBLK () { &S_IFBLK;}' unless defined(&IFBLK);
	eval 'sub IFREG () { &S_IFREG;}' unless defined(&IFREG);
	eval 'sub IFIFO () { &S_IFIFO;}' unless defined(&IFIFO);
	eval 'sub IFSOCK () { &S_IFSOCK;}' unless defined(&IFSOCK);
	eval 'sub IFLNK () { &S_IFLNK;}' unless defined(&IFLNK);
	eval 'sub ISUID () { &S_ISUID;}' unless defined(&ISUID);
	eval 'sub ISGID () { &S_ISGID;}' unless defined(&ISGID);
	eval 'sub ISVTX () { &S_ISVTX;}' unless defined(&ISVTX);
	eval 'sub IREAD () { &S_IREAD;}' unless defined(&IREAD);
	eval 'sub IWRITE () { &S_IWRITE;}' unless defined(&IWRITE);
	eval 'sub IEXEC () { &S_IEXEC;}' unless defined(&IEXEC);
	eval 'sub S_INMOD () {0xc0000000;}' unless defined(&S_INMOD);
	eval 'sub S_IXMOD () {0x40000000;}' unless defined(&S_IXMOD);
	eval 'sub S_IJRNL () {0x4000000;}' unless defined(&S_IJRNL);
	eval 'sub S_IXACL () {0x2000000;}' unless defined(&S_IXACL);
	eval 'sub S_ITCB () {0x1000000;}' unless defined(&S_ITCB);
	eval 'sub S_ITP () {0x800000;}' unless defined(&S_ITP);
    }
}
1;
