require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_PARAM)) {
    eval 'sub _H_PARAM () {1;}' unless defined(&_H_PARAM);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    require 'sys/m_param.ph';
    require 'sys/limits.ph';
    require 'jfs/fsparam.ph';
    require 'sys/machine.ph';
    eval 'sub MAXUPRC () { &CHILD_MAX;}' unless defined(&MAXUPRC);
    eval 'sub NOFILE () { &OPEN_MAX;}' unless defined(&NOFILE);
    eval 'sub MAXPID () { &PID_MAX;}' unless defined(&MAXPID);
    eval 'sub MAXUID () { &UID_MAX;}' unless defined(&MAXUID);
    eval 'sub MAXLINK () { &LINK_MAX;}' unless defined(&MAXLINK);
    eval 'sub MAXBLK () {500;}' unless defined(&MAXBLK);
    eval 'sub CANBSIZ () { &MAX_CANON;}' unless defined(&CANBSIZ);
    eval 'sub NCARGS_SHIFT () {19;}' unless defined(&NCARGS_SHIFT);
    eval 'sub NCARGS () { &ARG_MAX;}' unless defined(&NCARGS);
    eval 'sub NCARGS_MAX () {(1<< &NCARGS_SHIFT);}' unless defined(&NCARGS_MAX);
    eval 'sub NGROUPS () { &NGROUPS_MAX;}' unless defined(&NGROUPS);
    unless(defined(&PAGESIZE)) {
	eval 'sub PAGESIZE () {4096;}' unless defined(&PAGESIZE);
    }
    eval 'sub PGSHIFT () {12;}' unless defined(&PGSHIFT);
    eval 'sub NBPW () {$sizeof{\'int\'};}' unless defined(&NBPW);
    eval 'sub NBPB () {(8);}' unless defined(&NBPB);
    eval 'sub BPBSHIFT () {(3);}' unless defined(&BPBSHIFT);
    eval 'sub UWSHIFT () {(5);}' unless defined(&UWSHIFT);
    eval 'sub UBSIZE () {512;}' unless defined(&UBSIZE);
    eval 'sub UBSHIFT () {9;}' unless defined(&UBSHIFT);
    eval 'sub NCPS () {1;}' unless defined(&NCPS);
    eval 'sub NBPC () { &PAGESIZE;}' unless defined(&NBPC);
    eval 'sub NCPD () {1;}' unless defined(&NCPD);
    eval 'sub BPCSHIFT () {12;}' unless defined(&BPCSHIFT);
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    eval 'sub GOOD () {0;}' unless defined(&GOOD);
    eval 'sub BAD () {(-1);}' unless defined(&BAD);
    eval 'sub MAXPATHLEN () {( &PATH_MAX+1);}' unless defined(&MAXPATHLEN);
    eval 'sub MAXSYMLINKS () {20;}' unless defined(&MAXSYMLINKS);
    unless(defined(&MAXBSIZE)) {
	if(defined(&BSIZE)) {
	    eval 'sub MAXBSIZE () { &BSIZE;}' unless defined(&MAXBSIZE);
	} else {
	    eval 'sub MAXBSIZE () {4096;}' unless defined(&MAXBSIZE);
	}
    }
    eval 'sub MAXPATH () {512;}' unless defined(&MAXPATH);
    eval 'sub CMASK () {0;}' unless defined(&CMASK);
    eval 'sub CDLIMIT () {(1<<13);}' unless defined(&CDLIMIT);
    eval 'sub NODEVICE () {( &dev_t)(-1);}' unless defined(&NODEVICE);
    eval 'sub BASEPRI () {
        eval q(( &PS == 7));
    }' unless defined(&BASEPRI);
    eval 'sub BUSOPEN {
        my($ics) = @_;
	    eval q(($ics & 0x18));
    }' unless defined(&BUSOPEN);
    if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	eval 'sub lobyte {
	    my($X) = @_;
    	    eval q(((($X))[1]));
	}' unless defined(&lobyte);
	eval 'sub hibyte {
	    my($X) = @_;
    	    eval q(((($X))[0]));
	}' unless defined(&hibyte);
	eval 'sub loword {
	    my($X) = @_;
    	    eval q(((($X))[1]));
	}' unless defined(&loword);
	eval 'sub hiword {
	    my($X) = @_;
    	    eval q(((($X))[0]));
	}' unless defined(&hiword);
    } else {
	eval 'sub lobyte {
	    my($X) = @_;
    	    eval q(((($X))[0]));
	}' unless defined(&lobyte);
	eval 'sub hibyte {
	    my($X) = @_;
    	    eval q(((($X))[1]));
	}' unless defined(&hibyte);
	eval 'sub loword {
	    my($X) = @_;
    	    eval q(((($X))[0]));
	}' unless defined(&loword);
	eval 'sub hiword {
	    my($X) = @_;
    	    eval q(((($X))[1]));
	}' unless defined(&hiword);
    }
    eval 'sub setbit {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] |= 1<<(($i)% &NBBY)));
    }' unless defined(&setbit);
    eval 'sub clrbit {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] &= ~(1<<(($i)% &NBBY))));
    }' unless defined(&clrbit);
    eval 'sub isset {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))));
    }' unless defined(&isset);
    eval 'sub isclr {
        my($a,$i) = @_;
	    eval q(((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))) == 0));
    }' unless defined(&isclr);
    unless(defined(&MIN)) {
	eval 'sub MIN {
	    my($a,$b) = @_;
    	    eval q(((($a)<($b))?($a):($b)));
	}' unless defined(&MIN);
    }
    unless(defined(&MAX)) {
	eval 'sub MAX {
	    my($a,$b) = @_;
    	    eval q(((($a)>($b))?($a):($b)));
	}' unless defined(&MAX);
    }
    unless(defined(&howmany)) {
	eval 'sub howmany {
	    my($x, $y) = @_;
    	    eval q(((($x)+(($y)-1))/($y)));
	}' unless defined(&howmany);
    }
    eval 'sub roundup {
        my($x, $y) = @_;
	    eval q((((($x)+(($y)-1))/($y))*($y)));
    }' unless defined(&roundup);
    unless(defined(&MAXHOSTNAMELEN)) {
	eval 'sub MAXHOSTNAMELEN () {256;}' unless defined(&MAXHOSTNAMELEN);
    }
    eval 'sub NBPG () { &PAGESIZE;}' unless defined(&NBPG);
    eval 'sub CLUSTERSIZE () {1;}' unless defined(&CLUSTERSIZE);
    eval 'sub CLBYTES () {( &CLUSTERSIZE* &PAGESIZE);}' unless defined(&CLBYTES);
    eval 'sub CLOFSET () {( &CLUSTERSIZE* &PAGESIZE-1);}' unless defined(&CLOFSET);
    eval 'sub claligned {
        my($x) = @_;
	    eval q((((($x)) &CLOFSET)==0));
    }' unless defined(&claligned);
    eval 'sub CLOFF () { &CLOFSET;}' unless defined(&CLOFF);
    eval 'sub CLSIZELOG2 () {0;}' unless defined(&CLSIZELOG2);
    eval 'sub CLSHIFT () {( &BPCSHIFT+ &CLSIZELOG2);}' unless defined(&CLSHIFT);
    if((defined(&CLUSTERSIZE) ? &CLUSTERSIZE : 0)==1) {
	eval 'sub clbase {
	    my($i) = @_;
    	    eval q(($i));
	}' unless defined(&clbase);
	eval 'sub clrnd {
	    my($i) = @_;
    	    eval q(($i));
	}' unless defined(&clrnd);
    } else {
	eval 'sub clbase {
	    my($i) = @_;
    	    eval q((($i) &~ ( &CLUSTERSIZE-1)));
	}' unless defined(&clbase);
	eval 'sub clrnd {
	    my($i) = @_;
    	    eval q(((($i) + ( &CLUSTERSIZE-1)) &~ ( &CLUSTERSIZE-1)));
	}' unless defined(&clrnd);
    }
    if(defined(&_BSD)) {
	unless(defined(&_KERNEL)) {
	    require 'sys/signal.ph';
	}
    }
    require 'sys/sysmacros.ph';
    if(defined(&__cplusplus)) {
    }
}
1;
