require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_PMZONE)) {
    eval 'sub _H_PMZONE () {1;}' unless defined(&_H_PMZONE);
    require 'sys/lock_def.ph';
    require 'sys/uthread.ph';
    eval 'sub PM_ZERO () {0x1;}' unless defined(&PM_ZERO);
    eval 'sub PM_FIFO () {0x2;}' unless defined(&PM_FIFO);
    eval 'sub PM_GLOBAL () {0x4;}' unless defined(&PM_GLOBAL);
    eval 'sub PM_PROC () {0x8;}' unless defined(&PM_PROC);
    eval 'sub PM_THREAD () {0x10;}' unless defined(&PM_THREAD);
    eval 'sub PM_PRIMARY () {0x20;}' unless defined(&PM_PRIMARY);
    eval 'sub PM_LAST () {0x40;}' unless defined(&PM_LAST);
    eval 'sub PM_BIGZONE () {0x80;}' unless defined(&PM_BIGZONE);
    if(defined(&__ia64)) {
	eval 'sub MAXCPUS_SRAD () {32;}' unless defined(&MAXCPUS_SRAD);
    } else {
	eval 'sub MAXCPUS_SRAD () {48;}' unless defined(&MAXCPUS_SRAD);
    }
    unless(defined(&_32KERMODE)) {
	if(defined(&_KERNEL)) {
	    eval 'sub PM_NUMSRAD_BITS () {5;}' unless defined(&PM_NUMSRAD_BITS);
	    eval 'sub PM_NUMSRAD_ZONES () {(1<< &PM_NUMSRAD_BITS);}' unless defined(&PM_NUMSRAD_ZONES);
	    if(defined(&__64BIT_KERNEL)) {
		eval 'sub PM_PZONE_SHIFT () {23;}' unless defined(&PM_PZONE_SHIFT);
	    } else {
		eval 'sub PM_PZONE_SHIFT () {22;}' unless defined(&PM_PZONE_SHIFT);
	    }
	    eval 'sub PM_TZONE_SHIFT () {21;}' unless defined(&PM_TZONE_SHIFT);
	    eval 'sub PM_LZONE_SHIFT () {28;}' unless defined(&PM_LZONE_SHIFT);
	    eval 'sub MAX_PM_TZONE () {(1 <<  &PM_TZONE_SHIFT);}' unless defined(&MAX_PM_TZONE);
	    eval 'sub MAX_PM_PZONE () {(1 <<  &PM_PZONE_SHIFT);}' unless defined(&MAX_PM_PZONE);
	    eval 'sub MAX_PM_LZONE () {(1 <<  &PM_LZONE_SHIFT);}' unless defined(&MAX_PM_LZONE);
	    eval 'sub PM_TZONE_OFFSET {
	        my($_x) = @_;
    		eval q((($_x) & ( &MAX_PM_TZONE-1)));
	    }' unless defined(&PM_TZONE_OFFSET);
	    eval 'sub PM_PZONE_OFFSET {
	        my($_x) = @_;
    		eval q((($_x) & ( &MAX_PM_PZONE-1)));
	    }' unless defined(&PM_PZONE_OFFSET);
	    eval 'sub PM_LZONE_OFFSET {
	        my($_x) = @_;
    		eval q((($_x) & ( &MAX_PM_LZONE-1)));
	    }' unless defined(&PM_LZONE_OFFSET);
	    eval 'sub PM_TZONE_BASE {
	        my($_x) = @_;
    		eval q((($_x) & ~( &MAX_PM_TZONE-1)));
	    }' unless defined(&PM_TZONE_BASE);
	    eval 'sub PM_PZONE_BASE {
	        my($_x) = @_;
    		eval q((($_x) & ~( &MAX_PM_PZONE-1)));
	    }' unless defined(&PM_PZONE_BASE);
	    eval 'sub PM_LZONE_BASE {
	        my($_x) = @_;
    		eval q((($_x) & ~( &MAX_PM_LZONE-1)));
	    }' unless defined(&PM_LZONE_BASE);
	    eval 'sub PM_ZONE_OFFSET {
	        my($_x,$flags) = @_;
    		eval q((($flags &  &PM_GLOBAL)? (($flags &  &PM_PROC) ?  &PM_PZONE_OFFSET($_x) :  &PM_TZONE_OFFSET($_x)) :  &PM_LZONE_OFFSET($_x) ));
	    }' unless defined(&PM_ZONE_OFFSET);
	    eval 'sub ZONE_BASE {
	        my($_z) = @_;
    		eval q(( (($_z)-> &flags &  &PM_GLOBAL) ? ($_z)-> &base :  &PM_LZONE_BASE($_z)));
	    }' unless defined(&ZONE_BASE);
	    if(defined(&_KERNSYS)) {
	    }
	    if(defined(&__64BIT_KERNEL)) {
		eval 'sub pm_alloc_local {
		    my($n, $node) = @_;
    		    eval q( &xmalloc_srad(($n), 7,  &pinned_heap, ($node)));
		}' unless defined(&pm_alloc_local);
		eval 'sub pm_free_local {
		    my($n) = @_;
    		    eval q( &xmfree(($n),  &pinned_heap));
		}' unless defined(&pm_free_local);
	    } else {
		eval 'sub pm_alloc_local {
		    my($n, $node) = @_;
    		    eval q( &xmalloc(($n), 7,  &pinned_heap0));
		}' unless defined(&pm_alloc_local);
		eval 'sub pm_free_local {
		    my($n) = @_;
    		    eval q( &xmfree(($n),  &pinned_heap0));
		}' unless defined(&pm_free_local);
	    }
	    eval 'sub round_down {
	        my($addr,$size) = @_;
    		eval q((( &pmbase_t)($addr) & ~($size-1)));
	    }' unless defined(&round_down);
	    eval 'sub round_up {
	        my($addr,$size) = @_;
    		eval q( &round_down(( &pmbase_t)($addr)+($size)-1,($size)));
	    }' unless defined(&round_up);
	}
    }
}
1;
