require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SEG)) {
    eval 'sub _H_SEG () {1;}' unless defined(&_H_SEG);
    require 'sys/inode.ph';
    if(defined( &_POWER) || defined( &__ia64)) {
	unless(defined(&__64BIT_KERNEL)) {
	    eval 'sub SRTOSID {
	        my($srval) = @_;
    		eval q(( ($srval) & 0xffffff ));
	    }' unless defined(&SRTOSID);
	    eval 'sub SRTOKEY {
	        my($srval) = @_;
    		eval q(( (($srval) >> 30) & 0x1 ));
	    }' unless defined(&SRTOKEY);
	    if(defined(&_KERNSYS)) {
		eval 'sub SRVAL {
		    my($sid,$key,$special) = @_;
    		    eval q(( ($sid) | (($key) ?  &key_value : 0) ));
		}' unless defined(&SRVAL);
	    } else {
		eval 'sub SRVAL {
		    my($sid,$key,$special) = @_;
    		    eval q(( ($sid) | ($key) << 30));
		}' unless defined(&SRVAL);
	    }
	} else {
	    if(defined(&_KERNSYS)) {
		eval 'sub SRVAL {
		    my($sid,$key,$special) = @_;
    		    eval q(( &vm_handle(( &vmid_t)($sid), ($key))));
		}' unless defined(&SRVAL);
	    }
	}
    }
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub L2SIDLIMIT () {28;}' unless defined(&L2SIDLIMIT);
    } else {
	eval 'sub L2SIDLIMIT () {23;}' unless defined(&L2SIDLIMIT);
    }
    eval 'sub SIDMAX () {((1<<  &L2SIDLIMIT) - 1);}' unless defined(&SIDMAX);
    eval 'sub INVLSID () { &SIDMAX;}' unless defined(&INVLSID);
    eval 'sub INVLVMID () {(( &vmid_t) &SIDMAX);}' unless defined(&INVLVMID);
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub INVLKVMID () {(( &kvmid_t) &SIDMAX);}' unless defined(&INVLKVMID);
    }
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub UNKNSID () {( &SIDMAX-2);}' unless defined(&UNKNSID);
	eval 'sub INVALIDSID {
	    my($sid) = @_;
    	    eval q((($sid) ==  &INVLSID || ($sid) ==  &RSVDSID || ($sid) ==  &UNKNSID));
	}' unless defined(&INVALIDSID);
    } else {
	eval 'sub INVALIDSID {
	    my($sid) = @_;
    	    eval q((($sid) ==  &INVLSID || ($sid) ==  &RSVDSID));
	}' unless defined(&INVALIDSID);
    }
    eval 'sub NSEGS () {16;}' unless defined(&NSEGS);
    eval 'sub SEGSHIFT () {28;}' unless defined(&SEGSHIFT);
    eval 'sub SEGOFFSET {
        my($x) = @_;
	    eval q(((($x))& 0xfffffff));
    }' unless defined(&SEGOFFSET);
    eval 'sub SEGNUMBER {
        my($x) = @_;
	    eval q(((($x))>>28));
    }' unless defined(&SEGNUMBER);
    eval 'sub SEGSIZE () {(1<<28);}' unless defined(&SEGSIZE);
    eval 'sub NULLSEGID () { &INVLSID;}' unless defined(&NULLSEGID);
    eval 'sub NULLSEGVAL () { &SRVAL( &NULLSEGID,0,0);}' unless defined(&NULLSEGVAL);
    eval 'sub KERNELSEGID () {0x;}' unless defined(&KERNELSEGID);
    eval 'sub KERNELSEGVAL () { &SRVAL( &KERNELSEGID,0,0);}' unless defined(&KERNELSEGVAL);
    eval 'sub BASE {
        my($seg) = @_;
	    eval q((($seg)<< &SEGSHIFT));
    }' unless defined(&BASE);
    eval 'sub TOP {
        my($seg) = @_;
	    eval q((( &BASE(($seg)+1))-1));
    }' unless defined(&TOP);
    eval 'sub LASTLONG {
        my($seg) = @_;
	    eval q((( &BASE($seg+1))-4));
    }' unless defined(&LASTLONG);
    eval 'sub KERNELORG () {0x;}' unless defined(&KERNELORG);
    eval 'sub KERNELSEG () {0;}' unless defined(&KERNELSEG);
    eval 'sub KERNEXORG () {0xe0000000;}' unless defined(&KERNEXORG);
    eval 'sub KERNEXSEG () {14;}' unless defined(&KERNEXSEG);
    eval 'sub KX2ORG () {0x10000000;}' unless defined(&KX2ORG);
    eval 'sub KX2SEG () {1;}' unless defined(&KX2SEG);
    eval 'sub KX3ORG () {0x30000000;}' unless defined(&KX3ORG);
    eval 'sub KX3SEG () {3;}' unless defined(&KX3SEG);
    eval 'sub TEXTORG () {0x10000000;}' unless defined(&TEXTORG);
    eval 'sub TEXTSEG () {1;}' unless defined(&TEXTSEG);
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub PRIVORG () {0x20000000;}' unless defined(&PRIVORG);
	eval 'sub PRIVSEG () {2;}' unless defined(&PRIVSEG);
    } else {
	if(defined(&_POWER)) {
	    eval 'sub PRIVORG () {1.72938225696396e+19;}' unless defined(&PRIVORG);
	    eval 'sub PRIVSEG () {64424509442;}' unless defined(&PRIVSEG);
	}
	if(defined(&__ia64)) {
	    eval 'sub PRIVORG () {1.12480093208576e+15;}' unless defined(&PRIVORG);
	    eval 'sub PRIVSEG () {0x3ff002;}' unless defined(&PRIVSEG);
	}
    }
    eval 'sub PRIVORG_LO () {0x20000000;}' unless defined(&PRIVORG_LO);
    eval 'sub PRIVSEG_LO () {2;}' unless defined(&PRIVSEG_LO);
    eval 'sub DATAORG () {0x20000000;}' unless defined(&DATAORG);
    eval 'sub DATASEG () {2;}' unless defined(&DATASEG);
    eval 'sub STACKSEG () {2;}' unless defined(&STACKSEG);
    eval 'sub BDATASEG () {3;}' unless defined(&BDATASEG);
    eval 'sub BDATAORG () {0x30000000;}' unless defined(&BDATAORG);
    eval 'sub BDATASEGMAX () {11;}' unless defined(&BDATASEGMAX);
    eval 'sub TEMPORG () {0xc0000000;}' unless defined(&TEMPORG);
    eval 'sub TEMPSEG () {12;}' unless defined(&TEMPSEG);
    eval 'sub SHTEXTORG () {0xd0000000;}' unless defined(&SHTEXTORG);
    eval 'sub SHTEXTSEG () {13;}' unless defined(&SHTEXTSEG);
    eval 'sub DSASEGMAX () {13;}' unless defined(&DSASEGMAX);
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub KTHREADORG () {0xf0000000;}' unless defined(&KTHREADORG);
	eval 'sub KTHREADSEG () {15;}' unless defined(&KTHREADSEG);
    } else {
	if(defined(&_POWER)) {
	    eval 'sub KTHREADORG () {1.7293822569908e+19;}' unless defined(&KTHREADORG);
	    eval 'sub KTHREADSEG () {64424509443;}' unless defined(&KTHREADSEG);
	}
	if(defined(&__ia64)) {
	    eval 'sub KTHREADORG () {1.12480120052122e+15;}' unless defined(&KTHREADORG);
	    eval 'sub KTHREADSEG () {0x3ff003;}' unless defined(&KTHREADSEG);
	}
    }
    eval 'sub IOORG () {0xf0000000;}' unless defined(&IOORG);
    eval 'sub IOSEG () {15;}' unless defined(&IOSEG);
    eval 'sub SHDATAORG () {0xf0000000;}' unless defined(&SHDATAORG);
    eval 'sub SHDATASEG () {15;}' unless defined(&SHDATASEG);
    eval 'sub MBUF1ORG () {(0x70000000);}' unless defined(&MBUF1ORG);
    eval 'sub MBUFSEG1 () {(7);}' unless defined(&MBUFSEG1);
    eval 'sub MBUF2ORG () {(0x80000000);}' unless defined(&MBUF2ORG);
    eval 'sub MBUFSEG2 () {(8);}' unless defined(&MBUFSEG2);
    eval 'sub MBUF3ORG () {(0x90000000);}' unless defined(&MBUF3ORG);
    eval 'sub MBUFSEG3 () {(9);}' unless defined(&MBUFSEG3);
    eval 'sub MBUF4ORG () {(0xa0000000);}' unless defined(&MBUF4ORG);
    eval 'sub MBUFSEG4 () {(10);}' unless defined(&MBUFSEG4);
    if(defined(&__64BIT_KERNEL)) {
	if(defined(&_POWER)) {
	    eval 'sub USERALIAS () {( &user_alias_addr);}' unless defined(&USERALIAS);
	    eval 'sub LOADERALIAS () {( &loader_alias_addr);}' unless defined(&LOADERALIAS);
	    eval 'sub USERALIAS_LO () {( &USERALIAS >> 28);}' unless defined(&USERALIAS_LO);
	    eval 'sub LOADERALIAS_LO () {( &LOADERALIAS >> 28);}' unless defined(&LOADERALIAS_LO);
	}
    }
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub NEW_ADSPACE () {0xf000;}' unless defined(&NEW_ADSPACE);
    } else {
	eval 'sub NEW_ADSPACE () {( &g_adspaceval);}' unless defined(&NEW_ADSPACE);
    }
    eval 'sub PRIV_SEG_OPTS () {0x80000000;}' unless defined(&PRIV_SEG_OPTS);
    eval 'sub TEXT_SEG_OPTS () {0x40000000;}' unless defined(&TEXT_SEG_OPTS);
    eval 'sub READ_ACC () {1;}' unless defined(&READ_ACC);
    eval 'sub WRITE_ACC () {2;}' unless defined(&WRITE_ACC);
    if(defined(&__64BIT_KERNEL)) {
    } else {
    }
    if(defined(&__64BIT__)) {
    } else {
	if(defined(&_KERNSYS)) {
	} else {
	}
    }
    unless(defined(&__64BIT_KERNEL)) {
    }
    eval 'sub shm_ptr () { ($u_ptrs->{shmptr});}' unless defined(&shm_ptr);
    eval 'sub segfileno () { ($u_ptrs->{mfileno});}' unless defined(&segfileno);
    eval 'sub ss_attr () { ($u_ptrs->{attr});}' unless defined(&ss_attr);
    eval 'sub av_nsegs () { ($u_ptrs->{nsegs});}' unless defined(&av_nsegs);
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub ss_srval () { ($u_ptrs->{srval});}' unless defined(&ss_srval);
    }
    eval 'sub SEG_AVAIL () {0x;}' unless defined(&SEG_AVAIL);
    eval 'sub SEG_SHARED () {0x1;}' unless defined(&SEG_SHARED);
    eval 'sub SEG_MAPPED () {0x2;}' unless defined(&SEG_MAPPED);
    eval 'sub SEG_MRDWR () {0x4;}' unless defined(&SEG_MRDWR);
    eval 'sub SEG_DEFER () {0x8;}' unless defined(&SEG_DEFER);
    eval 'sub SEG_MMAP () {0x10;}' unless defined(&SEG_MMAP);
    eval 'sub SEG_WORKING () {0x20;}' unless defined(&SEG_WORKING);
    eval 'sub SEG_RMMAP () {0x40;}' unless defined(&SEG_RMMAP);
    eval 'sub SEG_OTHER () {0x80;}' unless defined(&SEG_OTHER);
    eval 'sub SEG_EXTSHM () {0x100;}' unless defined(&SEG_EXTSHM);
    eval 'sub SEG_TEXT () {0x200;}' unless defined(&SEG_TEXT);
    eval 'sub SEGATTR_TEXT () {0x40000000;}' unless defined(&SEGATTR_TEXT);
    if(defined(&_POWER)) {
	eval 'sub VM_MAXADDR () {(0xfffffff);}' unless defined(&VM_MAXADDR);
	eval 'sub MAXSRNO64 () {(0xffffffff);}' unless defined(&MAXSRNO64);
	if(defined( &_LONG_LONG)  && defined( &_KERNEL)) {
	    eval 'sub VM_MAXADDR64 () {((((1)<<60)-1));}' unless defined(&VM_MAXADDR64);
	}
    }
    if(defined(&__ia64)) {
	if(defined( &_LONG_LONG)  && defined( &_KERNEL)) {
	    eval 'sub VM_MAXADDR64 () {((((1)<<63)-1));}' unless defined(&VM_MAXADDR64);
	    eval 'sub VM_MAXPRIV () {((((0x3ff00)<<32)-1));}' unless defined(&VM_MAXPRIV);
	    eval 'sub VM_MAXADDR () {( &VM_MAXADDR64 >> 32);}' unless defined(&VM_MAXADDR);
	    eval 'sub MAXSRNO64 () {( &SEGNUMBER( &VM_MAXADDR64));}' unless defined(&MAXSRNO64);
	}
    }
    if(defined(&_LONG_LONG)) {
	eval 'sub ISVALID32 {
	    my($a) = @_;
    	    eval q(((($a) >> 32) ? 0: 1));
	}' unless defined(&ISVALID32);
    } else {
	if(defined(&__64BIT__)) {
	    eval 'sub ISVALID32 {
	        my($a) = @_;
    		eval q(((($a) >> 32) ? 0: 1));
	    }' unless defined(&ISVALID32);
	} else {
	    eval 'sub ISVALID32 {
	        my($a) = @_;
    		eval q((1));
	    }' unless defined(&ISVALID32);
	}
    }
    if(defined( &_LONG_LONG)  && defined( &_KERNEL)) {
	eval 'sub ISVALID64 {
	    my($a) = @_;
    	    eval q(((($a) >  &VM_MAXADDR64) ? 0: 1));
	}' unless defined(&ISVALID64);
    }
    eval 'sub un_adsp () { ($ua->{adsp});}' unless defined(&un_adsp);
    eval 'sub un_alloc () { ($ua->{adsp}->{alloc});}' unless defined(&un_alloc);
    eval 'sub un_srval () { ($ua->{adsp}->{srval});}' unless defined(&un_srval);
    eval 'sub un_child () { ($ua->{childptr});}' unless defined(&un_child);
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub NADNODES () {4;}' unless defined(&NADNODES);
	eval 'sub NSEGNODES () {2;}' unless defined(&NSEGNODES);
    }
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub VM_ESIDBITS () {36;}' unless defined(&VM_ESIDBITS);
	eval 'sub VM_LEAFNODE () {8;}' unless defined(&VM_LEAFNODE);
    } else {
	eval 'sub VM_ESIDBITS () {32;}' unless defined(&VM_ESIDBITS);
	eval 'sub VM_LEAFNODE () {7;}' unless defined(&VM_LEAFNODE);
    }
    eval 'sub LOGNSIZE {
        my($level) = @_;
	    eval q(( &VM_ESIDBITS - (($level) << 2)));
    }' unless defined(&LOGNSIZE);
    eval 'sub NODESIZE {
        my($level) = @_;
	    eval q((( &esid_t)1<<  &LOGNSIZE($level)));
    }' unless defined(&NODESIZE);
    eval 'sub VM_MAKEADSP () {(1);}' unless defined(&VM_MAKEADSP);
    eval 'sub VM_FINDADSP () {(2);}' unless defined(&VM_FINDADSP);
    eval 'sub VM_MAKEKPROC () {(3);}' unless defined(&VM_MAKEKPROC);
    eval 'sub UREQUEST () {(1);}' unless defined(&UREQUEST);
    eval 'sub UREQUEST_LOW () {(2);}' unless defined(&UREQUEST_LOW);
    eval 'sub KREQUEST () {(3);}' unless defined(&KREQUEST);
}
1;
