require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SOCKET_H_)) {
    eval 'sub _SYS_SOCKET_H_ () {1;}' unless defined(&_SYS_SOCKET_H_);
    require 'standards.ph';
    require 'sys/types.ph';
    require 'sys/uio.ph';
    if(defined(&_ALL_SOURCE)) {
	unless(defined(&_KERNEL)) {
	    if(defined(&__cplusplus)) {
		unless(defined(&COMPAT_43)) {
		} else {
		}
	    } else {
		eval 'sub recvfrom () { &nrecvfrom;}' unless defined(&recvfrom);
		eval 'sub accept () { &naccept;}' unless defined(&accept);
		eval 'sub getpeername () { &ngetpeername;}' unless defined(&getpeername);
		eval 'sub getsockname () { &ngetsockname;}' unless defined(&getsockname);
		unless(defined(&COMPAT_43)) {
		    eval 'sub recvmsg () { &nrecvmsg;}' unless defined(&recvmsg);
		    eval 'sub sendmsg () { &nsendmsg;}' unless defined(&sendmsg);
		}
	    }
	}
    }
    if((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0) == 1) {
	eval 'sub SOCK_STREAM () {1;}' unless defined(&SOCK_STREAM);
	eval 'sub SOCK_DGRAM () {2;}' unless defined(&SOCK_DGRAM);
	eval 'sub SOCK_RAW () {3;}' unless defined(&SOCK_RAW);
	eval 'sub SOCK_RDM () {4;}' unless defined(&SOCK_RDM);
	eval 'sub SOCK_SEQPACKET () {5;}' unless defined(&SOCK_SEQPACKET);
	eval 'sub SOCK_CONN_DGRAM () {6;}' unless defined(&SOCK_CONN_DGRAM);
	eval 'sub SO_DEBUG () {0x1;}' unless defined(&SO_DEBUG);
	eval 'sub SO_ACCEPTCONN () {0x2;}' unless defined(&SO_ACCEPTCONN);
	eval 'sub SO_REUSEADDR () {0x4;}' unless defined(&SO_REUSEADDR);
	eval 'sub SO_KEEPALIVE () {0x8;}' unless defined(&SO_KEEPALIVE);
	eval 'sub SO_DONTROUTE () {0x10;}' unless defined(&SO_DONTROUTE);
	eval 'sub SO_BROADCAST () {0x20;}' unless defined(&SO_BROADCAST);
	eval 'sub SO_USELOOPBACK () {0x40;}' unless defined(&SO_USELOOPBACK);
	eval 'sub SO_LINGER () {0x80;}' unless defined(&SO_LINGER);
	eval 'sub SO_OOBINLINE () {0x100;}' unless defined(&SO_OOBINLINE);
	eval 'sub SO_REUSEPORT () {0x200;}' unless defined(&SO_REUSEPORT);
	eval 'sub SO_USE_IFBUFS () {0x400;}' unless defined(&SO_USE_IFBUFS);
	eval 'sub SO_CKSUMRECV () {0x800;}' unless defined(&SO_CKSUMRECV);
	eval 'sub SO_NOREUSEADDR () {0x1000;}' unless defined(&SO_NOREUSEADDR);
	eval 'sub SO_KERNACCEPT () {0x2000;}' unless defined(&SO_KERNACCEPT);
	eval 'sub SO_AUDIT () {0x8000;}' unless defined(&SO_AUDIT);
	eval 'sub SO_SNDBUF () {0x1001;}' unless defined(&SO_SNDBUF);
	eval 'sub SO_RCVBUF () {0x1002;}' unless defined(&SO_RCVBUF);
	eval 'sub SO_SNDLOWAT () {0x1003;}' unless defined(&SO_SNDLOWAT);
	eval 'sub SO_RCVLOWAT () {0x1004;}' unless defined(&SO_RCVLOWAT);
	eval 'sub SO_SNDTIMEO () {0x1005;}' unless defined(&SO_SNDTIMEO);
	eval 'sub SO_RCVTIMEO () {0x1006;}' unless defined(&SO_RCVTIMEO);
	eval 'sub SO_ERROR () {0x1007;}' unless defined(&SO_ERROR);
	eval 'sub SO_TYPE () {0x1008;}' unless defined(&SO_TYPE);
	eval 'sub SOL_SOCKET () {0xffff;}' unless defined(&SOL_SOCKET);
	eval 'sub AF_UNSPEC () {0;}' unless defined(&AF_UNSPEC);
	eval 'sub AF_UNIX () {1;}' unless defined(&AF_UNIX);
	eval 'sub AF_INET () {2;}' unless defined(&AF_INET);
	eval 'sub AF_IMPLINK () {3;}' unless defined(&AF_IMPLINK);
	eval 'sub AF_PUP () {4;}' unless defined(&AF_PUP);
	eval 'sub AF_CHAOS () {5;}' unless defined(&AF_CHAOS);
	eval 'sub AF_NS () {6;}' unless defined(&AF_NS);
	eval 'sub AF_ISO () {7;}' unless defined(&AF_ISO);
	eval 'sub AF_OSI () { &AF_ISO;}' unless defined(&AF_OSI);
	eval 'sub AF_ECMA () {8;}' unless defined(&AF_ECMA);
	eval 'sub AF_DATAKIT () {9;}' unless defined(&AF_DATAKIT);
	eval 'sub AF_CCITT () {10;}' unless defined(&AF_CCITT);
	eval 'sub AF_SNA () {11;}' unless defined(&AF_SNA);
	eval 'sub AF_DECnet () {12;}' unless defined(&AF_DECnet);
	eval 'sub AF_DLI () {13;}' unless defined(&AF_DLI);
	eval 'sub AF_LAT () {14;}' unless defined(&AF_LAT);
	eval 'sub AF_HYLINK () {15;}' unless defined(&AF_HYLINK);
	eval 'sub AF_APPLETALK () {16;}' unless defined(&AF_APPLETALK);
	eval 'sub AF_ROUTE () {17;}' unless defined(&AF_ROUTE);
	eval 'sub AF_LINK () {18;}' unless defined(&AF_LINK);
	if(defined(&_AIX)) {
	    eval 'sub AF_INTF () {20;}' unless defined(&AF_INTF);
	    eval 'sub AF_RIF () {21;}' unless defined(&AF_RIF);
	    eval 'sub AF_NETWARE () {22;}' unless defined(&AF_NETWARE);
	    eval 'sub AF_NDD () {23;}' unless defined(&AF_NDD);
	    eval 'sub AF_INET6 () {24;}' unless defined(&AF_INET6);
	    eval 'sub AF_MAX () {30;}' unless defined(&AF_MAX);
	} else {
	    eval 'sub AF_MAX () {20;}' unless defined(&AF_MAX);
	}
	unless(defined(&_SA_FAMILY_T)) {
	    eval 'sub _SA_FAMILY_T () {1;}' unless defined(&_SA_FAMILY_T);
	}
	if(defined( &COMPAT_43)  && !defined( &_KERNEL)) {
	} else {
	}
	eval 'sub PF_UNSPEC () { &AF_UNSPEC;}' unless defined(&PF_UNSPEC);
	eval 'sub PF_UNIX () { &AF_UNIX;}' unless defined(&PF_UNIX);
	eval 'sub PF_INET () { &AF_INET;}' unless defined(&PF_INET);
	eval 'sub PF_IMPLINK () { &AF_IMPLINK;}' unless defined(&PF_IMPLINK);
	eval 'sub PF_PUP () { &AF_PUP;}' unless defined(&PF_PUP);
	eval 'sub PF_CHAOS () { &AF_CHAOS;}' unless defined(&PF_CHAOS);
	eval 'sub PF_NS () { &AF_NS;}' unless defined(&PF_NS);
	eval 'sub PF_ISO () { &AF_ISO;}' unless defined(&PF_ISO);
	eval 'sub PF_OSI () { &AF_ISO;}' unless defined(&PF_OSI);
	eval 'sub PF_ECMA () { &AF_ECMA;}' unless defined(&PF_ECMA);
	eval 'sub PF_DATAKIT () { &AF_DATAKIT;}' unless defined(&PF_DATAKIT);
	eval 'sub PF_CCITT () { &AF_CCITT;}' unless defined(&PF_CCITT);
	eval 'sub PF_SNA () { &AF_SNA;}' unless defined(&PF_SNA);
	eval 'sub PF_DECnet () { &AF_DECnet;}' unless defined(&PF_DECnet);
	eval 'sub PF_DLI () { &AF_DLI;}' unless defined(&PF_DLI);
	eval 'sub PF_LAT () { &AF_LAT;}' unless defined(&PF_LAT);
	eval 'sub PF_HYLINK () { &AF_HYLINK;}' unless defined(&PF_HYLINK);
	eval 'sub PF_APPLETALK () { &AF_APPLETALK;}' unless defined(&PF_APPLETALK);
	eval 'sub PF_ROUTE () { &AF_ROUTE;}' unless defined(&PF_ROUTE);
	eval 'sub PF_LINK () { &AF_LINK;}' unless defined(&PF_LINK);
	eval 'sub PF_XTP () { &pseudo_AF_XTP;}' unless defined(&PF_XTP);
	if(defined(&_AIX)) {
	    eval 'sub PF_RIF () { &AF_RIF;}' unless defined(&PF_RIF);
	    eval 'sub PF_INTF () { &AF_INTF;}' unless defined(&PF_INTF);
	    eval 'sub PF_NDD () { &AF_NDD;}' unless defined(&PF_NDD);
	    eval 'sub PF_INET6 () { &AF_INET6;}' unless defined(&PF_INET6);
	}
	eval 'sub PF_MAX () { &AF_MAX;}' unless defined(&PF_MAX);
	if(defined(&_AIX)) {
	    eval 'sub SOMAXCONN () {1024;}' unless defined(&SOMAXCONN);
	} else {
	    eval 'sub SOMAXCONN () {5;}' unless defined(&SOMAXCONN);
	}
	if(defined( &COMPAT_43)  && !defined( &_KERNEL)) {
	} else {
	}
	eval 'sub MSG_MAXIOVLEN () {16;}' unless defined(&MSG_MAXIOVLEN);
	eval 'sub MSG_OOB () {0x1;}' unless defined(&MSG_OOB);
	eval 'sub MSG_PEEK () {0x2;}' unless defined(&MSG_PEEK);
	eval 'sub MSG_DONTROUTE () {0x4;}' unless defined(&MSG_DONTROUTE);
	eval 'sub MSG_EOR () {0x8;}' unless defined(&MSG_EOR);
	eval 'sub MSG_TRUNC () {0x10;}' unless defined(&MSG_TRUNC);
	eval 'sub MSG_CTRUNC () {0x20;}' unless defined(&MSG_CTRUNC);
	eval 'sub MSG_WAITALL () {0x40;}' unless defined(&MSG_WAITALL);
	eval 'sub MSG_MPEG2 () {0x80;}' unless defined(&MSG_MPEG2);
	eval 'sub MSG_NONBLOCK () {0x4000;}' unless defined(&MSG_NONBLOCK);
	eval 'sub MSG_COMPAT () {0x8000;}' unless defined(&MSG_COMPAT);
	eval 'sub CMSG_DATA {
	    my($cmsg) = @_;
    	    eval q((( &uchar_t *)(($cmsg) + 1)));
	}' unless defined(&CMSG_DATA);
	eval 'sub _CMSG_ALIGN {
	    my($p) = @_;
    	    eval q(((( &uint_t)($p) + ($sizeof{\'int\'} - 1)) &~ ($sizeof{\'int\'} - 1)));
	}' unless defined(&_CMSG_ALIGN);
	eval 'sub CMSG_NXTHDR {
	    my($mhdr, $cmsg) = @_;
    	    eval q((( + -> &cmsg_len +  &sizeof > (($mhdr)-> &msg_control) + ($mhdr)-> &msg_controllen) ? 0: (($cmsg) +  &_CMSG_ALIGN(($cmsg)-> &cmsg_len))));
	}' unless defined(&CMSG_NXTHDR);
	eval 'sub CMSG_FIRSTHDR {
	    my($mhdr) = @_;
    	    eval q((($mhdr)-> &msg_control));
	}' unless defined(&CMSG_FIRSTHDR);
	if(defined(&_LINUX_SOURCE_COMPAT)) {
	    eval 'sub CMSG_ALIGN () { &_CMSG_ALIGN;}' unless defined(&CMSG_ALIGN);
	    eval 'sub CMSG_SPACE {
	        my($len) = @_;
    		eval q(( &_CMSG_ALIGN($sizeof{\'struct cmsghdr\'}) +  &_CMSG_ALIGN($len)));
	    }' unless defined(&CMSG_SPACE);
	    eval 'sub CMSG_LEN {
	        my($len) = @_;
    		eval q(( &_CMSG_ALIGN($sizeof{\'struct cmsghdr\'}) + ($len)));
	    }' unless defined(&CMSG_LEN);
	}
	eval 'sub SCM_RIGHTS () {0x1;}' unless defined(&SCM_RIGHTS);
	eval 'sub SHUT_RD () {0;}' unless defined(&SHUT_RD);
	eval 'sub SHUT_WR () {1;}' unless defined(&SHUT_WR);
	eval 'sub SHUT_RDWR () {2;}' unless defined(&SHUT_RDWR);
	unless(defined(&_KERNEL)) {
	    if(defined(&_NO_PROTO)) {
	    } else {
		if(!defined( &_ALL_SOURCE) || defined( &_KERNEL) || !defined( &__cplusplus)) {
		    unless(defined(&COMPAT_43)) {
		    }
		}
	    }
	}
    }
    if(defined(&_ALL_SOURCE)) {
	eval 'sub pseudo_AF_XTP () {19;}' unless defined(&pseudo_AF_XTP);
	unless(defined(&_SA_FAMILY_T)) {
	    eval 'sub _SA_FAMILY_T () {1;}' unless defined(&_SA_FAMILY_T);
	}
	eval 'sub _SS_MAXSIZE () {128;}' unless defined(&_SS_MAXSIZE);
	if(defined( &__64BIT__) || (defined( &_ALL_SOURCE)  && defined( &_LONG_LONG))) {
	    eval 'sub _SS_ALIGNSIZE () {($sizeof{ &int64_t});}' unless defined(&_SS_ALIGNSIZE);
	} else {
	    eval 'sub _SS_ALIGNSIZE () {(2* $sizeof{\'int\'});}' unless defined(&_SS_ALIGNSIZE);
	}
	if(defined( &COMPAT_43)  && !defined( &_KERNEL)) {
	    eval 'sub _SS_PAD1SIZE () {( &_SS_ALIGNSIZE - $sizeof{ &ushort_t});}' unless defined(&_SS_PAD1SIZE);
	    eval 'sub _SS_PAD2SIZE () {( &_SS_MAXSIZE - ($sizeof{ &ushort_t} +  &_SS_PAD1SIZE +  &_SS_ALIGNSIZE));}' unless defined(&_SS_PAD2SIZE);
	    if(defined( &__64BIT__) || (defined( &_ALL_SOURCE)  && defined( &_LONG_LONG))) {
	    } else {
	    }
	} else {
	    eval 'sub _SS_PAD1SIZE () {( &_SS_ALIGNSIZE - ($sizeof{ &uchar_t} + $sizeof{ &sa_family_t}));}' unless defined(&_SS_PAD1SIZE);
	    eval 'sub _SS_PAD2SIZE () {( &_SS_MAXSIZE - ($sizeof{ &sa_family_t} +  &_SS_PAD1SIZE +  &_SS_ALIGNSIZE));}' unless defined(&_SS_PAD2SIZE);
	    if(defined( &__64BIT__) || (defined( &_ALL_SOURCE)  && defined( &_LONG_LONG))) {
	    } else {
	    }
	}
	unless(defined(&UIO_MAXIOV)) {
	    eval 'sub UIO_MAXIOV () {1024;}' unless defined(&UIO_MAXIOV);
	}
	unless(defined(&UIO_SMALLIOV)) {
	    eval 'sub UIO_SMALLIOV () {8;}' unless defined(&UIO_SMALLIOV);
	}
	unless(defined(&MACHINE_ALIGNMENT)) {
	    eval 'sub MACHINE_ALIGNMENT () {$sizeof{ &void };}' unless defined(&MACHINE_ALIGNMENT);
	}
	unless(defined(&ALIGN)) {
	    eval 'sub ALIGNMENT {
	        my($p) = @_;
    		eval q((($p) %  &MACHINE_ALIGNMENT));
	    }' unless defined(&ALIGNMENT);
	    eval 'sub ALIGN {
	        my($p) = @_;
    		eval q(( +  &MACHINE_ALIGNMENT - 1-  &ALIGNMENT(($p) +  &MACHINE_ALIGNMENT - 1)));
	    }' unless defined(&ALIGN);
	}
	if(defined(&__64BIT__)) {
	    eval 'sub SF_INT64 {
	        my($x) = @_;
    		eval q( &int64_t $x;);
	    }' unless defined(&SF_INT64);
	    eval 'sub SF_UINT64 {
	        my($x) = @_;
    		eval q( &uint64_t $x;);
	    }' unless defined(&SF_UINT64);
	} else {
	    if(defined(&_LONG_LONG)) {
		eval 'sub SF_INT64 {
		    my($x) = @_;
    		    eval q( &int64_t $x;);
		}' unless defined(&SF_INT64);
		eval 'sub SF_UINT64 {
		    my($x) = @_;
    		    eval q( &uint64_t $x;);
		}' unless defined(&SF_UINT64);
	    } else {
		eval 'sub SF_INT64 {
		    my($x) = @_;
    		    eval q(\'int\'  &filler_$x; \'int\' $x;);
		}' unless defined(&SF_INT64);
		eval 'sub SF_UINT64 {
		    my($x) = @_;
    		    eval q(\'int\'  &filler_$x;  &uint_t $x;);
		}' unless defined(&SF_UINT64);
	    }
	}
	if(!defined( &__64BIT__)  && defined( &__ia64)) {
	}
	eval 'sub SF_CLOSE () {0x1;}' unless defined(&SF_CLOSE);
	eval 'sub SF_REUSE () {0x2;}' unless defined(&SF_REUSE);
	eval 'sub SF_DONT_CACHE () {0x4;}' unless defined(&SF_DONT_CACHE);
	eval 'sub SF_SYNC_CACHE () {0x8;}' unless defined(&SF_SYNC_CACHE);
	unless(defined(&_KERNEL)) {
	    if(defined(&_NO_PROTO)) {
	    } else {
	    }
	} else {
	}
    }
}
1;
