require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_STR_TTY)) {
    eval 'sub _H_STR_TTY () {1;}' unless defined(&_H_STR_TTY);
    require 'sys/termio.ph';
    require 'sys/stream.ph';
    require 'sys/cfgodm.ph';
    if(defined(&_KERNEL)) {
	require 'sys/errno.ph';
	require 'sys/ioctl.ph';
	require 'termios.ph';
	require 'sys/trchkid.ph';
	require 'sys/atomic_op.ph';
	unless(defined(&__ia64)) {
	    eval 'sub TTYDBG () {1;}' unless defined(&TTYDBG);
	}
	if(defined(&__64BIT_KERNEL)) {
	    eval 'sub sysinfo_add {
	        my($x,$y) = @_;
    		eval q( &fetch_and_addlp(($x), ($y)));
	    }' unless defined(&sysinfo_add);
	} else {
	    eval 'sub sysinfo_add {
	        my($x,$y) = @_;
    		eval q( &fetch_and_add(($x), ($y)));
	    }' unless defined(&sysinfo_add);
	}
	eval 'sub MAXBAUD () { &B38400;}' unless defined(&MAXBAUD);
	undef(&cfsetispeed) if defined(&cfsetispeed);
	eval 'sub cfsetispeed {
	    my($termios_ptr, $speed) = @_;
    	    eval q({  &if (($speed) <  &B0 || ($speed) >  &MAXBAUD);  &else { ($termios_ptr)-> &c_cflag &= ~ &_CIBAUD; ($termios_ptr)-> &c_cflag |= (($speed) &  &_CBAUD) <<  &_IBSHIFT; } };);
	}' unless defined(&cfsetispeed);
	undef(&cfsetospeed) if defined(&cfsetospeed);
	eval 'sub cfsetospeed {
	    my($termios_ptr, $speed) = @_;
    	    eval q({  &if (($speed) <  &B0 || ($speed) >  &MAXBAUD);  &else { ($termios_ptr)-> &c_cflag &= ~ &_CBAUD; ($termios_ptr)-> &c_cflag |= (($speed) &  &_CBAUD); } };);
	}' unless defined(&cfsetospeed);
	undef(&cfgetospeed) if defined(&cfgetospeed);
	eval 'sub cfgetospeed {
	    my($t_ptr) = @_;
    	    eval q((($t_ptr)-> &c_cflag& &_CBAUD));
	}' unless defined(&cfgetospeed);
	undef(&cfgetispeed) if defined(&cfgetispeed);
	eval 'sub cfgetispeed {
	    my($t_ptr) = @_;
    	    eval q(((($t_ptr)-> &c_cflag& &_CIBAUD)>> &_IBSHIFT));
	}' unless defined(&cfgetispeed);
	eval 'sub TIOC_REQUEST () { &_IO(ord(\'J\'), 0x91);}' unless defined(&TIOC_REQUEST);
	eval 'sub TIOC_REPLY () { &_IO(ord(\'J\'), 0x92);}' unless defined(&TIOC_REPLY);
	eval 'sub TTYPE_NOCOPY () {0;}' unless defined(&TTYPE_NOCOPY);
	eval 'sub TTYPE_COPYIN () {1;}' unless defined(&TTYPE_COPYIN);
	eval 'sub TTYPE_COPYOUT () {2;}' unless defined(&TTYPE_COPYOUT);
	eval 'sub TTYPE_COPYINOUT () {3;}' unless defined(&TTYPE_COPYINOUT);
	eval 'sub TTYPE_IMMEDIATE () {4;}' unless defined(&TTYPE_IMMEDIATE);
	eval 'sub TIOCGETMODEM () { &_IO(ord(\'J\'), 0xa0);}' unless defined(&TIOCGETMODEM);
	eval 'sub MC_CANONQUERY () { &_IO(ord(\'J\'), 0xa1);}' unless defined(&MC_CANONQUERY);
	eval 'sub MC_NO_CANON () { &_IO(ord(\'J\'), 0xa2);}' unless defined(&MC_NO_CANON);
	eval 'sub MC_DO_CANON () { &_IO(ord(\'J\'), 0xa3);}' unless defined(&MC_DO_CANON);
	eval 'sub MC_PART_CANON () { &_IO(ord(\'J\'), 0xa4);}' unless defined(&MC_PART_CANON);
	eval 'sub LPWR () {(ord(\'l\')<<8);}' unless defined(&LPWR);
	eval 'sub LPWRITE_ACK () {( &LPWR|31);}' unless defined(&LPWRITE_ACK);
	eval("sub good_char () { 0; }") unless defined(&good_char);
	eval("sub overrun () { 1; }") unless defined(&overrun);
	eval("sub parity_error () { 2; }") unless defined(&parity_error);
	eval("sub framing_error () { 3; }") unless defined(&framing_error);
	eval("sub break_interrupt () { 4; }") unless defined(&break_interrupt);
	eval("sub cts_on () { 5; }") unless defined(&cts_on);
	eval("sub cts_off () { 6; }") unless defined(&cts_off);
	eval("sub dsr_on () { 7; }") unless defined(&dsr_on);
	eval("sub dsr_off () { 8; }") unless defined(&dsr_off);
	eval("sub ri_on () { 9; }") unless defined(&ri_on);
	eval("sub ri_off () { 10; }") unless defined(&ri_off);
	eval("sub cd_on () { 11; }") unless defined(&cd_on);
	eval("sub cd_off () { 12; }") unless defined(&cd_off);
	eval("sub cblock_buf () { 13; }") unless defined(&cblock_buf);
	eval("sub other_buf () { 14; }") unless defined(&other_buf);
	eval 'sub TTY_CONFIG () {0x1;}' unless defined(&TTY_CONFIG);
	eval 'sub TTY_OPEN () {0x2;}' unless defined(&TTY_OPEN);
	eval 'sub TTY_CLOSE () {0x3;}' unless defined(&TTY_CLOSE);
	eval 'sub TTY_WPUT () {0x4;}' unless defined(&TTY_WPUT);
	eval 'sub TTY_RPUT () {0x5;}' unless defined(&TTY_RPUT);
	eval 'sub TTY_WSRV () {0x6;}' unless defined(&TTY_WSRV);
	eval 'sub TTY_RSRV () {0x7;}' unless defined(&TTY_RSRV);
	eval 'sub TTY_REVOKE () {0x8;}' unless defined(&TTY_REVOKE);
	eval 'sub TTY_IOCTL () {0x9;}' unless defined(&TTY_IOCTL);
	eval 'sub TTY_PROC () {0xa;}' unless defined(&TTY_PROC);
	eval 'sub TTY_SERVICE () {0xb;}' unless defined(&TTY_SERVICE);
	eval 'sub TTY_SLIH () {0xc;}' unless defined(&TTY_SLIH);
	eval 'sub TTY_OFFL () {0xd;}' unless defined(&TTY_OFFL);
	eval 'sub TTY_LAST () {0xe;}' unless defined(&TTY_LAST);
	eval 'sub Enter {
	    my($w, $dev, $ptr, $a, $b, $c) = @_;
    	    eval q( &dev_t  &DEV;  &void*  &PTR; \'int\'  &Flag = 0; \'int\'  &W;  &if ( &TRC_ISON(0)) {  &DEV = ($dev);  &PTR = ($ptr);  &Flag = 1;  &W = $w;  &TRCHKGT( &W,  &DEV,  &PTR, $a, $b, $c); });
	}' unless defined(&Enter);
	eval 'sub Return {
	    my($retval) = @_;
    	    eval q({ \'int\'  &RET = ($retval); \'int\'  &Line =  &__LINE__;  &if ( &Flag)  &TRCHKGT((( &W)|0x80),  &DEV,  &PTR,  &RET,  &Line, 0);  &return( &RET); });
	}' unless defined(&Return);
	eval 'sub Returnv () {{ \'int\'  &Line =  &__LINE__;  &if ( &Flag)  &TRCHKGT((( &W)|0x80),  &DEV,  &PTR, 0,  &Line, 0);  &return; };}' unless defined(&Returnv);
	eval 'sub Data {
	    my($a, $b, $c) = @_;
    	    eval q(( &Flag ?  &TRCHKGT((( &W)|0x40),  &DEV,  &PTR, $a, $b, $c), 0: 0));
	}' unless defined(&Data);
    }
    eval 'sub TIOCGETA () { &TCGETS;}' unless defined(&TIOCGETA);
    eval 'sub TIOCSETA () { &TCSETS;}' unless defined(&TIOCSETA);
    eval 'sub TIOCSETAW () { &TCSETSW;}' unless defined(&TIOCSETAW);
    eval 'sub TIOCSETAF () { &TCSETSF;}' unless defined(&TIOCSETAF);
    if(defined(&_NO_PROTO)) {
    } else {
    }
    eval 'sub DEV_NAME_LN () {16;}' unless defined(&DEV_NAME_LN);
    eval("sub LC_SJIS_DDS () { 0; }") unless defined(&LC_SJIS_DDS);
    eval("sub LDTERM_DDS () { 1; }") unless defined(&LDTERM_DDS);
    eval("sub LION_ADAP_DDS () { 2; }") unless defined(&LION_ADAP_DDS);
    eval("sub LION_LINE_DDS () { 3; }") unless defined(&LION_LINE_DDS);
    eval("sub NLS_DDS () { 4; }") unless defined(&NLS_DDS);
    eval("sub PTY_DDS () { 5; }") unless defined(&PTY_DDS);
    eval("sub RS_ADAP_DDS () { 6; }") unless defined(&RS_ADAP_DDS);
    eval("sub RS_LINE_DDS () { 7; }") unless defined(&RS_LINE_DDS);
    eval("sub SPTR_DDS () { 8; }") unless defined(&SPTR_DDS);
    eval("sub TIOC_DDS () { 9; }") unless defined(&TIOC_DDS);
    eval("sub UC_SJIS_DDS () { 10; }") unless defined(&UC_SJIS_DDS);
    eval("sub CXMA_ADAP_DDS () { 11; }") unless defined(&CXMA_ADAP_DDS);
    eval("sub CXMA_LINE_DDS () { 12; }") unless defined(&CXMA_LINE_DDS);
    eval("sub CXIA_ADAP_DDS () { 13; }") unless defined(&CXIA_ADAP_DDS);
    eval("sub CXIA_LINE_DDS () { 14; }") unless defined(&CXIA_LINE_DDS);
    eval("sub CXPA_ADAP_DDS () { 15; }") unless defined(&CXPA_ADAP_DDS);
    eval("sub CXPA_LINE_DDS () { 16; }") unless defined(&CXPA_LINE_DDS);
    eval("sub VCON_LINE_DDS () { 17; }") unless defined(&VCON_LINE_DDS);
    eval("sub VCON_ADAP_DDS () { 18; }") unless defined(&VCON_ADAP_DDS);
    eval("sub tioc () { 0; }") unless defined(&tioc);
    eval("sub ldterm () { 1; }") unless defined(&ldterm);
    eval("sub pty () { 2; }") unless defined(&pty);
    eval("sub uc_sjis () { 3; }") unless defined(&uc_sjis);
    eval("sub lc_sjis () { 4; }") unless defined(&lc_sjis);
    eval("sub nls () { 5; }") unless defined(&nls);
    eval("sub sptr () { 6; }") unless defined(&sptr);
    eval("sub rs () { 7; }") unless defined(&rs);
    eval("sub lion () { 8; }") unless defined(&lion);
    eval("sub cxma () { 9; }") unless defined(&cxma);
    eval("sub cxia () { 10; }") unless defined(&cxia);
    eval("sub cxpa () { 11; }") unless defined(&cxpa);
    eval("sub vcon () { 12; }") unless defined(&vcon);
    eval 'sub bcopy {
        my($a,$b,$c) = @_;
	    eval q( &bcopy($a,$b,$c));
    }' unless defined(&bcopy);
    eval 'sub bzero {
        my($a,$b) = @_;
	    eval q( &bzero($a,$b));
    }' unless defined(&bzero);
    unless(defined(&FMNAMESZ)) {
	eval 'sub FMNAMESZ () {8;}' unless defined(&FMNAMESZ);
    }
    eval 'sub TTYDBG_ARG_V () {0x1;}' unless defined(&TTYDBG_ARG_V);
    eval 'sub TTYDBG_ARG_O () {0x2;}' unless defined(&TTYDBG_ARG_O);
    eval("sub CXMA_PDPF () { 0; }") unless defined(&CXMA_PDPF);
    eval("sub LDTERM_PDPF () { 1; }") unless defined(&LDTERM_PDPF);
    eval("sub LION_PDPF () { 2; }") unless defined(&LION_PDPF);
    eval("sub NLS_PDPF () { 3; }") unless defined(&NLS_PDPF);
    eval("sub PTY_PDPF () { 4; }") unless defined(&PTY_PDPF);
    eval("sub RS_PDPF () { 5; }") unless defined(&RS_PDPF);
    eval("sub SPTR_PDPF () { 6; }") unless defined(&SPTR_PDPF);
    eval("sub STR_TTY_PDPF () { 7; }") unless defined(&STR_TTY_PDPF);
    eval("sub FU1_PDPF () { 8; }") unless defined(&FU1_PDPF);
    eval("sub FU2_PDPF () { 9; }") unless defined(&FU2_PDPF);
    eval("sub LAST_PDPF () { 10; }") unless defined(&LAST_PDPF);
    eval 'sub print_funcptr () { ($print_func->{func_ptr});}' unless defined(&print_funcptr);
    eval 'sub print_funcnum () { ($print_func->{func_num});}' unless defined(&print_funcnum);
    eval 'sub STR_TTY_CNT () {26;}' unless defined(&STR_TTY_CNT);
    eval 'sub MODULEMAX () {6;}' unless defined(&MODULEMAX);
    eval 'sub tty_db_register {
        my($p) = @_;
	    eval q(( &tty_db_register_ptr != 0?  &tty_db_register_ptr($p) : -1));
    }' unless defined(&tty_db_register);
    eval 'sub tty_db_unregister {
        my($p) = @_;
	    eval q(( &tty_db_unregister_ptr != 0?  &tty_db_unregister_ptr($p) : -1));
    }' unless defined(&tty_db_unregister);
    eval 'sub tty_db_open {
        my($p) = @_;
	    eval q(( &tty_db_open_ptr != 0?  &tty_db_open_ptr($p) : -1));
    }' unless defined(&tty_db_open);
    eval 'sub tty_db_close {
        my($p) = @_;
	    eval q(( &tty_db_close_ptr != 0?  &tty_db_close_ptr($p) : -1));
    }' unless defined(&tty_db_close);
    eval 'sub TTYDBG_NOMORE () {-2;}' unless defined(&TTYDBG_NOMORE);
    if(defined( &_KERNEL)  && defined( &IN_TTYDBG)) {
	eval 'sub tty_db_nomore {
	    my($X) = @_;
    	    eval q( &do { \'int\'  &X_cr;  &if (( &X_cr = ($X)) ==  &TTYDBG_NOMORE) {  &return( &X_cr); } }  &while (0));
	}' unless defined(&tty_db_nomore);
    } else {
	eval 'sub tty_db_nomore {
	    my($X) = @_;
    	    eval q(($X));
	}' unless defined(&tty_db_nomore);
    }
}
1;
