require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_VFS)) {
    eval 'sub _H_VFS () {1;}' unless defined(&_H_VFS);
    require 'sys/types.ph';
    require 'sys/gfs.ph';
    require 'sys/vnode.ph';
    require 'sys/vmount.ph';
    require 'sys/statfs.ph';
    eval 'sub VFSfile () {"/etc/vfs";}' unless defined(&VFSfile);
    eval 'sub VFSdir () {"/sbin/helpers/";}' unless defined(&VFSdir);
    eval 'sub FSfile () { &FSYSname;}' unless defined(&FSfile);
    eval 'sub NO_HELPER () {"none";}' unless defined(&NO_HELPER);
    eval 'sub VFS_DFLT_LOCAL () {0x1;}' unless defined(&VFS_DFLT_LOCAL);
    eval 'sub VFS_DFLT_REMOTE () {0x2;}' unless defined(&VFS_DFLT_REMOTE);
    if(defined(&_SUN)) {
    } else {
    }
    eval 'sub vfs_fsid () { ($vfs_mdata->{vmt_fsid});}' unless defined(&vfs_fsid);
    eval 'sub vfs_date () { ($vfs_mdata->{vmt_time});}' unless defined(&vfs_date);
    eval 'sub vfs_flag () { ($vfs_mdata->{vmt_flags});}' unless defined(&vfs_flag);
    eval 'sub vfs_type () { ($vfs_gfs->{gfs_type});}' unless defined(&vfs_type);
    eval 'sub vfs_ops () { ($vfs_gfs->{gfs_ops});}' unless defined(&vfs_ops);
    eval 'sub VFS_LOCK {
        my($vfsp) = @_;
	    eval q( &simple_lock(($vfsp)-> &vfs_lock));
    }' unless defined(&VFS_LOCK);
    eval 'sub VFS_UNLOCK {
        my($vfsp) = @_;
	    eval q( &simple_unlock(($vfsp)-> &vfs_lock));
    }' unless defined(&VFS_UNLOCK);
    if(defined(&_SUN)) {
	eval 'sub vfs_vnodecovered () { &vfs_mntdover;}' unless defined(&vfs_vnodecovered);
	eval 'sub vfs_pdata () { &vfs_data;}' unless defined(&vfs_pdata);
    }
    eval 'sub VFS_READONLY () { &MNT_READONLY;}' unless defined(&VFS_READONLY);
    eval 'sub VFS_REMOVABLE () { &MNT_REMOVABLE;}' unless defined(&VFS_REMOVABLE);
    eval 'sub VFS_DEVMOUNT () { &MNT_DEVICE;}' unless defined(&VFS_DEVMOUNT);
    eval 'sub VFS_REMOTE () { &MNT_REMOTE;}' unless defined(&VFS_REMOTE);
    eval 'sub VFS_UNMOUNTING () { &MNT_UNMOUNTING;}' unless defined(&VFS_UNMOUNTING);
    eval 'sub VFS_SYSV_MOUNT () { &MNT_SYSV_MOUNT;}' unless defined(&VFS_SYSV_MOUNT);
    eval 'sub VFS_NOSUID () { &MNT_NOSUID;}' unless defined(&VFS_NOSUID);
    eval 'sub VFS_NODEV () { &MNT_NODEV;}' unless defined(&VFS_NODEV);
    eval 'sub VFS_NOINTEG () { &MNT_NOINTEG;}' unless defined(&VFS_NOINTEG);
    eval 'sub VFS_NOMANAGER () { &MNT_NOMANAGER;}' unless defined(&VFS_NOMANAGER);
    eval 'sub VFS_DIO () { &MNT_DIO;}' unless defined(&VFS_DIO);
    eval 'sub VFS_MIND () { &MNT_MIND;}' unless defined(&VFS_MIND);
    eval 'sub VFS_RBR () { &MNT_RBR;}' unless defined(&VFS_RBR);
    eval 'sub VFS_RBW () { &MNT_RBW;}' unless defined(&VFS_RBW);
    eval 'sub VFS_DISCONNECTED () {0x10000;}' unless defined(&VFS_DISCONNECTED);
    eval 'sub VFS_SHUTDOWN () {0x20000;}' unless defined(&VFS_SHUTDOWN);
    eval 'sub VFS_VMOUNTOK () {0x40000;}' unless defined(&VFS_VMOUNTOK);
    eval 'sub VFS_SUSER () {0x80000;}' unless defined(&VFS_SUSER);
    eval 'sub VFS_SOFT_MOUNT () {0x100000;}' unless defined(&VFS_SOFT_MOUNT);
    eval 'sub VFS_UNMOUNTED () {0x200000;}' unless defined(&VFS_UNMOUNTED);
    eval 'sub VFS_DEADMOUNT () {0x400000;}' unless defined(&VFS_DEADMOUNT);
    if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
    } else {
    }
    if(defined(&_KERNEL)) {
	eval 'sub VFS_MOUNT {
	    my($vfsp, $crp) = @_;
    	    eval q( &vfs_mount($vfsp, $crp));
	}' unless defined(&VFS_MOUNT);
	eval 'sub VFS_UNMOUNT {
	    my($vfsp, $flags, $crp) = @_;
    	    eval q( &vfs_unmount($vfsp, $flags, $crp));
	}' unless defined(&VFS_UNMOUNT);
	eval 'sub VFS_ROOT {
	    my($vfsp, $vpp, $crp) = @_;
    	    eval q( &vfs_root($vfsp, $vpp, $crp));
	}' unless defined(&VFS_ROOT);
	eval 'sub VFS_STATFS {
	    my($vfsp, $sfsp, $crp) = @_;
    	    eval q( &vfs_statfs($vfsp, $sfsp, $crp));
	}' unless defined(&VFS_STATFS);
	eval 'sub VFS_SYNC {
	    my($gfsp) = @_;
    	    eval q( &vfs_sync($gfsp));
	}' unless defined(&VFS_SYNC);
	eval 'sub VFS_SYNCVFS {
	    my($gfsp, $vfsp, $cmd, $crp) = @_;
    	    eval q( &vfs_syncvfs($gfsp, $vfsp, $cmd, $crp));
	}' unless defined(&VFS_SYNCVFS);
	eval 'sub VFS_VGET {
	    my($vfsp, $vpp, $fidp, $crp) = @_;
    	    eval q( &vfs_vget($vfsp, $vpp, $fidp, $crp));
	}' unless defined(&VFS_VGET);
	eval 'sub VFS_CNTL {
	    my($vfsp, $cmd, $arg, $argsize, $crp) = @_;
    	    eval q( &vfs_cntl($vfsp, $cmd, $arg, $argsize, $crp));
	}' unless defined(&VFS_CNTL);
	eval 'sub VFS_QUOTACTL {
	    my($vfsp, $cmds, $uid, $arg, $crp) = @_;
    	    eval q( &vfs_quotactl($vfsp, $cmds, $uid, $arg, $crp));
	}' unless defined(&VFS_QUOTACTL);
	eval 'sub VFSLIST_UNLOCK () {0;}' unless defined(&VFSLIST_UNLOCK);
	eval 'sub VFSLIST_READLOCK () {1;}' unless defined(&VFSLIST_READLOCK);
	eval 'sub VFSLIST_WRITELOCK () {2;}' unless defined(&VFSLIST_WRITELOCK);
	if(defined( &__64BIT_KERNEL) || defined( (defined(&__FULL_PROTO) ? &__FULL_PROTO : 0))) {
	}
    }
}
1;
