require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_TCPIP_AUDIT)) {
    eval 'sub _H_TCPIP_AUDIT () {1;}' unless defined(&_H_TCPIP_AUDIT);
    if(defined(&_CSECURITY)) {
	require 'sys/audit.ph';
	require 'arpa/inet.ph';
	eval 'sub PROTOCOL () {"TCP/IP";}' unless defined(&PROTOCOL);
	eval 'sub CHANGE_HOST_ID () {0000001;}' unless defined(&CHANGE_HOST_ID);
	eval 'sub EVENT_CHANGE_HOST_ID () {"TCPIP_host_id";}' unless defined(&EVENT_CHANGE_HOST_ID);
	eval 'sub CHANGE_CONFIGURATION () {0000002;}' unless defined(&CHANGE_CONFIGURATION);
	eval 'sub EVENT_CHANGE_CONFIGURATION () {"TCPIP_config";}' unless defined(&EVENT_CHANGE_CONFIGURATION);
	eval 'sub CHANGE_MANUALLY_SET_ROUTE () {0000004;}' unless defined(&CHANGE_MANUALLY_SET_ROUTE);
	eval 'sub EVENT_CHANGE_MANUALLY_SET_ROUTE () {"TCPIP_route";}' unless defined(&EVENT_CHANGE_MANUALLY_SET_ROUTE);
	eval 'sub CONNECTION () {0000010;}' unless defined(&CONNECTION);
	eval 'sub EVENT_CONNECTION () {"TCPIP_connect";}' unless defined(&EVENT_CONNECTION);
	eval 'sub IMPORT_DATA () {0000020;}' unless defined(&IMPORT_DATA);
	eval 'sub EVENT_IMPORT_DATA () {"TCPIP_data_in";}' unless defined(&EVENT_IMPORT_DATA);
	eval 'sub EXPORT_DATA () {0000040;}' unless defined(&EXPORT_DATA);
	eval 'sub EVENT_EXPORT_DATA () {"TCPIP_data_out";}' unless defined(&EVENT_EXPORT_DATA);
	eval 'sub NET_ACCESS () {0000100;}' unless defined(&NET_ACCESS);
	eval 'sub EVENT_NET_ACCESS () {"TCPIP_access";}' unless defined(&EVENT_NET_ACCESS);
	eval 'sub SET_NETWORK_TIME () {0000200;}' unless defined(&SET_NETWORK_TIME);
	eval 'sub EVENT_SET_NETWORK_TIME () {"TCPIP_set_time";}' unless defined(&EVENT_SET_NETWORK_TIME);
	eval 'sub MAIL_CONFIGURATION () {0000400;}' unless defined(&MAIL_CONFIGURATION);
	eval 'sub EVENT_MAIL_CONFIGURATION () {"SENDMAIL_Config";}' unless defined(&EVENT_MAIL_CONFIGURATION);
	eval 'sub MAIL_TO_A_FILE () {0001000;}' unless defined(&MAIL_TO_A_FILE);
	eval 'sub EVENT_MAIL_TO_A_FILE () {"SENDMAIL_ToFile";}' unless defined(&EVENT_MAIL_TO_A_FILE);
	eval 'sub TCPIP_MAX_TAIL_FIELDS () {8;}' unless defined(&TCPIP_MAX_TAIL_FIELDS);
	eval 'sub USE_EFFECTIVE_UID {
	    my($euid) = @_;
    	    eval q( &if (( &setuid($euid)) == -1)  &syslog( &LOG_ALERT, \\"setuid: %m\\"););
	}' unless defined(&USE_EFFECTIVE_UID);
	eval 'sub USE_REAL_UID {
	    my($uid) = @_;
    	    eval q( &if (( &setuid($uid)) == -1)  &syslog( &LOG_ALERT, \\"setuid: %m\\"););
	}' unless defined(&USE_REAL_UID);
	eval 'sub CHANGE_HOST_ID_WRITE {
	    my($HOSTNAME, $RESULT, $ERRNO) = @_;
    	    eval q( $audit_tail[1] = $HOSTNAME;  $audit_tail[2] = $RESULT;  &tcpip_auditlog( &CHANGE_HOST_ID,  &audit_tail, $ERRNO););
	}' unless defined(&CHANGE_HOST_ID_WRITE);
	eval 'sub CHANGE_CONFIGURATION_WRITE {
	    my($ADD_DELETE, $INTERFACE, $INETADDR, $RESULT, $ERRNO) = @_;
    	    eval q( $audit_tail[1] = $ADD_DELETE;  $audit_tail[2] = $INTERFACE;  $audit_tail[3] =  &inet_ntoa($INETADDR);  $audit_tail[4] = $RESULT;  &tcpip_auditlog( &CHANGE_CONFIGURATION,  &audit_tail, $ERRNO););
	}' unless defined(&CHANGE_CONFIGURATION_WRITE);
	eval 'sub CHANGE_MANUALLY_SET_ROUTE_WRITE {
	    my($DESTINATION, $GATEWAY, $ADD_OR_DELETE, $NET_OR_HOST, $RESULT, $ERRNO) = @_;
    	    eval q( $audit_tail[1] =  &inet_ntoa($DESTINATION);  $audit_tail[2] =  &inet_ntoa($GATEWAY);  $audit_tail[3] = $ADD_OR_DELETE;  $audit_tail[4] = $NET_OR_HOST;  $audit_tail[5] = $RESULT;  &tcpip_auditlog( &CHANGE_MANUALLY_SET_ROUTE,  &audit_tail, $ERRNO););
	}' unless defined(&CHANGE_MANUALLY_SET_ROUTE_WRITE);
	eval 'sub CONNECTION_WRITE {
	    my($INETADDR, $PORT, $OPERATION, $RESULT, $ERRNO) = @_;
    	    eval q( $audit_tail[1] =  &inet_ntoa($INETADDR);  $audit_tail[2] = $PORT;  $audit_tail[3] = $OPERATION;  $audit_tail[4] = $RESULT;  &tcpip_auditlog( &CONNECTION,  &audit_tail, $ERRNO););
	}' unless defined(&CONNECTION_WRITE);
	eval 'sub AUDIT_TAIL_ADDR_BUF_SZ () {256;}' unless defined(&AUDIT_TAIL_ADDR_BUF_SZ);
	eval 'sub CONNECTION6_WRITE {
	    my($INET6ADDR, $PORT, $OPERATION, $RESULT, $ERRNO) = @_;
    	    eval q({ \'char\'  $audit_tail_addr_buf[ &AUDIT_TAIL_ADDR_BUF_SZ];  $audit_tail[1] =  &inet_ntop( &AF_INET6, $INET6ADDR,  &audit_tail_addr_buf,  &AUDIT_TAIL_ADDR_BUF_SZ);  $audit_tail[2] = $PORT;  $audit_tail[3] = $OPERATION;  $audit_tail[4] = $RESULT;  &tcpip_auditlog( &CONNECTION,  &audit_tail, $ERRNO); });
	}' unless defined(&CONNECTION6_WRITE);
	eval 'sub IMPORT_DATA_WRITE {
	    my($INETADDR, $FROM_FILE, $TO_FILE, $RESULT, $ERRNO) = @_;
    	    eval q( $audit_tail[1] =  &inet_ntoa($INETADDR);  $audit_tail[2] = $FROM_FILE;  $audit_tail[3] = $TO_FILE;  $audit_tail[4] = $RESULT;  &tcpip_auditlog( &IMPORT_DATA,  &audit_tail, $ERRNO););
	}' unless defined(&IMPORT_DATA_WRITE);
	eval 'sub IMPORT6_DATA_WRITE {
	    my($INET6ADDR, $FROM_FILE, $TO_FILE, $RESULT, $ERRNO) = @_;
    	    eval q({ \'char\'  $audit_tail_addr_buf[ &AUDIT_TAIL_ADDR_BUF_SZ];  $audit_tail[1] =  &inet_ntop( &AF_INET6, $INET6ADDR,  &audit_tail_addr_buf,  &AUDIT_TAIL_ADDR_BUF_SZ);  $audit_tail[2] = $FROM_FILE;  $audit_tail[3] = $TO_FILE;  $audit_tail[4] = $RESULT;  &tcpip_auditlog( &IMPORT_DATA,  &audit_tail, $ERRNO); });
	}' unless defined(&IMPORT6_DATA_WRITE);
	eval 'sub EXPORT_DATA_WRITE {
	    my($INETADDR, $FROM_FILE, $TO_FILE, $RESULT, $ERRNO) = @_;
    	    eval q( $audit_tail[1] =  &inet_ntoa($INETADDR);  $audit_tail[2] = $FROM_FILE;  $audit_tail[3] = $TO_FILE;  $audit_tail[4] = $RESULT;  &tcpip_auditlog( &EXPORT_DATA,  &audit_tail, $ERRNO););
	}' unless defined(&EXPORT_DATA_WRITE);
	eval 'sub EXPORT6_DATA_WRITE {
	    my($INET6ADDR, $FROM_FILE, $TO_FILE, $RESULT, $ERRNO) = @_;
    	    eval q({ \'char\'  $audit_tail_addr_buf[ &AUDIT_TAIL_ADDR_BUF_SZ];  $audit_tail[1] =  &inet_ntop( &AF_INET6, $INET6ADDR,  &audit_tail_addr_buf,  &AUDIT_TAIL_ADDR_BUF_SZ);  $audit_tail[2] = $FROM_FILE;  $audit_tail[3] = $TO_FILE;  $audit_tail[4] = $RESULT;  &tcpip_auditlog( &EXPORT_DATA,  &audit_tail, $ERRNO); });
	}' unless defined(&EXPORT6_DATA_WRITE);
	eval 'sub NET_ACCESS_WRITE {
	    my($INETADDR, $ACCESS_TYPE, $USER, $RESULT, $ERRNO) = @_;
    	    eval q( $audit_tail[1] =  &inet_ntoa($INETADDR);  $audit_tail[2] = $ACCESS_TYPE;  $audit_tail[3] = $USER;  $audit_tail[4] = $RESULT;  &tcpip_auditlog( &NET_ACCESS,  &audit_tail, $ERRNO););
	}' unless defined(&NET_ACCESS_WRITE);
	eval 'sub NET6_ACCESS_WRITE {
	    my($INET6ADDR, $ACCESS_TYPE, $USER, $RESULT, $ERRNO) = @_;
    	    eval q({ \'char\'  $audit_tail_addr_buf[ &AUDIT_TAIL_ADDR_BUF_SZ];  $audit_tail[1] =  &inet_ntop( &AF_INET6, $INET6ADDR,  &audit_tail_addr_buf,  &AUDIT_TAIL_ADDR_BUF_SZ);  $audit_tail[2] = $ACCESS_TYPE;  $audit_tail[3] = $USER;  $audit_tail[4] = $RESULT;  &tcpip_auditlog( &NET_ACCESS,  &audit_tail, $ERRNO); });
	}' unless defined(&NET6_ACCESS_WRITE);
	eval 'sub SET_NETWORK_TIME_WRITE {
	    my($INETADDR, $TIME, $RESULT, $ERRNO) = @_;
    	    eval q( $audit_tail[1] =  &inet_ntoa($INETADDR);  $audit_tail[2] = $TIME; *( $audit_tail[2] +  &strlen( $audit_tail[2]) - 1) = ord(\'\\\\0\');  $audit_tail[3] = $RESULT;  &tcpip_auditlog( &SET_NETWORK_TIME,  &audit_tail, $ERRNO););
	}' unless defined(&SET_NETWORK_TIME_WRITE);
	eval 'sub MAIL_CONFIGURATION_WRITE {
	    my($OPERATION, $RESULT, $ERRNO) = @_;
    	    eval q( $audit_tail[1] = $OPERATION;  $audit_tail[2] = $RESULT;  &tcpip_auditlog( &MAIL_CONFIGURATION,  &audit_tail, $ERRNO););
	}' unless defined(&MAIL_CONFIGURATION_WRITE);
	eval 'sub MAIL_TO_A_FILE_WRITE {
	    my($FROM, $TO, $RESULT, $ERRNO) = @_;
    	    eval q( $audit_tail[1] = $FROM;  $audit_tail[2] = $TO;  $audit_tail[3] = $RESULT;  &tcpip_auditlog( &MAIL_TO_A_FILE,  &audit_tail, $ERRNO););
	}' unless defined(&MAIL_TO_A_FILE_WRITE);
    }
}
1;
