require '_h2ph_pre.ph';

no warnings 'redefine';

require 'sys/font.ph';
unless(defined(&COLORPAL)) {
    sub COLORPAL () {	16;}
}
unless(defined(&FONTPAL)) {
    sub FONTPAL () {	8;}
}
unless(defined(&FG_COLOR_MASK)) {
    sub FG_COLOR_MASK () {	0xf000;}
}
unless(defined(&BG_COLOR_MASK)) {
    sub BG_COLOR_MASK () {	0xf00;}
}
unless(defined(&FONT_SELECT_MASK)) {
    sub FONT_SELECT_MASK () {	0xe0;}
}
unless(defined(&NO_DISP_MASK)) {
    sub NO_DISP_MASK () {	0x10;}
}
unless(defined(&BRIGHT_MASK)) {
    sub BRIGHT_MASK () {	0x8;}
}
unless(defined(&BLINK_MASK)) {
    sub BLINK_MASK () {	0x4;}
}
unless(defined(&REV_VIDEO_MASK)) {
    sub REV_VIDEO_MASK () {	0x2;}
}
unless(defined(&UNDERSCORE_MASK)) {
    sub UNDERSCORE_MASK () {	0x1;}
}
unless(defined(&REV_VIDEO_MASK)) {
    sub REV_VIDEO_MASK () {	0x2;}
}
unless(defined(&UNDERSCORE_MASK)) {
    sub UNDERSCORE_MASK () {	0x1;}
}
unless(defined(&ATTRIBUTES_INITIAL)) {
    sub ATTRIBUTES_INITIAL () {	0x2000;}
}
unless(defined(&ATTRIBRI)) {
    sub ATTRIBRI {
	my($attribute) = @_;
	eval q((($attribute) &  &BRIGHT_MASK));
    }
}
unless(defined(&ATTRIUNSC)) {
    sub ATTRIUNSC {
	my($attribute) = @_;
	eval q((($attribute) &  &UNDERSCORE_MASK));
    }
}
unless(defined(&ATTRIBLI)) {
    sub ATTRIBLI {
	my($attribute) = @_;
	eval q((($attribute) &  &BLINK_MASK));
    }
}
unless(defined(&ATTRIRV)) {
    sub ATTRIRV {
	my($attribute) = @_;
	eval q((($attribute) &  &REV_VIDEO_MASK));
    }
}
unless(defined(&ATTRIBLA)) {
    sub ATTRIBLA {
	my($attribute) = @_;
	eval q((($attribute) &  &NO_DISP_MASK));
    }
}
unless(defined(&ATTRIBAKCOL)) {
    sub ATTRIBAKCOL {
	my($attribute) = @_;
	eval q(((($attribute) >> 8) & 0xf));
    }
}
unless(defined(&ATTRIFORECOL)) {
    sub ATTRIFORECOL {
	my($attribute) = @_;
	eval q(((($attribute) >> 12) & 0xf));
    }
}
unless(defined(&ATTRIFONT)) {
    sub ATTRIFONT {
	my($attribute) = @_;
	eval q(((($attribute) >> 5) & 0x7));
    }
}
unless(defined(&SET_ATTRIFONT)) {
    sub SET_ATTRIFONT {
	my($attribute, $value) = @_;
	eval q($attribute = ((($attribute) & ~ &FONT_SELECT_MASK) | (($value) << 5)));
    }
}
unless(defined(&SET_ATTRIFORECOL)) {
    sub SET_ATTRIFORECOL {
	my($attribute, $value) = @_;
	eval q($attribute = ((($attribute) & ~ &FG_COLOR_MASK) | (($value) << 12)));
    }
}
unless(defined(&SET_ATTRIBAKCOL)) {
    sub SET_ATTRIBAKCOL {
	my($attribute, $value) = @_;
	eval q($attribute = ((($attribute) & ~ &BG_COLOR_MASK) | (($value) << 8)));
    }
}
unless(defined(&KSR_MODE)) {
    sub KSR_MODE () {	1;}
}
unless(defined(&GRAPHICS_MODE)) {
    sub GRAPHICS_MODE () {	0;}
}
if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
}
1;
