require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__cplusplus)) {
}
unless(defined(&_LIBGRAPH_H)) {
    eval 'sub _LIBGRAPH_H () {1;}' unless defined(&_LIBGRAPH_H);
    if((defined(&_PACKAGE_ast) ? &_PACKAGE_ast : 0)) {
	require 'ast.ph';
    } else {
	require 'string.ph';
	require 'stdlib.ph';
	unless(defined(&MSWIN32)) {
	    require 'unistd.ph';
	}
    }
    require 'ctype.ph';
    unless(defined(&EXTERN)) {
	eval 'sub EXTERN () { &extern;}' unless defined(&EXTERN);
    }
    unless(defined(&uchar)) {
	eval 'sub uchar () {\'unsigned char\';}' unless defined(&uchar);
    }
    unless(defined(&NIL)) {
	eval 'sub NIL {
	    my($t) = @_;
    	    eval q((($t)0));
	}' unless defined(&NIL);
    }
    unless(defined(&_BLD_graph)) {
	eval 'sub _BLD_graph () {1;}' unless defined(&_BLD_graph);
    }
    require 'graph.ph';
    if(defined(&offsetof)) {
	undef(&offsetof) if defined(&offsetof);
    }
    eval 'sub offsetof {
        my($typ,$fld) = @_;
	    eval q(((((($typ*)0)->$fld))));
    }' unless defined(&offsetof);
    unless(defined(&NOT)) {
	eval 'sub NOT {
	    my($v) = @_;
    	    eval q((!($v)));
	}' unless defined(&NOT);
    }
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
    }
    unless(defined(&TRUE)) {
	eval 'sub TRUE () { &NOT( &FALSE);}' unless defined(&TRUE);
    }
    eval 'sub NEW {
        my($t) = @_;
	    eval q(($t*) &calloc(1,$sizeof{$t}));
    }' unless defined(&NEW);
    eval 'sub N_NEW {
        my($n,$t) = @_;
	    eval q(($t*) &calloc(($n),$sizeof{$t}));
    }' unless defined(&N_NEW);
    eval 'sub ALLOC {
        my($size,$ptr,$type) = @_;
	    eval q(($ptr? ($type*) &realloc($ptr,($size)*$sizeof{$type}):($type*) &malloc(($size)*$sizeof{$type})));
    }' unless defined(&ALLOC);
    eval 'sub MIN {
        my($a,$b) = @_;
	    eval q((($a)<($b)?($a):($b)));
    }' unless defined(&MIN);
    eval 'sub MAX {
        my($a,$b) = @_;
	    eval q((($a)>($b)?($a):($b)));
    }' unless defined(&MAX);
    eval 'sub SMALLBUF () {128;}' unless defined(&SMALLBUF);
    eval 'sub ISALNUM {
        my($c) = @_;
	    eval q((( &isalnum($c)) || (($c) == ord(\'_\')) || (! &isascii($c))));
    }' unless defined(&ISALNUM);
    eval 'sub NOPRINT () {0;}' unless defined(&NOPRINT);
    eval 'sub MULTIPLE () {1;}' unless defined(&MULTIPLE);
    eval 'sub MUSTPRINT () {2;}' unless defined(&MUSTPRINT);
    eval 'sub ISEMPTYSTR {
        my($s) = @_;
	    eval q(((($s) ==  &NULL) || (*($s) == ord(\'\\\\0\'))));
    }' unless defined(&ISEMPTYSTR);
    eval 'sub NULL_FN {
        my($t) = @_;
	    eval q(0);
    }' unless defined(&NULL_FN);
    eval 'sub ZFREE {
        my($p) = @_;
	    eval q( &if ($p)  &free($p););
    }' unless defined(&ZFREE);
    eval 'sub TAG_NODE () {1;}' unless defined(&TAG_NODE);
    eval 'sub TAG_EDGE () {2;}' unless defined(&TAG_EDGE);
    eval 'sub TAG_GRAPH () {3;}' unless defined(&TAG_GRAPH);
    eval 'sub TAG_OF {
        my($p) = @_;
	    eval q(((( &Agraph_t*)($p))-> &tag));
    }' unless defined(&TAG_OF);
    eval 'sub AGFLAG_STRICT () {(1<<1);}' unless defined(&AGFLAG_STRICT);
    eval 'sub AGFLAG_METAGRAPH () {(1<<2);}' unless defined(&AGFLAG_METAGRAPH);
    eval 'sub METAGRAPH () {( &AGFLAG_DIRECTED |  &AGFLAG_STRICT |  &AGFLAG_METAGRAPH);}' unless defined(&METAGRAPH);
    eval 'sub KEY_ID () {"key";}' unless defined(&KEY_ID);
    eval 'sub KEYX () {0;}' unless defined(&KEYX);
    eval 'sub TAILX () {1;}' unless defined(&TAILX);
    eval 'sub HEADX () {2;}' unless defined(&HEADX);
}
if(defined(&__cplusplus)) {
}
1;
