require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__IDL_H)) {
    eval 'sub __IDL_H () {1;}' unless defined(&__IDL_H);
    require 'glib.ph';
    require 'stdlib.ph';
    if(1) {
	require 'wchar.ph';
    }
    if(0) {
	require 'wcstr.ph';
    }
    if(defined(&__cplusplus)) {
    }
    require 'stdio.ph';
    eval 'sub LIBIDL_VERSION {
        my($a,$b,$c) = @_;
	    eval q(((($a) << 16) + (($b) << 8) + ($c)));
    }' unless defined(&LIBIDL_VERSION);
    eval 'sub LIBIDL_MAJOR_VERSION () {0;}' unless defined(&LIBIDL_MAJOR_VERSION);
    eval 'sub LIBIDL_MINOR_VERSION () {6;}' unless defined(&LIBIDL_MINOR_VERSION);
    eval 'sub LIBIDL_MICRO_VERSION () {8;}' unless defined(&LIBIDL_MICRO_VERSION);
    eval 'sub LIBIDL_VERSION_CODE () { &LIBIDL_VERSION(0,6,8);}' unless defined(&LIBIDL_VERSION_CODE);
    eval 'sub IDL_SUCCESS () {0;}' unless defined(&IDL_SUCCESS);
    eval 'sub IDL_ERROR () {1;}' unless defined(&IDL_ERROR);
    eval 'sub IDL_WARNING1 () {2;}' unless defined(&IDL_WARNING1);
    eval 'sub IDL_WARNING2 () {3;}' unless defined(&IDL_WARNING2);
    eval 'sub IDL_WARNING3 () {4;}' unless defined(&IDL_WARNING3);
    eval 'sub IDL_WARNINGMAX () { &IDL_WARNING3;}' unless defined(&IDL_WARNINGMAX);
    eval 'sub IDLF_VERBOSE () {(1 << 0);}' unless defined(&IDLF_VERBOSE);
    eval 'sub IDLF_NO_EVAL_CONST () {(1 << 1);}' unless defined(&IDLF_NO_EVAL_CONST);
    eval 'sub IDLF_COMBINE_REOPENED_MODULES () {(1 << 2);}' unless defined(&IDLF_COMBINE_REOPENED_MODULES);
    eval 'sub IDLF_PREFIX_FILENAME () {(1 << 3);}' unless defined(&IDLF_PREFIX_FILENAME);
    eval 'sub IDLF_IGNORE_FORWARDS () {(1 << 4);}' unless defined(&IDLF_IGNORE_FORWARDS);
    eval 'sub IDLF_PEDANTIC () {(1 << 5);}' unless defined(&IDLF_PEDANTIC);
    eval 'sub IDLF_INHIBIT_TAG_ONLY () {(1 << 6);}' unless defined(&IDLF_INHIBIT_TAG_ONLY);
    eval 'sub IDLF_INHIBIT_INCLUDES () {(1 << 7);}' unless defined(&IDLF_INHIBIT_INCLUDES);
    eval 'sub IDLF_TYPECODES () {(1 << 16);}' unless defined(&IDLF_TYPECODES);
    eval 'sub IDLF_XPIDL () {(1 << 17);}' unless defined(&IDLF_XPIDL);
    eval 'sub IDLF_PROPERTIES () {(1 << 18);}' unless defined(&IDLF_PROPERTIES);
    eval 'sub IDLF_CODEFRAGS () {(1 << 19);}' unless defined(&IDLF_CODEFRAGS);
    eval 'sub IDLF_DECLSPEC_EXIST () {(1 << 0);}' unless defined(&IDLF_DECLSPEC_EXIST);
    eval 'sub IDLF_DECLSPEC_INHIBIT () {(1 << 1);}' unless defined(&IDLF_DECLSPEC_INHIBIT);
    eval 'sub IDLF_OUTPUT_NO_NEWLINES () {(1 << 0);}' unless defined(&IDLF_OUTPUT_NO_NEWLINES);
    eval 'sub IDLF_OUTPUT_NO_QUALIFY_IDENTS () {(1 << 1);}' unless defined(&IDLF_OUTPUT_NO_QUALIFY_IDENTS);
    eval 'sub IDLF_OUTPUT_PROPERTIES () {(1 << 2);}' unless defined(&IDLF_OUTPUT_PROPERTIES);
    eval 'sub IDLF_OUTPUT_CODEFRAGS () {(1 << 3);}' unless defined(&IDLF_OUTPUT_CODEFRAGS);
    if(defined(&_WIN32)) {
	eval 'sub IDL_EXPORT () { &__declspec ( &dllexport);}' unless defined(&IDL_EXPORT);
	eval 'sub IDL_IMPORT () { &__declspec ( &dllimport);}' unless defined(&IDL_IMPORT);
    } else {
	eval 'sub IDL_EXPORT () {1;}' unless defined(&IDL_EXPORT);
	eval 'sub IDL_IMPORT () { &extern;}' unless defined(&IDL_IMPORT);
    }
    eval 'sub IDL_check_cast_enable {
        my($boolean) = @_;
	    eval q( &do {  &IDL_IMPORT \'int\'  &__IDL_check_type_casts;  &__IDL_check_type_casts = ($boolean); }  &while (0));
    }' unless defined(&IDL_check_cast_enable);
    eval 'sub IDL_CHECK_CAST {
        my($tree, $thetype, $name) = @_;
	    eval q(( &IDL_check_type_cast($tree, $thetype,  &__FILE__,  &__LINE__,  &G_GNUC_PRETTY_FUNCTION)-> ($u->{name})));
    }' unless defined(&IDL_CHECK_CAST);
    if(defined(&G_HAVE_GINT64)) {
	if((defined(&G_MAXLONG) ? &G_MAXLONG : 0) > 0xffffffff) {
	    eval 'sub IDL_LL () {"l";}' unless defined(&IDL_LL);
	} else {
	    eval 'sub IDL_LL () {"ll";}' unless defined(&IDL_LL);
	}
    } else {
	eval 'sub IDL_LL () {"l";}' unless defined(&IDL_LL);
	warn("64\-bit\ integer\ type\ not\ available\,\ using\ 32\-bit\ instead");
    }
    eval 'sub IDL_LIST {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_LIST,  &idl_list));
    }' unless defined(&IDL_LIST);
    eval 'sub IDL_GENTREE {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_GENTREE,  &idl_gentree));
    }' unless defined(&IDL_GENTREE);
    eval 'sub IDL_INTEGER {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_INTEGER,  &idl_integer));
    }' unless defined(&IDL_INTEGER);
    eval 'sub IDL_STRING {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_STRING,  &idl_string));
    }' unless defined(&IDL_STRING);
    eval 'sub IDL_WIDE_STRING {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_WIDE_STRING,  &idl_wide_string));
    }' unless defined(&IDL_WIDE_STRING);
    eval 'sub IDL_CHAR {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_CHAR,  &idl_char));
    }' unless defined(&IDL_CHAR);
    eval 'sub IDL_WIDE_CHAR {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_WIDE_CHAR,  &idl_wide_char));
    }' unless defined(&IDL_WIDE_CHAR);
    eval 'sub IDL_FIXED {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_FIXED,  &idl_fixed));
    }' unless defined(&IDL_FIXED);
    eval 'sub IDL_FLOAT {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_FLOAT,  &idl_float));
    }' unless defined(&IDL_FLOAT);
    eval 'sub IDL_BOOLEAN {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_BOOLEAN,  &idl_boolean));
    }' unless defined(&IDL_BOOLEAN);
    eval 'sub IDLF_IDENT_CASE_MISMATCH_HIT () {(1 << 0);}' unless defined(&IDLF_IDENT_CASE_MISMATCH_HIT);
    eval 'sub IDL_IDENT {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_IDENT,  &idl_ident));
    }' unless defined(&IDL_IDENT);
    eval 'sub IDL_IDENT_TO_NS {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_IDENT,  ($idl_ident->{_ns_ref})));
    }' unless defined(&IDL_IDENT_TO_NS);
    eval 'sub IDL_IDENT_REPO_ID {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_IDENT,  ($idl_ident->{repo_id})));
    }' unless defined(&IDL_IDENT_REPO_ID);
    eval("sub IDL_FLOAT_TYPE_FLOAT () { 0; }") unless defined(&IDL_FLOAT_TYPE_FLOAT);
    eval("sub IDL_FLOAT_TYPE_DOUBLE () { 1; }") unless defined(&IDL_FLOAT_TYPE_DOUBLE);
    eval("sub IDL_FLOAT_TYPE_LONGDOUBLE () { 2; }") unless defined(&IDL_FLOAT_TYPE_LONGDOUBLE);
    eval 'sub IDL_TYPE_FLOAT {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_TYPE_FLOAT,  &idl_type_float));
    }' unless defined(&IDL_TYPE_FLOAT);
    eval 'sub IDL_TYPE_FIXED {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_TYPE_FIXED,  &idl_type_fixed));
    }' unless defined(&IDL_TYPE_FIXED);
    eval("sub IDL_INTEGER_TYPE_SHORT () { 0; }") unless defined(&IDL_INTEGER_TYPE_SHORT);
    eval("sub IDL_INTEGER_TYPE_LONG () { 1; }") unless defined(&IDL_INTEGER_TYPE_LONG);
    eval("sub IDL_INTEGER_TYPE_LONGLONG () { 2; }") unless defined(&IDL_INTEGER_TYPE_LONGLONG);
    eval 'sub IDL_TYPE_INTEGER {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_TYPE_INTEGER,  &idl_type_integer));
    }' unless defined(&IDL_TYPE_INTEGER);
    eval 'sub IDL_TYPE_STRING {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_TYPE_STRING,  &idl_type_string));
    }' unless defined(&IDL_TYPE_STRING);
    eval 'sub IDL_TYPE_WIDE_STRING {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_TYPE_WIDE_STRING,  &idl_type_wide_string));
    }' unless defined(&IDL_TYPE_WIDE_STRING);
    eval 'sub IDL_TYPE_ENUM {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_TYPE_ENUM,  &idl_type_enum));
    }' unless defined(&IDL_TYPE_ENUM);
    eval 'sub IDL_TYPE_ARRAY {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_TYPE_ARRAY,  &idl_type_array));
    }' unless defined(&IDL_TYPE_ARRAY);
    eval 'sub IDL_TYPE_SEQUENCE {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_TYPE_SEQUENCE,  &idl_type_sequence));
    }' unless defined(&IDL_TYPE_SEQUENCE);
    eval 'sub IDL_TYPE_STRUCT {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_TYPE_STRUCT,  &idl_type_struct));
    }' unless defined(&IDL_TYPE_STRUCT);
    eval 'sub IDL_TYPE_UNION {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_TYPE_UNION,  &idl_type_union));
    }' unless defined(&IDL_TYPE_UNION);
    eval 'sub IDL_MEMBER {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_MEMBER,  &idl_member));
    }' unless defined(&IDL_MEMBER);
    eval 'sub IDL_NATIVE {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_NATIVE,  &idl_native));
    }' unless defined(&IDL_NATIVE);
    eval 'sub IDL_TYPE_DCL {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_TYPE_DCL,  &idl_type_dcl));
    }' unless defined(&IDL_TYPE_DCL);
    eval 'sub IDL_CONST_DCL {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_CONST_DCL,  &idl_const_dcl));
    }' unless defined(&IDL_CONST_DCL);
    eval 'sub IDL_EXCEPT_DCL {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_EXCEPT_DCL,  &idl_except_dcl));
    }' unless defined(&IDL_EXCEPT_DCL);
    eval 'sub IDL_ATTR_DCL {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_ATTR_DCL,  &idl_attr_dcl));
    }' unless defined(&IDL_ATTR_DCL);
    eval 'sub IDL_OP_DCL {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_OP_DCL,  &idl_op_dcl));
    }' unless defined(&IDL_OP_DCL);
    eval("sub IDL_PARAM_IN () { 0; }") unless defined(&IDL_PARAM_IN);
    eval("sub IDL_PARAM_OUT () { 1; }") unless defined(&IDL_PARAM_OUT);
    eval("sub IDL_PARAM_INOUT () { 2; }") unless defined(&IDL_PARAM_INOUT);
    eval 'sub IDL_PARAM_DCL {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_PARAM_DCL,  &idl_param_dcl));
    }' unless defined(&IDL_PARAM_DCL);
    eval 'sub IDL_CASE_STMT {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_CASE_STMT,  &idl_case_stmt));
    }' unless defined(&IDL_CASE_STMT);
    eval 'sub IDL_INTERFACE {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_INTERFACE,  &idl_interface));
    }' unless defined(&IDL_INTERFACE);
    eval 'sub IDL_FORWARD_DCL {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_FORWARD_DCL,  &idl_forward_dcl));
    }' unless defined(&IDL_FORWARD_DCL);
    eval 'sub IDL_MODULE {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_MODULE,  &idl_module));
    }' unless defined(&IDL_MODULE);
    eval("sub IDL_BINOP_OR () { 0; }") unless defined(&IDL_BINOP_OR);
    eval("sub IDL_BINOP_XOR () { 1; }") unless defined(&IDL_BINOP_XOR);
    eval("sub IDL_BINOP_AND () { 2; }") unless defined(&IDL_BINOP_AND);
    eval("sub IDL_BINOP_SHR () { 3; }") unless defined(&IDL_BINOP_SHR);
    eval("sub IDL_BINOP_SHL () { 4; }") unless defined(&IDL_BINOP_SHL);
    eval("sub IDL_BINOP_ADD () { 5; }") unless defined(&IDL_BINOP_ADD);
    eval("sub IDL_BINOP_SUB () { 6; }") unless defined(&IDL_BINOP_SUB);
    eval("sub IDL_BINOP_MULT () { 7; }") unless defined(&IDL_BINOP_MULT);
    eval("sub IDL_BINOP_DIV () { 8; }") unless defined(&IDL_BINOP_DIV);
    eval("sub IDL_BINOP_MOD () { 9; }") unless defined(&IDL_BINOP_MOD);
    eval 'sub IDL_BINOP {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_BINOP,  &idl_binop));
    }' unless defined(&IDL_BINOP);
    eval("sub IDL_UNARYOP_PLUS () { 0; }") unless defined(&IDL_UNARYOP_PLUS);
    eval("sub IDL_UNARYOP_MINUS () { 1; }") unless defined(&IDL_UNARYOP_MINUS);
    eval("sub IDL_UNARYOP_COMPLEMENT () { 2; }") unless defined(&IDL_UNARYOP_COMPLEMENT);
    eval 'sub IDL_UNARYOP {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_UNARYOP,  &idl_unaryop));
    }' unless defined(&IDL_UNARYOP);
    eval 'sub IDL_CODEFRAG {
        my($a) = @_;
	    eval q( &IDL_CHECK_CAST($a,  &IDLN_CODEFRAG,  &idl_codefrag));
    }' unless defined(&IDL_CODEFRAG);
    eval("sub IDLN_NONE () { 0; }") unless defined(&IDLN_NONE);
    eval("sub IDLN_ANY () { 1; }") unless defined(&IDLN_ANY);
    eval("sub IDLN_LIST () { 2; }") unless defined(&IDLN_LIST);
    eval("sub IDLN_GENTREE () { 3; }") unless defined(&IDLN_GENTREE);
    eval("sub IDLN_INTEGER () { 4; }") unless defined(&IDLN_INTEGER);
    eval("sub IDLN_STRING () { 5; }") unless defined(&IDLN_STRING);
    eval("sub IDLN_WIDE_STRING () { 6; }") unless defined(&IDLN_WIDE_STRING);
    eval("sub IDLN_CHAR () { 7; }") unless defined(&IDLN_CHAR);
    eval("sub IDLN_WIDE_CHAR () { 8; }") unless defined(&IDLN_WIDE_CHAR);
    eval("sub IDLN_FIXED () { 9; }") unless defined(&IDLN_FIXED);
    eval("sub IDLN_FLOAT () { 10; }") unless defined(&IDLN_FLOAT);
    eval("sub IDLN_BOOLEAN () { 11; }") unless defined(&IDLN_BOOLEAN);
    eval("sub IDLN_IDENT () { 12; }") unless defined(&IDLN_IDENT);
    eval("sub IDLN_TYPE_DCL () { 13; }") unless defined(&IDLN_TYPE_DCL);
    eval("sub IDLN_CONST_DCL () { 14; }") unless defined(&IDLN_CONST_DCL);
    eval("sub IDLN_EXCEPT_DCL () { 15; }") unless defined(&IDLN_EXCEPT_DCL);
    eval("sub IDLN_ATTR_DCL () { 16; }") unless defined(&IDLN_ATTR_DCL);
    eval("sub IDLN_OP_DCL () { 17; }") unless defined(&IDLN_OP_DCL);
    eval("sub IDLN_PARAM_DCL () { 18; }") unless defined(&IDLN_PARAM_DCL);
    eval("sub IDLN_FORWARD_DCL () { 19; }") unless defined(&IDLN_FORWARD_DCL);
    eval("sub IDLN_TYPE_INTEGER () { 20; }") unless defined(&IDLN_TYPE_INTEGER);
    eval("sub IDLN_TYPE_FLOAT () { 21; }") unless defined(&IDLN_TYPE_FLOAT);
    eval("sub IDLN_TYPE_FIXED () { 22; }") unless defined(&IDLN_TYPE_FIXED);
    eval("sub IDLN_TYPE_CHAR () { 23; }") unless defined(&IDLN_TYPE_CHAR);
    eval("sub IDLN_TYPE_WIDE_CHAR () { 24; }") unless defined(&IDLN_TYPE_WIDE_CHAR);
    eval("sub IDLN_TYPE_STRING () { 25; }") unless defined(&IDLN_TYPE_STRING);
    eval("sub IDLN_TYPE_WIDE_STRING () { 26; }") unless defined(&IDLN_TYPE_WIDE_STRING);
    eval("sub IDLN_TYPE_BOOLEAN () { 27; }") unless defined(&IDLN_TYPE_BOOLEAN);
    eval("sub IDLN_TYPE_OCTET () { 28; }") unless defined(&IDLN_TYPE_OCTET);
    eval("sub IDLN_TYPE_ANY () { 29; }") unless defined(&IDLN_TYPE_ANY);
    eval("sub IDLN_TYPE_OBJECT () { 30; }") unless defined(&IDLN_TYPE_OBJECT);
    eval("sub IDLN_TYPE_TYPECODE () { 31; }") unless defined(&IDLN_TYPE_TYPECODE);
    eval("sub IDLN_TYPE_ENUM () { 32; }") unless defined(&IDLN_TYPE_ENUM);
    eval("sub IDLN_TYPE_SEQUENCE () { 33; }") unless defined(&IDLN_TYPE_SEQUENCE);
    eval("sub IDLN_TYPE_ARRAY () { 34; }") unless defined(&IDLN_TYPE_ARRAY);
    eval("sub IDLN_TYPE_STRUCT () { 35; }") unless defined(&IDLN_TYPE_STRUCT);
    eval("sub IDLN_TYPE_UNION () { 36; }") unless defined(&IDLN_TYPE_UNION);
    eval("sub IDLN_MEMBER () { 37; }") unless defined(&IDLN_MEMBER);
    eval("sub IDLN_NATIVE () { 38; }") unless defined(&IDLN_NATIVE);
    eval("sub IDLN_CASE_STMT () { 39; }") unless defined(&IDLN_CASE_STMT);
    eval("sub IDLN_INTERFACE () { 40; }") unless defined(&IDLN_INTERFACE);
    eval("sub IDLN_MODULE () { 41; }") unless defined(&IDLN_MODULE);
    eval("sub IDLN_BINOP () { 42; }") unless defined(&IDLN_BINOP);
    eval("sub IDLN_UNARYOP () { 43; }") unless defined(&IDLN_UNARYOP);
    eval("sub IDLN_CODEFRAG () { 44; }") unless defined(&IDLN_CODEFRAG);
    eval("sub IDLN_LAST () { 45; }") unless defined(&IDLN_LAST);
    eval 'sub IDL_NODE_TYPE {
        my($a) = @_;
	    eval q((($a)-> &_type));
    }' unless defined(&IDL_NODE_TYPE);
    eval 'sub IDL_NODE_TYPE_NAME {
        my($a) = @_;
	    eval q((($a)? $IDL_tree_type_names[ &IDL_NODE_TYPE($a)]:\\"NULL\\"));
    }' unless defined(&IDL_NODE_TYPE_NAME);
    eval 'sub IDL_NODE_UP {
        my($a) = @_;
	    eval q((($a)-> &up));
    }' unless defined(&IDL_NODE_UP);
    eval 'sub IDL_NODE_PROPERTIES {
        my($a) = @_;
	    eval q((($a)-> &properties));
    }' unless defined(&IDL_NODE_PROPERTIES);
    eval 'sub IDL_NODE_DECLSPEC {
        my($a) = @_;
	    eval q((($a)-> &declspec));
    }' unless defined(&IDL_NODE_DECLSPEC);
    eval 'sub IDL_NODE_REFS {
        my($a) = @_;
	    eval q((($a)-> &refs));
    }' unless defined(&IDL_NODE_REFS);
    eval 'sub IDL_NODE_IS_LITERAL {
        my($a) = @_;
	    eval q(( &IDL_NODE_TYPE($a) ==  &IDLN_INTEGER ||  &IDL_NODE_TYPE($a) ==  &IDLN_STRING ||  &IDL_NODE_TYPE($a) ==  &IDLN_WIDE_STRING ||  &IDL_NODE_TYPE($a) ==  &IDLN_CHAR ||  &IDL_NODE_TYPE($a) ==  &IDLN_WIDE_CHAR ||  &IDL_NODE_TYPE($a) ==  &IDLN_FIXED ||  &IDL_NODE_TYPE($a) ==  &IDLN_FLOAT ||  &IDL_NODE_TYPE($a) ==  &IDLN_BOOLEAN));
    }' unless defined(&IDL_NODE_IS_LITERAL);
    eval 'sub IDL_NODE_IS_TYPE {
        my($a) = @_;
	    eval q(( &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_INTEGER ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_STRING ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_WIDE_STRING ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_CHAR ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_WIDE_CHAR ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_FIXED ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_FLOAT ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_BOOLEAN ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_OCTET ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_ANY ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_OBJECT ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_TYPECODE ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_ENUM ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_ARRAY ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_SEQUENCE ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_STRUCT ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_UNION));
    }' unless defined(&IDL_NODE_IS_TYPE);
    eval 'sub IDL_NODE_IS_SCOPED {
        my($a) = @_;
	    eval q(( &IDL_NODE_TYPE($a) ==  &IDLN_IDENT ||  &IDL_NODE_TYPE($a) ==  &IDLN_INTERFACE ||  &IDL_NODE_TYPE($a) ==  &IDLN_MODULE ||  &IDL_NODE_TYPE($a) ==  &IDLN_EXCEPT_DCL ||  &IDL_NODE_TYPE($a) ==  &IDLN_OP_DCL ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_ENUM ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_STRUCT ||  &IDL_NODE_TYPE($a) ==  &IDLN_TYPE_UNION));
    }' unless defined(&IDL_NODE_IS_SCOPED);
    eval 'sub IDL_NS {
        my($a) = @_;
	    eval q((*($a)));
    }' unless defined(&IDL_NS);
    eval("sub IDL_INPUT_REASON_INIT () { 0; }") unless defined(&IDL_INPUT_REASON_INIT);
    eval("sub IDL_INPUT_REASON_FILL () { 1; }") unless defined(&IDL_INPUT_REASON_FILL);
    eval("sub IDL_INPUT_REASON_ABORT () { 2; }") unless defined(&IDL_INPUT_REASON_ABORT);
    eval("sub IDL_INPUT_REASON_FINISH () { 3; }") unless defined(&IDL_INPUT_REASON_FINISH);
    if(defined(&__cplusplus)) {
    }
}
1;
