require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__XML_XPATH_INTERNALS_H__)) {
    eval 'sub __XML_XPATH_INTERNALS_H__ () {1;}' unless defined(&__XML_XPATH_INTERNALS_H__);
    require 'libxml/xmlversion.ph';
    require 'libxml/xpath.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub xmlXPathSetError {
        my($ctxt, $err) = @_;
	    eval q({  &xmlXPatherror(($ctxt),  &__FILE__,  &__LINE__, ($err)); ($ctxt)-> &error = ($err); });
    }' unless defined(&xmlXPathSetError);
    eval 'sub xmlXPathSetArityError {
        my($ctxt) = @_;
	    eval q( &xmlXPathSetError(($ctxt),  &XPATH_INVALID_ARITY));
    }' unless defined(&xmlXPathSetArityError);
    eval 'sub xmlXPathSetTypeError {
        my($ctxt) = @_;
	    eval q( &xmlXPathSetError(($ctxt),  &XPATH_INVALID_TYPE));
    }' unless defined(&xmlXPathSetTypeError);
    eval 'sub xmlXPathGetError {
        my($ctxt) = @_;
	    eval q((($ctxt)-> &error));
    }' unless defined(&xmlXPathGetError);
    eval 'sub xmlXPathCheckError {
        my($ctxt) = @_;
	    eval q((($ctxt)-> &error !=  &XPATH_EXPRESSION_OK));
    }' unless defined(&xmlXPathCheckError);
    eval 'sub xmlXPathGetDocument {
        my($ctxt) = @_;
	    eval q((($ctxt)-> ($context->{doc})));
    }' unless defined(&xmlXPathGetDocument);
    eval 'sub xmlXPathGetContextNode {
        my($ctxt) = @_;
	    eval q((($ctxt)-> ($context->{node})));
    }' unless defined(&xmlXPathGetContextNode);
    eval 'sub xmlXPathReturnBoolean {
        my($ctxt, $val) = @_;
	    eval q( &valuePush(($ctxt),  &xmlXPathNewBoolean($val)));
    }' unless defined(&xmlXPathReturnBoolean);
    eval 'sub xmlXPathReturnTrue {
        my($ctxt) = @_;
	    eval q( &xmlXPathReturnBoolean(($ctxt), 1));
    }' unless defined(&xmlXPathReturnTrue);
    eval 'sub xmlXPathReturnFalse {
        my($ctxt) = @_;
	    eval q( &xmlXPathReturnBoolean(($ctxt), 0));
    }' unless defined(&xmlXPathReturnFalse);
    eval 'sub xmlXPathReturnNumber {
        my($ctxt, $val) = @_;
	    eval q( &valuePush(($ctxt),  &xmlXPathNewFloat($val)));
    }' unless defined(&xmlXPathReturnNumber);
    eval 'sub xmlXPathReturnString {
        my($ctxt, $str) = @_;
	    eval q( &valuePush(($ctxt),  &xmlXPathWrapString($str)));
    }' unless defined(&xmlXPathReturnString);
    eval 'sub xmlXPathReturnEmptyString {
        my($ctxt) = @_;
	    eval q( &valuePush(($ctxt),  &xmlXPathNewCString(\\"\\")));
    }' unless defined(&xmlXPathReturnEmptyString);
    eval 'sub xmlXPathReturnNodeSet {
        my($ctxt, $ns) = @_;
	    eval q( &valuePush(($ctxt),  &xmlXPathWrapNodeSet($ns)));
    }' unless defined(&xmlXPathReturnNodeSet);
    eval 'sub xmlXPathReturnEmptyNodeSet {
        my($ctxt) = @_;
	    eval q( &valuePush(($ctxt),  &xmlXPathNewNodeSet( &NULL)));
    }' unless defined(&xmlXPathReturnEmptyNodeSet);
    eval 'sub xmlXPathReturnExternal {
        my($ctxt, $val) = @_;
	    eval q( &valuePush(($ctxt),  &xmlXPathWrapExternal($val)));
    }' unless defined(&xmlXPathReturnExternal);
    eval 'sub xmlXPathStackIsNodeSet {
        my($ctxt) = @_;
	    eval q(((($ctxt)-> &value !=  &NULL)  && ((($ctxt)-> ($value->{type}) ==  &XPATH_NODESET) || (($ctxt)-> ($value->{type}) ==  &XPATH_XSLT_TREE))));
    }' unless defined(&xmlXPathStackIsNodeSet);
    eval 'sub xmlXPathStackIsExternal {
        my($ctxt) = @_;
	    eval q((( ($ctxt->{value}) !=  &NULL)  && ( ($ctxt->{value}->{type}) ==  &XPATH_USERS)));
    }' unless defined(&xmlXPathStackIsExternal);
    eval 'sub xmlXPathEmptyNodeSet {
        my($ns) = @_;
	    eval q({  &while (($ns)-> &nodeNr > 0) ($ns)-> $nodeTab[($ns)-> &nodeNr--] =  &NULL; });
    }' unless defined(&xmlXPathEmptyNodeSet);
    eval 'sub CHECK_ERROR () { &if ( ($ctxt->{error}) !=  &XPATH_EXPRESSION_OK)  &return;}' unless defined(&CHECK_ERROR);
    eval 'sub CHECK_ERROR0 () { &if ( ($ctxt->{error}) !=  &XPATH_EXPRESSION_OK)  &return(0);}' unless defined(&CHECK_ERROR0);
    eval 'sub XP_ERROR {
        my($X) = @_;
	    eval q({  &xmlXPatherror( &ctxt,  &__FILE__,  &__LINE__, $X);  ($ctxt->{error}) = ($X);  &return; });
    }' unless defined(&XP_ERROR);
    eval 'sub XP_ERROR0 {
        my($X) = @_;
	    eval q({  &xmlXPatherror( &ctxt,  &__FILE__,  &__LINE__, $X);  ($ctxt->{error}) = ($X);  &return(0); });
    }' unless defined(&XP_ERROR0);
    eval 'sub CHECK_TYPE {
        my($typeval) = @_;
	    eval q( &if (( ($ctxt->{value}) ==  &NULL) || ( ($ctxt->{value}->{type}) != $typeval))  &XP_ERROR( &XPATH_INVALID_TYPE));
    }' unless defined(&CHECK_TYPE);
    eval 'sub CHECK_TYPE0 {
        my($typeval) = @_;
	    eval q( &if (( ($ctxt->{value}) ==  &NULL) || ( ($ctxt->{value}->{type}) != $typeval))  &XP_ERROR0( &XPATH_INVALID_TYPE));
    }' unless defined(&CHECK_TYPE0);
    eval 'sub CHECK_ARITY {
        my($x) = @_;
	    eval q( &if ( &nargs != ($x))  &XP_ERROR( &XPATH_INVALID_ARITY););
    }' unless defined(&CHECK_ARITY);
    eval 'sub CAST_TO_STRING () { &if (( ($ctxt->{value}) !=  &NULL)  && ( ($ctxt->{value}->{type}) !=  &XPATH_STRING))  &xmlXPathStringFunction( &ctxt, 1);;}' unless defined(&CAST_TO_STRING);
    eval 'sub CAST_TO_NUMBER () { &if (( ($ctxt->{value}) !=  &NULL)  && ( ($ctxt->{value}->{type}) !=  &XPATH_NUMBER))  &xmlXPathNumberFunction( &ctxt, 1);;}' unless defined(&CAST_TO_NUMBER);
    eval 'sub CAST_TO_BOOLEAN () { &if (( ($ctxt->{value}) !=  &NULL)  && ( ($ctxt->{value}->{type}) !=  &XPATH_BOOLEAN))  &xmlXPathBooleanFunction( &ctxt, 1);;}' unless defined(&CAST_TO_BOOLEAN);
    if(defined(&__cplusplus)) {
    }
}
1;
