require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_m_string_h)) {
    eval 'sub _m_string_h () {1;}' unless defined(&_m_string_h);
    unless(defined(&__USE_GNU)) {
	eval 'sub __USE_GNU () {1;}' unless defined(&__USE_GNU);
    }
    if(defined( &HAVE_STRINGS_H)) {
	require 'strings.ph';
    }
    if(defined( &HAVE_STRING_H)) {
	require 'string.ph';
    }
    if(defined(&HAVE_UNIXWARE7_THREADS)) {
	undef(&HAVE_STRINGS_H) if defined(&HAVE_STRINGS_H);
	undef(&HAVE_MEMORY_H) if defined(&HAVE_MEMORY_H);
	eval 'sub HAVE_MEMCPY () {1;}' unless defined(&HAVE_MEMCPY);
	unless(defined(&HAVE_MEMMOVE)) {
	    eval 'sub HAVE_MEMMOVE () {1;}' unless defined(&HAVE_MEMMOVE);
	}
	undef(&HAVE_BCMP) if defined(&HAVE_BCMP);
	undef(&bcopy) if defined(&bcopy);
	undef(&bcmp) if defined(&bcmp);
	undef(&bzero) if defined(&bzero);
    }
    if(defined(&_AIX)) {
	undef(&HAVE_BCMP) if defined(&HAVE_BCMP);
    }
    if(defined( &HAVE_STRINGS_H)  && !defined( &HAVE_mit_thread)) {
	require 'strings.ph';
    }
    if(defined( &HAVE_MEMORY_H)  && !defined( &__cplusplus)) {
	require 'memory.ph';
    }
    if(!defined( &HAVE_MEMCPY)  && !defined( &HAVE_MEMMOVE)) {
	eval 'sub memcpy {
	    my($d, $s, $n) = @_;
    	    eval q( &bcopy (($s), ($d), ($n)));
	}' unless defined(&memcpy);
	eval 'sub memset {
	    my($A,$C,$B) = @_;
    	    eval q( &bfill(($A),($B),($C)));
	}' unless defined(&memset);
	eval 'sub memmove {
	    my($d, $s, $n) = @_;
    	    eval q( &bmove (($d), ($s), ($n)));
	}' unless defined(&memmove);
    }
 elsif(defined( &HAVE_MEMMOVE)) {
	eval 'sub bmove {
	    my($d, $s, $n) = @_;
    	    eval q( &memmove(($d), ($s), ($n)));
	}' unless defined(&bmove);
    } else {
	eval 'sub memmove {
	    my($d, $s, $n) = @_;
    	    eval q( &bmove(($d), ($s), ($n)));
	}' unless defined(&memmove);
    }
    if(!defined( &HAVE_BFILL)) {
	eval 'sub bfill {
	    my($A,$B,$C) = @_;
    	    eval q( &memset(($A),($C),($B)));
	}' unless defined(&bfill);
	eval 'sub bmove_allign {
	    my($A,$B,$C) = @_;
    	    eval q( &memcpy(($A),($B),($C)));
	}' unless defined(&bmove_allign);
    }
    if(!defined( &HAVE_BCMP)) {
	eval 'sub bcopy {
	    my($s, $d, $n) = @_;
    	    eval q( &memcpy(($d), ($s), ($n)));
	}' unless defined(&bcopy);
	eval 'sub bcmp {
	    my($A,$B,$C) = @_;
    	    eval q( &memcmp(($A),($B),($C)));
	}' unless defined(&bcmp);
	eval 'sub bzero {
	    my($A,$B) = @_;
    	    eval q( &memset(($A),0,($B)));
	}' unless defined(&bzero);
	eval 'sub bmove_allign {
	    my($A,$B,$C) = @_;
    	    eval q( &memcpy(($A),($B),($C)));
	}' unless defined(&bmove_allign);
    }
    if(defined( &__cplusplus)  && !defined( &OS2)) {
    }
    if(defined( &HAVE_STPCPY)  && !defined( &HAVE_mit_thread)) {
	eval 'sub strmov {
	    my($A,$B) = @_;
    	    eval q( &stpcpy(($A),($B)));
	}' unless defined(&strmov);
	unless(defined(&stpcpy)) {
	}
    }
    if(defined(&BAD_STRING_COMPILER)) {
	eval 'sub strmov {
	    my($A,$B) = @_;
    	    eval q(( &memccpy($A,$B,0, &INT_MAX)-1));
	}' unless defined(&strmov);
    } else {
	eval 'sub strmov_overlapp {
	    my($A,$B) = @_;
    	    eval q( &strmov($A,$B));
	}' unless defined(&strmov_overlapp);
	eval 'sub strmake_overlapp {
	    my($A,$B,$C) = @_;
    	    eval q( &strmake($A,$B,$C));
	}' unless defined(&strmake_overlapp);
    }
    if(defined(&BAD_MEMCPY)) {
	eval 'sub memcpy_fixed {
	    my($A,$B,$C) = @_;
    	    eval q( &bmove(($A),($B),($C)));
	}' unless defined(&memcpy_fixed);
    } else {
	eval 'sub memcpy_fixed {
	    my($A,$B,$C) = @_;
    	    eval q( &memcpy(($A),($B),($C)));
	}' unless defined(&memcpy_fixed);
    }
    if(defined(&MSDOS)) {
	undef(&bmove_allign) if defined(&bmove_allign);
	eval 'sub bmove512 {
	    my($A,$B,$C) = @_;
    	    eval q( &bmove_allign($A,$B,$C));
	}' unless defined(&bmove512);
	eval 'sub my_itoa {
	    my($A,$B,$C) = @_;
    	    eval q( &itoa($A,$B,$C));
	}' unless defined(&my_itoa);
	eval 'sub my_ltoa {
	    my($A,$B,$C) = @_;
    	    eval q( &ltoa($A,$B,$C));
	}' unless defined(&my_ltoa);
    }
    if((!defined( &USE_BMOVE512) || defined( &HAVE_purify))  && !defined( &bmove512)) {
	eval 'sub bmove512 {
	    my($A,$B,$C) = @_;
    	    eval q( &memcpy($A,$B,$C));
	}' unless defined(&bmove512);
    }
    if(!defined( &bfill)  && !defined( &HAVE_BFILL)) {
    }
    if(!defined( &bzero)  && !defined( &HAVE_BZERO)) {
    }
    if(!defined( &bcmp)  && !defined( &HAVE_BCMP)) {
	if(defined(&HAVE_purify)) {
	    eval 'sub bcmp {
	        my($A,$B,$C) = @_;
    		eval q( &my_bcmp(($A),($B),($C)));
	    }' unless defined(&bcmp);
	}
    }
    unless(defined(&bmove512)) {
    }
    if(!defined( &HAVE_BMOVE)  && !defined( &bmove)) {
    }
    unless(defined(&strmake_overlapp)) {
    }
    unless(defined(&strmov)) {
    }
    if(defined(&WANT_STRING_PROTOTYPES)) {
	unless(defined(&__GNUC__)) {
	}
    }
    unless(defined(&HAVE_STRNLEN)) {
    }
    if(!defined( &__cplusplus)) {
	unless(defined(&HAVE_STRPBRK)) {
	}
	unless(defined(&HAVE_STRSTR)) {
	}
    }
    if(defined(&USE_MY_ITOA)) {
    }
    unless(defined(&HAVE_STRTOUL)) {
    }
    if((defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0) == (defined(&SIZEOF_LONG_LONG) ? &SIZEOF_LONG_LONG : 0)) {
	eval 'sub longlong2str {
	    my($A,$B,$C) = @_;
    	    eval q( &int2str(($A),($B),($C)));
	}' unless defined(&longlong2str);
	eval 'sub longlong10_to_str {
	    my($A,$B,$C) = @_;
    	    eval q( &int10_to_str(($A),($B),($C)));
	}' unless defined(&longlong10_to_str);
	eval 'sub strtoll {
	    my($A,$B,$C) = @_;
    	    eval q( &strtol(($A),($B),($C)));
	}' unless defined(&strtoll);
	eval 'sub strtoull {
	    my($A,$B,$C) = @_;
    	    eval q( &strtoul(($A),($B),($C)));
	}' unless defined(&strtoull);
	unless(defined(&HAVE_STRTOULL)) {
	    eval 'sub HAVE_STRTOULL () {1;}' unless defined(&HAVE_STRTOULL);
	}
    } else {
	if(defined(&HAVE_LONG_LONG)) {
	    if((!defined( &HAVE_STRTOULL) || defined( &HAVE_mit_thread)) || defined( &NO_STRTOLL_PROTO)) {
	    }
	}
    }
    if(defined( &__cplusplus)  && !defined( &OS2)) {
    }
}
1;
