require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_TOOLS_H)) {
    eval 'sub _TOOLS_H () {1;}' unless defined(&_TOOLS_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&WIN32)) {
	eval 'sub SNMP_MAXPATH () { &MAX_PATH;}' unless defined(&SNMP_MAXPATH);
    } else {
	if(defined(&PATH_MAX)) {
	    eval 'sub SNMP_MAXPATH () { &PATH_MAX;}' unless defined(&SNMP_MAXPATH);
	} else {
	    if(defined(&MAXPATHLEN)) {
		eval 'sub SNMP_MAXPATH () { &MAXPATHLEN;}' unless defined(&SNMP_MAXPATH);
	    } else {
		eval 'sub SNMP_MAXPATH () {1024;}' unless defined(&SNMP_MAXPATH);
	    }
	}
    }
    eval 'sub SNMP_MAXBUF () {(1024* 4);}' unless defined(&SNMP_MAXBUF);
    eval 'sub SNMP_MAXBUF_MEDIUM () {1024;}' unless defined(&SNMP_MAXBUF_MEDIUM);
    eval 'sub SNMP_MAXBUF_SMALL () {512;}' unless defined(&SNMP_MAXBUF_SMALL);
    eval 'sub SNMP_MAXBUF_MESSAGE () {1500;}' unless defined(&SNMP_MAXBUF_MESSAGE);
    eval 'sub SNMP_MAXOID () {64;}' unless defined(&SNMP_MAXOID);
    eval 'sub SNMP_FILEMODE_CLOSED () {0600;}' unless defined(&SNMP_FILEMODE_CLOSED);
    eval 'sub SNMP_FILEMODE_OPEN () {0644;}' unless defined(&SNMP_FILEMODE_OPEN);
    eval 'sub BYTESIZE {
        my($bitsize) = @_;
	    eval q((($bitsize + 7) >> 3));
    }' unless defined(&BYTESIZE);
    eval 'sub ROUNDUP8 {
        my($x) = @_;
	    eval q(( ( ($x+7) >> 3) * 8));
    }' unless defined(&ROUNDUP8);
    eval 'sub SNMP_FREE {
        my($s) = @_;
	    eval q( &do {  &if ($s) {  &free(( &void *)$s); $s= &NULL; } }  &while(0));
    }' unless defined(&SNMP_FREE);
    eval 'sub SNMP_MALLOC_STRUCT {
        my($s) = @_;
	    eval q(  &calloc(1, $sizeof{\'struct s\'}));
    }' unless defined(&SNMP_MALLOC_STRUCT);
    eval 'sub SNMP_MALLOC_TYPEDEF {
        my($td) = @_;
	    eval q(($td *)  &calloc(1, $sizeof{$td}));
    }' unless defined(&SNMP_MALLOC_TYPEDEF);
    eval 'sub SNMP_ZERO {
        my($s,$l) = @_;
	    eval q( &if ($s)  &memset($s, 0, $l););
    }' unless defined(&SNMP_ZERO);
    eval 'sub TOUPPER {
        my($c) = @_;
	    eval q(($c >= ord(\'a\' && c <= \'z\' ? c - (\'a\' - \'A\')) : $c));
    }' unless defined(&TOUPPER);
    eval 'sub TOLOWER {
        my($c) = @_;
	    eval q(($c >= ord(\'A\' && c <= \'Z\' ? c + (\'a\' - \'A\')) : $c));
    }' unless defined(&TOLOWER);
    eval 'sub HEX2VAL {
        my($s) = @_;
	    eval q((( &isalpha($s) ? ( &TOLOWER($s)-ord(\'a\'+10) : (TOLOWER(s)-\'0\'))) & 0xf));
    }' unless defined(&HEX2VAL);
    eval 'sub VAL2HEX {
        my($s) = @_;
	    eval q(( ($s) + ((($s) >= 10) ? (ord(\'a\'-10) : \'0\')) ));
    }' unless defined(&VAL2HEX);
    eval 'sub SNMP_MAX {
        my($a,$b) = @_;
	    eval q((($a) > ($b) ? ($a) : ($b)));
    }' unless defined(&SNMP_MAX);
    eval 'sub SNMP_MIN {
        my($a,$b) = @_;
	    eval q((($a) > ($b) ? ($b) : ($a)));
    }' unless defined(&SNMP_MIN);
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
    }
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {1;}' unless defined(&TRUE);
    }
    eval 'sub QUITFUN {
        my($e, $l) = @_;
	    eval q( &if ( ($e) !=  &SNMPERR_SUCCESS) {  &rval =  &SNMPERR_GENERR;  &goto $l ; });
    }' unless defined(&QUITFUN);
    eval 'sub DIFFTIMEVAL {
        my($now, $then, $diff) = @_;
	    eval q({  ($now->{tv_sec})--;  ($now->{tv_usec}) += 1000000;  ($diff->{tv_sec})  =  ($now->{tv_sec})  -  ($then->{tv_sec});  ($diff->{tv_usec}) =  ($now->{tv_usec}) -  ($then->{tv_usec});  &if ( ($diff->{tv_usec}) > 1000000){  ($diff->{tv_usec}) -= 1000000;  ($diff->{tv_sec})++; } });
    }' unless defined(&DIFFTIMEVAL);
    eval 'sub USM_LENGTH_OID_TRANSFORM () {10;}' unless defined(&USM_LENGTH_OID_TRANSFORM);
    eval 'sub ISTRANSFORM {
        my($ttype, $toid) = @_;
	    eval q(! &snmp_oid_compare($ttype,  &USM_LENGTH_OID_TRANSFORM,  &usm  $toid   &Protocol,  &USM_LENGTH_OID_TRANSFORM));
    }' unless defined(&ISTRANSFORM);
    eval 'sub ENGINETIME_MAX () {2147483647;}' unless defined(&ENGINETIME_MAX);
    eval 'sub ENGINEBOOT_MAX () {2147483647;}' unless defined(&ENGINEBOOT_MAX);
    if(defined(&__cplusplus)) {
    }
}
1;
