require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&C_H)) {
    eval 'sub C_H () {1;}' unless defined(&C_H);
    require 'pg_config.ph';
    require 'postgres_ext.ph';
    require 'stdio.ph';
    require 'stdlib.ph';
    require 'string.ph';
    require 'stddef.ph';
    require 'stdarg.ph';
    if(defined(&HAVE_STRINGS_H)) {
	require 'strings.ph';
    }
    require 'sys/types.ph';
    if(defined(&__CYGWIN__)) {
	require 'errno.ph';
	require 'sys/fcntl.ph';
    }
    if(defined(&HAVE_SUPPORTDEFS_H)) {
	require 'SupportDefs.ph';
    }
    require 'locale.ph';
    if(defined(&ENABLE_NLS)) {
	require 'libintl.ph';
    } else {
	eval 'sub gettext {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&gettext);
    }
    eval 'sub gettext_noop {
        my($x) = @_;
	    eval q(($x));
    }' unless defined(&gettext_noop);
    if(defined( &HAVE_STRINGIZE)) {
	eval 'sub CppAsString {
	    my($identifier) = @_;
    	    eval q($identifier);
	}' unless defined(&CppAsString);
	eval 'sub CppConcat {
	    my($x, $y) = @_;
    	    eval q($x$y);
	}' unless defined(&CppConcat);
    } else {
	eval 'sub CppAsString {
	    my($identifier) = @_;
    	    eval q(\\"identifier\\");
	}' unless defined(&CppAsString);
	eval 'sub _priv_CppIdentity {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&_priv_CppIdentity);
	eval 'sub CppConcat {
	    my($x, $y) = @_;
    	    eval q( &_priv_CppIdentity($x)$y);
	}' unless defined(&CppConcat);
    }
    if(defined(&__GNUC__)) {
	eval 'sub dummyret () { &void;}' unless defined(&dummyret);
    } else {
	eval 'sub dummyret () {\'char\';}' unless defined(&dummyret);
    }
    unless(defined(&__GNUC__)) {
	eval 'sub __attribute__ {
	    my($_arg_) = @_;
    	    eval q();
	}' unless defined(&__attribute__);
    }
    unless(defined(&__BEOS__)) {
	unless(defined(&__cplusplus)) {
	    unless(defined(&bool)) {
	    }
	    unless(defined(&true)) {
		eval 'sub true () {(( &bool) 1);}' unless defined(&true);
	    }
	    unless(defined(&false)) {
		eval 'sub false () {(( &bool) 0);}' unless defined(&false);
	    }
	}
    }
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {1;}' unless defined(&TRUE);
    }
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
    }
    unless(defined(&NULL)) {
	eval 'sub NULL () {(( &void *) 0);}' unless defined(&NULL);
    }
    unless(defined(&HAVE_INT8)) {
    }
    unless(defined(&HAVE_UINT8)) {
    }
    if(defined(&HAVE_LONG_INT_64)) {
	unless(defined(&HAVE_INT64)) {
	}
	unless(defined(&HAVE_UINT64)) {
	}
    }
 elsif(defined( &HAVE_LONG_LONG_INT_64)) {
	unless(defined(&HAVE_INT64)) {
	}
	unless(defined(&HAVE_UINT64)) {
	}
    } else {
	unless(defined(&HAVE_INT64)) {
	}
	unless(defined(&HAVE_UINT64)) {
	}
	eval 'sub INT64_IS_BUSTED () {1;}' unless defined(&INT64_IS_BUSTED);
    }
    if(defined(&HAVE_LL_CONSTANTS)) {
	eval 'sub INT64CONST {
	    my($x) = @_;
    	    eval q((( &int64) $x &LL));
	}' unless defined(&INT64CONST);
	eval 'sub UINT64CONST {
	    my($x) = @_;
    	    eval q((( &uint64) $x &LL));
	}' unless defined(&UINT64CONST);
    } else {
	eval 'sub INT64CONST {
	    my($x) = @_;
    	    eval q((( &int64) $x));
	}' unless defined(&INT64CONST);
	eval 'sub UINT64CONST {
	    my($x) = @_;
    	    eval q((( &uint64) $x));
	}' unless defined(&UINT64CONST);
    }
    if(defined( &USE_INTEGER_DATETIMES)  && !defined( &INT64_IS_BUSTED)) {
	eval 'sub HAVE_INT64_TIMESTAMP () {1;}' unless defined(&HAVE_INT64_TIMESTAMP);
    }
    unless(defined(&HAVE_SIG_ATOMIC_T)) {
    }
    eval 'sub FirstCommandId () {(( &CommandId) 0);}' unless defined(&FirstCommandId);
    eval 'sub MAXDIM () {6;}' unless defined(&MAXDIM);
    eval 'sub VARHDRSZ () {(( &int32) $sizeof{ &int32});}' unless defined(&VARHDRSZ);
    eval 'sub NameStr {
        my($name) = @_;
	    eval q((($name). &data));
    }' unless defined(&NameStr);
    eval 'sub BoolIsValid {
        my($boolean) = @_;
	    eval q((($boolean) ==  &false || ($boolean) ==  &true));
    }' unless defined(&BoolIsValid);
    eval 'sub PointerIsValid {
        my($pointer) = @_;
	    eval q((( &void*)($pointer) !=  &NULL));
    }' unless defined(&PointerIsValid);
    eval 'sub PointerIsAligned {
        my($pointer, $type) = @_;
	    eval q(((($pointer) % ($sizeof{$type})) == 0));
    }' unless defined(&PointerIsAligned);
    eval 'sub OidIsValid {
        my($objectId) = @_;
	    eval q((( &bool) (($objectId) !=  &InvalidOid)));
    }' unless defined(&OidIsValid);
    eval 'sub RegProcedureIsValid {
        my($p) = @_;
	    eval q( &OidIsValid($p));
    }' unless defined(&RegProcedureIsValid);
    unless(defined(&offsetof)) {
	eval 'sub offsetof {
	    my($type, $field) = @_;
    	    eval q(( (($type *)0)->$field));
	}' unless defined(&offsetof);
    }
    eval 'sub lengthof {
        my($array) = @_;
	    eval q(($sizeof{$array} / $sizeof{($array)[0]}));
    }' unless defined(&lengthof);
    eval 'sub endof {
        my($array) = @_;
	    eval q(($array->[ &lengthof($array)]));
    }' unless defined(&endof);
    eval 'sub TYPEALIGN {
        my($ALIGNVAL,$LEN) = @_;
	    eval q(((($LEN) + ($ALIGNVAL-1)) & ~($ALIGNVAL-1)));
    }' unless defined(&TYPEALIGN);
    eval 'sub SHORTALIGN {
        my($LEN) = @_;
	    eval q( &TYPEALIGN( &ALIGNOF_SHORT, ($LEN)));
    }' unless defined(&SHORTALIGN);
    eval 'sub INTALIGN {
        my($LEN) = @_;
	    eval q( &TYPEALIGN( &ALIGNOF_INT, ($LEN)));
    }' unless defined(&INTALIGN);
    eval 'sub LONGALIGN {
        my($LEN) = @_;
	    eval q( &TYPEALIGN( &ALIGNOF_LONG, ($LEN)));
    }' unless defined(&LONGALIGN);
    eval 'sub DOUBLEALIGN {
        my($LEN) = @_;
	    eval q( &TYPEALIGN( &ALIGNOF_DOUBLE, ($LEN)));
    }' unless defined(&DOUBLEALIGN);
    eval 'sub MAXALIGN {
        my($LEN) = @_;
	    eval q( &TYPEALIGN( &MAXIMUM_ALIGNOF, ($LEN)));
    }' unless defined(&MAXALIGN);
    eval 'sub Max {
        my($x, $y) = @_;
	    eval q((($x) > ($y) ? ($x) : ($y)));
    }' unless defined(&Max);
    eval 'sub Min {
        my($x, $y) = @_;
	    eval q((($x) < ($y) ? ($x) : ($y)));
    }' unless defined(&Min);
    eval 'sub Abs {
        my($x) = @_;
	    eval q((($x) >= 0? ($x) : -($x)));
    }' unless defined(&Abs);
    eval 'sub StrNCpy {
        my($dst,$src,$len) = @_;
	    eval q( &do { \'char\' *  &_dst = ($dst);  &Size  &_len = ($len);  &if ( &_len > 0) {  &strncpy( &_dst, ($src),  &_len);  $_dst[ &_len-1] = ord(\'\\\\0\'); } }  &while (0));
    }' unless defined(&StrNCpy);
    eval 'sub INT_ALIGN_MASK () {($sizeof{ &int32} - 1);}' unless defined(&INT_ALIGN_MASK);
    eval 'sub MemSet {
        my($start, $val, $len) = @_;
	    eval q( &do {  &int32 *  &_start = ( &int32 *) ; \'int\'  &_val = ;  &Size  &_len = ;  &if (((  &_start) &  &INT_ALIGN_MASK) == 0 && ( &_len &  &INT_ALIGN_MASK) == 0 &&  &_val == 0 &&  &_len <=  &MEMSET_LOOP_LIMIT) {  &int32 *  &_stop = ( &int32 *) (  &_start +  &_len);  &while ( &_start <  &_stop) * &_start++ = 0; }  &else  &memset(  &_start,  &_val,  &_len); }  &while (0));
    }' unless defined(&MemSet);
    eval 'sub MEMSET_LOOP_LIMIT () {1024;}' unless defined(&MEMSET_LOOP_LIMIT);
    eval 'sub CSIGNBIT () {(0x80);}' unless defined(&CSIGNBIT);
    eval 'sub STATUS_OK () {(0);}' unless defined(&STATUS_OK);
    eval 'sub STATUS_ERROR () {(-1);}' unless defined(&STATUS_ERROR);
    eval 'sub STATUS_EOF () {(-2);}' unless defined(&STATUS_EOF);
    eval 'sub STATUS_FOUND () {(1);}' unless defined(&STATUS_FOUND);
    if(defined(&__CYGWIN__)) {
	eval 'sub PG_BINARY () { &O_BINARY;}' unless defined(&PG_BINARY);
	eval 'sub PG_BINARY_R () {"rb";}' unless defined(&PG_BINARY_R);
	eval 'sub PG_BINARY_W () {"wb";}' unless defined(&PG_BINARY_W);
    } else {
	eval 'sub PG_BINARY () {0;}' unless defined(&PG_BINARY);
	eval 'sub PG_BINARY_R () {"r";}' unless defined(&PG_BINARY_R);
	eval 'sub PG_BINARY_W () {"w";}' unless defined(&PG_BINARY_W);
    }
    if(defined( &sun)  && defined( &__sparc__)  && !defined( &__SVR4)) {
	require 'unistd.ph';
    }
    if(defined( &bsdi) || defined( &netbsd)) {
    }
    eval 'sub NULL_DEV () {"/dev/null";}' unless defined(&NULL_DEV);
    if(!(defined(&HAVE_DECL_SNPRINTF) ? &HAVE_DECL_SNPRINTF : 0)) {
    }
    if(!(defined(&HAVE_DECL_VSNPRINTF) ? &HAVE_DECL_VSNPRINTF : 0)) {
    }
    if(!defined( &HAVE_MEMMOVE)  && !defined( &memmove)) {
	eval 'sub memmove {
	    my($d, $s, $c) = @_;
    	    eval q( &bcopy($s, $d, $c));
	}' unless defined(&memmove);
    }
}
1;
