require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&HTUP_H)) {
    eval 'sub HTUP_H () {1;}' unless defined(&HTUP_H);
    require 'storage/bufpage.ph';
    require 'storage/relfilenode.ph';
    require 'access/transam.ph';
    eval 'sub MaxTupleAttributeNumber () {1664;}' unless defined(&MaxTupleAttributeNumber);
    eval 'sub MaxHeapAttributeNumber () {1600;}' unless defined(&MaxHeapAttributeNumber);
    eval 'sub HEAP_HASNULL () {0x1;}' unless defined(&HEAP_HASNULL);
    eval 'sub HEAP_HASVARWIDTH () {0x2;}' unless defined(&HEAP_HASVARWIDTH);
    eval 'sub HEAP_HASEXTERNAL () {0x4;}' unless defined(&HEAP_HASEXTERNAL);
    eval 'sub HEAP_HASCOMPRESSED () {0x8;}' unless defined(&HEAP_HASCOMPRESSED);
    eval 'sub HEAP_HASEXTENDED () {0xc;}' unless defined(&HEAP_HASEXTENDED);
    eval 'sub HEAP_HASOID () {0x10;}' unless defined(&HEAP_HASOID);
    eval 'sub HEAP_XMAX_IS_XMIN () {0x40;}' unless defined(&HEAP_XMAX_IS_XMIN);
    eval 'sub HEAP_XMAX_UNLOGGED () {0x80;}' unless defined(&HEAP_XMAX_UNLOGGED);
    eval 'sub HEAP_XMIN_COMMITTED () {0x100;}' unless defined(&HEAP_XMIN_COMMITTED);
    eval 'sub HEAP_XMIN_INVALID () {0x200;}' unless defined(&HEAP_XMIN_INVALID);
    eval 'sub HEAP_XMAX_COMMITTED () {0x400;}' unless defined(&HEAP_XMAX_COMMITTED);
    eval 'sub HEAP_XMAX_INVALID () {0x800;}' unless defined(&HEAP_XMAX_INVALID);
    eval 'sub HEAP_MARKED_FOR_UPDATE () {0x1000;}' unless defined(&HEAP_MARKED_FOR_UPDATE);
    eval 'sub HEAP_UPDATED () {0x2000;}' unless defined(&HEAP_UPDATED);
    eval 'sub HEAP_MOVED_OFF () {0x4000;}' unless defined(&HEAP_MOVED_OFF);
    eval 'sub HEAP_MOVED_IN () {0x8000;}' unless defined(&HEAP_MOVED_IN);
    eval 'sub HEAP_MOVED () {( &HEAP_MOVED_OFF |  &HEAP_MOVED_IN);}' unless defined(&HEAP_MOVED);
    eval 'sub HEAP_XACT_MASK () {0xffc0;}' unless defined(&HEAP_XACT_MASK);
    eval 'sub HeapTupleHeaderGetXmin {
        my($tup) = @_;
	    eval q(( ($tup)-> &t_xmin ));
    }' unless defined(&HeapTupleHeaderGetXmin);
    eval 'sub HeapTupleHeaderSetXmin {
        my($tup, $xid) = @_;
	    eval q((  &TransactionIdStore(($xid), ($tup)-> &t_xmin) ));
    }' unless defined(&HeapTupleHeaderSetXmin);
    eval 'sub HeapTupleHeaderGetXmax {
        my($tup) = @_;
	    eval q(( (($tup)-> &t_infomask &  &HEAP_XMAX_IS_XMIN) ? ($tup)-> &t_xmin : ($tup)-> ($t_field2->{t_xmax}) ));
    }' unless defined(&HeapTupleHeaderGetXmax);
    eval 'sub HeapTupleHeaderSetXmax {
        my($tup, $xid) = @_;
	    eval q( &do {  &TransactionId  &_newxid = ($xid);  &if ( &TransactionIdEquals(($tup)-> &t_xmin,  &_newxid)) ($tup)-> &t_infomask |=  &HEAP_XMAX_IS_XMIN;  &else { ($tup)-> &t_infomask &= ~ &HEAP_XMAX_IS_XMIN;  &TransactionIdStore( &_newxid, ($tup)-> ($t_field2->{t_xmax})); } }  &while (0));
    }' unless defined(&HeapTupleHeaderSetXmax);
    eval 'sub HeapTupleHeaderGetCmin {
        my($tup) = @_;
	    eval q(( ($tup)-> ($t_field2->{t_cmin}) ));
    }' unless defined(&HeapTupleHeaderGetCmin);
    eval 'sub HeapTupleHeaderSetCmin {
        my($tup, $cid) = @_;
	    eval q( &do {  &Assert(($tup)-> &t_infomask &  &HEAP_XMAX_INVALID); ($tup)-> ($t_field2->{t_cmin}) = ($cid); }  &while (0));
    }' unless defined(&HeapTupleHeaderSetCmin);
    eval 'sub HeapTupleHeaderGetCmax {
        my($tup) = @_;
	    eval q(( ($tup)-> ($t_field3->{t_cmax}) ));
    }' unless defined(&HeapTupleHeaderGetCmax);
    eval 'sub HeapTupleHeaderSetCmax {
        my($tup, $cid) = @_;
	    eval q( &do {  &Assert(!(($tup)-> &t_infomask &  &HEAP_MOVED)); ($tup)-> ($t_field3->{t_cmax}) = ($cid); }  &while (0));
    }' unless defined(&HeapTupleHeaderSetCmax);
    eval 'sub HeapTupleHeaderGetXvac {
        my($tup) = @_;
	    eval q(( (($tup)-> &t_infomask &  &HEAP_MOVED) ? ($tup)-> ($t_field3->{t_xvac})  :  &InvalidTransactionId ));
    }' unless defined(&HeapTupleHeaderGetXvac);
    eval 'sub HeapTupleHeaderSetXvac {
        my($tup, $xid) = @_;
	    eval q( &do {  &Assert(($tup)-> &t_infomask &  &HEAP_MOVED);  &TransactionIdStore(($xid), ($tup)-> ($t_field3->{t_xvac})); }  &while (0));
    }' unless defined(&HeapTupleHeaderSetXvac);
    eval 'sub HeapTupleHeaderGetOid {
        my($tup) = @_;
	    eval q(( (($tup)-> &t_infomask &  &HEAP_HASOID) ? *(( &Oid *) (($tup) + ($tup)-> &t_hoff - $sizeof{ &Oid})) :  &InvalidOid ));
    }' unless defined(&HeapTupleHeaderGetOid);
    eval 'sub HeapTupleHeaderSetOid {
        my($tup, $oid) = @_;
	    eval q( &do {  &Assert(($tup)-> &t_infomask &  &HEAP_HASOID); *(( &Oid *) (($tup) + ($tup)-> &t_hoff - $sizeof{ &Oid})) = ($oid); }  &while (0));
    }' unless defined(&HeapTupleHeaderSetOid);
    eval 'sub XLOG_HEAP_INSERT () {0x;}' unless defined(&XLOG_HEAP_INSERT);
    eval 'sub XLOG_HEAP_DELETE () {0x10;}' unless defined(&XLOG_HEAP_DELETE);
    eval 'sub XLOG_HEAP_UPDATE () {0x20;}' unless defined(&XLOG_HEAP_UPDATE);
    eval 'sub XLOG_HEAP_MOVE () {0x30;}' unless defined(&XLOG_HEAP_MOVE);
    eval 'sub XLOG_HEAP_CLEAN () {0x40;}' unless defined(&XLOG_HEAP_CLEAN);
    eval 'sub XLOG_HEAP_OPMASK () {0x70;}' unless defined(&XLOG_HEAP_OPMASK);
    eval 'sub XLOG_HEAP_INIT_PAGE () {0x80;}' unless defined(&XLOG_HEAP_INIT_PAGE);
    eval 'sub SizeOfHeapTid () {( &offsetof( &xl_heaptid,  &tid) +  &SizeOfIptrData);}' unless defined(&SizeOfHeapTid);
    eval 'sub SizeOfHeapDelete () {( &offsetof( &xl_heap_delete,  &target) +  &SizeOfHeapTid);}' unless defined(&SizeOfHeapDelete);
    eval 'sub SizeOfHeapHeader () {( &offsetof( &xl_heap_header,  &t_hoff) + $sizeof{ &uint8});}' unless defined(&SizeOfHeapHeader);
    eval 'sub SizeOfHeapInsert () {( &offsetof( &xl_heap_insert,  &target) +  &SizeOfHeapTid);}' unless defined(&SizeOfHeapInsert);
    eval 'sub SizeOfHeapUpdate () {( &offsetof( &xl_heap_update,  &newtid) +  &SizeOfIptrData);}' unless defined(&SizeOfHeapUpdate);
    eval 'sub SizeOfHeapClean () {( &offsetof( &xl_heap_clean,  &block) + $sizeof{ &BlockNumber});}' unless defined(&SizeOfHeapClean);
    eval 'sub MaxSpecialSpace () {32;}' unless defined(&MaxSpecialSpace);
    eval 'sub MaxTupleSize () {( &BLCKSZ -  &MAXALIGN($sizeof{ &PageHeaderData} +  &MaxSpecialSpace));}' unless defined(&MaxTupleSize);
    eval 'sub MaxAttrSize () {(10* 1024* 1024);}' unless defined(&MaxAttrSize);
    eval 'sub SelfItemPointerAttributeNumber () {(-1);}' unless defined(&SelfItemPointerAttributeNumber);
    eval 'sub ObjectIdAttributeNumber () {(-2);}' unless defined(&ObjectIdAttributeNumber);
    eval 'sub MinTransactionIdAttributeNumber () {(-3);}' unless defined(&MinTransactionIdAttributeNumber);
    eval 'sub MinCommandIdAttributeNumber () {(-4);}' unless defined(&MinCommandIdAttributeNumber);
    eval 'sub MaxTransactionIdAttributeNumber () {(-5);}' unless defined(&MaxTransactionIdAttributeNumber);
    eval 'sub MaxCommandIdAttributeNumber () {(-6);}' unless defined(&MaxCommandIdAttributeNumber);
    eval 'sub TableOidAttributeNumber () {(-7);}' unless defined(&TableOidAttributeNumber);
    eval 'sub FirstLowInvalidHeapAttributeNumber () {(-8);}' unless defined(&FirstLowInvalidHeapAttributeNumber);
    eval 'sub HEAPTUPLESIZE () { &MAXALIGN($sizeof{ &HeapTupleData});}' unless defined(&HEAPTUPLESIZE);
    eval 'sub GETSTRUCT {
        my($TUP) = @_;
	    eval q(( (($TUP)-> &t_data) + ($TUP)-> ($t_data->{t_hoff})));
    }' unless defined(&GETSTRUCT);
    eval 'sub BITMAPLEN {
        my($NATTS) = @_;
	    eval q(((($NATTS) + 7) / 8));
    }' unless defined(&BITMAPLEN);
    eval 'sub HeapTupleIsValid {
        my($tuple) = @_;
	    eval q( &PointerIsValid($tuple));
    }' unless defined(&HeapTupleIsValid);
    eval 'sub HeapTupleNoNulls {
        my($tuple) = @_;
	    eval q((!(($tuple)-> ($t_data->{t_infomask}) &  &HEAP_HASNULL)));
    }' unless defined(&HeapTupleNoNulls);
    eval 'sub HeapTupleAllFixed {
        my($tuple) = @_;
	    eval q((!(($tuple)-> ($t_data->{t_infomask}) &  &HEAP_HASVARWIDTH)));
    }' unless defined(&HeapTupleAllFixed);
    eval 'sub HeapTupleHasExternal {
        my($tuple) = @_;
	    eval q(((($tuple)-> ($t_data->{t_infomask}) &  &HEAP_HASEXTERNAL) != 0));
    }' unless defined(&HeapTupleHasExternal);
    eval 'sub HeapTupleHasCompressed {
        my($tuple) = @_;
	    eval q(((($tuple)-> ($t_data->{t_infomask}) &  &HEAP_HASCOMPRESSED) != 0));
    }' unless defined(&HeapTupleHasCompressed);
    eval 'sub HeapTupleHasExtended {
        my($tuple) = @_;
	    eval q(((($tuple)-> ($t_data->{t_infomask}) &  &HEAP_HASEXTENDED) != 0));
    }' unless defined(&HeapTupleHasExtended);
    eval 'sub HeapTupleGetOid {
        my($tuple) = @_;
	    eval q( &HeapTupleHeaderGetOid(($tuple)-> &t_data));
    }' unless defined(&HeapTupleGetOid);
    eval 'sub HeapTupleSetOid {
        my($tuple, $oid) = @_;
	    eval q( &HeapTupleHeaderSetOid(($tuple)-> &t_data, ($oid)));
    }' unless defined(&HeapTupleSetOid);
}
1;
