require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&NBTREE_H)) {
    eval 'sub NBTREE_H () {1;}' unless defined(&NBTREE_H);
    require 'access/itup.ph';
    require 'access/relscan.ph';
    require 'access/sdir.ph';
    require 'access/xlogutils.ph';
    eval 'sub BTP_LEAF () {(1<< 0);}' unless defined(&BTP_LEAF);
    eval 'sub BTP_ROOT () {(1<< 1);}' unless defined(&BTP_ROOT);
    eval 'sub BTP_FREE () {(1<< 2);}' unless defined(&BTP_FREE);
    eval 'sub BTP_META () {(1<< 3);}' unless defined(&BTP_META);
    eval 'sub BTP_REORDER () {(1<< 4);}' unless defined(&BTP_REORDER);
    eval 'sub BTPageGetMeta {
        my($p) = @_;
	    eval q((( &BTMetaPageData *)  &PageGetContents($p)));
    }' unless defined(&BTPageGetMeta);
    eval 'sub BTREE_METAPAGE () {0;}' unless defined(&BTREE_METAPAGE);
    eval 'sub BTREE_MAGIC () {0x53162;}' unless defined(&BTREE_MAGIC);
    eval 'sub BTreeInvalidParent {
        my($opaque) = @_;
	    eval q(( ($opaque->{btpo_parent}) ==  &InvalidBlockNumber ||  ($opaque->{btpo_parent}) ==  &BTREE_METAPAGE));
    }' unless defined(&BTreeInvalidParent);
    eval 'sub BTREE_VERSION () {1;}' unless defined(&BTREE_VERSION);
    eval 'sub BTMaxItemSize {
        my($page) = @_;
	    eval q((( &PageGetPageSize($page) - $sizeof{ &PageHeaderData} -  &MAXALIGN($sizeof{ &BTPageOpaqueData})) / 3- $sizeof{ &ItemIdData}));
    }' unless defined(&BTMaxItemSize);
    eval 'sub SizeOfBTItem () {$sizeof{ &BTItemData};}' unless defined(&SizeOfBTItem);
    eval 'sub BTItemSame {
        my($i1, $i2) = @_;
	    eval q(( ($i1)-> ($bti_itup->{t_tid}->{ip_blkid}->{bi_hi}) == ($i2)-> ($bti_itup->{t_tid}->{ip_blkid}->{bi_hi})  && ($i1)-> ($bti_itup->{t_tid}->{ip_blkid}->{bi_lo}) == ($i2)-> ($bti_itup->{t_tid}->{ip_blkid}->{bi_lo})  && ($i1)-> ($bti_itup->{t_tid}->{ip_posid}) == ($i2)-> ($bti_itup->{t_tid}->{ip_posid}) ));
    }' unless defined(&BTItemSame);
    eval 'sub BT_READ () { &BUFFER_LOCK_SHARE;}' unless defined(&BT_READ);
    eval 'sub BT_WRITE () { &BUFFER_LOCK_EXCLUSIVE;}' unless defined(&BT_WRITE);
    eval 'sub P_NONE () {0;}' unless defined(&P_NONE);
    eval 'sub P_LEFTMOST {
        my($opaque) = @_;
	    eval q((($opaque)-> &btpo_prev ==  &P_NONE));
    }' unless defined(&P_LEFTMOST);
    eval 'sub P_RIGHTMOST {
        my($opaque) = @_;
	    eval q((($opaque)-> &btpo_next ==  &P_NONE));
    }' unless defined(&P_RIGHTMOST);
    eval 'sub P_ISLEAF {
        my($opaque) = @_;
	    eval q((($opaque)-> &btpo_flags &  &BTP_LEAF));
    }' unless defined(&P_ISLEAF);
    eval 'sub P_ISROOT {
        my($opaque) = @_;
	    eval q((($opaque)-> &btpo_flags &  &BTP_ROOT));
    }' unless defined(&P_ISROOT);
    eval 'sub P_HIKEY () {(( &OffsetNumber) 1);}' unless defined(&P_HIKEY);
    eval 'sub P_FIRSTKEY () {(( &OffsetNumber) 2);}' unless defined(&P_FIRSTKEY);
    eval 'sub P_FIRSTDATAKEY {
        my($opaque) = @_;
	    eval q(( &P_RIGHTMOST($opaque) ?  &P_HIKEY :  &P_FIRSTKEY));
    }' unless defined(&P_FIRSTDATAKEY);
    eval 'sub XLOG_BTREE_DELETE () {0x;}' unless defined(&XLOG_BTREE_DELETE);
    eval 'sub XLOG_BTREE_INSERT () {0x10;}' unless defined(&XLOG_BTREE_INSERT);
    eval 'sub XLOG_BTREE_SPLIT () {0x20;}' unless defined(&XLOG_BTREE_SPLIT);
    eval 'sub XLOG_BTREE_SPLEFT () {0x30;}' unless defined(&XLOG_BTREE_SPLEFT);
    eval 'sub XLOG_BTREE_NEWROOT () {0x40;}' unless defined(&XLOG_BTREE_NEWROOT);
    eval 'sub XLOG_BTREE_LEAF () {0x80;}' unless defined(&XLOG_BTREE_LEAF);
    eval 'sub SizeOfBtreeDelete () {( &offsetof( &xl_btreetid,  &tid) +  &SizeOfIptrData);}' unless defined(&SizeOfBtreeDelete);
    eval 'sub SizeOfBtreeInsert () {( &offsetof( &xl_btreetid,  &tid) +  &SizeOfIptrData);}' unless defined(&SizeOfBtreeInsert);
    eval 'sub SizeOfBtreeSplit () {( &offsetof( &xl_btree_split,  &leftlen) + $sizeof{ &uint16});}' unless defined(&SizeOfBtreeSplit);
    eval 'sub SizeOfBtreeNewroot () {( &offsetof( &xl_btree_newroot,  &rootblk) + $sizeof{ &BlockIdData});}' unless defined(&SizeOfBtreeNewroot);
    eval 'sub BTLessStrategyNumber () {1;}' unless defined(&BTLessStrategyNumber);
    eval 'sub BTLessEqualStrategyNumber () {2;}' unless defined(&BTLessEqualStrategyNumber);
    eval 'sub BTEqualStrategyNumber () {3;}' unless defined(&BTEqualStrategyNumber);
    eval 'sub BTGreaterEqualStrategyNumber () {4;}' unless defined(&BTGreaterEqualStrategyNumber);
    eval 'sub BTGreaterStrategyNumber () {5;}' unless defined(&BTGreaterStrategyNumber);
    eval 'sub BTMaxStrategyNumber () {5;}' unless defined(&BTMaxStrategyNumber);
    eval 'sub BTORDER_PROC () {1;}' unless defined(&BTORDER_PROC);
}
1;
