require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&BUFMGR_H)) {
    eval 'sub BUFMGR_H () {1;}' unless defined(&BUFMGR_H);
    require 'access/xlogdefs.ph';
    require 'storage/buf.ph';
    require 'storage/lock.ph';
    require 'storage/relfilenode.ph';
    require 'utils/rel.ph';
    eval 'sub P_NEW () { &InvalidBlockNumber;}' unless defined(&P_NEW);
    eval 'sub BUFFER_LOCK_UNLOCK () {0;}' unless defined(&BUFFER_LOCK_UNLOCK);
    eval 'sub BUFFER_LOCK_SHARE () {1;}' unless defined(&BUFFER_LOCK_SHARE);
    eval 'sub BUFFER_LOCK_EXCLUSIVE () {2;}' unless defined(&BUFFER_LOCK_EXCLUSIVE);
    eval 'sub BAD_BUFFER_ID {
        my($bid) = @_;
	    eval q((($bid) < 1|| ($bid) >  &NBuffers));
    }' unless defined(&BAD_BUFFER_ID);
    eval 'sub INVALID_DESCRIPTOR () {(-3);}' unless defined(&INVALID_DESCRIPTOR);
    eval 'sub UnlockAndReleaseBuffer {
        my($buffer) = @_;
	    eval q((  &LockBuffer($buffer,  &BUFFER_LOCK_UNLOCK),  &ReleaseBuffer($buffer) ));
    }' unless defined(&UnlockAndReleaseBuffer);
    eval 'sub UnlockAndWriteBuffer {
        my($buffer) = @_;
	    eval q((  &LockBuffer($buffer,  &BUFFER_LOCK_UNLOCK),  &WriteBuffer($buffer) ));
    }' unless defined(&UnlockAndWriteBuffer);
    eval 'sub BufferIsValid {
        my($bufnum) = @_;
	    eval q((  &BufferIsLocal($bufnum) ? (($bufnum) >= - &NLocBuffer) : (!  &BAD_BUFFER_ID($bufnum)) ));
    }' unless defined(&BufferIsValid);
    eval 'sub BufferIsPinned {
        my($bufnum) = @_;
	    eval q((  &BufferIsLocal($bufnum) ? (($bufnum) >= - &NLocBuffer  &&  $LocalRefCount[-($bufnum) - 1] > 0) : (  &BAD_BUFFER_ID($bufnum) ?  &false : ( $PrivateRefCount[($bufnum) - 1] > 0) ) ));
    }' unless defined(&BufferIsPinned);
    eval 'sub IncrBufferRefCount {
        my($buffer) = @_;
	    eval q((  &BufferIsLocal($buffer) ? ( ( &void)  &AssertMacro(($buffer) >= - &NLocBuffer), ( &void)  &AssertMacro( $LocalRefCount[-($buffer) - 1] > 0), ( &void)  $LocalRefCount[-($buffer) - 1]++ ) : ( ( &void)  &AssertMacro(! &BAD_BUFFER_ID($buffer)), ( &void)  &AssertMacro( $PrivateRefCount[($buffer) - 1] > 0), ( &void)  $PrivateRefCount[($buffer) - 1]++ ) ));
    }' unless defined(&IncrBufferRefCount);
    eval 'sub BufferGetBlock {
        my($buffer) = @_;
	    eval q((  &AssertMacro( &BufferIsValid($buffer)),  &BufferIsLocal($buffer) ?  $LocalBufferBlockPointers[-($buffer) - 1] :  $BufferBlockPointers[($buffer) - 1] ));
    }' unless defined(&BufferGetBlock);
    if(defined(&NOT_USED)) {
    }
}
1;
