require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&BUFPAGE_H)) {
    eval 'sub BUFPAGE_H () {1;}' unless defined(&BUFPAGE_H);
    require 'storage/buf.ph';
    require 'storage/bufmgr.ph';
    require 'storage/item.ph';
    require 'storage/itemid.ph';
    require 'storage/off.ph';
    require 'storage/page.ph';
    require 'access/xlog.ph';
    eval 'sub PageIsValid {
        my($page) = @_;
	    eval q( &PointerIsValid($page));
    }' unless defined(&PageIsValid);
    eval 'sub PG_PAGE_LAYOUT_VERSION () {1;}' unless defined(&PG_PAGE_LAYOUT_VERSION);
    eval 'sub PageIsUsed {
        my($page) = @_;
	    eval q((  &AssertMacro( &PageIsValid($page)), (( &bool) ((( &PageHeader) ($page))-> &pd_lower != 0)) ));
    }' unless defined(&PageIsUsed);
    eval 'sub SizeOfPageHeaderData () {( &offsetof( &PageHeaderData,  $pd_linp[0]));}' unless defined(&SizeOfPageHeaderData);
    eval 'sub PageIsEmpty {
        my($page) = @_;
	    eval q(((( &PageHeader) ($page))-> &pd_lower <=  &SizeOfPageHeaderData));
    }' unless defined(&PageIsEmpty);
    eval 'sub PageIsNew {
        my($page) = @_;
	    eval q(((( &PageHeader) ($page))-> &pd_upper == 0));
    }' unless defined(&PageIsNew);
    eval 'sub PageGetItemId {
        my($page, $offsetNumber) = @_;
	    eval q((( &ItemId) ((( &PageHeader) ($page))-> $pd_linp[($offsetNumber) - 1])));
    }' unless defined(&PageGetItemId);
    eval 'sub PageGetContents {
        my($page) = @_;
	    eval q(( ((( &PageHeader) ($page))-> $pd_linp[0])));
    }' unless defined(&PageGetContents);
    eval 'sub PageSizeIsValid {
        my($pageSize) = @_;
	    eval q((($pageSize) ==  &BLCKSZ));
    }' unless defined(&PageSizeIsValid);
    eval 'sub PageGetPageSize {
        my($page) = @_;
	    eval q((( &Size) ((( &PageHeader) ($page))-> &pd_pagesize_version & ( &uint16) 0xff00)));
    }' unless defined(&PageGetPageSize);
    eval 'sub PageGetPageLayoutVersion {
        my($page) = @_;
	    eval q(((( &PageHeader) ($page))-> &pd_pagesize_version & 0xff));
    }' unless defined(&PageGetPageLayoutVersion);
    eval 'sub PageSetPageSizeAndVersion {
        my($page, $size, $version) = @_;
	    eval q((  &AssertMacro((($size) & 0xff00) == ($size)),  &AssertMacro((($version) & 0xff) == ($version)), (( &PageHeader) ($page))-> &pd_pagesize_version = ($size) | ($version) ));
    }' unless defined(&PageSetPageSizeAndVersion);
    eval 'sub PageGetSpecialSize {
        my($page) = @_;
	    eval q((( &uint16) ( &PageGetPageSize($page) - (( &PageHeader)($page))-> &pd_special)));
    }' unless defined(&PageGetSpecialSize);
    eval 'sub PageGetSpecialPointer {
        my($page) = @_;
	    eval q((  &AssertMacro, ( ($page) + (( &PageHeader) ($page))-> &pd_special) ));
    }' unless defined(&PageGetSpecialPointer);
    eval 'sub PageGetItem {
        my($page, $itemId) = @_;
	    eval q((  &AssertMacro( &PageIsValid($page)),  &AssertMacro(($itemId)-> &lp_flags &  &LP_USED), ( &Item)((($page)) + ($itemId)-> &lp_off) ));
    }' unless defined(&PageGetItem);
    eval 'sub BufferGetPageSize {
        my($buffer) = @_;
	    eval q((  &AssertMacro( &BufferIsValid($buffer)), ( &Size) &BLCKSZ ));
    }' unless defined(&BufferGetPageSize);
    eval 'sub BufferGetPage {
        my($buffer) = @_;
	    eval q((( &Page) &BufferGetBlock($buffer)));
    }' unless defined(&BufferGetPage);
    eval 'sub PageGetMaxOffsetNumber {
        my($page) = @_;
	    eval q((( ((( &PageHeader) )-> &pd_lower -  &SizeOfPageHeaderData)) / ( $sizeof{ &ItemIdData})));
    }' unless defined(&PageGetMaxOffsetNumber);
    eval 'sub PageGetLSN {
        my($page) = @_;
	    eval q(((( &PageHeader) ($page))-> &pd_lsn));
    }' unless defined(&PageGetLSN);
    eval 'sub PageSetLSN {
        my($page, $lsn) = @_;
	    eval q(((( &PageHeader) ($page))-> &pd_lsn = ($lsn)));
    }' unless defined(&PageSetLSN);
    eval 'sub PageGetSUI {
        my($page) = @_;
	    eval q(((( &PageHeader) ($page))-> &pd_sui));
    }' unless defined(&PageGetSUI);
    eval 'sub PageSetSUI {
        my($page, $sui) = @_;
	    eval q(((( &PageHeader) ($page))-> &pd_sui = ( &StartUpID) ($sui)));
    }' unless defined(&PageSetSUI);
}
1;
