require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&DATETIME_H)) {
    eval 'sub DATETIME_H () {1;}' unless defined(&DATETIME_H);
    require 'limits.ph';
    require 'math.ph';
    require 'time.ph';
    require 'utils/timestamp.ph';
    eval 'sub DAGO () {"ago";}' unless defined(&DAGO);
    eval 'sub DCURRENT () {"current";}' unless defined(&DCURRENT);
    eval 'sub EPOCH () {"epoch";}' unless defined(&EPOCH);
    eval 'sub INVALID () {"invalid";}' unless defined(&INVALID);
    eval 'sub EARLY () {"-infinity";}' unless defined(&EARLY);
    eval 'sub LATE () {"infinity";}' unless defined(&LATE);
    eval 'sub NOW () {"now";}' unless defined(&NOW);
    eval 'sub TODAY () {"today";}' unless defined(&TODAY);
    eval 'sub TOMORROW () {"tomorrow";}' unless defined(&TOMORROW);
    eval 'sub YESTERDAY () {"yesterday";}' unless defined(&YESTERDAY);
    eval 'sub ZULU () {"zulu";}' unless defined(&ZULU);
    eval 'sub DMICROSEC () {"usecond";}' unless defined(&DMICROSEC);
    eval 'sub DMILLISEC () {"msecond";}' unless defined(&DMILLISEC);
    eval 'sub DSECOND () {"second";}' unless defined(&DSECOND);
    eval 'sub DMINUTE () {"minute";}' unless defined(&DMINUTE);
    eval 'sub DHOUR () {"hour";}' unless defined(&DHOUR);
    eval 'sub DDAY () {"day";}' unless defined(&DDAY);
    eval 'sub DWEEK () {"week";}' unless defined(&DWEEK);
    eval 'sub DMONTH () {"month";}' unless defined(&DMONTH);
    eval 'sub DQUARTER () {"quarter";}' unless defined(&DQUARTER);
    eval 'sub DYEAR () {"year";}' unless defined(&DYEAR);
    eval 'sub DDECADE () {"decade";}' unless defined(&DDECADE);
    eval 'sub DCENTURY () {"century";}' unless defined(&DCENTURY);
    eval 'sub DMILLENNIUM () {"millennium";}' unless defined(&DMILLENNIUM);
    eval 'sub DA_D () {"ad";}' unless defined(&DA_D);
    eval 'sub DB_C () {"bc";}' unless defined(&DB_C);
    eval 'sub DTIMEZONE () {"timezone";}' unless defined(&DTIMEZONE);
    eval 'sub AM () {0;}' unless defined(&AM);
    eval 'sub PM () {1;}' unless defined(&PM);
    eval 'sub HR24 () {2;}' unless defined(&HR24);
    eval 'sub AD () {0;}' unless defined(&AD);
    eval 'sub BC () {1;}' unless defined(&BC);
    eval 'sub RESERV () {0;}' unless defined(&RESERV);
    eval 'sub MONTH () {1;}' unless defined(&MONTH);
    eval 'sub YEAR () {2;}' unless defined(&YEAR);
    eval 'sub DAY () {3;}' unless defined(&DAY);
    eval 'sub JULIAN () {4;}' unless defined(&JULIAN);
    eval 'sub TZ () {5;}' unless defined(&TZ);
    eval 'sub DTZ () {6;}' unless defined(&DTZ);
    eval 'sub DTZMOD () {7;}' unless defined(&DTZMOD);
    eval 'sub IGNORE_DTF () {8;}' unless defined(&IGNORE_DTF);
    eval 'sub AMPM () {9;}' unless defined(&AMPM);
    eval 'sub HOUR () {10;}' unless defined(&HOUR);
    eval 'sub MINUTE () {11;}' unless defined(&MINUTE);
    eval 'sub SECOND () {12;}' unless defined(&SECOND);
    eval 'sub DOY () {13;}' unless defined(&DOY);
    eval 'sub DOW () {14;}' unless defined(&DOW);
    eval 'sub UNITS () {15;}' unless defined(&UNITS);
    eval 'sub ADBC () {16;}' unless defined(&ADBC);
    eval 'sub AGO () {17;}' unless defined(&AGO);
    eval 'sub ABS_BEFORE () {18;}' unless defined(&ABS_BEFORE);
    eval 'sub ABS_AFTER () {19;}' unless defined(&ABS_AFTER);
    eval 'sub ISODATE () {20;}' unless defined(&ISODATE);
    eval 'sub ISOTIME () {21;}' unless defined(&ISOTIME);
    eval 'sub UNKNOWN_FIELD () {31;}' unless defined(&UNKNOWN_FIELD);
    eval 'sub DTK_NUMBER () {0;}' unless defined(&DTK_NUMBER);
    eval 'sub DTK_STRING () {1;}' unless defined(&DTK_STRING);
    eval 'sub DTK_DATE () {2;}' unless defined(&DTK_DATE);
    eval 'sub DTK_TIME () {3;}' unless defined(&DTK_TIME);
    eval 'sub DTK_TZ () {4;}' unless defined(&DTK_TZ);
    eval 'sub DTK_AGO () {5;}' unless defined(&DTK_AGO);
    eval 'sub DTK_SPECIAL () {6;}' unless defined(&DTK_SPECIAL);
    eval 'sub DTK_INVALID () {7;}' unless defined(&DTK_INVALID);
    eval 'sub DTK_CURRENT () {8;}' unless defined(&DTK_CURRENT);
    eval 'sub DTK_EARLY () {9;}' unless defined(&DTK_EARLY);
    eval 'sub DTK_LATE () {10;}' unless defined(&DTK_LATE);
    eval 'sub DTK_EPOCH () {11;}' unless defined(&DTK_EPOCH);
    eval 'sub DTK_NOW () {12;}' unless defined(&DTK_NOW);
    eval 'sub DTK_YESTERDAY () {13;}' unless defined(&DTK_YESTERDAY);
    eval 'sub DTK_TODAY () {14;}' unless defined(&DTK_TODAY);
    eval 'sub DTK_TOMORROW () {15;}' unless defined(&DTK_TOMORROW);
    eval 'sub DTK_ZULU () {16;}' unless defined(&DTK_ZULU);
    eval 'sub DTK_DELTA () {17;}' unless defined(&DTK_DELTA);
    eval 'sub DTK_SECOND () {18;}' unless defined(&DTK_SECOND);
    eval 'sub DTK_MINUTE () {19;}' unless defined(&DTK_MINUTE);
    eval 'sub DTK_HOUR () {20;}' unless defined(&DTK_HOUR);
    eval 'sub DTK_DAY () {21;}' unless defined(&DTK_DAY);
    eval 'sub DTK_WEEK () {22;}' unless defined(&DTK_WEEK);
    eval 'sub DTK_MONTH () {23;}' unless defined(&DTK_MONTH);
    eval 'sub DTK_QUARTER () {24;}' unless defined(&DTK_QUARTER);
    eval 'sub DTK_YEAR () {25;}' unless defined(&DTK_YEAR);
    eval 'sub DTK_DECADE () {26;}' unless defined(&DTK_DECADE);
    eval 'sub DTK_CENTURY () {27;}' unless defined(&DTK_CENTURY);
    eval 'sub DTK_MILLENNIUM () {28;}' unless defined(&DTK_MILLENNIUM);
    eval 'sub DTK_MILLISEC () {29;}' unless defined(&DTK_MILLISEC);
    eval 'sub DTK_MICROSEC () {30;}' unless defined(&DTK_MICROSEC);
    eval 'sub DTK_JULIAN () {31;}' unless defined(&DTK_JULIAN);
    eval 'sub DTK_DOW () {32;}' unless defined(&DTK_DOW);
    eval 'sub DTK_DOY () {33;}' unless defined(&DTK_DOY);
    eval 'sub DTK_TZ_HOUR () {34;}' unless defined(&DTK_TZ_HOUR);
    eval 'sub DTK_TZ_MINUTE () {35;}' unless defined(&DTK_TZ_MINUTE);
    eval 'sub DTK_M {
        my($t) = @_;
	    eval q((0x1 << ($t)));
    }' unless defined(&DTK_M);
    eval 'sub DTK_DATE_M () {( &DTK_M( &YEAR) |  &DTK_M( &MONTH) |  &DTK_M( &DAY));}' unless defined(&DTK_DATE_M);
    eval 'sub DTK_TIME_M () {( &DTK_M( &HOUR) |  &DTK_M( &MINUTE) |  &DTK_M( &SECOND));}' unless defined(&DTK_TIME_M);
    eval 'sub MAXDATELEN () {51;}' unless defined(&MAXDATELEN);
    eval 'sub MAXDATEFIELDS () {25;}' unless defined(&MAXDATEFIELDS);
    eval 'sub TOKMAXLEN () {10;}' unless defined(&TOKMAXLEN);
    if(defined( &_AIX)) {
    } else {
    }
    if(defined(&HAVE_INT64_TIMESTAMP)) {
	eval 'sub TMODULO {
	    my($t,$q,$u) = @_;
    	    eval q( &do { $q = ($t / $u);  &if ($q != 0) $t -= ($q * $u); }  &while(0));
	}' unless defined(&TMODULO);
    } else {
	eval 'sub TMODULO {
	    my($t,$q,$u) = @_;
    	    eval q( &do { $q = (($t < 0)?  &ceil($t / $u):  &floor($t / $u));  &if ($q != 0) $t -=  &rint($q * $u); }  &while(0));
	}' unless defined(&TMODULO);
    }
    if(defined( &__CYGWIN__) || defined( &N_PLAT_NLM)) {
	eval 'sub TIMEZONE_GLOBAL () { &_timezone;}' unless defined(&TIMEZONE_GLOBAL);
    } else {
	eval 'sub TIMEZONE_GLOBAL () { &timezone;}' unless defined(&TIMEZONE_GLOBAL);
    }
    eval 'sub isleap {
        my($y) = @_;
	    eval q(((($y) % 4) == 0 && ((($y) % 100) != 0|| (($y) % 400) == 0)));
    }' unless defined(&isleap);
    eval 'sub JULIAN_MINYEAR () {(-4713);}' unless defined(&JULIAN_MINYEAR);
    eval 'sub JULIAN_MINMONTH () {(11);}' unless defined(&JULIAN_MINMONTH);
    eval 'sub JULIAN_MINDAY () {(23);}' unless defined(&JULIAN_MINDAY);
    eval 'sub IS_VALID_JULIAN {
        my($y,$m,$d) = @_;
	    eval q(((($y) >  &JULIAN_MINYEAR) || ((($y) ==  &JULIAN_MINYEAR)  && ((($m) >  &JULIAN_MINMONTH) || ((($m) ==  &JULIAN_MINMONTH)  && (($d) >=  &JULIAN_MINDAY))))));
    }' unless defined(&IS_VALID_JULIAN);
    eval 'sub UTIME_MINYEAR () {(1901);}' unless defined(&UTIME_MINYEAR);
    eval 'sub UTIME_MINMONTH () {(12);}' unless defined(&UTIME_MINMONTH);
    eval 'sub UTIME_MINDAY () {(14);}' unless defined(&UTIME_MINDAY);
    eval 'sub UTIME_MAXYEAR () {(2038);}' unless defined(&UTIME_MAXYEAR);
    eval 'sub UTIME_MAXMONTH () {(01);}' unless defined(&UTIME_MAXMONTH);
    eval 'sub UTIME_MAXDAY () {(18);}' unless defined(&UTIME_MAXDAY);
    eval 'sub IS_VALID_UTIME {
        my($y,$m,$d) = @_;
	    eval q((((($y) >  &UTIME_MINYEAR) || ((($y) ==  &UTIME_MINYEAR)  && ((($m) >  &UTIME_MINMONTH) || ((($m) ==  &UTIME_MINMONTH)  && (($d) >=  &UTIME_MINDAY)))))  && ((($y) <  &UTIME_MAXYEAR) || ((($y) ==  &UTIME_MAXYEAR)  && ((($m) <  &UTIME_MAXMONTH) || ((($m) ==  &UTIME_MAXMONTH)  && (($d) <=  &UTIME_MAXDAY)))))));
    }' unless defined(&IS_VALID_UTIME);
}
1;
