require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&GEO_DECLS_H)) {
    eval 'sub GEO_DECLS_H () {1;}' unless defined(&GEO_DECLS_H);
    require 'fmgr.ph';
    eval 'sub EPSILON () {1.0E-06;}' unless defined(&EPSILON);
    if(defined(&EPSILON)) {
	eval 'sub FPzero {
	    my($A) = @_;
    	    eval q(( &fabs($A) <=  &EPSILON));
	}' unless defined(&FPzero);
	eval 'sub FPeq {
	    my($A,$B) = @_;
    	    eval q(( &fabs(($A) - ($B)) <=  &EPSILON));
	}' unless defined(&FPeq);
	eval 'sub FPne {
	    my($A,$B) = @_;
    	    eval q(( &fabs(($A) - ($B)) >  &EPSILON));
	}' unless defined(&FPne);
	eval 'sub FPlt {
	    my($A,$B) = @_;
    	    eval q((($B) - ($A) >  &EPSILON));
	}' unless defined(&FPlt);
	eval 'sub FPle {
	    my($A,$B) = @_;
    	    eval q((($A) - ($B) <=  &EPSILON));
	}' unless defined(&FPle);
	eval 'sub FPgt {
	    my($A,$B) = @_;
    	    eval q((($A) - ($B) >  &EPSILON));
	}' unless defined(&FPgt);
	eval 'sub FPge {
	    my($A,$B) = @_;
    	    eval q((($B) - ($A) <=  &EPSILON));
	}' unless defined(&FPge);
    } else {
	eval 'sub FPzero {
	    my($A) = @_;
    	    eval q((($A) == 0));
	}' unless defined(&FPzero);
	eval 'sub FPeq {
	    my($A,$B) = @_;
    	    eval q((($A) == ($B)));
	}' unless defined(&FPeq);
	eval 'sub FPne {
	    my($A,$B) = @_;
    	    eval q((($A) != ($B)));
	}' unless defined(&FPne);
	eval 'sub FPlt {
	    my($A,$B) = @_;
    	    eval q((($A) < ($B)));
	}' unless defined(&FPlt);
	eval 'sub FPle {
	    my($A,$B) = @_;
    	    eval q((($A) <= ($B)));
	}' unless defined(&FPle);
	eval 'sub FPgt {
	    my($A,$B) = @_;
    	    eval q((($A) > ($B)));
	}' unless defined(&FPgt);
	eval 'sub FPge {
	    my($A,$B) = @_;
    	    eval q((($A) >= ($B)));
	}' unless defined(&FPge);
    }
    eval 'sub HYPOT {
        my($A, $B) = @_;
	    eval q( &sqrt(($A) * ($A) + ($B) * ($B)));
    }' unless defined(&HYPOT);
    eval 'sub DatumGetPointP {
        my($X) = @_;
	    eval q((( &Point *)  &DatumGetPointer($X)));
    }' unless defined(&DatumGetPointP);
    eval 'sub PointPGetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&PointPGetDatum);
    eval 'sub PG_GETARG_POINT_P {
        my($n) = @_;
	    eval q( &DatumGetPointP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_POINT_P);
    eval 'sub PG_RETURN_POINT_P {
        my($x) = @_;
	    eval q( &return  &PointPGetDatum($x));
    }' unless defined(&PG_RETURN_POINT_P);
    eval 'sub DatumGetLsegP {
        my($X) = @_;
	    eval q((( &LSEG *)  &DatumGetPointer($X)));
    }' unless defined(&DatumGetLsegP);
    eval 'sub LsegPGetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&LsegPGetDatum);
    eval 'sub PG_GETARG_LSEG_P {
        my($n) = @_;
	    eval q( &DatumGetLsegP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_LSEG_P);
    eval 'sub PG_RETURN_LSEG_P {
        my($x) = @_;
	    eval q( &return  &LsegPGetDatum($x));
    }' unless defined(&PG_RETURN_LSEG_P);
    eval 'sub DatumGetPathP {
        my($X) = @_;
	    eval q((( &PATH *)  &PG_DETOAST_DATUM($X)));
    }' unless defined(&DatumGetPathP);
    eval 'sub DatumGetPathPCopy {
        my($X) = @_;
	    eval q((( &PATH *)  &PG_DETOAST_DATUM_COPY($X)));
    }' unless defined(&DatumGetPathPCopy);
    eval 'sub PathPGetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&PathPGetDatum);
    eval 'sub PG_GETARG_PATH_P {
        my($n) = @_;
	    eval q( &DatumGetPathP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_PATH_P);
    eval 'sub PG_GETARG_PATH_P_COPY {
        my($n) = @_;
	    eval q( &DatumGetPathPCopy( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_PATH_P_COPY);
    eval 'sub PG_RETURN_PATH_P {
        my($x) = @_;
	    eval q( &return  &PathPGetDatum($x));
    }' unless defined(&PG_RETURN_PATH_P);
    eval 'sub DatumGetLineP {
        my($X) = @_;
	    eval q((( &LINE *)  &DatumGetPointer($X)));
    }' unless defined(&DatumGetLineP);
    eval 'sub LinePGetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&LinePGetDatum);
    eval 'sub PG_GETARG_LINE_P {
        my($n) = @_;
	    eval q( &DatumGetLineP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_LINE_P);
    eval 'sub PG_RETURN_LINE_P {
        my($x) = @_;
	    eval q( &return  &LinePGetDatum($x));
    }' unless defined(&PG_RETURN_LINE_P);
    eval 'sub DatumGetBoxP {
        my($X) = @_;
	    eval q((( &BOX *)  &DatumGetPointer($X)));
    }' unless defined(&DatumGetBoxP);
    eval 'sub BoxPGetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&BoxPGetDatum);
    eval 'sub PG_GETARG_BOX_P {
        my($n) = @_;
	    eval q( &DatumGetBoxP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_BOX_P);
    eval 'sub PG_RETURN_BOX_P {
        my($x) = @_;
	    eval q( &return  &BoxPGetDatum($x));
    }' unless defined(&PG_RETURN_BOX_P);
    eval 'sub DatumGetPolygonP {
        my($X) = @_;
	    eval q((( &POLYGON *)  &PG_DETOAST_DATUM($X)));
    }' unless defined(&DatumGetPolygonP);
    eval 'sub DatumGetPolygonPCopy {
        my($X) = @_;
	    eval q((( &POLYGON *)  &PG_DETOAST_DATUM_COPY($X)));
    }' unless defined(&DatumGetPolygonPCopy);
    eval 'sub PolygonPGetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&PolygonPGetDatum);
    eval 'sub PG_GETARG_POLYGON_P {
        my($n) = @_;
	    eval q( &DatumGetPolygonP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_POLYGON_P);
    eval 'sub PG_GETARG_POLYGON_P_COPY {
        my($n) = @_;
	    eval q( &DatumGetPolygonPCopy( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_POLYGON_P_COPY);
    eval 'sub PG_RETURN_POLYGON_P {
        my($x) = @_;
	    eval q( &return  &PolygonPGetDatum($x));
    }' unless defined(&PG_RETURN_POLYGON_P);
    eval 'sub DatumGetCircleP {
        my($X) = @_;
	    eval q((( &CIRCLE *)  &DatumGetPointer($X)));
    }' unless defined(&DatumGetCircleP);
    eval 'sub CirclePGetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&CirclePGetDatum);
    eval 'sub PG_GETARG_CIRCLE_P {
        my($n) = @_;
	    eval q( &DatumGetCircleP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_CIRCLE_P);
    eval 'sub PG_RETURN_CIRCLE_P {
        my($x) = @_;
	    eval q( &return  &CirclePGetDatum($x));
    }' unless defined(&PG_RETURN_CIRCLE_P);
}
1;
