require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&REL_H)) {
    eval 'sub REL_H () {1;}' unless defined(&REL_H);
    require 'access/strat.ph';
    require 'access/tupdesc.ph';
    require 'catalog/pg_am.ph';
    require 'catalog/pg_class.ph';
    require 'catalog/pg_index.ph';
    require 'rewrite/prs2lock.ph';
    require 'storage/block.ph';
    require 'storage/fd.ph';
    require 'storage/relfilenode.ph';
    eval 'sub TRIGGER_NUM_EVENT_CLASSES () {4;}' unless defined(&TRIGGER_NUM_EVENT_CLASSES);
    eval 'sub RelationIsValid {
        my($relation) = @_;
	    eval q( &PointerIsValid($relation));
    }' unless defined(&RelationIsValid);
    eval 'sub InvalidRelation () {(( &Relation)  &NULL);}' unless defined(&InvalidRelation);
    eval 'sub RelationHasReferenceCountZero {
        my($relation) = @_;
	    eval q((( &bool)(($relation)-> &rd_refcnt == 0)));
    }' unless defined(&RelationHasReferenceCountZero);
    eval 'sub RelationSetReferenceCount {
        my($relation,$count) = @_;
	    eval q((($relation)-> &rd_refcnt = ($count)));
    }' unless defined(&RelationSetReferenceCount);
    eval 'sub RelationIncrementReferenceCount {
        my($relation) = @_;
	    eval q((($relation)-> &rd_refcnt += 1));
    }' unless defined(&RelationIncrementReferenceCount);
    eval 'sub RelationDecrementReferenceCount {
        my($relation) = @_;
	    eval q(( &AssertMacro(($relation)-> &rd_refcnt > 0), ($relation)-> &rd_refcnt -= 1));
    }' unless defined(&RelationDecrementReferenceCount);
    eval 'sub RelationGetForm {
        my($relation) = @_;
	    eval q((($relation)-> &rd_rel));
    }' unless defined(&RelationGetForm);
    eval 'sub RelationGetRelid {
        my($relation) = @_;
	    eval q((($relation)-> &rd_id));
    }' unless defined(&RelationGetRelid);
    eval 'sub RelationGetFile {
        my($relation) = @_;
	    eval q((($relation)-> &rd_fd));
    }' unless defined(&RelationGetFile);
    eval 'sub RelationGetNumberOfAttributes {
        my($relation) = @_;
	    eval q((($relation)-> ($rd_rel->{relnatts})));
    }' unless defined(&RelationGetNumberOfAttributes);
    eval 'sub RelationGetDescr {
        my($relation) = @_;
	    eval q((($relation)-> &rd_att));
    }' unless defined(&RelationGetDescr);
    eval 'sub RelationGetIndexStrategy {
        my($relation) = @_;
	    eval q((($relation)-> &rd_istrat));
    }' unless defined(&RelationGetIndexStrategy);
    eval 'sub RelationGetRelationName {
        my($relation) = @_;
	    eval q(( &NameStr(($relation)-> ($rd_rel->{relname}))));
    }' unless defined(&RelationGetRelationName);
    eval 'sub RelationGetNamespace {
        my($relation) = @_;
	    eval q((($relation)-> ($rd_rel->{relnamespace})));
    }' unless defined(&RelationGetNamespace);
}
1;
