require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&TIMESTAMP_H)) {
    eval 'sub TIMESTAMP_H () {1;}' unless defined(&TIMESTAMP_H);
    require 'time.ph';
    require 'math.ph';
    require 'limits.ph';
    require 'float.ph';
    require 'fmgr.ph';
    if(defined(&HAVE_INT64_TIMESTAMP)) {
	require 'utils/int8.ph';
    }
    if(defined(&HAVE_INT64_TIMESTAMP)) {
    } else {
    }
    if(defined(&HAVE_INT64_TIMESTAMP)) {
    } else {
    }
    eval 'sub MAX_TIMESTAMP_PRECISION () {6;}' unless defined(&MAX_TIMESTAMP_PRECISION);
    eval 'sub MAX_INTERVAL_PRECISION () {6;}' unless defined(&MAX_INTERVAL_PRECISION);
    if(defined(&HAVE_INT64_TIMESTAMP)) {
	eval 'sub DatumGetTimestamp {
	    my($X) = @_;
    	    eval q((( &Timestamp)  &DatumGetInt64($X)));
	}' unless defined(&DatumGetTimestamp);
	eval 'sub DatumGetTimestampTz {
	    my($X) = @_;
    	    eval q((( &TimestampTz)  &DatumGetInt64($X)));
	}' unless defined(&DatumGetTimestampTz);
	eval 'sub DatumGetIntervalP {
	    my($X) = @_;
    	    eval q((( &Interval *)  &DatumGetPointer($X)));
	}' unless defined(&DatumGetIntervalP);
	eval 'sub TimestampGetDatum {
	    my($X) = @_;
    	    eval q( &Int64GetDatum($X));
	}' unless defined(&TimestampGetDatum);
	eval 'sub TimestampTzGetDatum {
	    my($X) = @_;
    	    eval q( &Int64GetDatum($X));
	}' unless defined(&TimestampTzGetDatum);
	eval 'sub IntervalPGetDatum {
	    my($X) = @_;
    	    eval q( &PointerGetDatum($X));
	}' unless defined(&IntervalPGetDatum);
	eval 'sub PG_GETARG_TIMESTAMP {
	    my($n) = @_;
    	    eval q( &PG_GETARG_INT64($n));
	}' unless defined(&PG_GETARG_TIMESTAMP);
	eval 'sub PG_GETARG_TIMESTAMPTZ {
	    my($n) = @_;
    	    eval q( &PG_GETARG_INT64($n));
	}' unless defined(&PG_GETARG_TIMESTAMPTZ);
	eval 'sub PG_GETARG_INTERVAL_P {
	    my($n) = @_;
    	    eval q( &DatumGetIntervalP( &PG_GETARG_DATUM($n)));
	}' unless defined(&PG_GETARG_INTERVAL_P);
	eval 'sub PG_RETURN_TIMESTAMP {
	    my($x) = @_;
    	    eval q( &PG_RETURN_INT64($x));
	}' unless defined(&PG_RETURN_TIMESTAMP);
	eval 'sub PG_RETURN_TIMESTAMPTZ {
	    my($x) = @_;
    	    eval q( &PG_RETURN_INT64($x));
	}' unless defined(&PG_RETURN_TIMESTAMPTZ);
	eval 'sub PG_RETURN_INTERVAL_P {
	    my($x) = @_;
    	    eval q( &return  &IntervalPGetDatum($x));
	}' unless defined(&PG_RETURN_INTERVAL_P);
	eval 'sub DT_NOBEGIN () {(- &INT64CONST(9.22337203685478e+18) - 1);}' unless defined(&DT_NOBEGIN);
	eval 'sub DT_NOEND () {( &INT64CONST(9.22337203685478e+18));}' unless defined(&DT_NOEND);
    } else {
	eval 'sub DatumGetTimestamp {
	    my($X) = @_;
    	    eval q((( &Timestamp)  &DatumGetFloat8($X)));
	}' unless defined(&DatumGetTimestamp);
	eval 'sub DatumGetTimestampTz {
	    my($X) = @_;
    	    eval q((( &TimestampTz)  &DatumGetFloat8($X)));
	}' unless defined(&DatumGetTimestampTz);
	eval 'sub DatumGetIntervalP {
	    my($X) = @_;
    	    eval q((( &Interval *)  &DatumGetPointer($X)));
	}' unless defined(&DatumGetIntervalP);
	eval 'sub TimestampGetDatum {
	    my($X) = @_;
    	    eval q( &Float8GetDatum($X));
	}' unless defined(&TimestampGetDatum);
	eval 'sub TimestampTzGetDatum {
	    my($X) = @_;
    	    eval q( &Float8GetDatum($X));
	}' unless defined(&TimestampTzGetDatum);
	eval 'sub IntervalPGetDatum {
	    my($X) = @_;
    	    eval q( &PointerGetDatum($X));
	}' unless defined(&IntervalPGetDatum);
	eval 'sub PG_GETARG_TIMESTAMP {
	    my($n) = @_;
    	    eval q( &DatumGetTimestamp( &PG_GETARG_DATUM($n)));
	}' unless defined(&PG_GETARG_TIMESTAMP);
	eval 'sub PG_GETARG_TIMESTAMPTZ {
	    my($n) = @_;
    	    eval q( &DatumGetTimestampTz( &PG_GETARG_DATUM($n)));
	}' unless defined(&PG_GETARG_TIMESTAMPTZ);
	eval 'sub PG_GETARG_INTERVAL_P {
	    my($n) = @_;
    	    eval q( &DatumGetIntervalP( &PG_GETARG_DATUM($n)));
	}' unless defined(&PG_GETARG_INTERVAL_P);
	eval 'sub PG_RETURN_TIMESTAMP {
	    my($x) = @_;
    	    eval q( &return  &TimestampGetDatum($x));
	}' unless defined(&PG_RETURN_TIMESTAMP);
	eval 'sub PG_RETURN_TIMESTAMPTZ {
	    my($x) = @_;
    	    eval q( &return  &TimestampTzGetDatum($x));
	}' unless defined(&PG_RETURN_TIMESTAMPTZ);
	eval 'sub PG_RETURN_INTERVAL_P {
	    my($x) = @_;
    	    eval q( &return  &IntervalPGetDatum($x));
	}' unless defined(&PG_RETURN_INTERVAL_P);
	if(defined(&HUGE_VAL)) {
	    eval 'sub DT_NOBEGIN () {(- &HUGE_VAL);}' unless defined(&DT_NOBEGIN);
	    eval 'sub DT_NOEND () {( &HUGE_VAL);}' unless defined(&DT_NOEND);
	} else {
	    eval 'sub DT_NOBEGIN () {(- &DBL_MAX);}' unless defined(&DT_NOBEGIN);
	    eval 'sub DT_NOEND () {( &DBL_MAX);}' unless defined(&DT_NOEND);
	}
    }
    eval 'sub TIMESTAMP_NOBEGIN {
        my($j) = @_;
	    eval q( &do {$j =  &DT_NOBEGIN;}  &while (0));
    }' unless defined(&TIMESTAMP_NOBEGIN);
    eval 'sub TIMESTAMP_IS_NOBEGIN {
        my($j) = @_;
	    eval q((($j) ==  &DT_NOBEGIN));
    }' unless defined(&TIMESTAMP_IS_NOBEGIN);
    eval 'sub TIMESTAMP_NOEND {
        my($j) = @_;
	    eval q( &do {$j =  &DT_NOEND;}  &while (0));
    }' unless defined(&TIMESTAMP_NOEND);
    eval 'sub TIMESTAMP_IS_NOEND {
        my($j) = @_;
	    eval q((($j) ==  &DT_NOEND));
    }' unless defined(&TIMESTAMP_IS_NOEND);
    eval 'sub TIMESTAMP_NOT_FINITE {
        my($j) = @_;
	    eval q(( &TIMESTAMP_IS_NOBEGIN($j) ||  &TIMESTAMP_IS_NOEND($j)));
    }' unless defined(&TIMESTAMP_NOT_FINITE);
    if(defined(&HAVE_INT64_TIMESTAMP)) {
    } else {
	eval 'sub TIME_PREC_INV () {1000000.0;}' unless defined(&TIME_PREC_INV);
	eval 'sub JROUND {
	    my($j) = @_;
    	    eval q(( &rint(( ($j))* &TIME_PREC_INV)/ &TIME_PREC_INV));
	}' unless defined(&JROUND);
    }
    eval 'sub TIMESTAMP_MASK {
        my($b) = @_;
	    eval q((1<< ($b)));
    }' unless defined(&TIMESTAMP_MASK);
    eval 'sub INTERVAL_MASK {
        my($b) = @_;
	    eval q((1<< ($b)));
    }' unless defined(&INTERVAL_MASK);
    eval 'sub INTERVAL_FULL_RANGE () {(0x7fff);}' unless defined(&INTERVAL_FULL_RANGE);
    eval 'sub INTERVAL_RANGE_MASK () {(0x7fff);}' unless defined(&INTERVAL_RANGE_MASK);
    eval 'sub INTERVAL_FULL_PRECISION () {(0xffff);}' unless defined(&INTERVAL_FULL_PRECISION);
    eval 'sub INTERVAL_PRECISION_MASK () {(0xffff);}' unless defined(&INTERVAL_PRECISION_MASK);
    eval 'sub INTERVAL_TYPMOD {
        my($p,$r) = @_;
	    eval q((((($r) &  &INTERVAL_RANGE_MASK) << 16) | (($p) &  &INTERVAL_PRECISION_MASK)));
    }' unless defined(&INTERVAL_TYPMOD);
    eval 'sub INTERVAL_PRECISION {
        my($t) = @_;
	    eval q((($t) &  &INTERVAL_PRECISION_MASK));
    }' unless defined(&INTERVAL_PRECISION);
    eval 'sub INTERVAL_RANGE {
        my($t) = @_;
	    eval q(((($t) >> 16) &  &INTERVAL_RANGE_MASK));
    }' unless defined(&INTERVAL_RANGE);
}
1;
