require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Py_OBJIMPL_H)) {
    eval 'sub Py_OBJIMPL_H () {1;}' unless defined(&Py_OBJIMPL_H);
    require 'pymem.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&WITH_PYMALLOC)) {
	eval 'sub PyCore_OBJECT_MALLOC_FUNC () { &_PyCore_ObjectMalloc;}' unless defined(&PyCore_OBJECT_MALLOC_FUNC);
	eval 'sub PyCore_OBJECT_REALLOC_FUNC () { &_PyCore_ObjectRealloc;}' unless defined(&PyCore_OBJECT_REALLOC_FUNC);
	eval 'sub PyCore_OBJECT_FREE_FUNC () { &_PyCore_ObjectFree;}' unless defined(&PyCore_OBJECT_FREE_FUNC);
	eval 'sub NEED_TO_DECLARE_OBJECT_MALLOC_AND_FRIEND () {1;}' unless defined(&NEED_TO_DECLARE_OBJECT_MALLOC_AND_FRIEND);
    }
    unless(defined(&PyCore_OBJECT_MALLOC_FUNC)) {
	undef(&PyCore_OBJECT_REALLOC_FUNC) if defined(&PyCore_OBJECT_REALLOC_FUNC);
	undef(&PyCore_OBJECT_FREE_FUNC) if defined(&PyCore_OBJECT_FREE_FUNC);
	eval 'sub PyCore_OBJECT_MALLOC_FUNC () { &PyCore_MALLOC_FUNC;}' unless defined(&PyCore_OBJECT_MALLOC_FUNC);
	eval 'sub PyCore_OBJECT_REALLOC_FUNC () { &PyCore_REALLOC_FUNC;}' unless defined(&PyCore_OBJECT_REALLOC_FUNC);
	eval 'sub PyCore_OBJECT_FREE_FUNC () { &PyCore_FREE_FUNC;}' unless defined(&PyCore_OBJECT_FREE_FUNC);
    }
    unless(defined(&PyCore_OBJECT_MALLOC_PROTO)) {
	undef(&PyCore_OBJECT_REALLOC_PROTO) if defined(&PyCore_OBJECT_REALLOC_PROTO);
	undef(&PyCore_OBJECT_FREE_PROTO) if defined(&PyCore_OBJECT_FREE_PROTO);
	eval 'sub PyCore_OBJECT_MALLOC_PROTO () { &PyCore_MALLOC_PROTO;}' unless defined(&PyCore_OBJECT_MALLOC_PROTO);
	eval 'sub PyCore_OBJECT_REALLOC_PROTO () { &PyCore_REALLOC_PROTO;}' unless defined(&PyCore_OBJECT_REALLOC_PROTO);
	eval 'sub PyCore_OBJECT_FREE_PROTO () { &PyCore_FREE_PROTO;}' unless defined(&PyCore_OBJECT_FREE_PROTO);
    }
    if(defined(&NEED_TO_DECLARE_OBJECT_MALLOC_AND_FRIEND)) {
    }
    unless(defined(&PyCore_OBJECT_MALLOC)) {
	undef(&PyCore_OBJECT_REALLOC) if defined(&PyCore_OBJECT_REALLOC);
	undef(&PyCore_OBJECT_FREE) if defined(&PyCore_OBJECT_FREE);
	eval 'sub PyCore_OBJECT_MALLOC {
	    my($n) = @_;
    	    eval q( &PyCore_OBJECT_MALLOC_FUNC($n));
	}' unless defined(&PyCore_OBJECT_MALLOC);
	eval 'sub PyCore_OBJECT_REALLOC {
	    my($p, $n) = @_;
    	    eval q( &PyCore_OBJECT_REALLOC_FUNC(($p), ($n)));
	}' unless defined(&PyCore_OBJECT_REALLOC);
	eval 'sub PyCore_OBJECT_FREE {
	    my($p) = @_;
    	    eval q( &PyCore_OBJECT_FREE_FUNC($p));
	}' unless defined(&PyCore_OBJECT_FREE);
    }
    eval 'sub PyObject_MALLOC {
        my($n) = @_;
	    eval q( &PyCore_OBJECT_MALLOC($n));
    }' unless defined(&PyObject_MALLOC);
    eval 'sub PyObject_REALLOC {
        my($op, $n) = @_;
	    eval q( &PyCore_OBJECT_REALLOC(( &void *)($op), ($n)));
    }' unless defined(&PyObject_REALLOC);
    eval 'sub PyObject_FREE {
        my($op) = @_;
	    eval q( &PyCore_OBJECT_FREE(( &void *)($op)));
    }' unless defined(&PyObject_FREE);
    eval 'sub PyObject_New {
        my($type, $typeobj) = @_;
	    eval q(( ($type *)  &_PyObject_New($typeobj) ));
    }' unless defined(&PyObject_New);
    eval 'sub PyObject_NewVar {
        my($type, $typeobj, $n) = @_;
	    eval q(( ($type *)  &_PyObject_NewVar(($typeobj), ($n)) ));
    }' unless defined(&PyObject_NewVar);
    eval 'sub PyObject_Del {
        my($op) = @_;
	    eval q( &_PyObject_Del(( &PyObject *)($op)));
    }' unless defined(&PyObject_Del);
    eval 'sub PyObject_INIT {
        my($op, $typeobj) = @_;
	    eval q(( ($op)-> &ob_type = ($typeobj),  &_Py_NewReference(( &PyObject *)($op)), ($op) ));
    }' unless defined(&PyObject_INIT);
    eval 'sub PyObject_INIT_VAR {
        my($op, $typeobj, $size) = @_;
	    eval q(( ($op)-> &ob_size = ($size),  &PyObject_INIT(($op), ($typeobj)) ));
    }' unless defined(&PyObject_INIT_VAR);
    eval 'sub _PyObject_SIZE {
        my($typeobj) = @_;
	    eval q(( ($typeobj)-> &tp_basicsize ));
    }' unless defined(&_PyObject_SIZE);
    if((((defined(&SIZEOF_VOID_P) ? &SIZEOF_VOID_P : 0) - 1) & (defined(&SIZEOF_VOID_P) ? &SIZEOF_VOID_P : 0)) != 0) {
	die("_PyObject_VAR_SIZE requires SIZEOF_VOID_P be a power of 2");
    }
    eval 'sub _PyObject_VAR_SIZE {
        my($typeobj, $nitems) = @_;
	    eval q( ( ( ($typeobj)-> &tp_basicsize + ($nitems)*($typeobj)-> &tp_itemsize + ( &SIZEOF_VOID_P - 1) ) & ~( &SIZEOF_VOID_P - 1) ));
    }' unless defined(&_PyObject_VAR_SIZE);
    eval 'sub PyObject_NEW {
        my($type, $typeobj) = @_;
	    eval q(( ($type *)  &PyObject_Init( ( &PyObject *)  &PyObject_MALLOC(  &_PyObject_SIZE($typeobj) ), ($typeobj)) ));
    }' unless defined(&PyObject_NEW);
    eval 'sub PyObject_NEW_VAR {
        my($type, $typeobj, $n) = @_;
	    eval q(( ($type *)  &PyObject_InitVar( ( &PyVarObject *)  &PyObject_MALLOC( &_PyObject_VAR_SIZE(($typeobj),($n)) ), ($typeobj), ($n)) ));
    }' unless defined(&PyObject_NEW_VAR);
    eval 'sub PyObject_DEL {
        my($op) = @_;
	    eval q( &PyObject_FREE($op));
    }' unless defined(&PyObject_DEL);
    eval 'sub PyType_IS_GC {
        my($t) = @_;
	    eval q( &PyType_HasFeature(($t),  &Py_TPFLAGS_HAVE_GC));
    }' unless defined(&PyType_IS_GC);
    eval 'sub PyObject_IS_GC {
        my($o) = @_;
	    eval q(( &PyType_IS_GC(($o)-> &ob_type)  && (($o)-> ($ob_type->{tp_is_gc}) ==  &NULL || ($o)-> ($ob_type->{tp_is_gc})($o))));
    }' unless defined(&PyObject_IS_GC);
    eval 'sub PyObject_GC_Resize {
        my($type, $op, $n) = @_;
	    eval q(( ($type *)  &_PyObject_GC_Resize(( &PyVarObject *)($op), ($n)) ));
    }' unless defined(&PyObject_GC_Resize);
    if(defined(&WITH_CYCLE_GC)) {
	eval 'sub _PyObject_GC_TRACK {
	    my($o) = @_;
    	    eval q( &do {  &PyGC_Head * &g = ( &PyGC_Head *)($o)-1;  &if ( ($g->{gc}->{gc_next}) !=  &NULL)  &Py_FatalError(\\"GC object already in linked list\\");  ($g->{gc}->{gc_next}) = & &_PyGC_generation0;  ($g->{gc}->{gc_prev}) =  ($_PyGC_generation0->{gc}->{gc_prev});  ($g->{gc}->{gc_prev}->{gc}->{gc_next}) =  &g;  ($_PyGC_generation0->{gc}->{gc_prev}) =  &g; }  &while (0););
	}' unless defined(&_PyObject_GC_TRACK);
	eval 'sub _PyObject_GC_UNTRACK {
	    my($o) = @_;
    	    eval q( &do {  &PyGC_Head * &g = ( &PyGC_Head *)($o)-1;  ($g->{gc}->{gc_prev}->{gc}->{gc_next}) =  ($g->{gc}->{gc_next});  ($g->{gc}->{gc_next}->{gc}->{gc_prev}) =  ($g->{gc}->{gc_prev});  ($g->{gc}->{gc_next}) =  &NULL; }  &while (0););
	}' unless defined(&_PyObject_GC_UNTRACK);
	eval 'sub PyObject_GC_Track {
	    my($op) = @_;
    	    eval q( &_PyObject_GC_Track(( &PyObject *)$op));
	}' unless defined(&PyObject_GC_Track);
	eval 'sub PyObject_GC_UnTrack {
	    my($op) = @_;
    	    eval q( &_PyObject_GC_UnTrack(( &PyObject *)$op));
	}' unless defined(&PyObject_GC_UnTrack);
	eval 'sub PyObject_GC_New {
	    my($type, $typeobj) = @_;
    	    eval q(( ($type *)  &_PyObject_GC_New($typeobj) ));
	}' unless defined(&PyObject_GC_New);
	eval 'sub PyObject_GC_NewVar {
	    my($type, $typeobj, $n) = @_;
    	    eval q(( ($type *)  &_PyObject_GC_NewVar(($typeobj), ($n)) ));
	}' unless defined(&PyObject_GC_NewVar);
	eval 'sub PyObject_GC_Del {
	    my($op) = @_;
    	    eval q( &_PyObject_GC_Del(( &PyObject *)($op)));
	}' unless defined(&PyObject_GC_Del);
    } else {
	eval 'sub PyObject_GC_New () { &PyObject_New;}' unless defined(&PyObject_GC_New);
	eval 'sub PyObject_GC_NewVar () { &PyObject_NewVar;}' unless defined(&PyObject_GC_NewVar);
	eval 'sub PyObject_GC_Del () { &PyObject_Del;}' unless defined(&PyObject_GC_Del);
	eval 'sub _PyObject_GC_TRACK {
	    my($op) = @_;
    	    eval q();
	}' unless defined(&_PyObject_GC_TRACK);
	eval 'sub _PyObject_GC_UNTRACK {
	    my($op) = @_;
    	    eval q();
	}' unless defined(&_PyObject_GC_UNTRACK);
	eval 'sub PyObject_GC_Track {
	    my($op) = @_;
    	    eval q();
	}' unless defined(&PyObject_GC_Track);
	eval 'sub PyObject_GC_UnTrack {
	    my($op) = @_;
    	    eval q();
	}' unless defined(&PyObject_GC_UnTrack);
    }
    eval 'sub PyGC_HEAD_SIZE () {0;}' unless defined(&PyGC_HEAD_SIZE);
    eval 'sub PyObject_GC_Init {
        my($op) = @_;
	    eval q();
    }' unless defined(&PyObject_GC_Init);
    eval 'sub PyObject_GC_Fini {
        my($op) = @_;
	    eval q();
    }' unless defined(&PyObject_GC_Fini);
    eval 'sub PyObject_AS_GC {
        my($op) = @_;
	    eval q(($op));
    }' unless defined(&PyObject_AS_GC);
    eval 'sub PyObject_FROM_GC {
        my($op) = @_;
	    eval q(($op));
    }' unless defined(&PyObject_FROM_GC);
    eval 'sub PyType_SUPPORTS_WEAKREFS {
        my($t) = @_;
	    eval q(( &PyType_HasFeature(($t),  &Py_TPFLAGS_HAVE_WEAKREFS)  && (($t)-> &tp_weaklistoffset > 0)));
    }' unless defined(&PyType_SUPPORTS_WEAKREFS);
    eval 'sub PyObject_GET_WEAKREFS_LISTPTR {
        my($o) = @_;
	    eval q((( &PyObject **) (( ($o)) + ($o)-> ($ob_type->{tp_weaklistoffset}))));
    }' unless defined(&PyObject_GET_WEAKREFS_LISTPTR);
    if(defined(&__cplusplus)) {
    }
}
1;
