require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Py_CURSES_H)) {
    eval 'sub Py_CURSES_H () {1;}' unless defined(&Py_CURSES_H);
    if(defined(&HAVE_NCURSES_H)) {
	require 'ncurses.ph';
    } else {
	require 'curses.ph';
	if(defined(&HAVE_TERM_H)) {
	    require 'term.ph';
	}
    }
    if(defined(&HAVE_NCURSES_H)) {
	unless(defined(&WINDOW_HAS_FLAGS)) {
	    eval 'sub WINDOW_HAS_FLAGS () {1;}' unless defined(&WINDOW_HAS_FLAGS);
	}
	unless(defined(&MVWDELCH_IS_EXPRESSION)) {
	    eval 'sub MVWDELCH_IS_EXPRESSION () {1;}' unless defined(&MVWDELCH_IS_EXPRESSION);
	}
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub PyCurses_API_pointers () {4;}' unless defined(&PyCurses_API_pointers);
    eval 'sub PyCursesWindow_Check {
        my($v) = @_;
	    eval q((($v)-> &ob_type ==  &PyCursesWindow_Type));
    }' unless defined(&PyCursesWindow_Check);
    if(defined(&CURSES_MODULE)) {
    } else {
	eval 'sub PyCursesWindow_Type () {(*( &PyTypeObject *)  $PyCurses_API[0]);}' unless defined(&PyCursesWindow_Type);
	eval 'sub PyCursesSetupTermCalled () {{ &if (! (( &int (*)( &void)) $PyCurses_API[1]) () )  &return  &NULL;};}' unless defined(&PyCursesSetupTermCalled);
	eval 'sub PyCursesInitialised () {{ &if (! (( &int (*)( &void)) $PyCurses_API[2]) () )  &return  &NULL;};}' unless defined(&PyCursesInitialised);
	eval 'sub PyCursesInitialisedColor () {{ &if (! (( &int (*)( &void)) $PyCurses_API[3]) () )  &return  &NULL;};}' unless defined(&PyCursesInitialisedColor);
	eval 'sub import_curses () {
	    eval q({  &PyObject * &module =  &PyImport_ImportModule(\\"_curses\\");  &if ( &module !=  &NULL) {  &PyObject * &module_dict =  &PyModule_GetDict( &module);  &PyObject * &c_api_object =  &PyDict_GetItemString( &module_dict, \\"_C_API\\");  &if ( &PyCObject_Check( &c_api_object)) {  &PyCurses_API = ( &void **) &PyCObject_AsVoidPtr( &c_api_object); } } });
	}' unless defined(&import_curses);
    }
    eval 'sub ARG_COUNT {
        my($X) = @_;
	    eval q(((($X) ==  &NULL) ? 0: ( &PyTuple_Check($X) ?  &PyTuple_Size($X) : 1)));
    }' unless defined(&ARG_COUNT);
    eval 'sub NoArgNoReturnFunction {
        my($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self,  &PyObject * &args) {  &PyCursesInitialised  &if (! &PyArg_NoArgs( &args))  &return  &NULL;  &return  &PyCursesCheckERR($X(),  $X); });
    }' unless defined(&NoArgNoReturnFunction);
    eval 'sub NoArgOrFlagNoReturnFunction {
        my($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self,  &PyObject * &args) { \'int\'  &flag = 0;  &PyCursesInitialised  &switch( &ARG_COUNT( &args)) {  &case 0:  &return  &PyCursesCheckERR($X(),  $X);  &case 1:  &if (! &PyArg_Parse( &args, \\"i;True(1) or False(0)\\",  &flag))  &return  &NULL;  &if ( &flag)  &return  &PyCursesCheckERR($X(),  $X);  &else  &return  &PyCursesCheckERR( &no  $X (),  $X);  &default:  &PyErr_SetString( &PyExc_TypeError,  $X \\" requires 0 or 1 arguments\\");  &return  &NULL; } });
    }' unless defined(&NoArgOrFlagNoReturnFunction);
    eval 'sub NoArgReturnIntFunction {
        my($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self,  &PyObject * &args) {  &PyCursesInitialised  &if (! &PyArg_NoArgs)  &return  &NULL;  &return  &PyInt_FromLong( $X()); });
    }' unless defined(&NoArgReturnIntFunction);
    eval 'sub NoArgReturnStringFunction {
        my($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self,  &PyObject * &args) {  &PyCursesInitialised  &if (! &PyArg_NoArgs( &args))  &return  &NULL;  &return  &PyString_FromString($X()); });
    }' unless defined(&NoArgReturnStringFunction);
    eval 'sub NoArgTrueFalseFunction {
        my($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self,  &PyObject * &args) {  &PyCursesInitialised  &if (! &PyArg_NoArgs( &args))  &return  &NULL;  &if ($X () ==  &FALSE) {  &Py_INCREF( &Py_False);  &return  &Py_False; }  &Py_INCREF( &Py_True);  &return  &Py_True; });
    }' unless defined(&NoArgTrueFalseFunction);
    eval 'sub NoArgNoReturnVoidFunction {
        my($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self,  &PyObject * &args) {  &PyCursesInitialised  &if (! &PyArg_NoArgs( &args))  &return  &NULL; $X();  &Py_INCREF( &Py_None);  &return  &Py_None; });
    }' unless defined(&NoArgNoReturnVoidFunction);
    if(defined(&__cplusplus)) {
    }
}
1;
