require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Py_PYPORT_H)) {
    eval 'sub Py_PYPORT_H () {1;}' unless defined(&Py_PYPORT_H);
    require 'pyconfig.ph';
    eval 'sub ANY () { &void;}' unless defined(&ANY);
    if(defined(&HAVE_PROTOTYPES)) {
	eval 'sub Py_PROTO {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&Py_PROTO);
    } else {
	eval 'sub Py_PROTO {
	    my($x) = @_;
    	    eval q(());
	}' unless defined(&Py_PROTO);
    }
    unless(defined(&Py_FPROTO)) {
	eval 'sub Py_FPROTO {
	    my($x) = @_;
    	    eval q( &Py_PROTO($x));
	}' unless defined(&Py_FPROTO);
    }
    if(defined(&HAVE_LONG_LONG)) {
	unless(defined(&LONG_LONG)) {
	    eval 'sub LONG_LONG () {\'long long\';}' unless defined(&LONG_LONG);
	}
    }
    if(defined(&HAVE_UINTPTR_T)) {
    }
 elsif((defined(&SIZEOF_VOID_P) ? &SIZEOF_VOID_P : 0) <= (defined(&SIZEOF_INT) ? &SIZEOF_INT : 0)) {
    }
 elsif((defined(&SIZEOF_VOID_P) ? &SIZEOF_VOID_P : 0) <= (defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0)) {
    }
 elsif(defined( &HAVE_LONG_LONG)  && ((defined(&SIZEOF_VOID_P) ? &SIZEOF_VOID_P : 0) <= (defined(&SIZEOF_LONG_LONG) ? &SIZEOF_LONG_LONG : 0))) {
    } else {
	die("Python needs a typedef for Py_uintptr_t in pyport.h.");
    }
    if(defined(&HAVE_STDLIB_H)) {
	require 'stdlib.ph';
    }
    require 'math.ph';
    if(defined(&TIME_WITH_SYS_TIME)) {
	require 'sys/time.ph';
	require 'time.ph';
    } else {
	if(defined(&HAVE_SYS_TIME_H)) {
	    require 'sys/time.ph';
	} else {
	    require 'time.ph';
	}
    }
    if(defined(&HAVE_SYS_SELECT_H)) {
	require 'sys/select.ph';
    } else {
	if(defined(&USE_GUSI1)) {
	    require 'GUSI.ph';
	}
    }
    unless(defined(&DONT_HAVE_STAT)) {
	eval 'sub HAVE_STAT () {1;}' unless defined(&HAVE_STAT);
    }
    unless(defined(&DONT_HAVE_FSTAT)) {
	eval 'sub HAVE_FSTAT () {1;}' unless defined(&HAVE_FSTAT);
    }
    if(defined(&RISCOS)) {
	require 'sys/types.ph';
    }
    unless(defined(&DONT_HAVE_SYS_STAT_H)) {
	require 'sys/stat.ph';
    }
 elsif(defined( &HAVE_STAT_H)) {
	require 'stat.ph';
    }
    if(defined( &PYCC_VACPP)) {
	eval 'sub S_IFMT () {( &S_IFDIR| &S_IFCHR| &S_IFREG);}' unless defined(&S_IFMT);
    }
    unless(defined(&S_ISREG)) {
	eval 'sub S_ISREG {
	    my($x) = @_;
    	    eval q(((($x) &  &S_IFMT) ==  &S_IFREG));
	}' unless defined(&S_ISREG);
    }
    unless(defined(&S_ISDIR)) {
	eval 'sub S_ISDIR {
	    my($x) = @_;
    	    eval q(((($x) &  &S_IFMT) ==  &S_IFDIR));
	}' unless defined(&S_ISDIR);
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&SIGNED_RIGHT_SHIFT_ZERO_FILLS)) {
	eval 'sub Py_ARITHMETIC_RIGHT_SHIFT {
	    my($TYPE, $I, $J) = @_;
    	    eval q((($I) < 0? ~((~($I)) >> ($J)) : ($I) >> ($J)));
	}' unless defined(&Py_ARITHMETIC_RIGHT_SHIFT);
    } else {
	eval 'sub Py_ARITHMETIC_RIGHT_SHIFT {
	    my($TYPE, $I, $J) = @_;
    	    eval q((($I) >> ($J)));
	}' unless defined(&Py_ARITHMETIC_RIGHT_SHIFT);
    }
    eval 'sub Py_FORCE_EXPANSION {
        my($X) = @_;
	    eval q($X);
    }' unless defined(&Py_FORCE_EXPANSION);
    if(defined(&Py_DEBUG)) {
	eval 'sub Py_SAFE_DOWNCAST {
	    my($VALUE, $WIDE, $NARROW) = @_;
    	    eval q(( &assert(($WIDE)($NARROW)($VALUE) == ($VALUE)), ($NARROW)($VALUE)));
	}' unless defined(&Py_SAFE_DOWNCAST);
    } else {
	eval 'sub Py_SAFE_DOWNCAST {
	    my($VALUE, $WIDE, $NARROW) = @_;
    	    eval q(($NARROW)($VALUE));
	}' unless defined(&Py_SAFE_DOWNCAST);
    }
    eval 'sub Py_IS_INFINITY {
        my($X) = @_;
	    eval q((($X)  && ($X)*0.5== ($X)));
    }' unless defined(&Py_IS_INFINITY);
    if(defined(&INFINITY)) {
	eval 'sub Py_HUGE_VAL () {( &INFINITY);}' unless defined(&Py_HUGE_VAL);
    } else {
	eval 'sub Py_HUGE_VAL () { &HUGE_VAL;}' unless defined(&Py_HUGE_VAL);
    }
    eval 'sub Py_OVERFLOWED {
        my($X) = @_;
	    eval q((($X) != 0.0 && ( &errno ==  &ERANGE || ($X) ==  &Py_HUGE_VAL || ($X) == - &Py_HUGE_VAL)));
    }' unless defined(&Py_OVERFLOWED);
    eval 'sub Py_SET_ERANGE_IF_OVERFLOW {
        my($X) = @_;
	    eval q( &do {  &if ( &errno == 0 && (($X) ==  &Py_HUGE_VAL || ($X) == - &Py_HUGE_VAL))  &errno =  &ERANGE; }  &while(0));
    }' unless defined(&Py_SET_ERANGE_IF_OVERFLOW);
    eval 'sub Py_ADJUST_ERANGE1 {
        my($X) = @_;
	    eval q( &do {  &if ( &errno == 0) {  &if (($X) ==  &Py_HUGE_VAL || ($X) == - &Py_HUGE_VAL)  &errno =  &ERANGE; }  &else  &if ( &errno ==  &ERANGE  && ($X) == 0.0)  &errno = 0; }  &while(0));
    }' unless defined(&Py_ADJUST_ERANGE1);
    eval 'sub Py_ADJUST_ERANGE2 {
        my($X, $Y) = @_;
	    eval q( &do {  &if (($X) ==  &Py_HUGE_VAL || ($X) == - &Py_HUGE_VAL || ($Y) ==  &Py_HUGE_VAL || ($Y) == - &Py_HUGE_VAL) {  &if ( &errno == 0)  &errno =  &ERANGE; }  &else  &if ( &errno ==  &ERANGE)  &errno = 0; }  &while(0));
    }' unless defined(&Py_ADJUST_ERANGE2);
    if(defined(&SOLARIS)) {
    }
    if(defined(&__BEOS__)) {
    }
    if(defined(&HAVE__GETPTY)) {
	require 'sys/types.ph';
    }
    if(defined( &HAVE_OPENPTY) || defined( &HAVE_FORKPTY)) {
	if(!defined( &HAVE_PTY_H)  && !defined( &HAVE_LIBUTIL_H)) {
	    require 'termios.ph';
	}
    }
    if(0) {
    }
    unless(defined(&HAVE_HYPOT)) {
    }
    unless(defined(&DL_IMPORT)) {
	eval 'sub DL_IMPORT {
	    my($RTYPE) = @_;
    	    eval q($RTYPE);
	}' unless defined(&DL_IMPORT);
    }
    if(defined(&MALLOC_ZERO_RETURNS_NULL)) {
	eval 'sub _PyMem_EXTRA () {1;}' unless defined(&_PyMem_EXTRA);
    } else {
	eval 'sub _PyMem_EXTRA () {0;}' unless defined(&_PyMem_EXTRA);
    }
    if(0) {
	unless(defined(&FD_SETSIZE)) {
	    eval 'sub FD_SETSIZE () {256;}' unless defined(&FD_SETSIZE);
	}
	unless(defined(&FD_SET)) {
	    eval 'sub NFDBITS () {($sizeof{ &fd_mask} *  &NBBY);}' unless defined(&NFDBITS);
	    unless(defined(&howmany)) {
		eval 'sub howmany {
		    my($x, $y) = @_;
    		    eval q(((($x)+(($y)-1))/($y)));
		}' unless defined(&howmany);
	    }
	    eval 'sub FD_SET {
	        my($n, $p) = @_;
    		eval q((($p)-> $fds_bits[($n)/ &NFDBITS] |= (1<< (($n) %  &NFDBITS))));
	    }' unless defined(&FD_SET);
	    eval 'sub FD_CLR {
	        my($n, $p) = @_;
    		eval q((($p)-> $fds_bits[($n)/ &NFDBITS] &= ~(1<< (($n) %  &NFDBITS))));
	    }' unless defined(&FD_CLR);
	    eval 'sub FD_ISSET {
	        my($n, $p) = @_;
    		eval q((($p)-> $fds_bits[($n)/ &NFDBITS] & (1<< (($n) %  &NFDBITS))));
	    }' unless defined(&FD_ISSET);
	    eval 'sub FD_ZERO {
	        my($p) = @_;
    		eval q( &memset(($p), ord(\'\\\\0\'), $sizeof{($p)}));
	    }' unless defined(&FD_ZERO);
	}
    }
    unless(defined(&INT_MAX)) {
	eval 'sub INT_MAX () {2147483647;}' unless defined(&INT_MAX);
    }
    unless(defined(&LONG_MAX)) {
	if((defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0) == 4) {
	    eval 'sub LONG_MAX () {0x7fffffff;}' unless defined(&LONG_MAX);
	}
 elsif((defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0) == 8) {
	    eval 'sub LONG_MAX () {9.22337203685478e+18;}' unless defined(&LONG_MAX);
	} else {
	    die("could not set LONG_MAX in pyport.h");
	}
    }
    unless(defined(&LONG_MIN)) {
	eval 'sub LONG_MIN () {(- &LONG_MAX-1);}' unless defined(&LONG_MIN);
    }
    unless(defined(&LONG_BIT)) {
	eval 'sub LONG_BIT () {(8*  &SIZEOF_LONG);}' unless defined(&LONG_BIT);
    }
    if((defined(&LONG_BIT) ? &LONG_BIT : 0) != 8* (defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0)) {
	die("LONG_BIT definition appears wrong for platform (bad gcc/glibc config?).");
    }
    if(defined(&__BORLANDC__)) {
	require 'io.ph';
	eval 'sub _chsize () { &chsize;}' unless defined(&_chsize);
	eval 'sub _setmode () { &setmode;}' unless defined(&_setmode);
    }
    if(defined(&__cplusplus)) {
    }
    if((!defined( &__GNUC__) || (defined(&__GNUC__) ? &__GNUC__ : 0) < 2|| ((defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) < 7) || defined( &NEXT) )  && !defined( &RISCOS)) {
	eval 'sub __attribute__ {
	    my($__x) = @_;
    	    eval q();
	}' unless defined(&__attribute__);
    }
}
1;
