require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_TCL)) {
    eval 'sub _TCL () {1;}' unless defined(&_TCL);
    if(defined(&__cplusplus)) {
    }
    eval 'sub TCL_ALPHA_RELEASE () {0;}' unless defined(&TCL_ALPHA_RELEASE);
    eval 'sub TCL_BETA_RELEASE () {1;}' unless defined(&TCL_BETA_RELEASE);
    eval 'sub TCL_FINAL_RELEASE () {2;}' unless defined(&TCL_FINAL_RELEASE);
    eval 'sub TCL_MAJOR_VERSION () {8;}' unless defined(&TCL_MAJOR_VERSION);
    eval 'sub TCL_MINOR_VERSION () {3;}' unless defined(&TCL_MINOR_VERSION);
    eval 'sub TCL_RELEASE_LEVEL () { &TCL_FINAL_RELEASE;}' unless defined(&TCL_RELEASE_LEVEL);
    eval 'sub TCL_RELEASE_SERIAL () {5;}' unless defined(&TCL_RELEASE_SERIAL);
    eval 'sub TCL_VERSION () {"8.3";}' unless defined(&TCL_VERSION);
    eval 'sub TCL_PATCH_LEVEL () {"8.3.5";}' unless defined(&TCL_PATCH_LEVEL);
    unless(defined(&__WIN32__)) {
	if(defined( &_WIN32) || defined( &WIN32) || defined( &__CYGWIN__) || defined( &__MINGW32__) || defined( &__BORLANDC__)) {
	    eval 'sub __WIN32__ () {1;}' unless defined(&__WIN32__);
	    unless(defined(&WIN32)) {
		eval 'sub WIN32 () {1;}' unless defined(&WIN32);
	    }
	}
    }
    if(defined(&__WIN32__)) {
	unless(defined(&STRICT)) {
	    eval 'sub STRICT () {1;}' unless defined(&STRICT);
	}
	unless(defined(&USE_PROTOTYPE)) {
	    eval 'sub USE_PROTOTYPE () {1;}' unless defined(&USE_PROTOTYPE);
	}
	unless(defined(&HAS_STDARG)) {
	    eval 'sub HAS_STDARG () {1;}' unless defined(&HAS_STDARG);
	}
	unless(defined(&USE_PROTOTYPE)) {
	    eval 'sub USE_PROTOTYPE () {1;}' unless defined(&USE_PROTOTYPE);
	}
    }
    if(defined(&MAC_TCL)) {
	require 'ConditionalMacros.ph';
	unless(defined(&HAS_STDARG)) {
	    eval 'sub HAS_STDARG () {1;}' unless defined(&HAS_STDARG);
	}
	unless(defined(&USE_TCLALLOC)) {
	    eval 'sub USE_TCLALLOC () {1;}' unless defined(&USE_TCLALLOC);
	}
	unless(defined(&NO_STRERROR)) {
	    eval 'sub NO_STRERROR () {1;}' unless defined(&NO_STRERROR);
	}
	eval 'sub INLINE () {1;}' unless defined(&INLINE);
    }
    eval 'sub VERBATIM {
        my($x) = @_;
	    eval q($x);
    }' unless defined(&VERBATIM);
    if(defined(&_MSC_VER)) {
	eval 'sub STRINGIFY {
	    my($x) = @_;
    	    eval q( &STRINGIFY1($x));
	}' unless defined(&STRINGIFY);
	eval 'sub STRINGIFY1 {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&STRINGIFY1);
	eval 'sub JOIN {
	    my($a,$b) = @_;
    	    eval q( &JOIN1($a,$b));
	}' unless defined(&JOIN);
	eval 'sub JOIN1 {
	    my($a,$b) = @_;
    	    eval q($a$b);
	}' unless defined(&JOIN1);
    } else {
	if(defined(&RESOURCE_INCLUDED)) {
	    eval 'sub STRINGIFY {
	        my($x) = @_;
    		eval q( &STRINGIFY1($x));
	    }' unless defined(&STRINGIFY);
	    eval 'sub STRINGIFY1 {
	        my($x) = @_;
    		eval q($x);
	    }' unless defined(&STRINGIFY1);
	    eval 'sub JOIN {
	        my($a,$b) = @_;
    		eval q( &JOIN1($a,$b));
	    }' unless defined(&JOIN);
	    eval 'sub JOIN1 {
	        my($a,$b) = @_;
    		eval q($a$b);
	    }' unless defined(&JOIN1);
	} else {
	    if(defined(&__STDC__)) {
		eval 'sub STRINGIFY {
		    my($x) = @_;
    		    eval q($x);
		}' unless defined(&STRINGIFY);
		eval 'sub JOIN {
		    my($a,$b) = @_;
    		    eval q($a$b);
		}' unless defined(&JOIN);
	    } else {
		eval 'sub STRINGIFY {
		    my($x) = @_;
    		    eval q(\\"x\\");
		}' unless defined(&STRINGIFY);
		eval 'sub JOIN {
		    my($a,$b) = @_;
    		    eval q( &VERBATIM($a) &VERBATIM($b));
		}' unless defined(&JOIN);
	    }
	}
    }
    if(defined(&TCL_THREADS)) {
	eval 'sub TCL_DECLARE_MUTEX {
	    my($name) = @_;
    	    eval q( &static  &Tcl_Mutex $name;);
	}' unless defined(&TCL_DECLARE_MUTEX);
    } else {
	eval 'sub TCL_DECLARE_MUTEX {
	    my($name) = @_;
    	    eval q();
	}' unless defined(&TCL_DECLARE_MUTEX);
    }
    unless(defined(&TCL_THREADS)) {
	eval 'sub Tcl_MutexLock {
	    my($mutexPtr) = @_;
    	    eval q();
	}' unless defined(&Tcl_MutexLock);
	eval 'sub Tcl_MutexUnlock {
	    my($mutexPtr) = @_;
    	    eval q();
	}' unless defined(&Tcl_MutexUnlock);
	eval 'sub Tcl_MutexFinalize {
	    my($mutexPtr) = @_;
    	    eval q();
	}' unless defined(&Tcl_MutexFinalize);
	eval 'sub Tcl_ConditionNotify {
	    my($condPtr) = @_;
    	    eval q();
	}' unless defined(&Tcl_ConditionNotify);
	eval 'sub Tcl_ConditionWait {
	    my($condPtr, $mutexPtr, $timePtr) = @_;
    	    eval q();
	}' unless defined(&Tcl_ConditionWait);
	eval 'sub Tcl_ConditionFinalize {
	    my($condPtr) = @_;
    	    eval q();
	}' unless defined(&Tcl_ConditionFinalize);
    }
    unless(defined(&RESOURCE_INCLUDED)) {
	unless(defined(&BUFSIZ)) {
	    require 'stdio.ph';
	}
	if(defined( &__STDC__) || defined( &HAS_STDARG)) {
	    require 'stdarg.ph';
	    eval 'sub TCL_VARARGS {
	        my($type, $name) = @_;
    		eval q(($type $name, ...));
	    }' unless defined(&TCL_VARARGS);
	    eval 'sub TCL_VARARGS_DEF {
	        my($type, $name) = @_;
    		eval q(($type $name, ...));
	    }' unless defined(&TCL_VARARGS_DEF);
	    eval 'sub TCL_VARARGS_START {
	        my($type, $name, $list) = @_;
    		eval q(( &va_start($list, $name), $name));
	    }' unless defined(&TCL_VARARGS_START);
	} else {
	    require 'varargs.ph';
	    if(defined(&__cplusplus)) {
		eval 'sub TCL_VARARGS {
		    my($type, $name) = @_;
    		    eval q(($type $name, ...));
		}' unless defined(&TCL_VARARGS);
		eval 'sub TCL_VARARGS_DEF {
		    my($type, $name) = @_;
    		    eval q(($type  &va_alist, ...));
		}' unless defined(&TCL_VARARGS_DEF);
	    } else {
		eval 'sub TCL_VARARGS {
		    my($type, $name) = @_;
    		    eval q(());
		}' unless defined(&TCL_VARARGS);
		eval 'sub TCL_VARARGS_DEF {
		    my($type, $name) = @_;
    		    eval q(( &va_alist));
		}' unless defined(&TCL_VARARGS_DEF);
	    }
	    eval 'sub TCL_VARARGS_START {
	        my($type, $name, $list) = @_;
    		eval q(( &va_start($list),  &va_arg($list, $type)));
	    }' unless defined(&TCL_VARARGS_START);
	}
	if(defined(&STATIC_BUILD)) {
	    eval 'sub DLLIMPORT () {1;}' unless defined(&DLLIMPORT);
	    eval 'sub DLLEXPORT () {1;}' unless defined(&DLLEXPORT);
	} else {
	    if((defined( &__WIN32__)  && (defined( &_MSC_VER) || (defined( &__GNUC__)  && defined( &__declspec)))) || (defined( &MAC_TCL)  && (defined(&FUNCTION_DECLSPEC) ? &FUNCTION_DECLSPEC : 0))) {
		eval 'sub DLLIMPORT () { &__declspec( &dllimport);}' unless defined(&DLLIMPORT);
		eval 'sub DLLEXPORT () { &__declspec( &dllexport);}' unless defined(&DLLEXPORT);
	    } else {
		eval 'sub DLLIMPORT () {1;}' unless defined(&DLLIMPORT);
		eval 'sub DLLEXPORT () {1;}' unless defined(&DLLEXPORT);
	    }
	}
	undef(&TCL_STORAGE_CLASS) if defined(&TCL_STORAGE_CLASS);
	if(defined(&BUILD_tcl)) {
	    eval 'sub TCL_STORAGE_CLASS () { &DLLEXPORT;}' unless defined(&TCL_STORAGE_CLASS);
	} else {
	    if(defined(&USE_TCL_STUBS)) {
		eval 'sub TCL_STORAGE_CLASS () {1;}' unless defined(&TCL_STORAGE_CLASS);
	    } else {
		eval 'sub TCL_STORAGE_CLASS () { &DLLIMPORT;}' unless defined(&TCL_STORAGE_CLASS);
	    }
	}
	undef(&_ANSI_ARGS_) if defined(&_ANSI_ARGS_);
	undef(&CONST) if defined(&CONST);
	unless(defined(&INLINE)) {
	    eval 'sub INLINE () {1;}' unless defined(&INLINE);
	}
	if(((defined( &__STDC__) || defined( &SABER))  && !defined( &NO_PROTOTYPE)) || defined( &__cplusplus) || defined( &USE_PROTOTYPE)) {
	    eval 'sub _USING_PROTOTYPES_ () {1;}' unless defined(&_USING_PROTOTYPES_);
	    eval 'sub _ANSI_ARGS_ {
	        my($x) = @_;
    		eval q($x);
	    }' unless defined(&_ANSI_ARGS_);
	    eval 'sub CONST () { &const;}' unless defined(&CONST);
	} else {
	    eval 'sub _ANSI_ARGS_ {
	        my($x) = @_;
    		eval q(());
	    }' unless defined(&_ANSI_ARGS_);
	    eval 'sub CONST () {1;}' unless defined(&CONST);
	}
	if(defined(&EXTERN)) {
	    undef(&EXTERN) if defined(&EXTERN);
	}
	if(defined(&__cplusplus)) {
	    eval 'sub EXTERN () { &extern "C"  &TCL_STORAGE_CLASS;}' unless defined(&EXTERN);
	} else {
	    eval 'sub EXTERN () { &extern  &TCL_STORAGE_CLASS;}' unless defined(&EXTERN);
	}
	unless(defined(&__WIN32__)) {
	    unless(defined(&VOID)) {
		if(defined(&__STDC__)) {
		    eval 'sub VOID () { &void;}' unless defined(&VOID);
		} else {
		    eval 'sub VOID () {\'char\';}' unless defined(&VOID);
		}
	    }
	} else {
	    unless(defined(&VOID)) {
		eval 'sub VOID () { &void;}' unless defined(&VOID);
	    }
	}
	unless(defined(&NULL)) {
	    eval 'sub NULL () {0;}' unless defined(&NULL);
	}
	unless(defined(&_CLIENTDATA)) {
	    if(defined( &__STDC__) || defined( &__cplusplus)) {
	    } else {
	    }
	    eval 'sub _CLIENTDATA () {1;}' unless defined(&_CLIENTDATA);
	}
	if(defined(&MAC_TCL)) {
	}
 elsif(defined (defined(&__WIN32__) ? &__WIN32__ : 0)) {
	} else {
	}
	if(defined(&MAC_TCL)) {
	    eval 'sub Tcl_ThreadCreateType () { &pascal  &void *;}' unless defined(&Tcl_ThreadCreateType);
	    eval 'sub TCL_THREAD_CREATE_RETURN () { &return  &NULL;}' unless defined(&TCL_THREAD_CREATE_RETURN);
	}
 elsif(defined (defined(&__WIN32__) ? &__WIN32__ : 0)) {
	    eval 'sub Tcl_ThreadCreateType () {\'unsigned __stdcall\';}' unless defined(&Tcl_ThreadCreateType);
	    eval 'sub TCL_THREAD_CREATE_RETURN () { &return 0;}' unless defined(&TCL_THREAD_CREATE_RETURN);
	} else {
	    eval 'sub Tcl_ThreadCreateType () { &void;}' unless defined(&Tcl_ThreadCreateType);
	    eval 'sub TCL_THREAD_CREATE_RETURN () {1;}' unless defined(&TCL_THREAD_CREATE_RETURN);
	}
	eval 'sub TCL_THREAD_STACK_DEFAULT () {(0);}' unless defined(&TCL_THREAD_STACK_DEFAULT);
	eval 'sub TCL_THREAD_NOFLAGS () {(0000);}' unless defined(&TCL_THREAD_NOFLAGS);
	eval 'sub TCL_THREAD_JOINABLE () {(0001);}' unless defined(&TCL_THREAD_JOINABLE);
	eval 'sub TCL_REG_BASIC () {000000;}' unless defined(&TCL_REG_BASIC);
	eval 'sub TCL_REG_EXTENDED () {000001;}' unless defined(&TCL_REG_EXTENDED);
	eval 'sub TCL_REG_ADVF () {000002;}' unless defined(&TCL_REG_ADVF);
	eval 'sub TCL_REG_ADVANCED () {000003;}' unless defined(&TCL_REG_ADVANCED);
	eval 'sub TCL_REG_QUOTE () {000004;}' unless defined(&TCL_REG_QUOTE);
	eval 'sub TCL_REG_NOCASE () {000010;}' unless defined(&TCL_REG_NOCASE);
	eval 'sub TCL_REG_NOSUB () {000020;}' unless defined(&TCL_REG_NOSUB);
	eval 'sub TCL_REG_EXPANDED () {000040;}' unless defined(&TCL_REG_EXPANDED);
	eval 'sub TCL_REG_NLSTOP () {000100;}' unless defined(&TCL_REG_NLSTOP);
	eval 'sub TCL_REG_NLANCH () {000200;}' unless defined(&TCL_REG_NLANCH);
	eval 'sub TCL_REG_NEWLINE () {000300;}' unless defined(&TCL_REG_NEWLINE);
	eval 'sub TCL_REG_CANMATCH () {001000;}' unless defined(&TCL_REG_CANMATCH);
	eval 'sub TCL_REG_BOSONLY () {002000;}' unless defined(&TCL_REG_BOSONLY);
	eval 'sub TCL_REG_NOTBOL () {0001;}' unless defined(&TCL_REG_NOTBOL);
	eval 'sub TCL_REG_NOTEOL () {0002;}' unless defined(&TCL_REG_NOTEOL);
	eval 'sub TCL_OK () {0;}' unless defined(&TCL_OK);
	eval 'sub TCL_ERROR () {1;}' unless defined(&TCL_ERROR);
	eval 'sub TCL_RETURN () {2;}' unless defined(&TCL_RETURN);
	eval 'sub TCL_BREAK () {3;}' unless defined(&TCL_BREAK);
	eval 'sub TCL_CONTINUE () {4;}' unless defined(&TCL_CONTINUE);
	eval 'sub TCL_RESULT_SIZE () {200;}' unless defined(&TCL_RESULT_SIZE);
	eval("sub TCL_INT () { 0; }") unless defined(&TCL_INT);
	eval("sub TCL_DOUBLE () { 1; }") unless defined(&TCL_DOUBLE);
	eval("sub TCL_EITHER () { 2; }") unless defined(&TCL_EITHER);
	if(defined(&TCL_MEM_DEBUG)) {
	    eval 'sub Tcl_IncrRefCount {
	        my($objPtr) = @_;
    		eval q( &Tcl_DbIncrRefCount($objPtr,  &__FILE__,  &__LINE__));
	    }' unless defined(&Tcl_IncrRefCount);
	    eval 'sub Tcl_DecrRefCount {
	        my($objPtr) = @_;
    		eval q( &Tcl_DbDecrRefCount($objPtr,  &__FILE__,  &__LINE__));
	    }' unless defined(&Tcl_DecrRefCount);
	    eval 'sub Tcl_IsShared {
	        my($objPtr) = @_;
    		eval q( &Tcl_DbIsShared($objPtr,  &__FILE__,  &__LINE__));
	    }' unless defined(&Tcl_IsShared);
	} else {
	    eval 'sub Tcl_IncrRefCount {
	        my($objPtr) = @_;
    		eval q(++($objPtr)-> &refCount);
	    }' unless defined(&Tcl_IncrRefCount);
	    eval 'sub Tcl_DecrRefCount {
	        my($objPtr) = @_;
    		eval q( &if (--($objPtr)-> &refCount <= 0)  &TclFreeObj($objPtr));
	    }' unless defined(&Tcl_DecrRefCount);
	    eval 'sub Tcl_IsShared {
	        my($objPtr) = @_;
    		eval q((($objPtr)-> &refCount > 1));
	    }' unless defined(&Tcl_IsShared);
	}
	if(defined(&TCL_MEM_DEBUG)) {
	    eval 'sub Tcl_NewBooleanObj {
	        my($val) = @_;
    		eval q( &Tcl_DbNewBooleanObj($val,  &__FILE__,  &__LINE__));
	    }' unless defined(&Tcl_NewBooleanObj);
	    eval 'sub Tcl_NewByteArrayObj {
	        my($bytes, $len) = @_;
    		eval q( &Tcl_DbNewByteArrayObj($bytes, $len,  &__FILE__,  &__LINE__));
	    }' unless defined(&Tcl_NewByteArrayObj);
	    eval 'sub Tcl_NewDoubleObj {
	        my($val) = @_;
    		eval q( &Tcl_DbNewDoubleObj($val,  &__FILE__,  &__LINE__));
	    }' unless defined(&Tcl_NewDoubleObj);
	    eval 'sub Tcl_NewIntObj {
	        my($val) = @_;
    		eval q( &Tcl_DbNewLongObj($val,  &__FILE__,  &__LINE__));
	    }' unless defined(&Tcl_NewIntObj);
	    eval 'sub Tcl_NewListObj {
	        my($objc, $objv) = @_;
    		eval q( &Tcl_DbNewListObj($objc, $objv,  &__FILE__,  &__LINE__));
	    }' unless defined(&Tcl_NewListObj);
	    eval 'sub Tcl_NewLongObj {
	        my($val) = @_;
    		eval q( &Tcl_DbNewLongObj($val,  &__FILE__,  &__LINE__));
	    }' unless defined(&Tcl_NewLongObj);
	    eval 'sub Tcl_NewObj () {
	        eval q( &Tcl_DbNewObj( &__FILE__,  &__LINE__));
	    }' unless defined(&Tcl_NewObj);
	    eval 'sub Tcl_NewStringObj {
	        my($bytes, $len) = @_;
    		eval q( &Tcl_DbNewStringObj($bytes, $len,  &__FILE__,  &__LINE__));
	    }' unless defined(&Tcl_NewStringObj);
	}
	eval 'sub TCL_DSTRING_STATIC_SIZE () {200;}' unless defined(&TCL_DSTRING_STATIC_SIZE);
	eval 'sub Tcl_DStringLength {
	    my($dsPtr) = @_;
    	    eval q((($dsPtr)-> &length));
	}' unless defined(&Tcl_DStringLength);
	eval 'sub Tcl_DStringValue {
	    my($dsPtr) = @_;
    	    eval q((($dsPtr)-> &string));
	}' unless defined(&Tcl_DStringValue);
	eval 'sub Tcl_DStringTrunc () { &Tcl_DStringSetLength;}' unless defined(&Tcl_DStringTrunc);
	eval 'sub TCL_MAX_PREC () {17;}' unless defined(&TCL_MAX_PREC);
	eval 'sub TCL_DOUBLE_SPACE () {( &TCL_MAX_PREC+10);}' unless defined(&TCL_DOUBLE_SPACE);
	eval 'sub TCL_INTEGER_SPACE () {24;}' unless defined(&TCL_INTEGER_SPACE);
	eval 'sub TCL_DONT_USE_BRACES () {1;}' unless defined(&TCL_DONT_USE_BRACES);
	eval 'sub TCL_EXACT () {1;}' unless defined(&TCL_EXACT);
	eval 'sub TCL_NO_EVAL () {0x10000;}' unless defined(&TCL_NO_EVAL);
	eval 'sub TCL_EVAL_GLOBAL () {0x20000;}' unless defined(&TCL_EVAL_GLOBAL);
	eval 'sub TCL_EVAL_DIRECT () {0x40000;}' unless defined(&TCL_EVAL_DIRECT);
	eval 'sub TCL_VOLATILE () {(( &Tcl_FreeProc *) 1);}' unless defined(&TCL_VOLATILE);
	eval 'sub TCL_STATIC () {(( &Tcl_FreeProc *) 0);}' unless defined(&TCL_STATIC);
	eval 'sub TCL_DYNAMIC () {(( &Tcl_FreeProc *) 3);}' unless defined(&TCL_DYNAMIC);
	eval 'sub TCL_GLOBAL_ONLY () {1;}' unless defined(&TCL_GLOBAL_ONLY);
	eval 'sub TCL_NAMESPACE_ONLY () {2;}' unless defined(&TCL_NAMESPACE_ONLY);
	eval 'sub TCL_APPEND_VALUE () {4;}' unless defined(&TCL_APPEND_VALUE);
	eval 'sub TCL_LIST_ELEMENT () {8;}' unless defined(&TCL_LIST_ELEMENT);
	eval 'sub TCL_TRACE_READS () {0x10;}' unless defined(&TCL_TRACE_READS);
	eval 'sub TCL_TRACE_WRITES () {0x20;}' unless defined(&TCL_TRACE_WRITES);
	eval 'sub TCL_TRACE_UNSETS () {0x40;}' unless defined(&TCL_TRACE_UNSETS);
	eval 'sub TCL_TRACE_DESTROYED () {0x80;}' unless defined(&TCL_TRACE_DESTROYED);
	eval 'sub TCL_INTERP_DESTROYED () {0x100;}' unless defined(&TCL_INTERP_DESTROYED);
	eval 'sub TCL_LEAVE_ERR_MSG () {0x200;}' unless defined(&TCL_LEAVE_ERR_MSG);
	eval 'sub TCL_TRACE_ARRAY () {0x800;}' unless defined(&TCL_TRACE_ARRAY);
	unless(defined(&TCL_NO_DEPRECATED)) {
	    eval 'sub TCL_PARSE_PART1 () {0x400;}' unless defined(&TCL_PARSE_PART1);
	}
	eval 'sub TCL_LINK_INT () {1;}' unless defined(&TCL_LINK_INT);
	eval 'sub TCL_LINK_DOUBLE () {2;}' unless defined(&TCL_LINK_DOUBLE);
	eval 'sub TCL_LINK_BOOLEAN () {3;}' unless defined(&TCL_LINK_BOOLEAN);
	eval 'sub TCL_LINK_STRING () {4;}' unless defined(&TCL_LINK_STRING);
	eval 'sub TCL_LINK_READ_ONLY () {0x80;}' unless defined(&TCL_LINK_READ_ONLY);
	if(defined(&__cplusplus)) {
	}
	eval 'sub TCL_SMALL_HASH_TABLE () {4;}' unless defined(&TCL_SMALL_HASH_TABLE);
	eval 'sub TCL_STRING_KEYS () {0;}' unless defined(&TCL_STRING_KEYS);
	eval 'sub TCL_ONE_WORD_KEYS () {1;}' unless defined(&TCL_ONE_WORD_KEYS);
	eval 'sub Tcl_GetHashValue {
	    my($h) = @_;
    	    eval q((($h)-> &clientData));
	}' unless defined(&Tcl_GetHashValue);
	eval 'sub Tcl_SetHashValue {
	    my($h, $value) = @_;
    	    eval q((($h)-> &clientData = ( &ClientData) ($value)));
	}' unless defined(&Tcl_SetHashValue);
	eval 'sub Tcl_GetHashKey {
	    my($tablePtr, $h) = @_;
    	    eval q(( ((($tablePtr)-> &keyType ==  &TCL_ONE_WORD_KEYS) ? ($h)-> ($key->{oneWordValue})  : ($h)-> ($key->{string}))));
	}' unless defined(&Tcl_GetHashKey);
	eval 'sub Tcl_FindHashEntry {
	    my($tablePtr, $key) = @_;
    	    eval q((*(($tablePtr)-> &findProc))($tablePtr, $key));
	}' unless defined(&Tcl_FindHashEntry);
	eval 'sub Tcl_CreateHashEntry {
	    my($tablePtr, $key, $newPtr) = @_;
    	    eval q((*(($tablePtr)-> &createProc))($tablePtr, $key, $newPtr));
	}' unless defined(&Tcl_CreateHashEntry);
	eval 'sub TCL_DONT_WAIT () {(1<<1);}' unless defined(&TCL_DONT_WAIT);
	eval 'sub TCL_WINDOW_EVENTS () {(1<<2);}' unless defined(&TCL_WINDOW_EVENTS);
	eval 'sub TCL_FILE_EVENTS () {(1<<3);}' unless defined(&TCL_FILE_EVENTS);
	eval 'sub TCL_TIMER_EVENTS () {(1<<4);}' unless defined(&TCL_TIMER_EVENTS);
	eval 'sub TCL_IDLE_EVENTS () {(1<<5);}' unless defined(&TCL_IDLE_EVENTS);
	eval 'sub TCL_ALL_EVENTS () {(~ &TCL_DONT_WAIT);}' unless defined(&TCL_ALL_EVENTS);
	eval("sub TCL_QUEUE_TAIL () { 0; }") unless defined(&TCL_QUEUE_TAIL);
	eval("sub TCL_QUEUE_HEAD () { 1; }") unless defined(&TCL_QUEUE_HEAD);
	eval("sub TCL_QUEUE_MARK () { 2; }") unless defined(&TCL_QUEUE_MARK);
	eval 'sub TCL_SERVICE_NONE () {0;}' unless defined(&TCL_SERVICE_NONE);
	eval 'sub TCL_SERVICE_ALL () {1;}' unless defined(&TCL_SERVICE_ALL);
	eval 'sub TCL_READABLE () {(1<<1);}' unless defined(&TCL_READABLE);
	eval 'sub TCL_WRITABLE () {(1<<2);}' unless defined(&TCL_WRITABLE);
	eval 'sub TCL_EXCEPTION () {(1<<3);}' unless defined(&TCL_EXCEPTION);
	eval 'sub TCL_STDIN () {(1<<1);}' unless defined(&TCL_STDIN);
	eval 'sub TCL_STDOUT () {(1<<2);}' unless defined(&TCL_STDOUT);
	eval 'sub TCL_STDERR () {(1<<3);}' unless defined(&TCL_STDERR);
	eval 'sub TCL_ENFORCE_MODE () {(1<<4);}' unless defined(&TCL_ENFORCE_MODE);
	eval 'sub TCL_CLOSE_READ () {(1<<1);}' unless defined(&TCL_CLOSE_READ);
	eval 'sub TCL_CLOSE_WRITE () {(1<<2);}' unless defined(&TCL_CLOSE_WRITE);
	eval 'sub TCL_CLOSE2PROC () {(( &Tcl_DriverCloseProc *)1);}' unless defined(&TCL_CLOSE2PROC);
	eval 'sub TCL_CHANNEL_VERSION_1 () {(( &Tcl_ChannelTypeVersion) 0x1);}' unless defined(&TCL_CHANNEL_VERSION_1);
	eval 'sub TCL_CHANNEL_VERSION_2 () {(( &Tcl_ChannelTypeVersion) 0x2);}' unless defined(&TCL_CHANNEL_VERSION_2);
	if(defined(&TCL_MEM_DEBUG)) {
	    eval 'sub ckalloc {
	        my($x) = @_;
    		eval q( &Tcl_DbCkalloc($x,  &__FILE__,  &__LINE__));
	    }' unless defined(&ckalloc);
	    eval 'sub ckfree {
	        my($x) = @_;
    		eval q( &Tcl_DbCkfree($x,  &__FILE__,  &__LINE__));
	    }' unless defined(&ckfree);
	    eval 'sub ckrealloc {
	        my($x,$y) = @_;
    		eval q( &Tcl_DbCkrealloc(($x), ($y), &__FILE__,  &__LINE__));
	    }' unless defined(&ckrealloc);
	} else {
	    eval 'sub ckalloc {
	        my($x) = @_;
    		eval q( &Tcl_Alloc($x));
	    }' unless defined(&ckalloc);
	    eval 'sub ckfree {
	        my($x) = @_;
    		eval q( &Tcl_Free($x));
	    }' unless defined(&ckfree);
	    eval 'sub ckrealloc {
	        my($x,$y) = @_;
    		eval q( &Tcl_Realloc($x,$y));
	    }' unless defined(&ckrealloc);
	    eval 'sub Tcl_InitMemory {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&Tcl_InitMemory);
	    eval 'sub Tcl_DumpActiveMemory {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&Tcl_DumpActiveMemory);
	    eval 'sub Tcl_ValidateAllMemory {
	        my($x,$y) = @_;
    		eval q();
	    }' unless defined(&Tcl_ValidateAllMemory);
	}
	eval("sub TCL_TRANSLATE_AUTO () { 0; }") unless defined(&TCL_TRANSLATE_AUTO);
	eval("sub TCL_TRANSLATE_CR () { 1; }") unless defined(&TCL_TRANSLATE_CR);
	eval("sub TCL_TRANSLATE_LF () { 2; }") unless defined(&TCL_TRANSLATE_LF);
	eval("sub TCL_TRANSLATE_CRLF () { 3; }") unless defined(&TCL_TRANSLATE_CRLF);
	eval 'sub TCL_MODE_BLOCKING () {0;}' unless defined(&TCL_MODE_BLOCKING);
	eval 'sub TCL_MODE_NONBLOCKING () {1;}' unless defined(&TCL_MODE_NONBLOCKING);
	eval("sub TCL_PATH_ABSOLUTE () { 0; }") unless defined(&TCL_PATH_ABSOLUTE);
	eval("sub TCL_PATH_RELATIVE () { 1; }") unless defined(&TCL_PATH_RELATIVE);
	eval("sub TCL_PATH_VOLUME_RELATIVE () { 2; }") unless defined(&TCL_PATH_VOLUME_RELATIVE);
	eval 'sub TCL_ENCODING_START () {0x1;}' unless defined(&TCL_ENCODING_START);
	eval 'sub TCL_ENCODING_END () {0x2;}' unless defined(&TCL_ENCODING_END);
	eval 'sub TCL_ENCODING_STOPONERROR () {0x4;}' unless defined(&TCL_ENCODING_STOPONERROR);
	eval 'sub TCL_TOKEN_WORD () {1;}' unless defined(&TCL_TOKEN_WORD);
	eval 'sub TCL_TOKEN_SIMPLE_WORD () {2;}' unless defined(&TCL_TOKEN_SIMPLE_WORD);
	eval 'sub TCL_TOKEN_TEXT () {4;}' unless defined(&TCL_TOKEN_TEXT);
	eval 'sub TCL_TOKEN_BS () {8;}' unless defined(&TCL_TOKEN_BS);
	eval 'sub TCL_TOKEN_COMMAND () {16;}' unless defined(&TCL_TOKEN_COMMAND);
	eval 'sub TCL_TOKEN_VARIABLE () {32;}' unless defined(&TCL_TOKEN_VARIABLE);
	eval 'sub TCL_TOKEN_SUB_EXPR () {64;}' unless defined(&TCL_TOKEN_SUB_EXPR);
	eval 'sub TCL_TOKEN_OPERATOR () {128;}' unless defined(&TCL_TOKEN_OPERATOR);
	eval 'sub TCL_PARSE_SUCCESS () {0;}' unless defined(&TCL_PARSE_SUCCESS);
	eval 'sub TCL_PARSE_QUOTE_EXTRA () {1;}' unless defined(&TCL_PARSE_QUOTE_EXTRA);
	eval 'sub TCL_PARSE_BRACE_EXTRA () {2;}' unless defined(&TCL_PARSE_BRACE_EXTRA);
	eval 'sub TCL_PARSE_MISSING_BRACE () {3;}' unless defined(&TCL_PARSE_MISSING_BRACE);
	eval 'sub TCL_PARSE_MISSING_BRACKET () {4;}' unless defined(&TCL_PARSE_MISSING_BRACKET);
	eval 'sub TCL_PARSE_MISSING_PAREN () {5;}' unless defined(&TCL_PARSE_MISSING_PAREN);
	eval 'sub TCL_PARSE_MISSING_QUOTE () {6;}' unless defined(&TCL_PARSE_MISSING_QUOTE);
	eval 'sub TCL_PARSE_MISSING_VAR_BRACE () {7;}' unless defined(&TCL_PARSE_MISSING_VAR_BRACE);
	eval 'sub TCL_PARSE_SYNTAX () {8;}' unless defined(&TCL_PARSE_SYNTAX);
	eval 'sub TCL_PARSE_BAD_NUMBER () {9;}' unless defined(&TCL_PARSE_BAD_NUMBER);
	eval 'sub NUM_STATIC_TOKENS () {20;}' unless defined(&NUM_STATIC_TOKENS);
	eval 'sub TCL_CONVERT_MULTIBYTE () {-1;}' unless defined(&TCL_CONVERT_MULTIBYTE);
	eval 'sub TCL_CONVERT_SYNTAX () {-2;}' unless defined(&TCL_CONVERT_SYNTAX);
	eval 'sub TCL_CONVERT_UNKNOWN () {-3;}' unless defined(&TCL_CONVERT_UNKNOWN);
	eval 'sub TCL_CONVERT_NOSPACE () {-4;}' unless defined(&TCL_CONVERT_NOSPACE);
	eval 'sub TCL_UTF_MAX () {3;}' unless defined(&TCL_UTF_MAX);
	unless(defined(&TCL_NO_DEPRECATED)) {
	    eval 'sub Tcl_EvalObj {
	        my($interp,$objPtr) = @_;
    		eval q( &Tcl_EvalObjEx(($interp),($objPtr),0));
	    }' unless defined(&Tcl_EvalObj);
	    eval 'sub Tcl_GlobalEvalObj {
	        my($interp,$objPtr) = @_;
    		eval q( &Tcl_EvalObjEx(($interp),($objPtr), &TCL_EVAL_GLOBAL));
	    }' unless defined(&Tcl_GlobalEvalObj);
	}
	eval 'sub Tcl_Ckalloc () { &Tcl_Alloc;}' unless defined(&Tcl_Ckalloc);
	eval 'sub Tcl_Ckfree () { &Tcl_Free;}' unless defined(&Tcl_Ckfree);
	eval 'sub Tcl_Ckrealloc () { &Tcl_Realloc;}' unless defined(&Tcl_Ckrealloc);
	eval 'sub Tcl_Return () { &Tcl_SetResult;}' unless defined(&Tcl_Return);
	eval 'sub Tcl_TildeSubst () { &Tcl_TranslateFileName;}' unless defined(&Tcl_TildeSubst);
	eval 'sub panic () { &Tcl_Panic;}' unless defined(&panic);
	eval 'sub panicVA () { &Tcl_PanicVA;}' unless defined(&panicVA);
	eval 'sub TCL_STUB_MAGIC () {0xfca3bacf;}' unless defined(&TCL_STUB_MAGIC);
	unless(defined(&USE_TCL_STUBS)) {
	    eval 'sub Tcl_InitStubs {
	        my($interp, $version, $exact) = @_;
    		eval q( &Tcl_PkgRequire($interp, \\"Tcl\\", $version, $exact));
	    }' unless defined(&Tcl_InitStubs);
	}
	require 'tclDecls.ph';
	undef(&TCL_STORAGE_CLASS) if defined(&TCL_STORAGE_CLASS);
	eval 'sub TCL_STORAGE_CLASS () {1;}' unless defined(&TCL_STORAGE_CLASS);
    }
    undef(&TCL_STORAGE_CLASS) if defined(&TCL_STORAGE_CLASS);
    eval 'sub TCL_STORAGE_CLASS () { &DLLIMPORT;}' unless defined(&TCL_STORAGE_CLASS);
    if(defined(&__cplusplus)) {
    }
}
1;
