require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_ASM_LINKAGE_H)) {
    eval 'sub _SYS_ASM_LINKAGE_H () {1;}' unless defined(&_SYS_ASM_LINKAGE_H);
    require 'sys/stack.ph';
    require 'sys/trap.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_ASM)) {
	if(defined(&__sparcv9)) {
	    eval 'sub CPTRSHIFT () {3;}' unless defined(&CPTRSHIFT);
	    eval 'sub CLONGSHIFT () {3;}' unless defined(&CLONGSHIFT);
	} else {
	    eval 'sub CPTRSHIFT () {2;}' unless defined(&CPTRSHIFT);
	    eval 'sub CLONGSHIFT () {2;}' unless defined(&CLONGSHIFT);
	}
	eval 'sub CPTRSIZE () {(1<< &CPTRSHIFT);}' unless defined(&CPTRSIZE);
	eval 'sub CLONGSIZE () {(1<< &CLONGSHIFT);}' unless defined(&CLONGSIZE);
	eval 'sub CPTRMASK () {( &CPTRSIZE - 1);}' unless defined(&CPTRMASK);
	eval 'sub CLONGMASK () {( &CLONGSIZE - 1);}' unless defined(&CLONGMASK);
	eval 'sub RODATA () {".rodata";}' unless defined(&RODATA);
	if(defined(&GPROF)) {
	    eval 'sub MCOUNT_SIZE () {(4*4);}' unless defined(&MCOUNT_SIZE);
	    eval 'sub MCOUNT {
	        my($x) = @_;
    		eval q( &save % &sp, - &SA( &MINFRAME), % &sp;  &call  &_mcount;  &nop;  &restore;);
	    }' unless defined(&MCOUNT);
	}
	if(defined(&PROF)) {
	    eval 'sub MCOUNT_SIZE () {(5*4);}' unless defined(&MCOUNT_SIZE);
	    eval 'sub MCOUNT {
	        my($x) = @_;
    		eval q( &save % &sp, - &SA( &MINFRAME), % &sp;  &sethi % &hi(. &L_ $x 1), % &o0;  &call  &_mcount;  &or % &o0, % &lo(. &L_ $x 1), % &o0;  &restore; . &common . &L_ $x 1, 4, 4);
	    }' unless defined(&MCOUNT);
	}
	if(!defined( &PROF)  && !defined( &GPROF)) {
	    eval 'sub MCOUNT_SIZE () {0;}' unless defined(&MCOUNT_SIZE);
	    eval 'sub MCOUNT {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&MCOUNT);
	}
	eval 'sub RTMCOUNT {
	    my($x) = @_;
    	    eval q( &MCOUNT($x));
	}' unless defined(&RTMCOUNT);
	eval 'sub ANSI_PRAGMA_WEAK {
	    my($sym, $stype) = @_;
    	    eval q(. &weak $sym; . &type $sym, $stype; $sym =  &_ $sym);
	}' unless defined(&ANSI_PRAGMA_WEAK);
	eval 'sub ENTRY {
	    my($x) = @_;
    	    eval q(. &section \\".text\\"; . &align 4; . &global $x; . &type $x,  &function; $x:  &MCOUNT($x));
	}' unless defined(&ENTRY);
	eval 'sub ENTRY_SIZE () { &MCOUNT_SIZE;}' unless defined(&ENTRY_SIZE);
	eval 'sub ENTRY_NP {
	    my($x) = @_;
    	    eval q(. &section \\".text\\"; . &align 4; . &global $x; . &type $x,  &function; $x:);
	}' unless defined(&ENTRY_NP);
	eval 'sub RTENTRY {
	    my($x) = @_;
    	    eval q(. &section \\".text\\"; . &align 4; . &global $x; . &type $x,  &function; $x:  &RTMCOUNT($x));
	}' unless defined(&RTENTRY);
	eval 'sub ENTRY2 {
	    my($x, $y) = @_;
    	    eval q(. &section \\".text\\"; . &align 4; . &global $x, $y; . &type $x,  &function; . &type $y,  &function; $x: ; $y:  &MCOUNT($x));
	}' unless defined(&ENTRY2);
	eval 'sub ENTRY_NP2 {
	    my($x, $y) = @_;
    	    eval q(. &section \\".text\\"; . &align 4; . &global $x, $y; . &type $x,  &function; . &type $y,  &function; $x: ; $y:);
	}' unless defined(&ENTRY_NP2);
	eval 'sub ALTENTRY {
	    my($x) = @_;
    	    eval q(. &global $x; . &type $x,  &function; $x:);
	}' unless defined(&ALTENTRY);
	eval 'sub DGDEF2 {
	    my($name, $sz) = @_;
    	    eval q(. &section \\".data\\"; . &global $name; . &type $name,  &object; . &size $name, $sz; $name:);
	}' unless defined(&DGDEF2);
	eval 'sub DGDEF3 {
	    my($name, $sz, $algn) = @_;
    	    eval q(. &section \\".data\\"; . &align $algn; . &global $name; . &type $name,  &object; . &size $name, $sz; $name:);
	}' unless defined(&DGDEF3);
	eval 'sub DGDEF {
	    my($name) = @_;
    	    eval q( &DGDEF3($name, 4, 4));
	}' unless defined(&DGDEF);
	eval 'sub SET_SIZE {
	    my($x) = @_;
    	    eval q(. &size $x, (.-$x));
	}' unless defined(&SET_SIZE);
	if(defined(&_KERNEL)) {
	    if(defined(&TRACE)) {
		require 'sys/vtrace.ph';
		eval 'sub TRACE_ASM_N {
		    my($scr, $fac, $tag, $name, $len, $trace_trap) = @_;
    		    eval q( &ld [ &THREAD_REG +  &T_CPU], % &o0;  &ld [% &o0 +  &CPU_TRACE_EVENT_MAP], % &o0;  &set  &FT2EVENT($fac, $tag), $scr;  &ldub [% &o0 + $scr], % &o0;  &andcc % &o0,  &VT_ENABLED, % &g0;  &bz . + 30*4;  &andcc % &o0,  &VT_USED, % &g0;  &bnz . + 26*4;  &sll $scr, 16, $scr;  &save % &sp, - &SA( &MINFRAME), % &sp;  &mov % &g1, % &l1;  &mov % &g2, % &l2;  &mov % &g3, % &l3;  &mov % &g4, % &l4;  &mov % &g5, % &l5;  &mov % &g6, % &l6;  &mov % &g7, % &l7;  &or % &g0, ($fac), % &o0;  &or % &g0, ($tag), % &o1;  &or % &g0, ($len), % &o2;  &sethi % &hi($name), % &o3;  &or % &o3, % &lo($name), % &o3;  &call  &trace_label;  &sub % &g0, 1, % &o4;  &mov % &o0, % &i0;  &mov % &l1, % &g1;  &mov % &l2, % &g2;  &mov % &l3, % &g3;  &mov % &l4, % &g4;  &mov % &l5, % &g5;  &mov % &l6, % &g6;  &mov % &l7, % &g7;  &restore;  &or % &o0, $scr, % &o0;  &ta $trace_trap;);
		}' unless defined(&TRACE_ASM_N);
		eval 'sub TRACE_ASM_0 {
		    my($scr, $fac, $tag, $name) = @_;
    		    eval q( &TRACE_ASM_N($scr, $fac, $tag, $name, 4,  &ST_TRACE_0));
		}' unless defined(&TRACE_ASM_0);
		eval 'sub TRACE_ASM_1 {
		    my($scr, $fac, $tag, $name, $d1) = @_;
    		    eval q( &mov $d1, % &o1;  &TRACE_ASM_N($scr, $fac, $tag, $name, 8,  &ST_TRACE_1));
		}' unless defined(&TRACE_ASM_1);
		eval 'sub TRACE_ASM_2 {
		    my($scr, $fac, $tag, $name, $d1, $d2) = @_;
    		    eval q( &mov $d1, % &o1;  &mov $d2, % &o2;  &TRACE_ASM_N($scr, $fac, $tag, $name, 12,  &ST_TRACE_2));
		}' unless defined(&TRACE_ASM_2);
		eval 'sub TRACE_ASM_3 {
		    my($scr, $fac, $tag, $name, $d1, $d2, $d3) = @_;
    		    eval q( &mov $d1, % &o1;  &mov $d2, % &o2;  &mov $d3, % &o3;  &TRACE_ASM_N($scr, $fac, $tag, $name, 16,  &ST_TRACE_3));
		}' unless defined(&TRACE_ASM_3);
		eval 'sub TRACE_ASM_4 {
		    my($scr, $fac, $tag, $name, $d1, $d2, $d3, $d4) = @_;
    		    eval q( &mov $d1, % &o1;  &mov $d2, % &o2;  &mov $d3, % &o3;  &mov $d4, % &o4;  &TRACE_ASM_N($scr, $fac, $tag, $name, 20,  &ST_TRACE_4));
		}' unless defined(&TRACE_ASM_4);
		eval 'sub TRACE_ASM_5 {
		    my($scr, $fac, $tag, $name, $d1, $d2, $d3, $d4, $d5) = @_;
    		    eval q( &mov $d1, % &o1;  &mov $d2, % &o2;  &mov $d3, % &o3;  &mov $d4, % &o4;  &mov $d5, % &o5;  &TRACE_ASM_N($scr, $fac, $tag, $name, 24,  &ST_TRACE_5));
		}' unless defined(&TRACE_ASM_5);
		if(defined(&_MACHDEP)) {
		    require 'sys/clock.ph';
		    eval 'sub TRACE_DUMP_HEAD {
		        my($event, $cpup, $headp, $time, $hrec, $escape) = @_;
    			eval q( &ld [$cpup +  &CPU_TRACE_THREAD], $hrec;  &ld [$cpup +  &CPU_THREAD], $time;  &cmp $time, $hrec;  &be . + 13*4;  &nop;  &tst $hrec;  &bnz . + 4*4;  &sethi % &hi( &FTT2HEAD( &TR_FAC_TRACE,  &TR_RAW_KTHREAD_ID, 0)), $hrec;  &b $escape;  &nop;  &st $time, [$cpup +  &CPU_TRACE_THREAD];  &ld [$cpup +  &CPU_TRACE_HEAD], $headp;  &st $hrec, [$headp +  &TRACE_KTID_HEAD];  &st $time, [$headp +  &TRACE_KTID_TID];  &add $headp,  &TRACE_KTID_SIZE, $headp;  &st $headp, [$cpup +  &CPU_TRACE_HEAD];  &GET_VTRACE_TIME($time, $headp, $hrec);  &ld [$cpup +  &CPU_TRACE_HRTIME], $hrec;  &ld [$cpup +  &CPU_TRACE_HEAD], $headp;  &st $time, [$cpup +  &CPU_TRACE_HRTIME];  &sub $time, $hrec, $time;  &srl $time, 16, $hrec;  &tst $hrec;  &bz . + 7*4;  &andn $event, 0xff, $hrec;  &st $time, [$headp +  &TRACE_ETIME_TIME];  &sethi % &hi( &FTT2HEAD( &TR_FAC_TRACE,  &TR_ELAPSED_TIME, 0)), $time;  &st $time, [$headp +  &TRACE_ETIME_HEAD];  &clr $time;  &add $headp,  &TRACE_ETIME_SIZE, $headp;  &or $hrec, $time, $hrec;  &st $hrec, [$headp];);
		    }' unless defined(&TRACE_DUMP_HEAD);
		    eval 'sub TRACE_STORE_STRING {
		        my($mask, $maskreg, $strptr, $headp, $scr1, $scr2) = @_;
    			eval q( &andcc $maskreg, $mask, % &g0;  &bz . + 20*4;  &clr $scr1;  &add $headp, 4, $headp;  &cmp $scr1,  &VT_MAX_BYTES - 5;  &blu . + 3*4;  &ldub [$strptr + $scr1], $scr2;  &clr $scr2;  &stb $scr2, [$headp + $scr1];  &tst $scr2;  &bnz . - 6*4;  &inc $scr1;  &sub $headp, 4, $headp;  &sethi % &hi( &bytes2data), $scr2;  &or $scr2, % &lo( &bytes2data), $scr2;  &sll $scr1, 2, $scr1;  &add $scr2, $scr1, $scr2;  &ld [$scr2], $scr1;  &st $scr1, [$headp];  &ld [$scr2 + 256*4], $scr1;  &add $headp, $scr1, $headp;);
		    }' unless defined(&TRACE_STORE_STRING);
		    eval 'sub TRACE_DUMP_TAIL {
		        my($cpup, $headp, $scr1, $scr2) = @_;
    			eval q( &ld [$cpup +  &CPU_TRACE_REDZONE], $scr1;  &andn $headp, 0xfff, $scr2;  &cmp $scr1, $scr2;  &bne . + 3*4;  &ld [$cpup +  &CPU_TRACE_WRAP], $scr1;  &st $headp, [$cpup +  &CPU_TRACE_OVERFLOW];  &cmp $headp, $scr1;  &blu . + 10*4;  &st $headp, [$cpup +  &CPU_TRACE_HEAD];  &sethi % &hi( &FTT2HEAD( &TR_FAC_TRACE,  &TR_PAD, 0)), $scr2;  &ld [$cpup +  &CPU_TRACE_END], $scr1;  &add $headp, 4, $headp;  &cmp $headp, $scr1;  &blu . - 2*4;  &st $scr2, [$headp - 4];  &ld [$cpup +  &CPU_TRACE_START], $headp;  &st $headp, [$cpup +  &CPU_TRACE_HEAD];);
		    }' unless defined(&TRACE_DUMP_TAIL);
		    eval 'sub TRACE_DUMP_0 {
		        my($event, $cpup, $headp, $scr1, $scr2) = @_;
    			eval q( &TRACE_DUMP_HEAD($event, $cpup, $headp, $scr1, $scr2,  &_trace_trap_ret);  &add $headp, 4, $headp;  &TRACE_DUMP_TAIL($cpup, $headp, $scr1, $scr2););
		    }' unless defined(&TRACE_DUMP_0);
		    eval 'sub TRACE_DUMP_1 {
		        my($event, $d1, $cpup, $headp, $scr1, $scr2) = @_;
    			eval q( &TRACE_DUMP_HEAD($event, $cpup, $headp, $scr1, $scr2,  &_trace_trap_ret);  &st $d1, [$headp + 4];  &add $headp, (1+ 1)*4, $headp;  &TRACE_STORE_STRING( &VT_STRING_1, $event, $d1, $headp, $scr1, $scr2);  &TRACE_DUMP_TAIL($cpup, $headp, $scr1, $scr2););
		    }' unless defined(&TRACE_DUMP_1);
		    eval 'sub TRACE_DUMP_2 {
		        my($event, $d1, $d2, $cpup, $headp, $scr1, $scr2) = @_;
    			eval q( &TRACE_DUMP_HEAD($event, $cpup, $headp, $scr1, $scr2,  &_trace_trap_ret);  &st $d1, [$headp + 4];  &st $d2, [$headp + 8];  &andcc $event,  &VT_STRING_MASK, % &g0;  &bz . + (2+ 2*21)*4;  &add $headp, (1+ 2)*4, $headp;  &TRACE_STORE_STRING( &VT_STRING_1, $event, $d1, $headp, $scr1, $scr2);  &TRACE_STORE_STRING( &VT_STRING_2, $event, $d2, $headp, $scr1, $scr2);  &TRACE_DUMP_TAIL($cpup, $headp, $scr1, $scr2););
		    }' unless defined(&TRACE_DUMP_2);
		    eval 'sub TRACE_DUMP_3 {
		        my($event, $d1, $d2, $d3, $cpup, $headp, $scr1, $scr2) = @_;
    			eval q( &TRACE_DUMP_HEAD($event, $cpup, $headp, $scr1, $scr2,  &_trace_trap_ret);  &st $d1, [$headp + 4];  &st $d2, [$headp + 8];  &st $d3, [$headp + 12];  &andcc $event,  &VT_STRING_MASK, % &g0;  &bz . + (2+ 3*21)*4;  &add $headp, (1+ 3)*4, $headp;  &TRACE_STORE_STRING( &VT_STRING_1, $event, $d1, $headp, $scr1, $scr2);  &TRACE_STORE_STRING( &VT_STRING_2, $event, $d2, $headp, $scr1, $scr2);  &TRACE_STORE_STRING( &VT_STRING_3, $event, $d3, $headp, $scr1, $scr2);  &TRACE_DUMP_TAIL($cpup, $headp, $scr1, $scr2););
		    }' unless defined(&TRACE_DUMP_3);
		    eval 'sub TRACE_DUMP_4 {
		        my($event, $d1, $d2, $d3, $d4, $cpup, $headp, $scr1, $scr2) = @_;
    			eval q( &TRACE_DUMP_HEAD($event, $cpup, $headp, $scr1, $scr2,  &_trace_trap_ret);  &st $d1, [$headp + 4];  &st $d2, [$headp + 8];  &st $d3, [$headp + 12];  &st $d4, [$headp + 16];  &andcc $event,  &VT_STRING_MASK, % &g0;  &bz . + (2+ 4*21)*4;  &add $headp, (1+ 4)*4, $headp;  &TRACE_STORE_STRING( &VT_STRING_1, $event, $d1, $headp, $scr1, $scr2);  &TRACE_STORE_STRING( &VT_STRING_2, $event, $d2, $headp, $scr1, $scr2);  &TRACE_STORE_STRING( &VT_STRING_3, $event, $d3, $headp, $scr1, $scr2);  &TRACE_STORE_STRING( &VT_STRING_4, $event, $d4, $headp, $scr1, $scr2);  &TRACE_DUMP_TAIL($cpup, $headp, $scr1, $scr2););
		    }' unless defined(&TRACE_DUMP_4);
		    eval 'sub TRACE_DUMP_5 {
		        my($event, $d1, $d2, $d3, $d4, $d5, $cpup, $headp, $scr1, $scr2) = @_;
    			eval q( &TRACE_DUMP_HEAD($event, $cpup, $headp, $scr1, $scr2,  &_trace_trap_ret);  &st $d1, [$headp + 4];  &st $d2, [$headp + 8];  &st $d3, [$headp + 12];  &st $d4, [$headp + 16];  &st $d5, [$headp + 20];  &andcc $event,  &VT_STRING_MASK, % &g0;  &bz . + (2+ 5*21)*4;  &add $headp, (1+ 5)*4, $headp;  &TRACE_STORE_STRING( &VT_STRING_1, $event, $d1, $headp, $scr1, $scr2);  &TRACE_STORE_STRING( &VT_STRING_2, $event, $d2, $headp, $scr1, $scr2);  &TRACE_STORE_STRING( &VT_STRING_3, $event, $d3, $headp, $scr1, $scr2);  &TRACE_STORE_STRING( &VT_STRING_4, $event, $d4, $headp, $scr1, $scr2);  &TRACE_STORE_STRING( &VT_STRING_5, $event, $d5, $headp, $scr1, $scr2);  &TRACE_DUMP_TAIL($cpup, $headp, $scr1, $scr2););
		    }' unless defined(&TRACE_DUMP_5);
		    eval 'sub VT_ASM_TEST_FT {
		        my($fac, $tag, $cpup, $event, $info) = @_;
    			eval q( &ld [$cpup +  &CPU_TRACE_EVENT_MAP], $info;  &set  &FT2EVENT($fac, $tag), $event;  &ldub [$info + $event], $info;  &andcc $info,  &VT_ENABLED, % &g0;);
		    }' unless defined(&VT_ASM_TEST_FT);
		    eval 'sub TRACE_SYS_TRAP_START {
		        my($type, $cpup, $event, $headp, $scr1, $scr2) = @_;
    			eval q( &CPU_ADDR($cpup, $scr1);  &VT_ASM_TEST_FT( &TR_FAC_TRAP,  &TR_TRAP_START, $cpup, $event, $scr1);  &bz 5 &f;  &sll $event, 16, $event;  &TRACE_DUMP_HEAD($event, $cpup, $headp, $scr1, $scr2, 5 &f);  &st $type, [$headp + 4];  &add $headp, (1+ 1)*4, $headp;  &TRACE_DUMP_TAIL($cpup, $headp, $scr1, $scr2); 5:);
		    }' unless defined(&TRACE_SYS_TRAP_START);
		    eval 'sub TRACE_SYS_TRAP_END {
		        my($cpup, $event, $headp, $scr1, $scr2) = @_;
    			eval q( &CPU_ADDR($cpup, $scr1);  &VT_ASM_TEST_FT( &TR_FAC_TRAP,  &TR_TRAP_END, $cpup, $event, $scr1);  &bz 5 &f;  &sll $event, 16, $event;  &TRACE_DUMP_HEAD($event, $cpup, $headp, $scr1, $scr2, 5 &f);  &add $headp, 4, $headp;  &TRACE_DUMP_TAIL($cpup, $headp, $scr1, $scr2); 5:);
		    }' unless defined(&TRACE_SYS_TRAP_END);
		}
	    } else {
		eval 'sub TRACE_ASM_0 {
		    my($scr, $fac, $tag, $name) = @_;
    		    eval q();
		}' unless defined(&TRACE_ASM_0);
		eval 'sub TRACE_ASM_1 {
		    my($scr, $fac, $tag, $name, $d1) = @_;
    		    eval q();
		}' unless defined(&TRACE_ASM_1);
		eval 'sub TRACE_ASM_2 {
		    my($scr, $fac, $tag, $name, $d1, $d2) = @_;
    		    eval q();
		}' unless defined(&TRACE_ASM_2);
		eval 'sub TRACE_ASM_3 {
		    my($scr, $fac, $tag, $name, $d1, $d2, $d3) = @_;
    		    eval q();
		}' unless defined(&TRACE_ASM_3);
		eval 'sub TRACE_ASM_4 {
		    my($scr, $fac, $tag, $name, $d1, $d2, $d3, $d4) = @_;
    		    eval q();
		}' unless defined(&TRACE_ASM_4);
		eval 'sub TRACE_ASM_5 {
		    my($scr, $fac, $tag, $name, $d1, $d2, $d3, $d4, $d5) = @_;
    		    eval q();
		}' unless defined(&TRACE_ASM_5);
	    }
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
