require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_BOOTCONF_H)) {
    eval 'sub _SYS_BOOTCONF_H () {1;}' unless defined(&_SYS_BOOTCONF_H);
    require 'sys/types.ph';
    require 'sys/memlist.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub BO_NO_ALIGN () {0x1000;}' unless defined(&BO_NO_ALIGN);
    eval 'sub BO_ALIGN_L3 () {0x1000;}' unless defined(&BO_ALIGN_L3);
    eval 'sub BO_ALIGN_L2 () {0x40000;}' unless defined(&BO_ALIGN_L2);
    eval 'sub BO_ALIGN_L1 () {0x1000000;}' unless defined(&BO_ALIGN_L1);
    eval 'sub BO_VERSION () {9;}' unless defined(&BO_VERSION);
    eval 'sub BOOTOPS_ARE_1275 {
        my($bop) = @_;
	    eval q((( &BOP_GETVERSION($bop)) >= 9 && ( ($bop->{bsys_1275_call}) != 0)));
    }' unless defined(&BOOTOPS_ARE_1275);
    unless(defined(&_LP64)) {
    }
    eval 'sub BOP_GETVERSION {
        my($bop) = @_;
	    eval q( &bop_getversion($bop));
    }' unless defined(&BOP_GETVERSION);
    eval 'sub BOP_OPEN {
        my($bop, $s, $flags) = @_;
	    eval q( &bop_open($bop, $s, $flags));
    }' unless defined(&BOP_OPEN);
    eval 'sub BOP_READ {
        my($bop, $fd, $buf, $size) = @_;
	    eval q( &bop_read($bop, $fd, $buf, $size));
    }' unless defined(&BOP_READ);
    eval 'sub BOP_SEEK {
        my($bop, $fd, $hi, $lo) = @_;
	    eval q( &bop_seek($bop, $fd, $hi, $lo));
    }' unless defined(&BOP_SEEK);
    eval 'sub BOP_CLOSE {
        my($bop, $fd) = @_;
	    eval q( &bop_close($bop, $fd));
    }' unless defined(&BOP_CLOSE);
    eval 'sub BOP_ALLOC {
        my($bop, $virthint, $size, $align) = @_;
	    eval q( &bop_alloc($bop, $virthint, $size, $align));
    }' unless defined(&BOP_ALLOC);
    eval 'sub BOP_FREE {
        my($bop, $virt, $size) = @_;
	    eval q( &bop_free($bop, $virt, $size));
    }' unless defined(&BOP_FREE);
    eval 'sub BOP_MAP {
        my($bop, $virt, $space, $phys, $size) = @_;
	    eval q( &bop_map($bop, $virt, $space, $phys, $size));
    }' unless defined(&BOP_MAP);
    eval 'sub BOP_UNMAP {
        my($bop, $virt, $size) = @_;
	    eval q( &bop_unmap($bop, $virt, $size));
    }' unless defined(&BOP_UNMAP);
    eval 'sub BOP_QUIESCE_IO {
        my($bop) = @_;
	    eval q( &bop_quiesce_io($bop));
    }' unless defined(&BOP_QUIESCE_IO);
    eval 'sub BOP_GETPROPLEN {
        my($bop, $name) = @_;
	    eval q( &bop_getproplen($bop, $name));
    }' unless defined(&BOP_GETPROPLEN);
    eval 'sub BOP_GETPROP {
        my($bop, $name, $buf) = @_;
	    eval q( &bop_getprop($bop, $name, $buf));
    }' unless defined(&BOP_GETPROP);
    eval 'sub BOP_NEXTPROP {
        my($bop, $prev) = @_;
	    eval q( &bop_nextprop($bop, $prev));
    }' unless defined(&BOP_NEXTPROP);
    eval 'sub BOP_MOUNTROOT {
        my($bop, $path) = @_;
	    eval q( &bop_mountroot($bop, $path));
    }' unless defined(&BOP_MOUNTROOT);
    eval 'sub BOP_UNMOUNTROOT {
        my($bop) = @_;
	    eval q( &bop_unmountroot($bop));
    }' unless defined(&BOP_UNMOUNTROOT);
    eval 'sub BOP_PUTS {
        my($bop, $msg) = @_;
	    eval q( &bop_puts($bop, $msg));
    }' unless defined(&BOP_PUTS);
    eval 'sub BOP_PUTSARG {
        my($bop, $msg, $arg) = @_;
	    eval q( &bop_putsarg($bop, $msg, $arg));
    }' unless defined(&BOP_PUTSARG);
    eval 'sub boot_ptr2cell {
        my($p) = @_;
	    eval q((( &boot_cell_t)(( &uintptr_t)(( &void *)($p)))));
    }' unless defined(&boot_ptr2cell);
    eval 'sub boot_int2cell {
        my($i) = @_;
	    eval q((( &boot_cell_t)(($i))));
    }' unless defined(&boot_int2cell);
    eval 'sub boot_uint2cell {
        my($u) = @_;
	    eval q((( &boot_cell_t)(($u))));
    }' unless defined(&boot_uint2cell);
    eval 'sub boot_uint642cell {
        my($u) = @_;
	    eval q((( &boot_cell_t)(( &uint64_t)($u))));
    }' unless defined(&boot_uint642cell);
    eval 'sub boot_offt2cell {
        my($u) = @_;
	    eval q((( &boot_cell_t)(( &off_t)($u))));
    }' unless defined(&boot_offt2cell);
    eval 'sub boot_size2cell {
        my($u) = @_;
	    eval q((( &boot_cell_t)(($u))));
    }' unless defined(&boot_size2cell);
    eval 'sub boot_phandle2cell {
        my($ph) = @_;
	    eval q((( &boot_cell_t)((( &phandle_t)($ph)))));
    }' unless defined(&boot_phandle2cell);
    eval 'sub boot_dnode2cell {
        my($d) = @_;
	    eval q((( &boot_cell_t)((( &dnode_t)($d)))));
    }' unless defined(&boot_dnode2cell);
    eval 'sub boot_ihandle2cell {
        my($ih) = @_;
	    eval q((( &boot_cell_t)((( &ihandle_t)($ih)))));
    }' unless defined(&boot_ihandle2cell);
    eval 'sub boot_cell2ptr {
        my($p) = @_;
	    eval q((( &void *)(( &boot_cell_t)($p))));
    }' unless defined(&boot_cell2ptr);
    eval 'sub boot_cell2int {
        my($i) = @_;
	    eval q(((( &boot_cell_t)($i))));
    }' unless defined(&boot_cell2int);
    eval 'sub boot_cell2uint {
        my($u) = @_;
	    eval q(((( &boot_cell_t)($u))));
    }' unless defined(&boot_cell2uint);
    eval 'sub boot_cell2uint64 {
        my($u) = @_;
	    eval q((( &uint64_t)(( &boot_cell_t)($u))));
    }' unless defined(&boot_cell2uint64);
    eval 'sub boot_cell2offt {
        my($u) = @_;
	    eval q((( &off_t)(( &boot_cell_t)($u))));
    }' unless defined(&boot_cell2offt);
    eval 'sub boot_cell2size {
        my($u) = @_;
	    eval q(((( &boot_cell_t)($u))));
    }' unless defined(&boot_cell2size);
    eval 'sub boot_cell2phandle {
        my($ph) = @_;
	    eval q((( &phandle_t)(( &boot_cell_t)($ph))));
    }' unless defined(&boot_cell2phandle);
    eval 'sub boot_cell2dnode {
        my($d) = @_;
	    eval q((( &dnode_t)(( &boot_cell_t)($d))));
    }' unless defined(&boot_cell2dnode);
    eval 'sub boot_cell2ihandle {
        my($ih) = @_;
	    eval q((( &ihandle_t)(( &boot_cell_t)($ih))));
    }' unless defined(&boot_cell2ihandle);
    eval 'sub boot_cells2ull {
        my($h, $l) = @_;
	    eval q((( &boot_cell_t)($l)));
    }' unless defined(&boot_cells2ull);
    eval 'sub BOOT_SVC_FAIL () {(-1);}' unless defined(&BOOT_SVC_FAIL);
    eval 'sub BOOT_SVC_OK () {(1);}' unless defined(&BOOT_SVC_OK);
    if(defined( &_KERNEL)  && !defined( &_BOOT)) {
	eval 'sub BO_MAXFSNAME () {16;}' unless defined(&BO_MAXFSNAME);
	eval 'sub BO_MAXOBJNAME () {256;}' unless defined(&BO_MAXOBJNAME);
	eval 'sub BO_VALID () {0x1;}' unless defined(&BO_VALID);
	eval 'sub BO_BUSY () {0x2;}' unless defined(&BO_BUSY);
    }
    if(defined( &_BOOT)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
