require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_CPUVAR_H)) {
    eval 'sub _SYS_CPUVAR_H () {1;}' unless defined(&_SYS_CPUVAR_H);
    require 'sys/thread.ph';
    require 'sys/sysinfo.ph';
    require 'sys/disp.ph';
    require 'sys/processor.ph';
    if((defined( &_KERNEL) || defined( &_KMEMUSER))  && defined( &_MACHDEP)) {
	require 'sys/machcpuvar.ph';
    }
    require 'sys/types.ph';
    require 'sys/file.ph';
    require 'sys/bitmap.ph';
    require 'sys/task.ph';
    if(defined(&__cplusplus)) {
    }
    if((defined( &_KERNEL) || defined( &_KMEMUSER))  && defined( &_MACHDEP)) {
    }
    eval 'sub INTR_STACK_SIZE () { &MAX(8192,  &PAGESIZE);}' unless defined(&INTR_STACK_SIZE);
    eval 'sub CPU_RUNNING () {0x1;}' unless defined(&CPU_RUNNING);
    eval 'sub CPU_READY () {0x2;}' unless defined(&CPU_READY);
    eval 'sub CPU_QUIESCED () {0x4;}' unless defined(&CPU_QUIESCED);
    eval 'sub CPU_EXISTS () {0x8;}' unless defined(&CPU_EXISTS);
    eval 'sub CPU_ENABLE () {0x10;}' unless defined(&CPU_ENABLE);
    eval 'sub CPU_OFFLINE () {0x20;}' unless defined(&CPU_OFFLINE);
    eval 'sub CPU_POWEROFF () {0x40;}' unless defined(&CPU_POWEROFF);
    eval 'sub CPU_ACTIVE {
        my($cpu) = @_;
	    eval q(((($cpu)-> &cpu_flags &  &CPU_OFFLINE) == 0));
    }' unless defined(&CPU_ACTIVE);
    if((defined( &_KERNEL) || defined( &_KMEMUSER))  && defined( &_MACHDEP)) {
	eval 'sub CPUSET_WORDS () { &BT_BITOUL( &NCPU);}' unless defined(&CPUSET_WORDS);
	if((defined(&CPUSET_WORDS) ? &CPUSET_WORDS : 0) > 1) {
	    eval 'sub CPUSET_ALL {
	        my($set) = @_;
    		eval q( &cpuset_all(($set)));
	    }' unless defined(&CPUSET_ALL);
	    eval 'sub CPUSET_ALL_BUT {
	        my($set, $cpu) = @_;
    		eval q( &cpuset_all_but(($set), $cpu));
	    }' unless defined(&CPUSET_ALL_BUT);
	    eval 'sub CPUSET_ONLY {
	        my($set) = @_;
    		eval q( &cpuset_only(($set),  &cpu));
	    }' unless defined(&CPUSET_ONLY);
	    eval 'sub CPU_IN_SET {
	        my($set, $cpu) = @_;
    		eval q( &BT_TEST(($set). &cpub, $cpu));
	    }' unless defined(&CPU_IN_SET);
	    eval 'sub CPUSET_ADD {
	        my($set, $cpu) = @_;
    		eval q( &BT_SET(($set). &cpub, $cpu));
	    }' unless defined(&CPUSET_ADD);
	    eval 'sub CPUSET_DEL {
	        my($set, $cpu) = @_;
    		eval q( &BT_CLEAR(($set). &cpub, $cpu));
	    }' unless defined(&CPUSET_DEL);
	    eval 'sub CPUSET_ISNULL {
	        my($set) = @_;
    		eval q( &cpuset_isnull(($set)));
	    }' unless defined(&CPUSET_ISNULL);
	    eval 'sub CPUSET_ISEQUAL {
	        my($set1, $set2) = @_;
    		eval q( &cpuset_cmp(($set1), ($set2)));
	    }' unless defined(&CPUSET_ISEQUAL);
	    eval 'sub CPUSET_OR {
	        my($set1, $set2) = @_;
    		eval q({ \'int\'  &_i;  &for ( &_i = 0;  &_i <  &CPUSET_WORDS;  &_i++) ($set1). $cpub[ &_i] |= ($set2). $cpub[ &_i]; });
	    }' unless defined(&CPUSET_OR);
	    eval 'sub CPUSET_AND {
	        my($set1, $set2) = @_;
    		eval q({ \'int\'  &_i;  &for ( &_i = 0;  &_i <  &CPUSET_WORDS;  &_i++) ($set1). $cpub[ &_i] &= ($set2). $cpub[ &_i]; });
	    }' unless defined(&CPUSET_AND);
	    eval 'sub CPUSET_ZERO {
	        my($set) = @_;
    		eval q({ \'int\'  &_i;  &for ( &_i = 0;  &_i <  &CPUSET_WORDS;  &_i++) ($set). $cpub[ &_i] = 0; });
	    }' unless defined(&CPUSET_ZERO);
	}
 elsif((defined(&CPUSET_WORDS) ? &CPUSET_WORDS : 0) == 1) {
	    eval 'sub CPUSET {
	        my($cpu) = @_;
    		eval q((1 << ($cpu)));
	    }' unless defined(&CPUSET);
	    eval 'sub CPUSET_ALL {
	        my($set) = @_;
    		eval q((( &void)(($set) = ~0)));
	    }' unless defined(&CPUSET_ALL);
	    eval 'sub CPUSET_ALL_BUT {
	        my($set, $cpu) = @_;
    		eval q((( &void)(($set) = ~ &CPUSET($cpu))));
	    }' unless defined(&CPUSET_ALL_BUT);
	    eval 'sub CPUSET_ONLY {
	        my($set, $cpu) = @_;
    		eval q((( &void)(($set) =  &CPUSET($cpu))));
	    }' unless defined(&CPUSET_ONLY);
	    eval 'sub CPU_IN_SET {
	        my($set, $cpu) = @_;
    		eval q((($set) &  &CPUSET($cpu)));
	    }' unless defined(&CPU_IN_SET);
	    eval 'sub CPUSET_ADD {
	        my($set, $cpu) = @_;
    		eval q((( &void)(($set) |=  &CPUSET($cpu))));
	    }' unless defined(&CPUSET_ADD);
	    eval 'sub CPUSET_DEL {
	        my($set, $cpu) = @_;
    		eval q((( &void)(($set) &= ~ &CPUSET($cpu))));
	    }' unless defined(&CPUSET_DEL);
	    eval 'sub CPUSET_ISNULL {
	        my($set) = @_;
    		eval q((($set) == 0));
	    }' unless defined(&CPUSET_ISNULL);
	    eval 'sub CPUSET_ISEQUAL {
	        my($set1, $set2) = @_;
    		eval q((($set1) == ($set2)));
	    }' unless defined(&CPUSET_ISEQUAL);
	    eval 'sub CPUSET_OR {
	        my($set1, $set2) = @_;
    		eval q((( &void)(($set1) |= ($set2))));
	    }' unless defined(&CPUSET_OR);
	    eval 'sub CPUSET_AND {
	        my($set1, $set2) = @_;
    		eval q((( &void)(($set1) &= ($set2))));
	    }' unless defined(&CPUSET_AND);
	    eval 'sub CPUSET_ZERO {
	        my($set) = @_;
    		eval q((( &void)(($set) = 0)));
	    }' unless defined(&CPUSET_ZERO);
	} else {
	    die("NCPU\ is\ undefined\ or\ invalid");
	}
    }
    eval 'sub CPU_CPR_ONLINE () {0x1;}' unless defined(&CPU_CPR_ONLINE);
    eval 'sub CPU_CPR_IS_OFFLINE {
        my($cpu) = @_;
	    eval q(((($cpu)-> &cpu_cpr_flags &  &CPU_CPR_ONLINE) == 0));
    }' unless defined(&CPU_CPR_IS_OFFLINE);
    eval 'sub CPU_SET_CPR_FLAGS {
        my($cpu, $flag) = @_;
	    eval q((($cpu)-> &cpu_cpr_flags |= $flag));
    }' unless defined(&CPU_SET_CPR_FLAGS);
    if(defined( &i386) || defined( &__i386)) {
	eval 'sub CPU () {( &curcpup());}' unless defined(&CPU);
    } else {
	eval 'sub CPU () {( ($curthread->{t_cpu}));}' unless defined(&CPU);
    }
    eval 'sub CPU_CURRENT () {-3;}' unless defined(&CPU_CURRENT);
    eval 'sub CPU_STAT_ENTER_K () {
        eval q( &kpreempt_disable());
    }' unless defined(&CPU_STAT_ENTER_K);
    eval 'sub CPU_STAT_EXIT_K () {
        eval q( &kpreempt_enable());
    }' unless defined(&CPU_STAT_EXIT_K);
    eval 'sub CPU_STAT_ADD_K {
        my($thing, $amount) = @_;
	    eval q({  &kpreempt_disable();  &CPU_STAT_ADDQ( &CPU, $thing, $amount);  &kpreempt_enable(); });
    }' unless defined(&CPU_STAT_ADD_K);
    eval 'sub CPU_STAT_ADDQ {
        my($cpuptr, $thing, $amount) = @_;
	    eval q( ($cpuptr->{cpu_stat}->{thing}) += $amount);
    }' unless defined(&CPU_STAT_ADDQ);
    if(defined( &_KERNEL)  && defined( &__STDC__) ) {
	eval("sub CPU_CONFIG () { 0; }") unless defined(&CPU_CONFIG);
	eval("sub CPU_UNCONFIG () { 1; }") unless defined(&CPU_UNCONFIG);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
