require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_EPM_H)) {
    eval 'sub _SYS_EPM_H () {1;}' unless defined(&_SYS_EPM_H);
    require 'sys/pm.ph';
    require 'sys/dditypes.ph';
    require 'sys/devops.ph';
    require 'sys/ddi_impldefs.ph';
    if(defined(&DEBUG)) {
	require 'sys/promif.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub PMC_NEEDS_SR () {0x1;}' unless defined(&PMC_NEEDS_SR);
	eval 'sub PMC_NO_SR () {0x2;}' unless defined(&PMC_NO_SR);
	eval 'sub PMC_PARENTAL_SR () {0x4;}' unless defined(&PMC_PARENTAL_SR);
	eval 'sub PMC_WANTS_NOTIFY () {0x8;}' unless defined(&PMC_WANTS_NOTIFY);
	eval 'sub PMC_NOTIFY_PARENT () {0x10;}' unless defined(&PMC_NOTIFY_PARENT);
	eval 'sub PMC_BC () {0x20;}' unless defined(&PMC_BC);
	eval 'sub PMC_COMPONENTS_DONE () {0x40;}' unless defined(&PMC_COMPONENTS_DONE);
	eval 'sub PMC_COMPONENTS_FAILED () {0x80;}' unless defined(&PMC_COMPONENTS_FAILED);
	eval 'sub PMC_SUSPENDED () {0x100;}' unless defined(&PMC_SUSPENDED);
	eval 'sub PMC_DEF_THRESH () {0x200;}' unless defined(&PMC_DEF_THRESH);
	eval 'sub PMC_DEV_THRESH () {0x400;}' unless defined(&PMC_DEV_THRESH);
	eval 'sub PMC_COMP_THRESH () {0x800;}' unless defined(&PMC_COMP_THRESH);
	eval 'sub PMC_NEXDEF_THRESH () {0x1000;}' unless defined(&PMC_NEXDEF_THRESH);
	eval 'sub PMC_NOPMKID () {0x2000;}' unless defined(&PMC_NOPMKID);
	eval 'sub PMC_NO_INVOL () {0x4000;}' unless defined(&PMC_NO_INVOL);
	eval 'sub PMC_VOLPMD () {0x8000;}' unless defined(&PMC_VOLPMD);
	eval 'sub PMC_CONSOLE_FB () {0x10000;}' unless defined(&PMC_CONSOLE_FB);
	eval 'sub PMC_THRESH_ALL () {( &PMC_DEF_THRESH |  &PMC_DEV_THRESH |  &PMC_COMP_THRESH |  &PMC_NEXDEF_THRESH);}' unless defined(&PMC_THRESH_ALL);
	eval 'sub PMC_THRESH_NONE () {~( &PMC_THRESH_ALL);}' unless defined(&PMC_THRESH_NONE);
	eval("sub PMR_SET_POWER () { 1; }") unless defined(&PMR_SET_POWER);
	eval("sub PMR_SUSPEND () { 2; }") unless defined(&PMR_SUSPEND);
	eval("sub PMR_RESUME () { 3; }") unless defined(&PMR_RESUME);
	eval("sub PMR_PRE_SET_POWER () { 4; }") unless defined(&PMR_PRE_SET_POWER);
	eval("sub PMR_POST_SET_POWER () { 5; }") unless defined(&PMR_POST_SET_POWER);
	eval("sub PMR_PPM_SET_POWER () { 6; }") unless defined(&PMR_PPM_SET_POWER);
	eval("sub PMR_PPM_ATTACH () { 7; }") unless defined(&PMR_PPM_ATTACH);
	eval("sub PMR_PPM_DETACH () { 8; }") unless defined(&PMR_PPM_DETACH);
	eval("sub PMR_PPM_POWER_CHANGE_NOTIFY () { 9; }") unless defined(&PMR_PPM_POWER_CHANGE_NOTIFY);
	eval("sub PMR_REPORT_PMCAP () { 10; }") unless defined(&PMR_REPORT_PMCAP);
	eval("sub PMR_CHANGED_POWER () { 11; }") unless defined(&PMR_CHANGED_POWER);
	eval("sub PMR_PPM_PRE_PROBE () { 12; }") unless defined(&PMR_PPM_PRE_PROBE);
	eval("sub PMR_PPM_POST_PROBE () { 13; }") unless defined(&PMR_PPM_POST_PROBE);
	eval("sub PMR_PPM_PRE_ATTACH () { 14; }") unless defined(&PMR_PPM_PRE_ATTACH);
	eval("sub PMR_PPM_POST_ATTACH () { 15; }") unless defined(&PMR_PPM_POST_ATTACH);
	eval("sub PMR_PPM_PRE_DETACH () { 16; }") unless defined(&PMR_PPM_PRE_DETACH);
	eval("sub PMR_PPM_POST_DETACH () { 17; }") unless defined(&PMR_PPM_POST_DETACH);
	eval("sub PMR_PPM_UNMANAGE () { 18; }") unless defined(&PMR_PPM_UNMANAGE);
	eval("sub PMR_PPM_PRE_RESUME () { 19; }") unless defined(&PMR_PPM_PRE_RESUME);
	eval("sub PMR_PPM_ALL_LOWEST () { 20; }") unless defined(&PMR_PPM_ALL_LOWEST);
	eval("sub PMR_PPM_LOCK_POWER () { 21; }") unless defined(&PMR_PPM_LOCK_POWER);
	eval("sub PMR_PPM_UNLOCK_POWER () { 22; }") unless defined(&PMR_PPM_UNLOCK_POWER);
	eval("sub PMR_PPM_TRY_LOCK_POWER () { 23; }") unless defined(&PMR_PPM_TRY_LOCK_POWER);
	eval 'sub PM_DIRECT_OLD () {0x1;}' unless defined(&PM_DIRECT_OLD);
	eval 'sub PM_SCAN () {0x2;}' unless defined(&PM_SCAN);
	eval 'sub PM_DETACHING () {0x4;}' unless defined(&PM_DETACHING);
	eval 'sub PM_DIRECT_NEW () {0x8;}' unless defined(&PM_DIRECT_NEW);
	eval 'sub PM_SCAN_DEFERRED () {0x10;}' unless defined(&PM_SCAN_DEFERRED);
	eval 'sub PM_GET_PM_INFO {
	    my($dip) = @_;
    	    eval q(( &DEVI($dip)-> &devi_pm_info));
	}' unless defined(&PM_GET_PM_INFO);
	eval 'sub PM_NUMCMPTS {
	    my($dip) = @_;
    	    eval q(( &DEVI($dip)-> &devi_pm_num_components));
	}' unless defined(&PM_NUMCMPTS);
	eval 'sub PM_CP {
	    my($dip, $comp) = @_;
    	    eval q(( &DEVI($dip)-> $devi_pm_components[$comp]));
	}' unless defined(&PM_CP);
	eval 'sub PM_ISDIRECT {
	    my($dip) = @_;
    	    eval q(((( &pm_info_t *) &PM_GET_PM_INFO($dip))-> &pmi_dev_pm_state & ( &PM_DIRECT_NEW |  &PM_DIRECT_OLD)));
	}' unless defined(&PM_ISDIRECT);
	eval 'sub PM_ISBC {
	    my($dip) = @_;
    	    eval q(( &DEVI($dip)-> &devi_pm_flags &  &PMC_BC));
	}' unless defined(&PM_ISBC);
	eval 'sub PM_NOT_ALL_LOWEST () {0x;}' unless defined(&PM_NOT_ALL_LOWEST);
	eval 'sub PM_ALL_LOWEST () {0x1;}' unless defined(&PM_ALL_LOWEST);
	if(defined(&DEBUG)) {
	    eval 'sub PMD_ERROR () {0x1;}' unless defined(&PMD_ERROR);
	    eval 'sub PMD_FAIL () {0x2;}' unless defined(&PMD_FAIL);
	    eval 'sub PMD_IOCTL () {0x4;}' unless defined(&PMD_IOCTL);
	    eval 'sub PMD_SCAN () {0x8;}' unless defined(&PMD_SCAN);
	    eval 'sub PMD_RESCAN () {0x10;}' unless defined(&PMD_RESCAN);
	    eval 'sub PMD_REMINFO () {0x20;}' unless defined(&PMD_REMINFO);
	    eval 'sub PMD_NAMETODIP () {0x40;}' unless defined(&PMD_NAMETODIP);
	    eval 'sub PMD_CLOSE () {0x80;}' unless defined(&PMD_CLOSE);
	    eval 'sub PMD_DIN () {0x100;}' unless defined(&PMD_DIN);
	    eval 'sub PMD_PMC () {0x200;}' unless defined(&PMD_PMC);
	    eval 'sub PMD_PPM () {0x400;}' unless defined(&PMD_PPM);
	    eval 'sub PMD_DEP () {0x800;}' unless defined(&PMD_DEP);
	    eval 'sub PMD_IDLEDOWN () {0x1000;}' unless defined(&PMD_IDLEDOWN);
	    eval 'sub PMD_SET () {0x2000;}' unless defined(&PMD_SET);
	    eval 'sub PMD_BRING () {0x4000;}' unless defined(&PMD_BRING);
	    eval 'sub PMD_ALLNORM () {0x8000;}' unless defined(&PMD_ALLNORM);
	    eval 'sub PMD_REMDEV () {0x10000;}' unless defined(&PMD_REMDEV);
	    eval 'sub PMD_LEVEL () {0x20000;}' unless defined(&PMD_LEVEL);
	    eval 'sub PMD_THRESH () {0x40000;}' unless defined(&PMD_THRESH);
	    eval 'sub PMD_DPM () {0x80000;}' unless defined(&PMD_DPM);
	    eval 'sub PMD_NORM () {0x100000;}' unless defined(&PMD_NORM);
	    eval 'sub PMD_STATS () {0x200000;}' unless defined(&PMD_STATS);
	    eval 'sub PMD_DEREG () {0x400000;}' unless defined(&PMD_DEREG);
	    eval 'sub PMD_KEEPS () {0x800000;}' unless defined(&PMD_KEEPS);
	    eval 'sub PMD_KIDSUP () {0x1000000;}' unless defined(&PMD_KIDSUP);
	    eval 'sub PMD_TCHECK () {0x2000000;}' unless defined(&PMD_TCHECK);
	    eval 'sub PMD_NOINVOL () {0x4000000;}' unless defined(&PMD_NOINVOL);
	    eval 'sub PMD_CFB () {0x8000000;}' unless defined(&PMD_CFB);
	    eval 'sub PMD_DHR () {0x10000000;}' unless defined(&PMD_DHR);
	    eval 'sub PMD {
	        my($level, $arglist) = @_;
    		eval q({  &if ( &pm_debug & ($level)) {  &pm_log $arglist; } });
	    }' unless defined(&PMD);
	} else {
	    eval 'sub PMD {
	        my($level, $arglist) = @_;
    		eval q();
	    }' unless defined(&PMD);
	}
	eval("sub PM_CANBLOCK_BLOCK () { 0; }") unless defined(&PM_CANBLOCK_BLOCK);
	eval("sub PM_CANBLOCK_FAIL () { 1; }") unless defined(&PM_CANBLOCK_FAIL);
	eval("sub PM_CANBLOCK_BYPASS () { 2; }") unless defined(&PM_CANBLOCK_BYPASS);
	eval 'sub PMC_ALLCOMPS () {-1;}' unless defined(&PMC_ALLCOMPS);
	eval 'sub PMC_DONTCARE () {-1;}' unless defined(&PMC_DONTCARE);
	if(defined(&DEBUG)) {
	    eval 'sub PM_IAM_LOCKING_POWER {
	        my($dip, $comp) = @_;
    		eval q( &pm_iam_locking_power($dip, $comp));
	    }' unless defined(&PM_IAM_LOCKING_POWER);
	}
	eval 'sub PM_LOCK_DIP {
	    my($dip) = @_;
    	    eval q( &mutex_enter( &DEVI($dip)-> &devi_pm_lock));
	}' unless defined(&PM_LOCK_DIP);
	eval 'sub PM_UNLOCK_DIP {
	    my($dip) = @_;
    	    eval q( &mutex_exit( &DEVI($dip)-> &devi_pm_lock));
	}' unless defined(&PM_UNLOCK_DIP);
	eval 'sub PM_LOCK_BUSY {
	    my($dip) = @_;
    	    eval q( &mutex_enter( &DEVI($dip)-> &devi_pm_busy_lock));
	}' unless defined(&PM_LOCK_BUSY);
	eval 'sub PM_UNLOCK_BUSY {
	    my($dip) = @_;
    	    eval q( &mutex_exit( &DEVI($dip)-> &devi_pm_busy_lock));
	}' unless defined(&PM_UNLOCK_BUSY);
	eval 'sub PM_LOCK_POWER {
	    my($dip, $comp) = @_;
    	    eval q( &pm_lock_power($dip, $comp));
	}' unless defined(&PM_LOCK_POWER);
	eval 'sub PM_UNLOCK_POWER {
	    my($dip, $comp) = @_;
    	    eval q( &pm_unlock_power($dip, $comp));
	}' unless defined(&PM_UNLOCK_POWER);
	eval 'sub PM_TRY_LOCK_POWER {
	    my($dip, $comp) = @_;
    	    eval q( &pm_try_locking_power($dip, $comp));
	}' unless defined(&PM_TRY_LOCK_POWER);
	eval 'sub PM_IAM_LOCKING_DIP {
	    my($dip) = @_;
    	    eval q(( &mutex_owned( &DEVI($dip)-> &devi_pm_lock)));
	}' unless defined(&PM_IAM_LOCKING_DIP);
	eval 'sub PM_DEFAULT_SYS_IDLENESS () {1800;}' unless defined(&PM_DEFAULT_SYS_IDLENESS);
	eval 'sub PMP_SUCCEED () {0x1;}' unless defined(&PMP_SUCCEED);
	eval 'sub PMP_FAIL () {0x2;}' unless defined(&PMP_FAIL);
	eval 'sub PMP_RELEASE () {0x3;}' unless defined(&PMP_RELEASE);
	eval 'sub PMP_SETPOWER () {0x4;}' unless defined(&PMP_SETPOWER);
	eval 'sub PM_MAX_CLONE () {256;}' unless defined(&PM_MAX_CLONE);
	eval 'sub PSCCOUNT () {128;}' unless defined(&PSCCOUNT);
	eval 'sub PMID_IOCTIMER () {0x1;}' unless defined(&PMID_IOCTIMER);
	eval 'sub PMID_CFBTIMER () {0x2;}' unless defined(&PMID_CFBTIMER);
	eval 'sub PMID_IOCSCAN () {0x4;}' unless defined(&PMID_IOCSCAN);
	eval 'sub PMID_CFBSCAN () {0x8;}' unless defined(&PMID_CFBSCAN);
	eval 'sub PMID_IOC () {( &PMID_IOCTIMER |  &PMID_IOCSCAN);}' unless defined(&PMID_IOC);
	eval 'sub PMID_CFB () {( &PMID_CFBTIMER |  &PMID_CFBSCAN);}' unless defined(&PMID_CFB);
	eval 'sub PMID_TIMERS () {( &PMID_IOCTIMER |  &PMID_CFBTIMER);}' unless defined(&PMID_TIMERS);
	eval 'sub PMID_SCANS () {( &PMID_IOCSCAN |  &PMID_CFBSCAN);}' unless defined(&PMID_SCANS);
	eval 'sub PMID_SCANS_SHIFT () {2;}' unless defined(&PMID_SCANS_SHIFT);
	eval 'sub PMID_SET_SCANS {
	    my($pmid) = @_;
    	    eval q(($pmid) |= ((($pmid) &  &PMID_TIMERS) <<  &PMID_SCANS_SHIFT););
	}' unless defined(&PMID_SET_SCANS);
	eval 'sub PMID_IS_IOC {
	    my($pmid) = @_;
    	    eval q((($pmid) &  &PMID_IOC));
	}' unless defined(&PMID_IS_IOC);
	eval 'sub PMID_IS_CFB {
	    my($pmid, $dip) = @_;
    	    eval q(((($pmid) &  &PMID_CFB)  && ( &DEVI($dip)-> &devi_pm_flags & ( &PMC_DEF_THRESH |  &PMC_NEXDEF_THRESH))));
	}' unless defined(&PMID_IS_CFB);
	eval 'sub EPOCH_YEAR () {1970;}' unless defined(&EPOCH_YEAR);
	eval 'sub SECSPERMIN () {60;}' unless defined(&SECSPERMIN);
	eval 'sub MINSPERHOUR () {60;}' unless defined(&MINSPERHOUR);
	eval 'sub HOURSPERDAY () {24;}' unless defined(&HOURSPERDAY);
	eval 'sub DAYSPERWEEK () {7;}' unless defined(&DAYSPERWEEK);
	eval 'sub DAYSPERNYEAR () {365;}' unless defined(&DAYSPERNYEAR);
	eval 'sub SECSPERHOUR () {( &SECSPERMIN *  &MINSPERHOUR);}' unless defined(&SECSPERHOUR);
	eval 'sub SECSPERDAY () {( &SECSPERHOUR *  &HOURSPERDAY);}' unless defined(&SECSPERDAY);
	eval 'sub DC_SPY () {( &SECSPERDAY *  &DAYSPERNYEAR);}' unless defined(&DC_SPY);
	eval 'sub DC_SPW () {( &SECSPERDAY *  &DAYSPERWEEK);}' unless defined(&DC_SPW);
	eval 'sub DC_SPD () { &SECSPERDAY;}' unless defined(&DC_SPD);
	eval 'sub DC_SCSI_YEAR_LEN () {4;}' unless defined(&DC_SCSI_YEAR_LEN);
	eval 'sub DC_SCSI_WEEK_LEN () {2;}' unless defined(&DC_SCSI_WEEK_LEN);
	eval 'sub DC_SCSI_NPY () {5;}' unless defined(&DC_SCSI_NPY);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
