require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FLOCK_IMPL_H)) {
    eval 'sub _SYS_FLOCK_IMPL_H () {1;}' unless defined(&_SYS_FLOCK_IMPL_H);
    require 'sys/types.ph';
    require 'sys/fcntl.ph';
    require 'sys/file.ph';
    require 'sys/flock.ph';
    require 'sys/kmem.ph';
    require 'sys/user.ph';
    require 'sys/thread.ph';
    require 'sys/proc.ph';
    require 'sys/cred.ph';
    require 'sys/debug.ph';
    require 'sys/cmn_err.ph';
    require 'sys/errno.ph';
    require 'sys/systm.ph';
    require 'sys/vnode.ph';
    require 'sys/share.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub FLK_INITIAL_STATE () {1;}' unless defined(&FLK_INITIAL_STATE);
    eval 'sub FLK_START_STATE () {2;}' unless defined(&FLK_START_STATE);
    eval 'sub FLK_ACTIVE_STATE () {3;}' unless defined(&FLK_ACTIVE_STATE);
    eval 'sub FLK_SLEEPING_STATE () {4;}' unless defined(&FLK_SLEEPING_STATE);
    eval 'sub FLK_GRANTED_STATE () {5;}' unless defined(&FLK_GRANTED_STATE);
    eval 'sub FLK_INTERRUPTED_STATE () {6;}' unless defined(&FLK_INTERRUPTED_STATE);
    eval 'sub FLK_CANCELLED_STATE () {7;}' unless defined(&FLK_CANCELLED_STATE);
    eval 'sub FLK_DEAD_STATE () {8;}' unless defined(&FLK_DEAD_STATE);
    eval 'sub ACTIVE_LOCK () {0x1;}' unless defined(&ACTIVE_LOCK);
    eval 'sub SLEEPING_LOCK () {0x2;}' unless defined(&SLEEPING_LOCK);
    eval 'sub IO_LOCK () {0x4;}' unless defined(&IO_LOCK);
    eval 'sub REFERENCED_LOCK () {0x8;}' unless defined(&REFERENCED_LOCK);
    eval 'sub QUERY_LOCK () {0x10;}' unless defined(&QUERY_LOCK);
    eval 'sub WILLING_TO_SLEEP_LOCK () {0x20;}' unless defined(&WILLING_TO_SLEEP_LOCK);
    eval 'sub RECOMPUTE_LOCK () {0x40;}' unless defined(&RECOMPUTE_LOCK);
    eval 'sub RECOMPUTE_DONE () {0x80;}' unless defined(&RECOMPUTE_DONE);
    eval 'sub BARRIER_LOCK () {0x100;}' unless defined(&BARRIER_LOCK);
    eval 'sub GRANTED_LOCK () {0x200;}' unless defined(&GRANTED_LOCK);
    eval 'sub CANCELLED_LOCK () {0x400;}' unless defined(&CANCELLED_LOCK);
    eval 'sub DELETED_LOCK () {0x800;}' unless defined(&DELETED_LOCK);
    eval 'sub INTERRUPTED_LOCK () {0x1000;}' unless defined(&INTERRUPTED_LOCK);
    eval 'sub LOCKMGR_LOCK () {0x2000;}' unless defined(&LOCKMGR_LOCK);
    eval 'sub PXFS_LOCK () {0x4000;}' unless defined(&PXFS_LOCK);
    eval 'sub HASH_SIZE () {32;}' unless defined(&HASH_SIZE);
    eval 'sub HASH_SHIFT () {( &HASH_SIZE - 1);}' unless defined(&HASH_SHIFT);
    eval 'sub HASH_INDEX {
        my($vp) = @_;
	    eval q((($vp >> 7) &  &HASH_SHIFT));
    }' unless defined(&HASH_INDEX);
    eval 'sub FLK_USE_GRAPH () {0;}' unless defined(&FLK_USE_GRAPH);
    eval 'sub FLK_INIT_GRAPH () {1;}' unless defined(&FLK_INIT_GRAPH);
    eval 'sub NO_COLOR () {0;}' unless defined(&NO_COLOR);
    eval 'sub NO_CHECK_CYCLE () {0;}' unless defined(&NO_CHECK_CYCLE);
    eval 'sub CHECK_CYCLE () {1;}' unless defined(&CHECK_CYCLE);
    eval 'sub SAME_OWNER {
        my($lock1, $lock2) = @_;
	    eval q(((($lock1)-> ($l_flock->{l_pid}) == ($lock2)-> ($l_flock->{l_pid}))  && (($lock1)-> ($l_flock->{l_sysid}) == ($lock2)-> ($l_flock->{l_sysid}))));
    }' unless defined(&SAME_OWNER);
    eval 'sub COLORED {
        my($vertex) = @_;
	    eval q((($vertex)-> &l_color == ($vertex)-> ($l_graph->{mark})));
    }' unless defined(&COLORED);
    eval 'sub COLOR {
        my($vertex) = @_;
	    eval q((($vertex)-> &l_color = ($vertex)-> ($l_graph->{mark})));
    }' unless defined(&COLOR);
    eval 'sub STACK_INIT {
        my($stack) = @_;
	    eval q((($stack) =  &NULL));
    }' unless defined(&STACK_INIT);
    eval 'sub STACK_PUSH {
        my($stack, $ptr, $stack_link) = @_;
	    eval q(($ptr)->$stack_link = ($stack), ($stack) = ($ptr));
    }' unless defined(&STACK_PUSH);
    eval 'sub STACK_POP {
        my($stack, $stack_link) = @_;
	    eval q(($stack) = ($stack)->$stack_link);
    }' unless defined(&STACK_POP);
    eval 'sub STACK_TOP {
        my($stack) = @_;
	    eval q(($stack));
    }' unless defined(&STACK_TOP);
    eval 'sub STACK_EMPTY {
        my($stack) = @_;
	    eval q((($stack) ==  &NULL));
    }' unless defined(&STACK_EMPTY);
    eval 'sub ACTIVE_HEAD {
        my($gp) = @_;
	    eval q((($gp)-> &active_locks));
    }' unless defined(&ACTIVE_HEAD);
    eval 'sub SLEEPING_HEAD {
        my($gp) = @_;
	    eval q((($gp)-> &sleeping_locks));
    }' unless defined(&SLEEPING_HEAD);
    eval 'sub SET_LOCK_TO_FIRST_ACTIVE_VP {
        my($gp, $lock, $vp) = @_;
	    eval q({ ($lock) = ( &lock_descriptor_t *) ($vp->{v_filocks}); });
    }' unless defined(&SET_LOCK_TO_FIRST_ACTIVE_VP);
    eval 'sub SET_LOCK_TO_FIRST_SLEEP_VP {
        my($gp, $lock, $vp) = @_;
	    eval q({  &for (($lock) =  &SLEEPING_HEAD(($gp))-> &l_next; (($lock) !=  &SLEEPING_HEAD(($gp))  && ($lock)-> &l_vnode != ($vp)); ($lock) = ($lock)-> &l_next) ; ($lock) = (($lock) ==  &SLEEPING_HEAD(($gp))) ?  &NULL : ($lock); });
    }' unless defined(&SET_LOCK_TO_FIRST_SLEEP_VP);
    eval 'sub OVERLAP {
        my($lock1, $lock2) = @_;
	    eval q(((($lock1)-> &l_start <= ($lock2)-> &l_start  && ($lock2)-> &l_start <= ($lock1)-> &l_end) || (($lock2)-> &l_start <= ($lock1)-> &l_start  && ($lock1)-> &l_start <= ($lock2)-> &l_end)));
    }' unless defined(&OVERLAP);
    eval 'sub IS_INITIAL {
        my($lock) = @_;
	    eval q((($lock)-> &l_status ==  &FLK_INITIAL_STATE));
    }' unless defined(&IS_INITIAL);
    eval 'sub IS_ACTIVE {
        my($lock) = @_;
	    eval q((($lock)-> &l_status ==  &FLK_ACTIVE_STATE));
    }' unless defined(&IS_ACTIVE);
    eval 'sub IS_SLEEPING {
        my($lock) = @_;
	    eval q((($lock)-> &l_status ==  &FLK_SLEEPING_STATE));
    }' unless defined(&IS_SLEEPING);
    eval 'sub IS_GRANTED {
        my($lock) = @_;
	    eval q((($lock)-> &l_status ==  &FLK_GRANTED_STATE));
    }' unless defined(&IS_GRANTED);
    eval 'sub IS_INTERRUPTED {
        my($lock) = @_;
	    eval q((($lock)-> &l_status ==  &FLK_INTERRUPTED_STATE));
    }' unless defined(&IS_INTERRUPTED);
    eval 'sub IS_CANCELLED {
        my($lock) = @_;
	    eval q((($lock)-> &l_status ==  &FLK_CANCELLED_STATE));
    }' unless defined(&IS_CANCELLED);
    eval 'sub IS_DEAD {
        my($lock) = @_;
	    eval q((($lock)-> &l_status ==  &FLK_DEAD_STATE));
    }' unless defined(&IS_DEAD);
    eval 'sub IS_QUERY_LOCK {
        my($lock) = @_;
	    eval q((($lock)-> &l_state &  &QUERY_LOCK));
    }' unless defined(&IS_QUERY_LOCK);
    eval 'sub IS_RECOMPUTE {
        my($lock) = @_;
	    eval q((($lock)-> &l_state &  &RECOMPUTE_LOCK));
    }' unless defined(&IS_RECOMPUTE);
    eval 'sub IS_BARRIER {
        my($lock) = @_;
	    eval q((($lock)-> &l_state &  &BARRIER_LOCK));
    }' unless defined(&IS_BARRIER);
    eval 'sub IS_DELETED {
        my($lock) = @_;
	    eval q((($lock)-> &l_state &  &DELETED_LOCK));
    }' unless defined(&IS_DELETED);
    eval 'sub IS_REFERENCED {
        my($lock) = @_;
	    eval q((($lock)-> &l_state &  &REFERENCED_LOCK));
    }' unless defined(&IS_REFERENCED);
    eval 'sub IS_IO_LOCK {
        my($lock) = @_;
	    eval q((($lock)-> &l_state &  &IO_LOCK));
    }' unless defined(&IS_IO_LOCK);
    eval 'sub IS_WILLING_TO_SLEEP {
        my($lock) = @_;
	    eval q((($lock)-> &l_state &  &WILLING_TO_SLEEP_LOCK));
    }' unless defined(&IS_WILLING_TO_SLEEP);
    eval 'sub IS_LOCKMGR {
        my($lock) = @_;
	    eval q((($lock)-> &l_state &  &LOCKMGR_LOCK));
    }' unless defined(&IS_LOCKMGR);
    eval 'sub IS_NLM_UP {
        my($lock) = @_;
	    eval q((($lock)-> &l_nlm_state ==  &FLK_NLM_UP));
    }' unless defined(&IS_NLM_UP);
    eval 'sub IS_PXFS {
        my($lock) = @_;
	    eval q((($lock)-> &l_state &  &PXFS_LOCK));
    }' unless defined(&IS_PXFS);
    eval 'sub IS_LOCAL {
        my($lock) = @_;
	    eval q(( &GETSYSID(($lock)-> ($l_flock->{l_sysid})) == 0));
    }' unless defined(&IS_LOCAL);
    eval 'sub IS_REMOTE {
        my($lock) = @_;
	    eval q((!  &IS_LOCAL($lock)));
    }' unless defined(&IS_REMOTE);
    eval 'sub PXFS_LOCK_BLOCKED () {-1;}' unless defined(&PXFS_LOCK_BLOCKED);
    eval 'sub BLOCKS {
        my($lock1, $lock2) = @_;
	    eval q((! &SAME_OWNER(($lock1), ($lock2))  && ((($lock1)-> &l_type ==  &F_WRLCK) || (($lock2)-> &l_type ==  &F_WRLCK))  &&  &OVERLAP(($lock1), ($lock2))));
    }' unless defined(&BLOCKS);
    eval 'sub COVERS {
        my($lock1, $lock2) = @_;
	    eval q(((($lock1)-> &l_start <= ($lock2)-> &l_start)  && (($lock1)-> &l_end >= ($lock2)-> &l_end)));
    }' unless defined(&COVERS);
    eval 'sub IN_LIST_REMOVE {
        my($ep) = @_;
	    eval q({ ($ep)-> ($edge_in_next->{edge_in_prev}) = ($ep)-> &edge_in_prev; ($ep)-> ($edge_in_prev->{edge_in_next}) = ($ep)-> &edge_in_next; });
    }' unless defined(&IN_LIST_REMOVE);
    eval 'sub ADJ_LIST_REMOVE {
        my($ep) = @_;
	    eval q({ ($ep)-> ($edge_adj_next->{edge_adj_prev}) = ($ep)-> &edge_adj_prev; ($ep)-> ($edge_adj_prev->{edge_adj_next}) = ($ep)-> &edge_adj_next; });
    }' unless defined(&ADJ_LIST_REMOVE);
    eval 'sub NOT_BLOCKED {
        my($lock) = @_;
	    eval q((($lock)-> ($l_edge->{edge_adj_next}) == ($lock)-> &l_edge  && ! &IS_GRANTED($lock)));
    }' unless defined(&NOT_BLOCKED);
    eval 'sub GRANT_WAKEUP {
        my($lock) = @_;
	    eval q({  &flk_set_state($lock,  &FLK_GRANTED_STATE); ($lock)-> &l_state |=  &GRANTED_LOCK;  &if (! &IS_PXFS($lock)) {  &cv_signal(($lock)-> &l_cv); } });
    }' unless defined(&GRANT_WAKEUP);
    eval 'sub CANCEL_WAKEUP {
        my($lock) = @_;
	    eval q({  &flk_set_state($lock,  &FLK_CANCELLED_STATE); ($lock)-> &l_state |=  &CANCELLED_LOCK;  &if (! &IS_PXFS($lock)) {  &cv_signal(($lock)-> &l_cv); } });
    }' unless defined(&CANCEL_WAKEUP);
    eval 'sub INTERRUPT_WAKEUP {
        my($lock) = @_;
	    eval q({  &flk_set_state($lock,  &FLK_INTERRUPTED_STATE); ($lock)-> &l_state |=  &INTERRUPTED_LOCK;  &if (! &IS_PXFS($lock)) {  &cv_signal(($lock)-> &l_cv); } });
    }' unless defined(&INTERRUPT_WAKEUP);
    eval 'sub REMOVE_SLEEP_QUEUE {
        my($lock) = @_;
	    eval q({  &ASSERT( &IS_SLEEPING($lock) ||  &IS_GRANTED($lock) ||  &IS_INTERRUPTED($lock) ||  &IS_CANCELLED($lock)); ($lock)-> &l_state &= ~ &SLEEPING_LOCK; ($lock)-> ($l_next->{l_prev}) = ($lock)-> &l_prev; ($lock)-> ($l_prev->{l_next}) = ($lock)-> &l_next; ($lock)-> &l_next = ($lock)-> &l_prev = ( &lock_descriptor_t *) &NULL; });
    }' unless defined(&REMOVE_SLEEP_QUEUE);
    eval 'sub NO_DEPENDENTS {
        my($lock) = @_;
	    eval q((($lock)-> ($l_edge->{edge_in_next}) == ($lock)-> &l_edge));
    }' unless defined(&NO_DEPENDENTS);
    eval 'sub GRANT {
        my($lock) = @_;
	    eval q({ ($lock)-> &l_state |=  &GRANTED_LOCK;  &flk_set_state($lock,  &FLK_GRANTED_STATE); });
    }' unless defined(&GRANT);
    eval 'sub FIRST_IN {
        my($lock) = @_;
	    eval q((($lock)-> ($l_edge->{edge_in_next})));
    }' unless defined(&FIRST_IN);
    eval 'sub FIRST_ADJ {
        my($lock) = @_;
	    eval q((($lock)-> ($l_edge->{edge_adj_next})));
    }' unless defined(&FIRST_ADJ);
    eval 'sub HEAD {
        my($lock) = @_;
	    eval q((($lock)-> &l_edge));
    }' unless defined(&HEAD);
    eval 'sub NEXT_ADJ {
        my($ep) = @_;
	    eval q((($ep)-> &edge_adj_next));
    }' unless defined(&NEXT_ADJ);
    eval 'sub NEXT_IN {
        my($ep) = @_;
	    eval q((($ep)-> &edge_in_next));
    }' unless defined(&NEXT_IN);
    eval 'sub IN_ADJ_INIT {
        my($lock) = @_;
	    eval q({ ($lock)-> ($l_edge->{edge_adj_next}) = ($lock)-> ($l_edge->{edge_adj_prev}) = ($lock)-> &l_edge; ($lock)-> ($l_edge->{edge_in_next}) = ($lock)-> ($l_edge->{edge_in_prev}) = ($lock)-> &l_edge; });
    }' unless defined(&IN_ADJ_INIT);
    eval 'sub COPY {
        my($lock1, $lock2) = @_;
	    eval q({ ($lock1)-> &l_graph = ($lock2)-> &l_graph; ($lock1)-> &l_vnode = ($lock2)-> &l_vnode; ($lock1)-> &l_type = ($lock2)-> &l_type; ($lock1)-> &l_state = ($lock2)-> &l_state; ($lock1)-> &l_start = ($lock2)-> &l_start; ($lock1)-> &l_end = ($lock2)-> &l_end; ($lock1)-> &l_flock = ($lock2)-> &l_flock; ($lock1)-> &pvertex = ($lock2)-> &pvertex; });
    }' unless defined(&COPY);
    eval 'sub SET_NLM_STATE {
        my($lock, $nlm_state) = @_;
	    eval q((($lock)-> &l_nlm_state = $nlm_state));
    }' unless defined(&SET_NLM_STATE);
    eval 'sub GET_NLM_STATE {
        my($lock) = @_;
	    eval q((($lock)-> &l_nlm_state));
    }' unless defined(&GET_NLM_STATE);
    eval 'sub FLK_REGISTRY_IS_NLM_UNKNOWN {
        my($nlmreg, $nlmid) = @_;
	    eval q((($nlmreg)[$nlmid] ==  &FLK_NLM_UNKNOWN));
    }' unless defined(&FLK_REGISTRY_IS_NLM_UNKNOWN);
    eval 'sub FLK_REGISTRY_IS_NLM_UP {
        my($nlmreg, $nlmid) = @_;
	    eval q((($nlmreg)[$nlmid] ==  &FLK_NLM_UP));
    }' unless defined(&FLK_REGISTRY_IS_NLM_UP);
    eval 'sub FLK_REGISTRY_ADD_NLMID {
        my($nlmreg, $nlmid) = @_;
	    eval q((($nlmreg)[$nlmid] =  &FLK_NLM_UP));
    }' unless defined(&FLK_REGISTRY_ADD_NLMID);
    eval 'sub FLK_REGISTRY_CHANGE_NLM_STATE {
        my($nlmreg, $nlmid, $state) = @_;
	    eval q((($nlmreg)[$nlmid] = $state));
    }' unless defined(&FLK_REGISTRY_CHANGE_NLM_STATE);
    eval 'sub FLK_UNLOCK () {0x1;}' unless defined(&FLK_UNLOCK);
    eval 'sub FLK_DOWNGRADE () {0x2;}' unless defined(&FLK_DOWNGRADE);
    eval 'sub FLK_UPGRADE () {0x3;}' unless defined(&FLK_UPGRADE);
    eval 'sub FLK_STAY_SAME () {0x4;}' unless defined(&FLK_STAY_SAME);
    eval 'sub PROC_CHUNK () {100;}' unless defined(&PROC_CHUNK);
    eval 'sub PROC_SAME_OWNER {
        my($lock, $pvertex) = @_;
	    eval q(((($lock)-> ($l_flock->{l_pid}) == ($pvertex)-> &pid)  && (($lock)-> ($l_flock->{l_sysid}) == ($pvertex)-> &sysid)));
    }' unless defined(&PROC_SAME_OWNER);
    eval 'sub PROC_ARRIVE {
        my($pvertex) = @_;
	    eval q((($pvertex)-> &atime =  ($pgraph->{mark})));
    }' unless defined(&PROC_ARRIVE);
    eval 'sub PROC_DEPART {
        my($pvertex) = @_;
	    eval q((($pvertex)-> &dtime =  ($pgraph->{mark})));
    }' unless defined(&PROC_DEPART);
    eval 'sub PROC_ARRIVED {
        my($pvertex) = @_;
	    eval q((($pvertex)-> &atime ==  ($pgraph->{mark})));
    }' unless defined(&PROC_ARRIVED);
    eval 'sub PROC_DEPARTED {
        my($pvertex) = @_;
	    eval q((($pvertex)-> &dtime ==  ($pgraph->{mark})));
    }' unless defined(&PROC_DEPARTED);
    if(defined(&__cplusplus)) {
    }
}
1;
