require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_AUTOFS_H)) {
    eval 'sub _SYS_FS_AUTOFS_H () {1;}' unless defined(&_SYS_FS_AUTOFS_H);
    require 'rpcsvc/autofs_prot.ph';
    require 'rpc/rpc.ph';
    require 'sys/note.ph';
    require 'sys/time_impl.ph';
    require 'sys/types.ph';
    require 'sys/mntent.ph';
    require 'sys/varargs.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	unless(defined(&DEBUG)) {
	    eval 'sub AUTOFS_DPRINT {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&AUTOFS_DPRINT);
	} else {
	    eval 'sub AUTOFS_DPRINT {
	        my($x) = @_;
    		eval q( &auto_dprint $x);
	    }' unless defined(&AUTOFS_DPRINT);
	}
	eval 'sub vntofn {
	    my($vp) = @_;
    	    eval q(((($vp)-> &v_data)));
	}' unless defined(&vntofn);
	eval 'sub fntovn {
	    my($fnp) = @_;
    	    eval q(((($fnp)-> &fn_vnode)));
	}' unless defined(&fntovn);
	eval 'sub vfstofni {
	    my($vfsp) = @_;
    	    eval q(((($vfsp)-> &vfs_data)));
	}' unless defined(&vfstofni);
	eval 'sub MF_DIRECT () {0x1;}' unless defined(&MF_DIRECT);
	eval 'sub MF_INPROG () {0x2;}' unless defined(&MF_INPROG);
	eval 'sub MF_WAITING () {0x4;}' unless defined(&MF_WAITING);
	eval 'sub MF_LOOKUP () {0x8;}' unless defined(&MF_LOOKUP);
	eval 'sub MF_ATTR_WAIT () {0x10;}' unless defined(&MF_ATTR_WAIT);
	eval 'sub MF_IK_MOUNT () {0x40;}' unless defined(&MF_IK_MOUNT);
	eval 'sub MF_TRIGGER () {0x80;}' unless defined(&MF_TRIGGER);
	eval 'sub MF_THISUID_MATCH_RQD () {0x100;}' unless defined(&MF_THISUID_MATCH_RQD);
	eval 'sub AUTOFS_MODE () {0555;}' unless defined(&AUTOFS_MODE);
	eval 'sub AUTOFS_BLOCKSIZE () {1024;}' unless defined(&AUTOFS_BLOCKSIZE);
	eval 'sub AUTOFS_BLOCK_OTHERS {
	    my($fnp, $operation) = @_;
    	    eval q({  &ASSERT( &MUTEX_HELD(($fnp)-> &fn_lock));  &ASSERT(!(($fnp)-> &fn_flags & $operation)); ($fnp)-> &fn_flags |= ($operation); });
	}' unless defined(&AUTOFS_BLOCK_OTHERS);
	eval 'sub AUTOFS_UNBLOCK_OTHERS {
	    my($fnp, $operation) = @_;
    	    eval q({  &auto_unblock_others(($fnp), ($operation)); });
	}' unless defined(&AUTOFS_UNBLOCK_OTHERS);
	eval 'sub BROWSE () {"browse";}' unless defined(&BROWSE);
	eval 'sub NOBROWSE () {"nobrowse";}' unless defined(&NOBROWSE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
