require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_HSFS_SPEC_H)) {
    eval 'sub _SYS_FS_HSFS_SPEC_H () {1;}' unless defined(&_SYS_FS_HSFS_SPEC_H);
    require 'sys/types.ph';
    require 'sys/time.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
    }
    eval 'sub ZERO {
        my($x) = @_;
	    eval q(( &uint_t)((( &uchar_t *)($x))[0]));
    }' unless defined(&ZERO);
    eval 'sub ONE {
        my($x) = @_;
	    eval q(( &uint_t)((( &uchar_t *)($x))[1]));
    }' unless defined(&ONE);
    eval 'sub TWO {
        my($x) = @_;
	    eval q(( &uint_t)((( &uchar_t *)($x))[2]));
    }' unless defined(&TWO);
    eval 'sub THREE {
        my($x) = @_;
	    eval q(( &uint_t)((( &uchar_t *)($x))[3]));
    }' unless defined(&THREE);
    eval 'sub MSB_INT {
        my($x) = @_;
	    eval q((((((( &ZERO($x) << 8) |  &ONE($x)) << 8) |  &TWO($x)) << 8) |  &THREE($x)));
    }' unless defined(&MSB_INT);
    eval 'sub LSB_INT {
        my($x) = @_;
	    eval q((((((( &THREE($x) << 8) |  &TWO($x)) << 8) |  &ONE($x)) << 8) |  &ZERO($x)));
    }' unless defined(&LSB_INT);
    eval 'sub MSB_SHORT {
        my($x) = @_;
	    eval q((( &ZERO($x) << 8) |  &ONE($x)));
    }' unless defined(&MSB_SHORT);
    eval 'sub LSB_SHORT {
        my($x) = @_;
	    eval q((( &ONE($x) << 8) |  &ZERO($x)));
    }' unless defined(&LSB_SHORT);
    if(defined( &i386) || defined( &__i386) || defined( &__ia64)) {
	eval 'sub BOTH_SHORT {
	    my($x) = @_;
    	    eval q(*($x));
	}' unless defined(&BOTH_SHORT);
	eval 'sub BOTH_INT {
	    my($x) = @_;
    	    eval q(*($x));
	}' unless defined(&BOTH_INT);
    }
 elsif(defined( &sparc) || defined( &__sparc)) {
	eval 'sub BOTH_SHORT {
	    my($x) = @_;
    	    eval q( &LSB_SHORT($x));
	}' unless defined(&BOTH_SHORT);
	eval 'sub BOTH_INT {
	    my($x) = @_;
    	    eval q( &LSB_INT($x));
	}' unless defined(&BOTH_INT);
    }
    eval 'sub HS_SECTOR_SIZE () {2048;}' unless defined(&HS_SECTOR_SIZE);
    eval 'sub HS_SECTOR_SHIFT () {11;}' unless defined(&HS_SECTOR_SHIFT);
    eval 'sub HS_SEC_PER_PAGE () {( &PAGESIZE/ &HS_SECTOR_SIZE);}' unless defined(&HS_SEC_PER_PAGE);
    eval 'sub HS_SYSAREA_SEC () {0;}' unless defined(&HS_SYSAREA_SEC);
    eval 'sub HS_VOLDESC_SEC () {16;}' unless defined(&HS_VOLDESC_SEC);
    eval 'sub MAXHSOFFSET () {( &HS_SECTOR_SIZE - 1);}' unless defined(&MAXHSOFFSET);
    eval 'sub MAXHSMASK () {(~ &MAXHSOFFSET);}' unless defined(&MAXHSMASK);
    eval("sub VD_BOOT () { 0; }") unless defined(&VD_BOOT);
    eval("sub VD_SFS () { 1; }") unless defined(&VD_SFS);
    eval("sub VD_CCFS () { 2; }") unless defined(&VD_CCFS);
    eval("sub VD_UNSPEC () { 3; }") unless defined(&VD_UNSPEC);
    eval("sub VD_EOV () { 255; }") unless defined(&VD_EOV);
    eval 'sub HSV_ID_STRING () {"CDROM";}' unless defined(&HSV_ID_STRING);
    eval 'sub HSV_ID_STRLEN () {5;}' unless defined(&HSV_ID_STRLEN);
    eval 'sub HSV_ID_VER () {1;}' unless defined(&HSV_ID_VER);
    eval 'sub HSV_FILE_STRUCT_ID_VER () {1;}' unless defined(&HSV_FILE_STRUCT_ID_VER);
    eval 'sub HSV_SYS_ID_STRLEN () {32;}' unless defined(&HSV_SYS_ID_STRLEN);
    eval 'sub HSV_VOL_ID_STRLEN () {32;}' unless defined(&HSV_VOL_ID_STRLEN);
    eval 'sub HSV_VOL_SET_ID_STRLEN () {128;}' unless defined(&HSV_VOL_SET_ID_STRLEN);
    eval 'sub HSV_PUB_ID_STRLEN () {128;}' unless defined(&HSV_PUB_ID_STRLEN);
    eval 'sub HSV_PREP_ID_STRLEN () {128;}' unless defined(&HSV_PREP_ID_STRLEN);
    eval 'sub HSV_APPL_ID_STRLEN () {128;}' unless defined(&HSV_APPL_ID_STRLEN);
    eval 'sub HSV_COPYR_ID_STRLEN () {32;}' unless defined(&HSV_COPYR_ID_STRLEN);
    eval 'sub HSV_ABSTR_ID_STRLEN () {32;}' unless defined(&HSV_ABSTR_ID_STRLEN);
    eval 'sub HSV_DATE_LEN () {16;}' unless defined(&HSV_DATE_LEN);
    eval 'sub HSV_desc_lbn {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[0]));
    }' unless defined(&HSV_desc_lbn);
    eval 'sub HSV_desc_type {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[8]));
    }' unless defined(&HSV_desc_type);
    eval 'sub HSV_std_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[9]));
    }' unless defined(&HSV_std_id);
    eval 'sub HSV_std_ver {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[14]));
    }' unless defined(&HSV_std_ver);
    eval 'sub HSV_sys_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[16]));
    }' unless defined(&HSV_sys_id);
    eval 'sub HSV_vol_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[48]));
    }' unless defined(&HSV_vol_id);
    eval 'sub HSV_vol_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[88]));
    }' unless defined(&HSV_vol_size);
    eval 'sub HSV_set_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[128]));
    }' unless defined(&HSV_set_size);
    eval 'sub HSV_set_seq {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[132]));
    }' unless defined(&HSV_set_seq);
    eval 'sub HSV_blk_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[136]));
    }' unless defined(&HSV_blk_size);
    eval 'sub HSV_ptbl_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[140]));
    }' unless defined(&HSV_ptbl_size);
    eval 'sub HSV_ptbl_man_ls {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[148]));
    }' unless defined(&HSV_ptbl_man_ls);
    eval 'sub HSV_ptbl_opt_ls1 {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[152]));
    }' unless defined(&HSV_ptbl_opt_ls1);
    eval 'sub HSV_ptbl_opt_ls2 {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[156]));
    }' unless defined(&HSV_ptbl_opt_ls2);
    eval 'sub HSV_ptbl_opt_ls3 {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[160]));
    }' unless defined(&HSV_ptbl_opt_ls3);
    eval 'sub HSV_ptbl_man_ms {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[164]));
    }' unless defined(&HSV_ptbl_man_ms);
    eval 'sub HSV_ptbl_opt_ms1 {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[168]));
    }' unless defined(&HSV_ptbl_opt_ms1);
    eval 'sub HSV_ptbl_opt_ms2 {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[172]));
    }' unless defined(&HSV_ptbl_opt_ms2);
    eval 'sub HSV_ptbl_opt_ms3 {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[176]));
    }' unless defined(&HSV_ptbl_opt_ms3);
    eval 'sub HSV_root_dir {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[180]));
    }' unless defined(&HSV_root_dir);
    eval 'sub HSV_vol_set_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[214]));
    }' unless defined(&HSV_vol_set_id);
    eval 'sub HSV_pub_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[342]));
    }' unless defined(&HSV_pub_id);
    eval 'sub HSV_prep_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[470]));
    }' unless defined(&HSV_prep_id);
    eval 'sub HSV_appl_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[598]));
    }' unless defined(&HSV_appl_id);
    eval 'sub HSV_copyr_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[726]));
    }' unless defined(&HSV_copyr_id);
    eval 'sub HSV_abstr_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[758]));
    }' unless defined(&HSV_abstr_id);
    eval 'sub HSV_cre_date {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[790]));
    }' unless defined(&HSV_cre_date);
    eval 'sub HSV_mod_date {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[806]));
    }' unless defined(&HSV_mod_date);
    eval 'sub HSV_exp_date {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[822]));
    }' unless defined(&HSV_exp_date);
    eval 'sub HSV_eff_date {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[838]));
    }' unless defined(&HSV_eff_date);
    eval 'sub HSV_file_struct_ver {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[854]));
    }' unless defined(&HSV_file_struct_ver);
    eval 'sub HSV_DESC_LBN {
        my($x) = @_;
	    eval q( &BOTH_INT( &HSV_desc_lbn($x)));
    }' unless defined(&HSV_DESC_LBN);
    eval 'sub HSV_DESC_TYPE {
        my($x) = @_;
	    eval q((( &enum  &hs_voldesc_type)*( &HSV_desc_type($x))));
    }' unless defined(&HSV_DESC_TYPE);
    eval 'sub HSV_STD_ID {
        my($x) = @_;
	    eval q( &HSV_std_id($x));
    }' unless defined(&HSV_STD_ID);
    eval 'sub HSV_STD_VER {
        my($x) = @_;
	    eval q(*( &HSV_std_ver($x)));
    }' unless defined(&HSV_STD_VER);
    eval 'sub HSV_SYS_ID {
        my($x) = @_;
	    eval q( &HSV_sys_id($x));
    }' unless defined(&HSV_SYS_ID);
    eval 'sub HSV_VOL_ID {
        my($x) = @_;
	    eval q( &HSV_vol_id($x));
    }' unless defined(&HSV_VOL_ID);
    eval 'sub HSV_VOL_SIZE {
        my($x) = @_;
	    eval q( &BOTH_INT( &HSV_vol_size($x)));
    }' unless defined(&HSV_VOL_SIZE);
    eval 'sub HSV_SET_SIZE {
        my($x) = @_;
	    eval q( &BOTH_SHORT( &HSV_set_size($x)));
    }' unless defined(&HSV_SET_SIZE);
    eval 'sub HSV_SET_SEQ {
        my($x) = @_;
	    eval q( &BOTH_SHORT( &HSV_set_seq($x)));
    }' unless defined(&HSV_SET_SEQ);
    eval 'sub HSV_BLK_SIZE {
        my($x) = @_;
	    eval q( &BOTH_SHORT( &HSV_blk_size($x)));
    }' unless defined(&HSV_BLK_SIZE);
    eval 'sub HSV_PTBL_SIZE {
        my($x) = @_;
	    eval q( &BOTH_INT( &HSV_ptbl_size($x)));
    }' unless defined(&HSV_PTBL_SIZE);
    eval 'sub HSV_PTBL_MAN_LS {
        my($x) = @_;
	    eval q( &LSB_INT( &HSV_ptbl_man_ls($x)));
    }' unless defined(&HSV_PTBL_MAN_LS);
    eval 'sub HSV_PTBL_OPT_LS1 {
        my($x) = @_;
	    eval q( &LSB_INT( &HSV_ptbl_opt_ls1($x)));
    }' unless defined(&HSV_PTBL_OPT_LS1);
    eval 'sub HSV_PTBL_OPT_LS2 {
        my($x) = @_;
	    eval q( &LSB_INT( &HSV_ptbl_opt_ls2($x)));
    }' unless defined(&HSV_PTBL_OPT_LS2);
    eval 'sub HSV_PTBL_OPT_LS3 {
        my($x) = @_;
	    eval q( &LSB_INT( &HSV_ptbl_opt_ls3($x)));
    }' unless defined(&HSV_PTBL_OPT_LS3);
    eval 'sub HSV_PTBL_MAN_MS {
        my($x) = @_;
	    eval q( &MSB_INT( &HSV_ptbl_man_ms($x)));
    }' unless defined(&HSV_PTBL_MAN_MS);
    eval 'sub HSV_PTBL_OPT_MS1 {
        my($x) = @_;
	    eval q( &MSB_INT( &HSV_ptbl_opt_ms1($x)));
    }' unless defined(&HSV_PTBL_OPT_MS1);
    eval 'sub HSV_PTBL_OPT_MS2 {
        my($x) = @_;
	    eval q( &MSB_INT( &HSV_ptbl_opt_ms2($x)));
    }' unless defined(&HSV_PTBL_OPT_MS2);
    eval 'sub HSV_PTBL_OPT_MS3 {
        my($x) = @_;
	    eval q( &MSB_INT( &HSV_ptbl_opt_ms3($x)));
    }' unless defined(&HSV_PTBL_OPT_MS3);
    eval 'sub HSV_ROOT_DIR {
        my($x) = @_;
	    eval q( &HSV_root_dir($x));
    }' unless defined(&HSV_ROOT_DIR);
    eval 'sub HSV_VOL_SET_ID {
        my($x) = @_;
	    eval q( &HSV_vol_set_id($x));
    }' unless defined(&HSV_VOL_SET_ID);
    eval 'sub HSV_PUB_ID {
        my($x) = @_;
	    eval q( &HSV_pub_id($x));
    }' unless defined(&HSV_PUB_ID);
    eval 'sub HSV_PREP_ID {
        my($x) = @_;
	    eval q( &HSV_prep_id($x));
    }' unless defined(&HSV_PREP_ID);
    eval 'sub HSV_APPL_ID {
        my($x) = @_;
	    eval q( &HSV_appl_id($x));
    }' unless defined(&HSV_APPL_ID);
    eval 'sub HSV_COPYR_ID {
        my($x) = @_;
	    eval q( &HSV_copyr_id($x));
    }' unless defined(&HSV_COPYR_ID);
    eval 'sub HSV_ABSTR_ID {
        my($x) = @_;
	    eval q( &HSV_abstr_id($x));
    }' unless defined(&HSV_ABSTR_ID);
    eval 'sub HSV_CRE_DATE {
        my($x) = @_;
	    eval q( &HSV_cre_date($x));
    }' unless defined(&HSV_CRE_DATE);
    eval 'sub HSV_MOD_DATE {
        my($x) = @_;
	    eval q( &HSV_mod_date($x));
    }' unless defined(&HSV_MOD_DATE);
    eval 'sub HSV_EXP_DATE {
        my($x) = @_;
	    eval q( &HSV_exp_date($x));
    }' unless defined(&HSV_EXP_DATE);
    eval 'sub HSV_EFF_DATE {
        my($x) = @_;
	    eval q( &HSV_eff_date($x));
    }' unless defined(&HSV_EFF_DATE);
    eval 'sub HSV_FILE_STRUCT_VER {
        my($x) = @_;
	    eval q(*( &HSV_file_struct_ver($x)));
    }' unless defined(&HSV_FILE_STRUCT_VER);
    eval 'sub HSV_DATE_2DIG {
        my($x) = @_;
	    eval q((((($x)[0] - ord(\'0\') * 10) + 					((x)[1] - \'0\'))));
    }' unless defined(&HSV_DATE_2DIG);
    eval 'sub HSV_DATE_4DIG {
        my($x) = @_;
	    eval q((((($x)[0] - ord(\'0\') * 1000) + 					(((x)[1] - \'0\') * 100) + 					(((x)[2] - \'0\') * 10) +							((x)[3] - \'0\'))));
    }' unless defined(&HSV_DATE_4DIG);
    eval 'sub HSV_DATE_YEAR {
        my($x) = @_;
	    eval q( &HSV_DATE_4DIG((( &uchar_t *)$x)[0]));
    }' unless defined(&HSV_DATE_YEAR);
    eval 'sub HSV_DATE_MONTH {
        my($x) = @_;
	    eval q( &HSV_DATE_2DIG((( &uchar_t *)$x)[4]));
    }' unless defined(&HSV_DATE_MONTH);
    eval 'sub HSV_DATE_DAY {
        my($x) = @_;
	    eval q( &HSV_DATE_2DIG((( &uchar_t *)$x)[6]));
    }' unless defined(&HSV_DATE_DAY);
    eval 'sub HSV_DATE_HOUR {
        my($x) = @_;
	    eval q( &HSV_DATE_2DIG((( &uchar_t *)$x)[8]));
    }' unless defined(&HSV_DATE_HOUR);
    eval 'sub HSV_DATE_MIN {
        my($x) = @_;
	    eval q( &HSV_DATE_2DIG((( &uchar_t *)$x)[10]));
    }' unless defined(&HSV_DATE_MIN);
    eval 'sub HSV_DATE_SEC {
        my($x) = @_;
	    eval q( &HSV_DATE_2DIG((( &uchar_t *)$x)[12]));
    }' unless defined(&HSV_DATE_SEC);
    eval 'sub HSV_DATE_HSEC {
        my($x) = @_;
	    eval q( &HSV_DATE_2DIG((( &uchar_t *)$x)[14]));
    }' unless defined(&HSV_DATE_HSEC);
    eval 'sub HSV_DATE_GMTOFF {
        my($x) = @_;
	    eval q((($x)[16]));
    }' unless defined(&HSV_DATE_GMTOFF);
    eval 'sub HPE_FPESIZE () {8;}' unless defined(&HPE_FPESIZE);
    eval 'sub HPE_ext_lbn {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[0]));
    }' unless defined(&HPE_ext_lbn);
    eval 'sub HPE_xar_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&HPE_xar_len);
    eval 'sub HPE_name_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[5]));
    }' unless defined(&HPE_name_len);
    eval 'sub HPE_parent_no {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[6]));
    }' unless defined(&HPE_parent_no);
    eval 'sub HPE_name {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[8]));
    }' unless defined(&HPE_name);
    if(defined( &sparc) || defined( &__sparc)) {
	eval 'sub HPE_EXT_LBN {
	    my($x) = @_;
    	    eval q(( &MSB_INT( &HPE_ext_lbn($x))));
	}' unless defined(&HPE_EXT_LBN);
    } else {
	eval 'sub HPE_EXT_LBN {
	    my($x) = @_;
    	    eval q(*( &HPE_ext_lbn($x)));
	}' unless defined(&HPE_EXT_LBN);
    }
    eval 'sub HPE_XAR_LEN {
        my($x) = @_;
	    eval q(*( &HPE_xar_len($x)));
    }' unless defined(&HPE_XAR_LEN);
    eval 'sub HPE_NAME_LEN {
        my($x) = @_;
	    eval q(*( &HPE_name_len($x)));
    }' unless defined(&HPE_NAME_LEN);
    eval 'sub HPE_PARENT_NO {
        my($x) = @_;
	    eval q(*( &HPE_parent_no($x)));
    }' unless defined(&HPE_PARENT_NO);
    eval 'sub HPE_NAME {
        my($x) = @_;
	    eval q( &HPE_name($x));
    }' unless defined(&HPE_NAME);
    eval 'sub HDE_ROOT_DIR_REC_SIZE () {34;}' unless defined(&HDE_ROOT_DIR_REC_SIZE);
    eval 'sub HDE_FDESIZE () {33;}' unless defined(&HDE_FDESIZE);
    eval 'sub HDE_FUSIZE () {12;}' unless defined(&HDE_FUSIZE);
    eval 'sub HDE_MAX_NAME_LEN () {(255-  &HDE_FDESIZE -  &HDE_FUSIZE);}' unless defined(&HDE_MAX_NAME_LEN);
    eval 'sub UNIX_TO_HDE_DATE {
        my($t, $p) = @_;
	    eval q( &parse_unixdate(($t), ($p)));
    }' unless defined(&UNIX_TO_HDE_DATE);
    eval 'sub HDE_dir_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[0]));
    }' unless defined(&HDE_dir_len);
    eval 'sub HDE_xar_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[1]));
    }' unless defined(&HDE_xar_len);
    eval 'sub HDE_ext_lbn {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[2]));
    }' unless defined(&HDE_ext_lbn);
    eval 'sub HDE_ext_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[10]));
    }' unless defined(&HDE_ext_size);
    eval 'sub HDE_cdate {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[18]));
    }' unless defined(&HDE_cdate);
    eval 'sub HDE_flags {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[24]));
    }' unless defined(&HDE_flags);
    eval 'sub HDE_reserved {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[25]));
    }' unless defined(&HDE_reserved);
    eval 'sub HDE_intrlv_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[26]));
    }' unless defined(&HDE_intrlv_size);
    eval 'sub HDE_intrlv_skip {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[27]));
    }' unless defined(&HDE_intrlv_skip);
    eval 'sub HDE_vol_set {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[28]));
    }' unless defined(&HDE_vol_set);
    eval 'sub HDE_name_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[32]));
    }' unless defined(&HDE_name_len);
    eval 'sub HDE_name {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[33]));
    }' unless defined(&HDE_name);
    eval 'sub HDE_mode {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[0]));
    }' unless defined(&HDE_mode);
    eval 'sub HDE_uid {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&HDE_uid);
    eval 'sub HDE_gid {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[8]));
    }' unless defined(&HDE_gid);
    eval 'sub HDE_DIR_LEN {
        my($x) = @_;
	    eval q(*( &HDE_dir_len($x)));
    }' unless defined(&HDE_DIR_LEN);
    eval 'sub HDE_XAR_LEN {
        my($x) = @_;
	    eval q(*( &HDE_xar_len($x)));
    }' unless defined(&HDE_XAR_LEN);
    eval 'sub HDE_EXT_LBN {
        my($x) = @_;
	    eval q( &BOTH_INT( &HDE_ext_lbn($x)));
    }' unless defined(&HDE_EXT_LBN);
    eval 'sub HDE_EXT_SIZE {
        my($x) = @_;
	    eval q( &BOTH_INT( &HDE_ext_size($x)));
    }' unless defined(&HDE_EXT_SIZE);
    eval 'sub HDE_CDATE {
        my($x) = @_;
	    eval q( &HDE_cdate($x));
    }' unless defined(&HDE_CDATE);
    eval 'sub HDE_FLAGS {
        my($x) = @_;
	    eval q(*( &HDE_flags($x)));
    }' unless defined(&HDE_FLAGS);
    eval 'sub HDE_RESERVED {
        my($x) = @_;
	    eval q(*( &HDE_reserved($x)));
    }' unless defined(&HDE_RESERVED);
    eval 'sub HDE_INTRLV_SIZE {
        my($x) = @_;
	    eval q(*( &HDE_intrlv_size($x)));
    }' unless defined(&HDE_INTRLV_SIZE);
    eval 'sub HDE_INTRLV_SKIP {
        my($x) = @_;
	    eval q(*( &HDE_intrlv_skip($x)));
    }' unless defined(&HDE_INTRLV_SKIP);
    eval 'sub HDE_VOL_SET {
        my($x) = @_;
	    eval q( &BOTH_SHORT( &HDE_vol_set($x)));
    }' unless defined(&HDE_VOL_SET);
    eval 'sub HDE_NAME_LEN {
        my($x) = @_;
	    eval q(*( &HDE_name_len($x)));
    }' unless defined(&HDE_NAME_LEN);
    eval 'sub HDE_NAME {
        my($x) = @_;
	    eval q( &HDE_name($x));
    }' unless defined(&HDE_NAME);
    eval 'sub HDE_MODE {
        my($x) = @_;
	    eval q(*( &HDE_mode($x)));
    }' unless defined(&HDE_MODE);
    eval 'sub HDE_UID {
        my($x) = @_;
	    eval q(*( &HDE_uid($x)));
    }' unless defined(&HDE_UID);
    eval 'sub HDE_GID {
        my($x) = @_;
	    eval q(*( &HDE_gid($x)));
    }' unless defined(&HDE_GID);
    eval 'sub HDE_EXISTENCE () {0x1;}' unless defined(&HDE_EXISTENCE);
    eval 'sub HDE_DIRECTORY () {0x2;}' unless defined(&HDE_DIRECTORY);
    eval 'sub HDE_ASSOCIATED () {0x4;}' unless defined(&HDE_ASSOCIATED);
    eval 'sub HDE_RECORD () {0x8;}' unless defined(&HDE_RECORD);
    eval 'sub HDE_PROTECTION () {0x10;}' unless defined(&HDE_PROTECTION);
    eval 'sub HDE_UNUSED_FLAGS () {0x60;}' unless defined(&HDE_UNUSED_FLAGS);
    eval 'sub HDE_LAST_EXTENT () {0x80;}' unless defined(&HDE_LAST_EXTENT);
    eval 'sub HDE_PROHIBITED () {( &HDE_DIRECTORY |  &HDE_RECORD |  &HDE_LAST_EXTENT |  &HDE_UNUSED_FLAGS);}' unless defined(&HDE_PROHIBITED);
    eval 'sub HDE_DATE_YEAR {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[0] + 1900));
    }' unless defined(&HDE_DATE_YEAR);
    eval 'sub HDE_DATE_MONTH {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[1]));
    }' unless defined(&HDE_DATE_MONTH);
    eval 'sub HDE_DATE_DAY {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[2]));
    }' unless defined(&HDE_DATE_DAY);
    eval 'sub HDE_DATE_HOUR {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[3]));
    }' unless defined(&HDE_DATE_HOUR);
    eval 'sub HDE_DATE_MIN {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&HDE_DATE_MIN);
    eval 'sub HDE_DATE_SEC {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[5]));
    }' unless defined(&HDE_DATE_SEC);
    eval 'sub HDE_DATE_GMTOFF {
        my($x) = @_;
	    eval q((($x)[6]));
    }' unless defined(&HDE_DATE_GMTOFF);
    eval 'sub HDE_REGULAR_FILE {
        my($x) = @_;
	    eval q(((($x) &  &HDE_PROHIBITED) == 0));
    }' unless defined(&HDE_REGULAR_FILE);
    eval 'sub HDE_REGULAR_DIR {
        my($x) = @_;
	    eval q(((($x) &  &HDE_PROHIBITED) ==  &HDE_DIRECTORY));
    }' unless defined(&HDE_REGULAR_DIR);
    eval 'sub HS_DIR_NAMELEN () {31;}' unless defined(&HS_DIR_NAMELEN);
    eval 'sub HS_FILE_NAMELEN () {31;}' unless defined(&HS_FILE_NAMELEN);
    if(defined(&__cplusplus)) {
    }
}
1;
