require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_LUFS_H)) {
    eval 'sub _SYS_FS_LUFS_H () {1;}' unless defined(&_SYS_FS_LUFS_H);
    require 'sys/buf.ph';
    require 'sys/fs/ufs_trans.ph';
    require 'sys/fs/ufs_filio.ph';
    require 'sys/fs/ufs_inode.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub LUFS_EXTENTS () {( &UINT32_C(0));}' unless defined(&LUFS_EXTENTS);
    eval 'sub LS_SECTORS () {2;}' unless defined(&LS_SECTORS);
    eval 'sub LDL_MINTRANSFER () {( &UINT32_C(32768));}' unless defined(&LDL_MINTRANSFER);
    eval 'sub LDL_MAXTRANSFER () {( &UINT32_C(1048576));}' unless defined(&LDL_MAXTRANSFER);
    eval 'sub LDL_DIVISOR () {1024;}' unless defined(&LDL_DIVISOR);
    eval 'sub LDL_MINLOGSIZE () {(1024* 1024);}' unless defined(&LDL_MINLOGSIZE);
    eval 'sub LDL_MAXLOGSIZE () {(64* 1024* 1024);}' unless defined(&LDL_MAXLOGSIZE);
    eval 'sub LDL_MINBUFSIZE () {(32* 1024);}' unless defined(&LDL_MINBUFSIZE);
    eval 'sub LDL_USABLE_BSIZE () {( &DEV_BSIZE - $sizeof{ &sect_trailer_t});}' unless defined(&LDL_USABLE_BSIZE);
    eval 'sub NB_LEFT_IN_SECTOR {
        my($off) = @_;
	    eval q(( &LDL_USABLE_BSIZE - (($off) -  &dbtob( &btodb($off)))));
    }' unless defined(&NB_LEFT_IN_SECTOR);
    eval 'sub LUFS_VERSION () {( &UINT32_C(1));}' unless defined(&LUFS_VERSION);
    eval 'sub LUFS_VERSION_LATEST () { &LUFS_VERSION;}' unless defined(&LUFS_VERSION_LATEST);
    eval 'sub un_version () { ($un_ondisk->{od_version});}' unless defined(&un_version);
    eval 'sub un_logalloc () { ($un_ondisk->{od_logalloc});}' unless defined(&un_logalloc);
    eval 'sub un_badlog () { ($un_ondisk->{od_badlog});}' unless defined(&un_badlog);
    eval 'sub un_maxtransfer () { ($un_ondisk->{od_maxtransfer});}' unless defined(&un_maxtransfer);
    eval 'sub un_devbsize () { ($un_ondisk->{od_devbsize});}' unless defined(&un_devbsize);
    eval 'sub un_bol_lof () { ($un_ondisk->{od_bol_lof});}' unless defined(&un_bol_lof);
    eval 'sub un_eol_lof () { ($un_ondisk->{od_eol_lof});}' unless defined(&un_eol_lof);
    eval 'sub un_statesize () { ($un_ondisk->{od_statesize});}' unless defined(&un_statesize);
    eval 'sub un_logsize () { ($un_ondisk->{od_logsize});}' unless defined(&un_logsize);
    eval 'sub un_statebno () { ($un_ondisk->{od_statebno});}' unless defined(&un_statebno);
    eval 'sub un_logbno () { ($un_ondisk->{od_logbno});}' unless defined(&un_logbno);
    eval 'sub un_requestsize () { ($un_ondisk->{od_requestsize});}' unless defined(&un_requestsize);
    eval 'sub un_head_lof () { ($un_ondisk->{od_head_lof});}' unless defined(&un_head_lof);
    eval 'sub un_head_ident () { ($un_ondisk->{od_head_ident});}' unless defined(&un_head_ident);
    eval 'sub un_tail_lof () { ($un_ondisk->{od_tail_lof});}' unless defined(&un_tail_lof);
    eval 'sub un_tail_ident () { ($un_ondisk->{od_tail_ident});}' unless defined(&un_tail_ident);
    eval 'sub un_chksum () { ($un_ondisk->{od_chksum});}' unless defined(&un_chksum);
    eval 'sub un_head_tid () { ($un_ondisk->{od_head_tid});}' unless defined(&un_head_tid);
    eval 'sub un_debug () { ($un_ondisk->{od_debug});}' unless defined(&un_debug);
    eval 'sub un_timestamp () { ($un_ondisk->{od_timestamp});}' unless defined(&un_timestamp);
    eval 'sub LDL_SCAN () {0x1;}' unless defined(&LDL_SCAN);
    eval 'sub LDL_ERROR () {0x2;}' unless defined(&LDL_ERROR);
    eval 'sub MAPBLOCKSIZE () {(8192);}' unless defined(&MAPBLOCKSIZE);
    eval 'sub MAPBLOCKSHIFT () {(13);}' unless defined(&MAPBLOCKSHIFT);
    eval 'sub MAPBLOCKOFF () {( &MAPBLOCKSIZE-1);}' unless defined(&MAPBLOCKOFF);
    eval 'sub MAPBLOCKMASK () {(~ &MAPBLOCKOFF);}' unless defined(&MAPBLOCKMASK);
    eval 'sub me_mof () { ($me_delta->{d_mof});}' unless defined(&me_mof);
    eval 'sub me_nb () { ($me_delta->{d_nb});}' unless defined(&me_nb);
    eval 'sub me_dt () { ($me_delta->{d_typ});}' unless defined(&me_dt);
    eval 'sub ME_FREE () {(0x1);}' unless defined(&ME_FREE);
    eval 'sub ME_HASH () {(0x2);}' unless defined(&ME_HASH);
    eval 'sub ME_CANCEL () {(0x4);}' unless defined(&ME_CANCEL);
    eval 'sub ME_AGE () {(0x8);}' unless defined(&ME_AGE);
    eval 'sub ME_LIST () {(0x10);}' unless defined(&ME_LIST);
    eval 'sub ME_ROLL () {(0x20);}' unless defined(&ME_ROLL);
    eval("sub deltamaptype () { 0; }") unless defined(&deltamaptype);
    eval("sub udmaptype () { 1; }") unless defined(&udmaptype);
    eval("sub logmaptype () { 2; }") unless defined(&logmaptype);
    eval("sub matamaptype () { 3; }") unless defined(&matamaptype);
    eval 'sub DELTAMAP_NHASH () {(512);}' unless defined(&DELTAMAP_NHASH);
    eval 'sub LOGMAP_NHASH () {(2048);}' unless defined(&LOGMAP_NHASH);
    eval 'sub MAP_INDEX {
        my($mof, $mtm) = @_;
	    eval q(((($mof) >>  &MAPBLOCKSHIFT) & ( ($mtm->{mtm_nhash})-1)));
    }' unless defined(&MAP_INDEX);
    eval 'sub MAP_HASH {
        my($mof, $mtm) = @_;
	    eval q(( ($mtm->{mtm_hash}) +  &MAP_INDEX($mof, $mtm)));
    }' unless defined(&MAP_HASH);
    eval 'sub MTM_ROLL_EXIT () {(0x1);}' unless defined(&MTM_ROLL_EXIT);
    eval 'sub MTM_ROLL_RUNNING () {(0x2);}' unless defined(&MTM_ROLL_RUNNING);
    eval 'sub MTM_FORCE_ROLL () {(0x4);}' unless defined(&MTM_FORCE_ROLL);
    eval 'sub OVERLAP {
        my($sof, $snb, $dof, $dnb) = @_;
	    eval q((($sof >= $dof  && $sof < ($dof + $dnb)) || ($dof >= $sof  && $dof < ($sof + $snb))));
    }' unless defined(&OVERLAP);
    eval 'sub WITHIN {
        my($sof, $snb, $dof, $dnb) = @_;
	    eval q((($sof >= $dof)  && (($sof+$snb) <= ($dof+$dnb))));
    }' unless defined(&WITHIN);
    eval 'sub DATAoverlapME {
        my($mof, $hnb, $me) = @_;
	    eval q(( &OVERLAP($mof, $hnb,  ($me->{me_mof}),  ($me->{me_nb}))));
    }' unless defined(&DATAoverlapME);
    eval 'sub MEwithinDATA {
        my($me, $mof, $hnb) = @_;
	    eval q(( &WITHIN( ($me->{me_mof}),  ($me->{me_nb}), $mof, $hnb)));
    }' unless defined(&MEwithinDATA);
    eval 'sub DATAwithinME {
        my($mof, $hnb, $me) = @_;
	    eval q(( &WITHIN($mof, $hnb,  ($me->{me_mof}),  ($me->{me_nb}))));
    }' unless defined(&DATAwithinME);
    eval 'sub PW_INUSE () {0x1;}' unless defined(&PW_INUSE);
    eval 'sub PW_WAIT () {0x2;}' unless defined(&PW_WAIT);
    eval 'sub PW_REM () {0x4;}' unless defined(&PW_REM);
    eval 'sub MT_NONE () {(0x);}' unless defined(&MT_NONE);
    eval 'sub MT_TRANSACT () {(0x1);}' unless defined(&MT_TRANSACT);
    eval 'sub MT_MATAMAP () {(0x2);}' unless defined(&MT_MATAMAP);
    eval 'sub MT_WRITE_CHECK () {(0x4);}' unless defined(&MT_WRITE_CHECK);
    eval 'sub MT_LOG_WRITE_CHECK () {(0x8);}' unless defined(&MT_LOG_WRITE_CHECK);
    eval 'sub MT_CHECK_MAP () {(0x10);}' unless defined(&MT_CHECK_MAP);
    eval 'sub MT_TRACE () {(0x20);}' unless defined(&MT_TRACE);
    eval 'sub MT_SIZE () {(0x40);}' unless defined(&MT_SIZE);
    eval 'sub MT_NOASYNC () {(0x80);}' unless defined(&MT_NOASYNC);
    eval 'sub MT_FORCEROLL () {(0x100);}' unless defined(&MT_FORCEROLL);
    eval 'sub MT_SCAN () {(0x200);}' unless defined(&MT_SCAN);
    eval 'sub MT_PREWRITE () {(0x400);}' unless defined(&MT_PREWRITE);
    if(defined(&_KERNEL)) {
	eval 'sub LUFS_ENABLE {
	    my($vp, $fl, $cr, $error) = @_;
    	    eval q($error = (* ($lufsops->{lufs_enable}))($vp, $fl, $cr));
	}' unless defined(&LUFS_ENABLE);
	eval 'sub LUFS_DISABLE {
	    my($vp, $fl, $error) = @_;
    	    eval q($error = (* ($lufsops->{lufs_disable}))($vp, $fl));
	}' unless defined(&LUFS_DISABLE);
	eval 'sub LUFS_SNARF {
	    my($ufsvfsp, $fs, $ronly, $error) = @_;
    	    eval q($error = (* ($lufsops->{lufs_snarf}))($ufsvfsp, $fs, $ronly));
	}' unless defined(&LUFS_SNARF);
	eval 'sub LUFS_UNSNARF {
	    my($ufsvfsp) = @_;
    	    eval q((* ($lufsops->{lufs_unsnarf}))($ufsvfsp));
	}' unless defined(&LUFS_UNSNARF);
	eval 'sub LUFS_EMPTY {
	    my($ufsvfsp) = @_;
    	    eval q((* ($lufsops->{lufs_empty}))($ufsvfsp));
	}' unless defined(&LUFS_EMPTY);
	eval 'sub LUFS_STRATEGY {
	    my($ul, $bp) = @_;
    	    eval q((* ($lufsops->{lufs_strategy}))($ul, $bp));
	}' unless defined(&LUFS_STRATEGY);
	if(defined(&DEBUG)) {
	} else {
	    eval 'sub trans_alloc {
	        my($nb) = @_;
    		eval q( &kmem_alloc($nb,  &KM_SLEEP));
	    }' unless defined(&trans_alloc);
	    eval 'sub trans_zalloc {
	        my($nb) = @_;
    		eval q( &kmem_zalloc($nb,  &KM_SLEEP));
	    }' unless defined(&trans_zalloc);
	    eval 'sub trans_alloc_nosleep {
	        my($nb) = @_;
    		eval q( &kmem_alloc($nb,  &KM_NOSLEEP));
	    }' unless defined(&trans_alloc_nosleep);
	    eval 'sub trans_zalloc_nosleep {
	        my($nb) = @_;
    		eval q( &kmem_zalloc($nb,  &KM_NOSLEEP));
	    }' unless defined(&trans_zalloc_nosleep);
	    eval 'sub trans_free {
	        my($va, $nb) = @_;
    		eval q( &kmem_free($va, $nb));
	    }' unless defined(&trans_free);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
