require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_KMEM_IMPL_H)) {
    eval 'sub _SYS_KMEM_IMPL_H () {1;}' unless defined(&_SYS_KMEM_IMPL_H);
    require 'sys/kmem.ph';
    require 'sys/vmem.ph';
    require 'sys/thread.ph';
    require 'sys/t_lock.ph';
    require 'sys/time.ph';
    require 'sys/kstat.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub KMF_AUDIT () {0x1;}' unless defined(&KMF_AUDIT);
    eval 'sub KMF_DEADBEEF () {0x2;}' unless defined(&KMF_DEADBEEF);
    eval 'sub KMF_REDZONE () {0x4;}' unless defined(&KMF_REDZONE);
    eval 'sub KMF_CONTENTS () {0x8;}' unless defined(&KMF_CONTENTS);
    eval 'sub KMF_STICKY () {0x10;}' unless defined(&KMF_STICKY);
    eval 'sub KMF_NOMAGAZINE () {0x20;}' unless defined(&KMF_NOMAGAZINE);
    eval 'sub KMF_PAGEPERBUF () {0x40;}' unless defined(&KMF_PAGEPERBUF);
    eval 'sub KMF_LITE () {0x100;}' unless defined(&KMF_LITE);
    eval 'sub KMF_HASH () {0x200;}' unless defined(&KMF_HASH);
    eval 'sub KMF_RANDOMIZE () {0x400;}' unless defined(&KMF_RANDOMIZE);
    eval 'sub KMF_BUFTAG () {( &KMF_AUDIT |  &KMF_DEADBEEF |  &KMF_REDZONE |  &KMF_CONTENTS);}' unless defined(&KMF_BUFTAG);
    eval 'sub KMF_DBFLAGS () {( &KMF_BUFTAG |  &KMF_NOMAGAZINE |  &KMF_LITE);}' unless defined(&KMF_DBFLAGS);
    eval 'sub KMEM_STACK_DEPTH () {14;}' unless defined(&KMEM_STACK_DEPTH);
    eval 'sub KMEM_FREE_PATTERN () {0xdeadbeef;}' unless defined(&KMEM_FREE_PATTERN);
    eval 'sub KMEM_FREE_PATTERN_64 () {1.60456909848333e+19;}' unless defined(&KMEM_FREE_PATTERN_64);
    eval 'sub KMEM_UNINITIALIZED_PATTERN () {0xbaddcafe;}' unless defined(&KMEM_UNINITIALIZED_PATTERN);
    eval 'sub KMEM_REDZONE_PATTERN_64 () {1.83696142220613e+19;}' unless defined(&KMEM_REDZONE_PATTERN_64);
    eval 'sub KMEM_REDZONE_BYTE () {0xbb;}' unless defined(&KMEM_REDZONE_BYTE);
    eval 'sub bt_lastalloc () { ($_bt_info_un->{_bt_caller_info}->{_bt_lastalloc});}' unless defined(&bt_lastalloc);
    eval 'sub bt_lastfree () { ($_bt_info_un->{_bt_caller_info}->{_bt_lastfree});}' unless defined(&bt_lastfree);
    eval 'sub bt_bufctl () { ($_bt_info_un->{_bt_bufctl_info}->{_bt_bufctl});}' unless defined(&bt_bufctl);
    eval 'sub bt_bxstat () { ($_bt_info_un->{_bt_bufctl_info}->{_bt_bxstat});}' unless defined(&bt_bxstat);
    eval 'sub KMEM_BUFTAG {
        my($cp, $buf) = @_;
	    eval q((( &kmem_buftag_t *)(($buf) + ($cp)-> &cache_offset)));
    }' unless defined(&KMEM_BUFTAG);
    eval 'sub KMEM_BUFTAG_ALLOC () {0xa110c8ed;}' unless defined(&KMEM_BUFTAG_ALLOC);
    eval 'sub KMEM_BUFTAG_FREE () {0xf4eef4ee;}' unless defined(&KMEM_BUFTAG_FREE);
    eval 'sub KMEM_HASH_INITIAL () {64;}' unless defined(&KMEM_HASH_INITIAL);
    eval 'sub KMEM_HASH {
        my($cp, $buf) = @_;
	    eval q((($cp)-> &cache_hash_table + ((( &uintptr_t)($buf) >> ($cp)-> &cache_hash_shift) & ($cp)-> &cache_hash_mask)));
    }' unless defined(&KMEM_HASH);
    eval 'sub KMEM_CPU_CACHE_SIZE () {64;}' unless defined(&KMEM_CPU_CACHE_SIZE);
    eval 'sub KMEM_CPU_PAD () {( &KMEM_CPU_CACHE_SIZE - $sizeof{ &kmutex_t} - 4* $sizeof{\'int\'} - 3* $sizeof{ &void });}' unless defined(&KMEM_CPU_PAD);
    eval 'sub KMEM_CACHE_SIZE {
        my($ncpus) = @_;
	    eval q((((( &kmem_cache_t *)0)-> $cache_cpu[$ncpus])));
    }' unless defined(&KMEM_CACHE_SIZE);
    eval 'sub KMEM_CACHE_NAMELEN () {31;}' unless defined(&KMEM_CACHE_NAMELEN);
    eval 'sub KMEM_ALIGN () {8;}' unless defined(&KMEM_ALIGN);
    eval 'sub KMEM_ALIGN_SHIFT () {3;}' unless defined(&KMEM_ALIGN_SHIFT);
    eval 'sub KMEM_VOID_FRACTION () {8;}' unless defined(&KMEM_VOID_FRACTION);
    if(defined(&__cplusplus)) {
    }
}
1;
