require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MMAN_H)) {
    eval 'sub _SYS_MMAN_H () {1;}' unless defined(&_SYS_MMAN_H);
    require 'sys/feature_tests.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub PROT_READ () {0x1;}' unless defined(&PROT_READ);
    eval 'sub PROT_WRITE () {0x2;}' unless defined(&PROT_WRITE);
    eval 'sub PROT_EXEC () {0x4;}' unless defined(&PROT_EXEC);
    if(defined(&_KERNEL)) {
	eval 'sub PROT_USER () {0x8;}' unless defined(&PROT_USER);
	eval 'sub PROT_ZFOD () {( &PROT_READ |  &PROT_WRITE |  &PROT_EXEC |  &PROT_USER);}' unless defined(&PROT_ZFOD);
	eval 'sub PROT_ALL () {( &PROT_READ |  &PROT_WRITE |  &PROT_EXEC |  &PROT_USER);}' unless defined(&PROT_ALL);
    }
    eval 'sub PROT_NONE () {0x;}' unless defined(&PROT_NONE);
    eval 'sub MAP_SHARED () {1;}' unless defined(&MAP_SHARED);
    eval 'sub MAP_PRIVATE () {2;}' unless defined(&MAP_PRIVATE);
    eval 'sub MAP_TYPE () {0xf;}' unless defined(&MAP_TYPE);
    eval 'sub MAP_FIXED () {0x10;}' unless defined(&MAP_FIXED);
    eval 'sub MAP_NORESERVE () {0x40;}' unless defined(&MAP_NORESERVE);
    eval 'sub MAP_ANON () {0x100;}' unless defined(&MAP_ANON);
    eval 'sub MAP_ANONYMOUS () { &MAP_ANON;}' unless defined(&MAP_ANONYMOUS);
    eval 'sub MAP_RENAME () {0x20;}' unless defined(&MAP_RENAME);
    if(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) <= 2)  && !defined( &_XPG4_2)) {
	eval 'sub PROC_TEXT () {( &PROT_EXEC |  &PROT_READ);}' unless defined(&PROC_TEXT);
	eval 'sub PROC_DATA () {( &PROT_READ |  &PROT_WRITE |  &PROT_EXEC);}' unless defined(&PROC_DATA);
	eval 'sub SHARED () {0x10;}' unless defined(&SHARED);
	eval 'sub PRIVATE () {0x20;}' unless defined(&PRIVATE);
	eval 'sub VALID_ATTR () {( &PROT_READ| &PROT_WRITE| &PROT_EXEC| &SHARED| &PRIVATE);}' unless defined(&VALID_ATTR);
    }
    if(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) <= 2) || defined( &_XPG4_2)) {
	if(defined(&_KERNEL)) {
	    eval 'sub PROT_EXCL () {0x20;}' unless defined(&PROT_EXCL);
	    eval 'sub _MAP_LOW32 () {0x80;}' unless defined(&_MAP_LOW32);
	}
	eval 'sub _MAP_NEW () {0x80000000;}' unless defined(&_MAP_NEW);
    }
    if(!defined( &_ASM)  && !defined( &_KERNEL)) {
	require 'sys/types.ph';
	if(!defined( &_LP64)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    } else {
		eval 'sub mmap () { &mmap64;}' unless defined(&mmap);
	    }
	}
	if(defined( &_LP64)  && defined( &_LARGEFILE64_SOURCE)) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    } else {
		eval 'sub mmap64 () { &mmap;}' unless defined(&mmap64);
	    }
	}
	if(defined(&__STDC__)) {
	    if(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2) || defined( &_XPG4_2)) {
		if((!defined( &_XPG4_2) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2)) || defined( &__EXTENSIONS__)) {
		}
		if(defined( &_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64)  && !defined( &__PRAGMA_REDEFINE_EXTNAME))) {
		}
	    } else {
		if(defined(&_LARGEFILE64_SOURCE)) {
		}
	    }
	    if((!defined( &_XPG4_2) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2)) || defined( &__EXTENSIONS__)) {
	    }
	    eval 'sub MAP_FAILED () {(( &void *) -1);}' unless defined(&MAP_FAILED);
	} else {
	    if(defined( &_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64)  && !defined( &__PRAGMA_REDEFINE_EXTNAME))) {
	    }
	}
    }
    if(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) <= 2)  && !defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub MADV_NORMAL () {0;}' unless defined(&MADV_NORMAL);
	eval 'sub MADV_RANDOM () {1;}' unless defined(&MADV_RANDOM);
	eval 'sub MADV_SEQUENTIAL () {2;}' unless defined(&MADV_SEQUENTIAL);
	eval 'sub MADV_WILLNEED () {3;}' unless defined(&MADV_WILLNEED);
	eval 'sub MADV_DONTNEED () {4;}' unless defined(&MADV_DONTNEED);
	eval 'sub MADV_FREE () {5;}' unless defined(&MADV_FREE);
    }
    eval 'sub MS_OLDSYNC () {0x;}' unless defined(&MS_OLDSYNC);
    eval 'sub MS_SYNC () {0x4;}' unless defined(&MS_SYNC);
    eval 'sub MS_ASYNC () {0x1;}' unless defined(&MS_ASYNC);
    eval 'sub MS_INVALIDATE () {0x2;}' unless defined(&MS_INVALIDATE);
    if(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) <= 2)  && !defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub MC_SYNC () {1;}' unless defined(&MC_SYNC);
	eval 'sub MC_LOCK () {2;}' unless defined(&MC_LOCK);
	eval 'sub MC_UNLOCK () {3;}' unless defined(&MC_UNLOCK);
	eval 'sub MC_ADVISE () {4;}' unless defined(&MC_ADVISE);
	eval 'sub MC_LOCKAS () {5;}' unless defined(&MC_LOCKAS);
	eval 'sub MC_UNLOCKAS () {6;}' unless defined(&MC_UNLOCKAS);
    }
    if((!defined( &_XPG4_2) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2)) || defined( &__EXTENSIONS__)) {
	eval 'sub MCL_CURRENT () {0x1;}' unless defined(&MCL_CURRENT);
	eval 'sub MCL_FUTURE () {0x2;}' unless defined(&MCL_FUTURE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
