require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PROC_H)) {
    eval 'sub _SYS_PROC_H () {1;}' unless defined(&_SYS_PROC_H);
    require 'sys/time.ph';
    require 'sys/thread.ph';
    require 'sys/cred.ph';
    require 'sys/user.ph';
    require 'sys/watchpoint.ph';
    require 'sys/timer.ph';
    if(defined( &i386) || defined( &__i386) || defined( &__ia64)) {
	require 'sys/segment.ph';
    }
    require 'sys/utrap.ph';
    require 'sys/model.ph';
    require 'sys/refstr.ph';
    require 'sys/task.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined( &i386) || defined( &__i386) || defined( &__ia64)) {
    }
    if(defined( &__ia64)) {
    }
    if(defined( &__ia64)) {
	eval 'sub _ISA_IA32 () {0;}' unless defined(&_ISA_IA32);
	eval 'sub _ISA_IA64 () {1;}' unless defined(&_ISA_IA64);
	eval 'sub is_ia32_process {
	    my($p) = @_;
    	    eval q((($p)-> &p_isa ==  &_ISA_IA32));
	}' unless defined(&is_ia32_process);
    }
    eval 'sub PROC_T () {1;}' unless defined(&PROC_T);
    eval 'sub p_pgrp () { ($p_pgidp->{pid_id});}' unless defined(&p_pgrp);
    eval 'sub p_pid () { ($p_pidp->{pid_id});}' unless defined(&p_pid);
    eval 'sub p_slot () { ($p_pidp->{pid_prslot});}' unless defined(&p_slot);
    eval 'sub p_detached () { ($p_pgidp->{pid_pgorphaned});}' unless defined(&p_detached);
    eval 'sub PID_HOLD {
        my($pidp) = @_;
	    eval q( &ASSERT( &MUTEX_HELD( &pidlock)); ++($pidp)-> &pid_ref;);
    }' unless defined(&PID_HOLD);
    eval 'sub PID_RELE {
        my($pidp) = @_;
	    eval q( &ASSERT( &MUTEX_HELD( &pidlock)); ($pidp)-> &pid_ref > 1? --($pidp)-> &pid_ref :  &pid_rele($pidp););
    }' unless defined(&PID_RELE);
    eval 'sub p_lock () { ($p_lockp->{pl_lock});}' unless defined(&p_lock);
    eval 'sub SSLEEP () {1;}' unless defined(&SSLEEP);
    eval 'sub SRUN () {2;}' unless defined(&SRUN);
    eval 'sub SZOMB () {3;}' unless defined(&SZOMB);
    eval 'sub SSTOP () {4;}' unless defined(&SSTOP);
    eval 'sub SIDL () {5;}' unless defined(&SIDL);
    eval 'sub SONPROC () {6;}' unless defined(&SONPROC);
    eval 'sub CLDPEND () {0x1;}' unless defined(&CLDPEND);
    eval 'sub CLDCONT () {0x2;}' unless defined(&CLDCONT);
    eval 'sub SSYS () {0x1;}' unless defined(&SSYS);
    eval 'sub STRC () {0x2;}' unless defined(&STRC);
    eval 'sub SLOAD () {0x8;}' unless defined(&SLOAD);
    eval 'sub SLOCK () {0x10;}' unless defined(&SLOCK);
    eval 'sub SPREXEC () {0x20;}' unless defined(&SPREXEC);
    eval 'sub SPROCTR () {0x40;}' unless defined(&SPROCTR);
    eval 'sub SPRFORK () {0x80;}' unless defined(&SPRFORK);
    eval 'sub SKILLED () {0x100;}' unless defined(&SKILLED);
    eval 'sub SULOAD () {0x200;}' unless defined(&SULOAD);
    eval 'sub SRUNLCL () {0x400;}' unless defined(&SRUNLCL);
    eval 'sub SBPTADJ () {0x800;}' unless defined(&SBPTADJ);
    eval 'sub SKILLCL () {0x1000;}' unless defined(&SKILLCL);
    eval 'sub SOWEUPC () {0x2000;}' unless defined(&SOWEUPC);
    eval 'sub SEXECED () {0x4000;}' unless defined(&SEXECED);
    eval 'sub SPASYNC () {0x8000;}' unless defined(&SPASYNC);
    eval 'sub SJCTL () {0x10000;}' unless defined(&SJCTL);
    eval 'sub SNOWAIT () {0x20000;}' unless defined(&SNOWAIT);
    eval 'sub SVFORK () {0x40000;}' unless defined(&SVFORK);
    eval 'sub SVFWAIT () {0x80000;}' unless defined(&SVFWAIT);
    eval 'sub EXITLWPS () {0x100000;}' unless defined(&EXITLWPS);
    eval 'sub HOLDFORK () {0x200000;}' unless defined(&HOLDFORK);
    eval 'sub SWAITSIG () {0x400000;}' unless defined(&SWAITSIG);
    eval 'sub HOLDFORK1 () {0x800000;}' unless defined(&HOLDFORK1);
    eval 'sub COREDUMP () {0x1000000;}' unless defined(&COREDUMP);
    eval 'sub SMSACCT () {0x2000000;}' unless defined(&SMSACCT);
    eval 'sub ASLWP () {0x4000000;}' unless defined(&ASLWP);
    eval 'sub SPRLOCK () {0x8000000;}' unless defined(&SPRLOCK);
    eval 'sub NOCD () {0x10000000;}' unless defined(&NOCD);
    eval 'sub HOLDWATCH () {0x20000000;}' unless defined(&HOLDWATCH);
    eval 'sub SMSFORK () {0x40000000;}' unless defined(&SMSFORK);
    eval 'sub SDOCORE () {0x80000000;}' unless defined(&SDOCORE);
    eval 'sub PTOU {
        my($p) = @_;
	    eval q((($p)-> &p_user));
    }' unless defined(&PTOU);
    eval 'sub tracing {
        my($p, $sig) = @_;
	    eval q(( &sigismember(($p)-> &p_sigmask, $sig)));
    }' unless defined(&tracing);
    eval 'sub ISSIG {
        my($t, $why) = @_;
	    eval q( &ISSIG_FAST($t,  &ttolwp($t),  &ttoproc($t), $why));
    }' unless defined(&ISSIG);
    eval 'sub ISSIG_FAST {
        my($t, $lwp, $p, $why) = @_;
	    eval q(( &ISSIG_PENDING($t, $lwp, $p)  &&  &issig($why)));
    }' unless defined(&ISSIG_FAST);
    eval 'sub ISSIG_PENDING {
        my($t, $lwp, $p) = @_;
	    eval q((($lwp)-> &lwp_cursig | ($p)-> ($p_sig->{__sigbits[0]}) | ($p)-> ($p_sig->{__sigbits[1]}) | ($t)-> ($t_sig->{__sigbits[0]}) | ($t)-> ($t_sig->{__sigbits[1]}) | ($p)-> &p_stopsig | (($t)-> &t_proc_flag & ( &TP_PRSTOP| &TP_HOLDLWP| &TP_CHKPT| &TP_PAUSE)) | (($p)-> &p_flag & ( &EXITLWPS| &SKILLED| &HOLDFORK1| &HOLDWATCH))));
    }' unless defined(&ISSIG_PENDING);
    eval 'sub ISSTOP {
        my($sig) = @_;
	    eval q(( ($u->{u_signal[$sig}-1]) ==  &SIG_DFL  &&  &sigismember( &stopdefault, $sig)));
    }' unless defined(&ISSTOP);
    eval 'sub ISHOLD {
        my($p) = @_;
	    eval q((($p)-> &p_flag &  &HOLDFORK));
    }' unless defined(&ISHOLD);
    eval 'sub MUSTRETURN {
        my($p, $t) = @_;
	    eval q(( &ISHOLD($p) | ($t)-> ($t_activefd->{a_stale})));
    }' unless defined(&MUSTRETURN);
    eval 'sub ISANOMALOUS {
        my($p) = @_;
	    eval q(( ($curthread->{t_astflag}) | (($p)-> &p_flag & ( &EXITLWPS| &SKILLED| &HOLDFORK| &HOLDFORK1| &HOLDWATCH)) | ( ($curthread->{t_proc_flag}) &  &TP_HOLDLWP)));
    }' unless defined(&ISANOMALOUS);
    eval 'sub FORREAL () {0;}' unless defined(&FORREAL);
    eval 'sub JUSTLOOKING () {1;}' unless defined(&JUSTLOOKING);
    eval 'sub SUSPEND_NORMAL () {0;}' unless defined(&SUSPEND_NORMAL);
    eval 'sub SUSPEND_PAUSE () {1;}' unless defined(&SUSPEND_PAUSE);
    eval 'sub NOCLASS () {(-1);}' unless defined(&NOCLASS);
    eval 'sub TIDHASHSZ () {1024;}' unless defined(&TIDHASHSZ);
    eval 'sub TIDHASH {
        my($tid) = @_;
	    eval q((($tid) & ( &TIDHASHSZ - 1)));
    }' unless defined(&TIDHASH);
    if(defined(&_KERNEL)) {
	if(defined( &i386) || defined( &__i386) || defined( &__ia64)) {
	}
	if(defined(&_SYSCALL32_IMPL)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
