require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PROCFS_H)) {
    eval 'sub _SYS_PROCFS_H () {1;}' unless defined(&_SYS_PROCFS_H);
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_STRUCTURED_PROC)) {
	eval 'sub _STRUCTURED_PROC () {0;}' unless defined(&_STRUCTURED_PROC);
    }
    if(!defined( &_KERNEL)  && (defined(&_STRUCTURED_PROC) ? &_STRUCTURED_PROC : 0) == 0) {
	require 'sys/old_procfs.ph';
    } else {
	require 'sys/feature_tests.ph';
	require 'sys/types.ph';
	require 'sys/time_impl.ph';
	require 'sys/signal.ph';
	require 'sys/siginfo.ph';
	require 'sys/fault.ph';
	require 'sys/syscall.ph';
	require 'sys/pset.ph';
	require 'sys/procfs_isa.ph';
	if(!defined( &_LP64)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) {
	    die("Cannot use procfs in the large file compilation environment");
	}
	eval 'sub PCNULL () {0;}' unless defined(&PCNULL);
	eval 'sub PCSTOP () {1;}' unless defined(&PCSTOP);
	eval 'sub PCDSTOP () {2;}' unless defined(&PCDSTOP);
	eval 'sub PCWSTOP () {3;}' unless defined(&PCWSTOP);
	eval 'sub PCTWSTOP () {4;}' unless defined(&PCTWSTOP);
	eval 'sub PCRUN () {5;}' unless defined(&PCRUN);
	eval 'sub PCCSIG () {6;}' unless defined(&PCCSIG);
	eval 'sub PCCFAULT () {7;}' unless defined(&PCCFAULT);
	eval 'sub PCSSIG () {8;}' unless defined(&PCSSIG);
	eval 'sub PCKILL () {9;}' unless defined(&PCKILL);
	eval 'sub PCUNKILL () {10;}' unless defined(&PCUNKILL);
	eval 'sub PCSHOLD () {11;}' unless defined(&PCSHOLD);
	eval 'sub PCSTRACE () {12;}' unless defined(&PCSTRACE);
	eval 'sub PCSFAULT () {13;}' unless defined(&PCSFAULT);
	eval 'sub PCSENTRY () {14;}' unless defined(&PCSENTRY);
	eval 'sub PCSEXIT () {15;}' unless defined(&PCSEXIT);
	eval 'sub PCSET () {16;}' unless defined(&PCSET);
	eval 'sub PCUNSET () {17;}' unless defined(&PCUNSET);
	eval 'sub PCSREG () {18;}' unless defined(&PCSREG);
	eval 'sub PCSFPREG () {19;}' unless defined(&PCSFPREG);
	eval 'sub PCSXREG () {20;}' unless defined(&PCSXREG);
	eval 'sub PCNICE () {21;}' unless defined(&PCNICE);
	eval 'sub PCSVADDR () {22;}' unless defined(&PCSVADDR);
	eval 'sub PCWATCH () {23;}' unless defined(&PCWATCH);
	eval 'sub PCAGENT () {24;}' unless defined(&PCAGENT);
	eval 'sub PCREAD () {25;}' unless defined(&PCREAD);
	eval 'sub PCWRITE () {26;}' unless defined(&PCWRITE);
	eval 'sub PCSCRED () {27;}' unless defined(&PCSCRED);
	eval 'sub PCSASRS () {28;}' unless defined(&PCSASRS);
	eval 'sub PRCSIG () {0x1;}' unless defined(&PRCSIG);
	eval 'sub PRCFAULT () {0x2;}' unless defined(&PRCFAULT);
	eval 'sub PRSTEP () {0x4;}' unless defined(&PRSTEP);
	eval 'sub PRSABORT () {0x8;}' unless defined(&PRSABORT);
	eval 'sub PRSTOP () {0x10;}' unless defined(&PRSTOP);
	eval 'sub PRCLSZ () {8;}' unless defined(&PRCLSZ);
	eval 'sub PRSYSARGS () {8;}' unless defined(&PRSYSARGS);
	eval 'sub PR_STOPPED () {0x1;}' unless defined(&PR_STOPPED);
	eval 'sub PR_ISTOP () {0x2;}' unless defined(&PR_ISTOP);
	eval 'sub PR_DSTOP () {0x4;}' unless defined(&PR_DSTOP);
	eval 'sub PR_STEP () {0x8;}' unless defined(&PR_STEP);
	eval 'sub PR_ASLEEP () {0x10;}' unless defined(&PR_ASLEEP);
	eval 'sub PR_PCINVAL () {0x20;}' unless defined(&PR_PCINVAL);
	eval 'sub PR_ASLWP () {0x40;}' unless defined(&PR_ASLWP);
	eval 'sub PR_AGENT () {0x80;}' unless defined(&PR_AGENT);
	eval 'sub PR_ISSYS () {0x1000;}' unless defined(&PR_ISSYS);
	eval 'sub PR_VFORKP () {0x2000;}' unless defined(&PR_VFORKP);
	eval 'sub PR_ORPHAN () {0x4000;}' unless defined(&PR_ORPHAN);
	eval 'sub PR_FORK () {0x100000;}' unless defined(&PR_FORK);
	eval 'sub PR_RLC () {0x200000;}' unless defined(&PR_RLC);
	eval 'sub PR_KLC () {0x400000;}' unless defined(&PR_KLC);
	eval 'sub PR_ASYNC () {0x800000;}' unless defined(&PR_ASYNC);
	eval 'sub PR_MSACCT () {0x1000000;}' unless defined(&PR_MSACCT);
	eval 'sub PR_BPTADJ () {0x2000000;}' unless defined(&PR_BPTADJ);
	eval 'sub PR_PTRACE () {0x4000000;}' unless defined(&PR_PTRACE);
	eval 'sub PR_MSFORK () {0x8000000;}' unless defined(&PR_MSFORK);
	eval 'sub PR_REQUESTED () {1;}' unless defined(&PR_REQUESTED);
	eval 'sub PR_SIGNALLED () {2;}' unless defined(&PR_SIGNALLED);
	eval 'sub PR_SYSENTRY () {3;}' unless defined(&PR_SYSENTRY);
	eval 'sub PR_SYSEXIT () {4;}' unless defined(&PR_SYSEXIT);
	eval 'sub PR_JOBCONTROL () {5;}' unless defined(&PR_JOBCONTROL);
	eval 'sub PR_FAULTED () {6;}' unless defined(&PR_FAULTED);
	eval 'sub PR_SUSPENDED () {7;}' unless defined(&PR_SUSPENDED);
	eval 'sub PR_CHECKPOINT () {8;}' unless defined(&PR_CHECKPOINT);
	eval 'sub PRFNSZ () {16;}' unless defined(&PRFNSZ);
	eval 'sub PRARGSZ () {80;}' unless defined(&PRARGSZ);
	eval 'sub PRNODEV () {( &dev_t)(-1);}' unless defined(&PRNODEV);
	eval 'sub PRMAPSZ () {64;}' unless defined(&PRMAPSZ);
	eval 'sub MA_READ () {0x4;}' unless defined(&MA_READ);
	eval 'sub MA_WRITE () {0x2;}' unless defined(&MA_WRITE);
	eval 'sub MA_EXEC () {0x1;}' unless defined(&MA_EXEC);
	eval 'sub MA_SHARED () {0x8;}' unless defined(&MA_SHARED);
	eval 'sub MA_ANON () {0x40;}' unless defined(&MA_ANON);
	eval 'sub MA_ISM () {0x80;}' unless defined(&MA_ISM);
	eval 'sub MA_BREAK () {0x10;}' unless defined(&MA_BREAK);
	eval 'sub MA_STACK () {0x20;}' unless defined(&MA_STACK);
	eval 'sub WA_READ () {0x4;}' unless defined(&WA_READ);
	eval 'sub WA_WRITE () {0x2;}' unless defined(&WA_WRITE);
	eval 'sub WA_EXEC () {0x1;}' unless defined(&WA_EXEC);
	eval 'sub WA_TRAPAFTER () {0x8;}' unless defined(&WA_TRAPAFTER);
	eval 'sub PG_REFERENCED () {0x2;}' unless defined(&PG_REFERENCED);
	eval 'sub PG_MODIFIED () {0x1;}' unless defined(&PG_MODIFIED);
	eval 'sub PG_HWMAPPED () {0x4;}' unless defined(&PG_HWMAPPED);
	eval 'sub prfillset {
	    my($sp) = @_;
    	    eval q({  &register \'int\'  &_i_ = $sizeof{($sp)}/$sizeof{ &uint32_t};  &while ( &_i_) (( &uint32_t *)($sp))[-- &_i_] = ( &uint32_t)0xffffffff; });
	}' unless defined(&prfillset);
	eval 'sub premptyset {
	    my($sp) = @_;
    	    eval q({  &register \'int\'  &_i_ = $sizeof{($sp)}/$sizeof{ &uint32_t};  &while ( &_i_) (( &uint32_t *)($sp))[-- &_i_] = ( &uint32_t)0; });
	}' unless defined(&premptyset);
	eval 'sub praddset {
	    my($sp, $flag) = @_;
    	    eval q((( &void)(((($flag)-1) < 32*$sizeof{($sp)}/$sizeof{ &uint32_t}) ? ((( &uint32_t *)($sp))[(($flag)-1)/32] |= (1<<((($flag)-1)%32))) : 0)));
	}' unless defined(&praddset);
	eval 'sub prdelset {
	    my($sp, $flag) = @_;
    	    eval q((( &void)(((($flag)-1) < 32*$sizeof{($sp)}/$sizeof{ &uint32_t}) ? ((( &uint32_t *)($sp))[(($flag)-1)/32] &= ~(1<<((($flag)-1)%32))) : 0)));
	}' unless defined(&prdelset);
	eval 'sub prismember {
	    my($sp, $flag) = @_;
    	    eval q((((($flag)-1) < 32*$sizeof{($sp)}/$sizeof{ &uint32_t})  && ((( &uint32_t *)($sp))[(($flag)-1)/32] & (1<<((($flag)-1)%32)))));
	}' unless defined(&prismember);
	if(defined( &_SYSCALL32)) {
	    eval 'sub PRNODEV32 () {( &dev32_t)(-1);}' unless defined(&PRNODEV32);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
