require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_VFS_H)) {
    eval 'sub _SYS_VFS_H () {1;}' unless defined(&_SYS_VFS_H);
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'sys/cred.ph';
    require 'sys/vnode.ph';
    require 'sys/statvfs.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub MAXFIDSZ () {64;}' unless defined(&MAXFIDSZ);
    eval 'sub OLD_MAXFIDSZ () {16;}' unless defined(&OLD_MAXFIDSZ);
    if(defined(&_SYSCALL32)) {
    } else {
	eval 'sub fid32 () { &fid;}' unless defined(&fid32);
    }
    eval 'sub fid_len () { ($un->{_fid}->{len});}' unless defined(&fid_len);
    eval 'sub fid_data () { ($un->{_fid}->{data});}' unless defined(&fid_data);
    eval 'sub MO_SET () {0x1;}' unless defined(&MO_SET);
    eval 'sub MO_NODISPLAY () {0x2;}' unless defined(&MO_NODISPLAY);
    eval 'sub MO_HASVALUE () {0x4;}' unless defined(&MO_HASVALUE);
    eval 'sub MO_IGNORE () {0x8;}' unless defined(&MO_IGNORE);
    eval 'sub MO_DEFAULT () { &MO_SET;}' unless defined(&MO_DEFAULT);
    eval 'sub MO_TAG () {0x10;}' unless defined(&MO_TAG);
    eval 'sub MO_EMPTY () {0x20;}' unless defined(&MO_EMPTY);
    eval 'sub VFS_NOFORCEOPT () {0x1;}' unless defined(&VFS_NOFORCEOPT);
    eval 'sub VFS_DISPLAY () {0x2;}' unless defined(&VFS_DISPLAY);
    eval 'sub VFS_NODISPLAY () {0x4;}' unless defined(&VFS_NODISPLAY);
    eval 'sub VFS_CREATEOPT () {0x8;}' unless defined(&VFS_CREATEOPT);
    eval 'sub VFS_RDONLY () {0x1;}' unless defined(&VFS_RDONLY);
    eval 'sub VFS_NOMNTTAB () {0x2;}' unless defined(&VFS_NOMNTTAB);
    eval 'sub VFS_NOSUID () {0x8;}' unless defined(&VFS_NOSUID);
    eval 'sub VFS_REMOUNT () {0x10;}' unless defined(&VFS_REMOUNT);
    eval 'sub VFS_NOTRUNC () {0x20;}' unless defined(&VFS_NOTRUNC);
    eval 'sub VFS_UNLINKABLE () {0x40;}' unless defined(&VFS_UNLINKABLE);
    eval 'sub VFS_PXFS () {0x80;}' unless defined(&VFS_PXFS);
    eval 'sub VFS_UNMOUNTED () {0x100;}' unless defined(&VFS_UNMOUNTED);
    eval 'sub VFS_NORESOURCE () {"unspecified_resource";}' unless defined(&VFS_NORESOURCE);
    eval 'sub VFS_NOMNTPT () {"unspecified_mountpoint";}' unless defined(&VFS_NOMNTPT);
    eval("sub ROOT_INIT () { 0; }") unless defined(&ROOT_INIT);
    eval("sub ROOT_REMOUNT () { 1; }") unless defined(&ROOT_REMOUNT);
    eval("sub ROOT_UNMOUNT () { 2; }") unless defined(&ROOT_UNMOUNT);
    eval("sub ROOT_FRONTMOUNT () { 3; }") unless defined(&ROOT_FRONTMOUNT);
    eval("sub ROOT_BACKMOUNT () { 4; }") unless defined(&ROOT_BACKMOUNT);
    eval 'sub VFS_MOUNT {
        my($vfsp, $mvp, $uap, $cr) = @_;
	    eval q((*($vfsp)-> ($vfs_op->{vfs_mount}))($vfsp, $mvp, $uap, $cr));
    }' unless defined(&VFS_MOUNT);
    eval 'sub VFS_UNMOUNT {
        my($vfsp, $flag, $cr) = @_;
	    eval q((*($vfsp)-> ($vfs_op->{vfs_unmount}))($vfsp, $flag, $cr));
    }' unless defined(&VFS_UNMOUNT);
    eval 'sub VFS_ROOT {
        my($vfsp, $vpp) = @_;
	    eval q((*($vfsp)-> ($vfs_op->{vfs_root}))($vfsp, $vpp));
    }' unless defined(&VFS_ROOT);
    eval 'sub VFS_STATVFS {
        my($vfsp, $sp) = @_;
	    eval q((*($vfsp)-> ($vfs_op->{vfs_statvfs}))($vfsp, $sp));
    }' unless defined(&VFS_STATVFS);
    eval 'sub VFS_SYNC {
        my($vfsp, $flag, $cr) = @_;
	    eval q((*($vfsp)-> ($vfs_op->{vfs_sync}))($vfsp, $flag, $cr));
    }' unless defined(&VFS_SYNC);
    eval 'sub VFS_VGET {
        my($vfsp, $vpp, $fidp) = @_;
	    eval q((*($vfsp)-> ($vfs_op->{vfs_vget}))($vfsp, $vpp, $fidp));
    }' unless defined(&VFS_VGET);
    eval 'sub VFS_MOUNTROOT {
        my($vfsp, $init) = @_;
	    eval q((*($vfsp)-> ($vfs_op->{vfs_mountroot}))($vfsp, $init));
    }' unless defined(&VFS_MOUNTROOT);
    eval 'sub VFS_SWAPVP {
        my($vfsp, $vpp, $nm) = @_;
	    eval q((*($vfsp)-> ($vfs_op->{vfs_swapvp}))($vfsp, $vpp, $nm));
    }' unless defined(&VFS_SWAPVP);
    eval 'sub VFS_FREEVFS {
        my($vfsp) = @_;
	    eval q((*($vfsp)-> ($vfs_op->{vfs_freevfs}))($vfsp));
    }' unless defined(&VFS_FREEVFS);
    eval 'sub VSW_HASPROTO () {0x1;}' unless defined(&VSW_HASPROTO);
    eval 'sub VSW_CANRWRO () {0x2;}' unless defined(&VSW_CANRWRO);
    if(defined( &_KERNEL)) {
	eval 'sub vfs_opttblptr {
	    my($vfsp) = @_;
    	    eval q(( ($vfsp->{vfs_mntopts})));
	}' unless defined(&vfs_opttblptr);
	eval 'sub VFSHASH {
	    my($dev, $fstyp) = @_;
    	    eval q((($dev + $fstyp) & ( &vfshsz - 1)));
	}' unless defined(&VFSHASH);
    }
    eval 'sub VFS_HOLD {
        my($vfsp) = @_;
	    eval q({  &vfs_hold($vfsp); });
    }' unless defined(&VFS_HOLD);
    eval 'sub VFS_RELE {
        my($vfsp) = @_;
	    eval q({  &vfs_rele($vfsp); });
    }' unless defined(&VFS_RELE);
    eval 'sub VFS_INIT {
        my($vfsp, $op, $data) = @_;
	    eval q({ ($vfsp)-> &vfs_count = 0; ($vfsp)-> &vfs_next = 0; ($vfsp)-> &vfs_op = ($op); ($vfsp)-> &vfs_flag = 0; ($vfsp)-> &vfs_data = ($data); ($vfsp)-> &vfs_nsubmounts = 0; ($vfsp)-> &vfs_resource =  &NULL; ($vfsp)-> &vfs_mntpt =  &NULL; ($vfsp)-> ($vfs_mntopts->{mo_count}) = 0; ($vfsp)-> ($vfs_mntopts->{mo_list}) =  &NULL;  &sema_init(($vfsp)-> &vfs_reflock, 1,  &NULL,  &SEMA_DEFAULT,  &NULL); });
    }' unless defined(&VFS_INIT);
    eval 'sub VFS_INSTALLED {
        my($vfsswp) = @_;
	    eval q((($vfsswp)-> &vsw_vfsops));
    }' unless defined(&VFS_INSTALLED);
    eval 'sub ALLOCATED_VFSSW {
        my($vswp) = @_;
	    eval q((($vswp)-> $vsw_name[0] != ord(\'\\\\0\')));
    }' unless defined(&ALLOCATED_VFSSW);
    eval 'sub RLOCK_VFSSW () {
        eval q(( &rw_enter( &vfssw_lock,  &RW_READER)));
    }' unless defined(&RLOCK_VFSSW);
    eval 'sub RUNLOCK_VFSSW () {
        eval q(( &rw_exit( &vfssw_lock)));
    }' unless defined(&RUNLOCK_VFSSW);
    eval 'sub WLOCK_VFSSW () {
        eval q(( &rw_enter( &vfssw_lock,  &RW_WRITER)));
    }' unless defined(&WLOCK_VFSSW);
    eval 'sub WUNLOCK_VFSSW () {
        eval q(( &rw_exit( &vfssw_lock)));
    }' unless defined(&WUNLOCK_VFSSW);
    eval 'sub VFSSW_LOCKED () {
        eval q(( &RW_LOCK_HELD( &vfssw_lock)));
    }' unless defined(&VFSSW_LOCKED);
    eval 'sub VFSSW_WRITE_LOCKED () {
        eval q(( &RW_WRITE_HELD( &vfssw_lock)));
    }' unless defined(&VFSSW_WRITE_LOCKED);
    eval 'sub SYNC_ATTR () {0x1;}' unless defined(&SYNC_ATTR);
    eval 'sub SYNC_CLOSE () {0x2;}' unless defined(&SYNC_CLOSE);
    eval 'sub SYNC_ALL () {0x4;}' unless defined(&SYNC_ALL);
    if(defined(&__cplusplus)) {
    }
}
1;
