require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_UTILITY_H)) {
    eval 'sub _UTILITY_H () {1;}' unless defined(&_UTILITY_H);
    require 'form.ph';
    require 'memory.ph';
    require 'string.ph';
    require 'ctype.ph';
    require 'stdarg.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub MIN {
        my($x, $y) = @_;
	    eval q((($x) < ($y) ? ($x) : ($y)));
    }' unless defined(&MIN);
    eval 'sub POSTED () {0x1;}' unless defined(&POSTED);
    eval 'sub DRIVER () {0x2;}' unless defined(&DRIVER);
    eval 'sub OVERLAY () {0x4;}' unless defined(&OVERLAY);
    eval 'sub WIN_CHG () {0x10;}' unless defined(&WIN_CHG);
    eval 'sub BUF_CHG () {0x20;}' unless defined(&BUF_CHG);
    eval 'sub USR_CHG () {0x1;}' unless defined(&USR_CHG);
    eval 'sub TOP_CHG () {0x2;}' unless defined(&TOP_CHG);
    eval 'sub NEW_PAGE () {0x4;}' unless defined(&NEW_PAGE);
    eval 'sub GROWABLE () {0x8;}' unless defined(&GROWABLE);
    eval 'sub LINKED () {0x1;}' unless defined(&LINKED);
    eval 'sub ARGS () {0x2;}' unless defined(&ARGS);
    eval 'sub CHOICE () {0x4;}' unless defined(&CHOICE);
    eval 'sub Status {
        my($f, $s) = @_;
	    eval q((($f) ->  &status & ($s)));
    }' unless defined(&Status);
    eval 'sub Set {
        my($f, $s) = @_;
	    eval q((($f) ->  &status |= ($s)));
    }' unless defined(&Set);
    eval 'sub Clr {
        my($f, $s) = @_;
	    eval q((($f) ->  &status &= ~($s)));
    }' unless defined(&Clr);
    eval 'sub Opt {
        my($f, $x) = @_;
	    eval q((($f) ->  &opts & ($x)));
    }' unless defined(&Opt);
    eval 'sub Alloc {
        my($x, $t) = @_;
	    eval q((($x = ($t *)  &malloc($sizeof{$t})) != ($t *)0));
    }' unless defined(&Alloc);
    eval 'sub arrayAlloc {
        my($x, $n, $t) = @_;
	    eval q((($x = ($t *)  &malloc(($n) * $sizeof{$t})) != ($t *)0));
    }' unless defined(&arrayAlloc);
    eval 'sub Free {
        my($x) = @_;
	    eval q({  &if ($x)  &free($x); });
    }' unless defined(&Free);
    eval 'sub MakeArg {
        my($f, $p, $err) = @_;
	    eval q(( &_makearg(($f) ->  &type, $p, $err)));
    }' unless defined(&MakeArg);
    eval 'sub CopyArg {
        my($f, $err) = @_;
	    eval q(( &_copyarg(($f) ->  &type, ($f) ->  &arg, $err)));
    }' unless defined(&CopyArg);
    eval 'sub FreeArg {
        my($f) = @_;
	    eval q(( &_freearg(($f) ->  &type, ($f) ->  &arg)));
    }' unless defined(&FreeArg);
    eval 'sub CheckField {
        my($f) = @_;
	    eval q(( &_checkfield(($f) ->  &type, ($f), ($f) ->  &arg)));
    }' unless defined(&CheckField);
    eval 'sub CheckChar {
        my($f, $c) = @_;
	    eval q(( &_checkchar(($f) ->  &type, ($c), ($f) ->  &arg)));
    }' unless defined(&CheckChar);
    eval 'sub NextChoice {
        my($f) = @_;
	    eval q(( &_nextchoice(($f) ->  &type, ($f), ($f) ->  &arg)));
    }' unless defined(&NextChoice);
    eval 'sub PrevChoice {
        my($f) = @_;
	    eval q(( &_prevchoice(($f) ->  &type, ($f), ($f) ->  &arg)));
    }' unless defined(&PrevChoice);
    eval 'sub IncrType {
        my($type) = @_;
	    eval q({  &if ($type) ++($type ->  &ref); });
    }' unless defined(&IncrType);
    eval 'sub DecrType {
        my($type) = @_;
	    eval q({  &if ($type) --($type ->  &ref); });
    }' unless defined(&DecrType);
    eval 'sub init_field {
        my($f) = @_;
	    eval q({  &if (($f) ->  &fieldinit) {  &Set($f,  &DRIVER); (*($f) ->  &fieldinit)($f);  &Clr($f,  &DRIVER); } });
    }' unless defined(&init_field);
    eval 'sub term_field {
        my($f) = @_;
	    eval q({  &if (($f) ->  &fieldterm) {  &Set($f,  &DRIVER); (*($f) ->  &fieldterm)($f);  &Clr($f,  &DRIVER); } });
    }' unless defined(&term_field);
    eval 'sub init_form {
        my($f) = @_;
	    eval q({  &if (($f) ->  &forminit) {  &Set($f,  &DRIVER); (*($f) ->  &forminit)($f);  &Clr($f,  &DRIVER); } });
    }' unless defined(&init_form);
    eval 'sub term_form {
        my($f) = @_;
	    eval q({  &if (($f) ->  &formterm) {  &Set($f,  &DRIVER); (*($f) ->  &formterm)($f);  &Clr($f,  &DRIVER); } });
    }' unless defined(&term_form);
    eval 'sub P {
        my($f) = @_;
	    eval q((($f) ->  &curpage));
    }' unless defined(&P);
    eval 'sub Pmin {
        my($f, $p) = @_;
	    eval q((($f) ->  &page [$p]. &pmin));
    }' unless defined(&Pmin);
    eval 'sub Pmax {
        my($f, $p) = @_;
	    eval q((($f) ->  &page [$p]. &pmax));
    }' unless defined(&Pmax);
    eval 'sub Smin {
        my($f,	$p) = @_;
	    eval q((($f) ->  &page [$p]. &smin));
    }' unless defined(&Smin);
    eval 'sub Smax {
        my($f, $p) = @_;
	    eval q((($f) ->  &page [$p]. &smax));
    }' unless defined(&Smax);
    eval 'sub Form {
        my($f) = @_;
	    eval q((($f) ? ($f) :  &_DEFAULT_FORM));
    }' unless defined(&Form);
    eval 'sub ValidIndex {
        my($f, $i) = @_;
	    eval q((($i) >= 0 && ($i) < ($f) ->  &maxfield));
    }' unless defined(&ValidIndex);
    eval 'sub ValidPage {
        my($f, $i) = @_;
	    eval q((($i) >= 0 && ($i) < ($f) ->  &maxpage));
    }' unless defined(&ValidPage);
    eval 'sub C {
        my($f) = @_;
	    eval q((($f) ->  &current));
    }' unless defined(&C);
    eval 'sub W {
        my($f) = @_;
	    eval q((($f) ->  &w));
    }' unless defined(&W);
    eval 'sub X {
        my($f) = @_;
	    eval q((($f) ->  &curcol));
    }' unless defined(&X);
    eval 'sub Y {
        my($f) = @_;
	    eval q((($f) ->  &currow));
    }' unless defined(&Y);
    eval 'sub T {
        my($f) = @_;
	    eval q((($f) ->  &toprow));
    }' unless defined(&T);
    eval 'sub B {
        my($f) = @_;
	    eval q((($f) ->  &begincol));
    }' unless defined(&B);
    eval 'sub Xmax {
        my($f) = @_;
	    eval q(( &C($f) ->  &dcols));
    }' unless defined(&Xmax);
    eval 'sub Ymax {
        my($f) = @_;
	    eval q(( &C($f) ->  &drows));
    }' unless defined(&Ymax);
    eval 'sub Win {
        my($f) = @_;
	    eval q((($f) ->  &win ? ($f) ->  &win :  &stdscr));
    }' unless defined(&Win);
    eval 'sub Sub {
        my($f) = @_;
	    eval q((($f) ->  &sub ? ($f) ->  &sub :  &Win($f)));
    }' unless defined(&Sub);
    eval 'sub Field {
        my($f) = @_;
	    eval q((($f) ? ($f) :  &_DEFAULT_FIELD));
    }' unless defined(&Field);
    eval 'sub Buf {
        my($f) = @_;
	    eval q((($f) ->  &buf));
    }' unless defined(&Buf);
    eval 'sub OneRow {
        my($f) = @_;
	    eval q((($f)-> &rows + ($f)-> &nrow == 1));
    }' unless defined(&OneRow);
    eval 'sub GrowSize {
        my($f) = @_;
	    eval q(((($f) ->  &rows + ($f) ->  &nrow) * ($f) ->  &cols));
    }' unless defined(&GrowSize);
    eval 'sub BufSize {
        my($f) = @_;
	    eval q((($f) ->  &drows * ($f) ->  &dcols));
    }' unless defined(&BufSize);
    eval 'sub Buffer {
        my($f, $n) = @_;
	    eval q(( &Buf($f) + ($n) * ( &BufSize($f) + 1)));
    }' unless defined(&Buffer);
    eval 'sub LineBuf {
        my($f, $n) = @_;
	    eval q(( &Buf($f) + ($n) * ($f) ->  &dcols));
    }' unless defined(&LineBuf);
    eval 'sub TotalBuf {
        my($f) = @_;
	    eval q((( &BufSize($f) + 1) * (($f) ->  &nbuf + 1)));
    }' unless defined(&TotalBuf);
    eval 'sub Just {
        my($f) = @_;
	    eval q((($f) ->  &just));
    }' unless defined(&Just);
    eval 'sub Fore {
        my($f) = @_;
	    eval q((($f) ->  &fore));
    }' unless defined(&Fore);
    eval 'sub Back {
        my($f) = @_;
	    eval q((($f) ->  &back));
    }' unless defined(&Back);
    eval 'sub Pad {
        my($f) = @_;
	    eval q((($f) ->  &pad));
    }' unless defined(&Pad);
    if(defined(&__cplusplus)) {
    }
}
1;
