require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PRIVREGS_H)) {
    eval 'sub _SYS_PRIVREGS_H () {1;}' unless defined(&_SYS_PRIVREGS_H);
    if(defined(&__cplusplus)) {
    }
    require 'v7/sys/psr.ph';
    require 'sys/fsr.ph';
    unless(defined(&_ASM)) {
	eval 'sub r_ps () { &r_psr;}' unless defined(&r_ps);
	eval 'sub r_r0 () { &r_o0;}' unless defined(&r_r0);
	eval 'sub r_sp () { &r_o6;}' unless defined(&r_sp);
    }
    if(defined(&_KERNEL)) {
	eval 'sub PIL_MAX () {0xf;}' unless defined(&PIL_MAX);
	eval 'sub lwptoregs {
	    my($lwp) = @_;
    	    eval q(((($lwp)-> &lwp_regs)));
	}' unless defined(&lwptoregs);
	eval 'sub lwptofpu {
	    my($lwp) = @_;
    	    eval q(((($lwp)-> &lwp_fpu)));
	}' unless defined(&lwptofpu);
	eval 'sub SAVE_GLOBALS {
	    my($RP) = @_;
    	    eval q( &st % &g1, [$RP +  &G1*4];  &std % &g2, [$RP +  &G2*4];  &std % &g4, [$RP +  &G4*4];  &std % &g6, [$RP +  &G6*4];  &mov % &y, % &g1;  &st % &g1, [$RP +  &Y*4]);
	}' unless defined(&SAVE_GLOBALS);
	eval 'sub RESTORE_GLOBALS {
	    my($RP) = @_;
    	    eval q( &ld [$RP +  &Y*4], % &g1;  &mov % &g1, % &y;  &ld [$RP +  &G1*4], % &g1;  &ldd [$RP +  &G2*4], % &g2;  &ldd [$RP +  &G4*4], % &g4;  &ldd [$RP +  &G6*4], % &g6;);
	}' unless defined(&RESTORE_GLOBALS);
	eval 'sub SAVE_OUTS {
	    my($RP) = @_;
    	    eval q( &std % &i0, [$RP +  &O0*4];  &std % &i2, [$RP +  &O2*4];  &std % &i4, [$RP +  &O4*4];  &std % &i6, [$RP +  &O6*4];);
	}' unless defined(&SAVE_OUTS);
	eval 'sub RESTORE_OUTS {
	    my($RP) = @_;
    	    eval q( &ldd [$RP +  &O0*4], % &i0;  &ldd [$RP +  &O2*4], % &i2;  &ldd [$RP +  &O4*4], % &i4;  &ldd [$RP +  &O6*4], % &i6;);
	}' unless defined(&RESTORE_OUTS);
	eval 'sub SAVE_WINDOW {
	    my($SBP) = @_;
    	    eval q( &std % &l0, [$SBP + (0*4)];  &std % &l2, [$SBP + (2*4)];  &std % &l4, [$SBP + (4*4)];  &std % &l6, [$SBP + (6*4)];  &std % &i0, [$SBP + (8*4)];  &std % &i2, [$SBP + (10*4)];  &std % &i4, [$SBP + (12*4)];  &std % &i6, [$SBP + (14*4)];);
	}' unless defined(&SAVE_WINDOW);
	eval 'sub RESTORE_WINDOW {
	    my($SBP) = @_;
    	    eval q( &ldd [$SBP + (0*4)], % &l0;  &ldd [$SBP + (2*4)], % &l2;  &ldd [$SBP + (4*4)], % &l4;  &ldd [$SBP + (6*4)], % &l6;  &ldd [$SBP + (8*4)], % &i0;  &ldd [$SBP + (10*4)], % &i2;  &ldd [$SBP + (12*4)], % &i4;  &ldd [$SBP + (14*4)], % &i6;);
	}' unless defined(&RESTORE_WINDOW);
	eval 'sub STORE_FPREGS {
	    my($FP) = @_;
    	    eval q( &std % &f0, [$FP];  &std % &f2, [$FP + 8];  &std % &f4, [$FP + 16];  &std % &f6, [$FP + 24];  &std % &f8, [$FP + 32];  &std % &f10, [$FP + 40];  &std % &f12, [$FP + 48];  &std % &f14, [$FP + 56];  &std % &f16, [$FP + 64];  &std % &f18, [$FP + 72];  &std % &f20, [$FP + 80];  &std % &f22, [$FP + 88];  &std % &f24, [$FP + 96];  &std % &f26, [$FP + 104];  &std % &f28, [$FP + 112];  &std % &f30, [$FP + 120];);
	}' unless defined(&STORE_FPREGS);
	eval 'sub LOAD_FPREGS {
	    my($FP) = @_;
    	    eval q( &ldd [$FP], % &f0;  &ldd [$FP + 8], % &f2;  &ldd [$FP + 16], % &f4;  &ldd [$FP + 24], % &f6;  &ldd [$FP + 32], % &f8;  &ldd [$FP + 40], % &f10;  &ldd [$FP + 48], % &f12;  &ldd [$FP + 56], % &f14;  &ldd [$FP + 64], % &f16;  &ldd [$FP + 72], % &f18;  &ldd [$FP + 80], % &f20;  &ldd [$FP + 88], % &f22;  &ldd [$FP + 96], % &f24;  &ldd [$FP + 104], % &f26;  &ldd [$FP + 112], % &f28;  &ldd [$FP + 120], % &f30;);
	}' unless defined(&LOAD_FPREGS);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
