require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_VALUES_H)) {
    eval 'sub _VALUES_H () {1;}' unless defined(&_VALUES_H);
    require 'sys/isa_defs.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub BITSPERBYTE () {8;}' unless defined(&BITSPERBYTE);
    eval 'sub BITS {
        my($type) = @_;
	    eval q(( &BITSPERBYTE * $sizeof{$type}));
    }' unless defined(&BITS);
    eval 'sub HIBITS () {((1<<  &BITS - 1));}' unless defined(&HIBITS);
    if(defined( &__STDC__)) {
	eval 'sub HIBITI () {(1 <<  &BITS - 1);}' unless defined(&HIBITI);
	eval 'sub HIBITL () {(1 <<  &BITS - 1);}' unless defined(&HIBITL);
    } else {
	eval 'sub HIBITI () {(1<<  &BITS - 1);}' unless defined(&HIBITI);
	eval 'sub HIBITL () {(1 <<  &BITS - 1);}' unless defined(&HIBITL);
    }
    eval 'sub MAXSHORT () {(~ &HIBITS);}' unless defined(&MAXSHORT);
    eval 'sub MAXINT () {((~ &HIBITI));}' unless defined(&MAXINT);
    eval 'sub MAXLONG () {((~ &HIBITL));}' unless defined(&MAXLONG);
    if(defined( &_IEEE_754)) {
	eval 'sub MAXDOUBLE () {1.79769313486231570e+308;}' unless defined(&MAXDOUBLE);
	eval 'sub MAXFLOAT () {(3.40282346638528860e+38);}' unless defined(&MAXFLOAT);
	eval 'sub MINDOUBLE () {4.94065645841246544e-324;}' unless defined(&MINDOUBLE);
	eval 'sub MINFLOAT () {(1.40129846432481707e-45);}' unless defined(&MINFLOAT);
	eval 'sub _IEEE () {1;}' unless defined(&_IEEE);
	eval 'sub _DEXPLEN () {11;}' unless defined(&_DEXPLEN);
	eval 'sub _HIDDENBIT () {1;}' unless defined(&_HIDDENBIT);
	eval 'sub _LENBASE () {1;}' unless defined(&_LENBASE);
	eval 'sub DMINEXP () {(-( &DMAXEXP +  &DSIGNIF -  &_HIDDENBIT - 3));}' unless defined(&DMINEXP);
	eval 'sub FMINEXP () {(-( &FMAXEXP +  &FSIGNIF -  &_HIDDENBIT - 3));}' unless defined(&FMINEXP);
    } else {
	die("ISA not supported");
    }
    eval 'sub _EXPBASE () {(1<<  &_LENBASE);}' unless defined(&_EXPBASE);
    eval 'sub _FEXPLEN () {8;}' unless defined(&_FEXPLEN);
    eval 'sub DSIGNIF () {( &BITS -  &_DEXPLEN +  &_HIDDENBIT - 1);}' unless defined(&DSIGNIF);
    eval 'sub FSIGNIF () {( &BITS -  &_FEXPLEN +  &_HIDDENBIT - 1);}' unless defined(&FSIGNIF);
    eval 'sub DMAXPOWTWO () {((1<<  &BITS - 2) * (1<<  &DSIGNIF -  &BITS + 1));}' unless defined(&DMAXPOWTWO);
    eval 'sub FMAXPOWTWO () {((1<<  &FSIGNIF - 1));}' unless defined(&FMAXPOWTWO);
    eval 'sub DMAXEXP () {((1<<  &_DEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&DMAXEXP);
    eval 'sub FMAXEXP () {((1<<  &_FEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&FMAXEXP);
    eval 'sub LN_MAXDOUBLE () {( &M_LN2 *  &DMAXEXP);}' unless defined(&LN_MAXDOUBLE);
    eval 'sub LN_MAXFLOAT () {( &M_LN2 *  &FMAXEXP);}' unless defined(&LN_MAXFLOAT);
    eval 'sub LN_MINDOUBLE () {( &M_LN2 * ( &DMINEXP - 1));}' unless defined(&LN_MINDOUBLE);
    eval 'sub LN_MINFLOAT () {( &M_LN2 * ( &FMINEXP - 1));}' unless defined(&LN_MINFLOAT);
    eval 'sub H_PREC () {( &DSIGNIF % 2? (1<<  &DSIGNIF/2) *  &M_SQRT2 : 1<<  &DSIGNIF/2);}' unless defined(&H_PREC);
    eval 'sub FH_PREC () {( &FSIGNIF % 2? (1<<  &FSIGNIF/2) *  &M_SQRT2 : 1<<  &FSIGNIF/2);}' unless defined(&FH_PREC);
    eval 'sub X_EPS () {(1.0/ &H_PREC);}' unless defined(&X_EPS);
    eval 'sub FX_EPS () {(1.0/ &FH_PREC);}' unless defined(&FX_EPS);
    eval 'sub X_PLOSS () {(( &M_PI *  &H_PREC));}' unless defined(&X_PLOSS);
    eval 'sub FX_PLOSS () {(( &M_PI *  &FH_PREC));}' unless defined(&FX_PLOSS);
    eval 'sub X_TLOSS () {( &M_PI *  &DMAXPOWTWO);}' unless defined(&X_TLOSS);
    eval 'sub FX_TLOSS () {( &M_PI *  &FMAXPOWTWO);}' unless defined(&FX_TLOSS);
    eval 'sub M_LN2 () {0.69314718055994530942;}' unless defined(&M_LN2);
    eval 'sub M_PI () {3.14159265358979323846;}' unless defined(&M_PI);
    eval 'sub M_SQRT2 () {1.41421356237309504880;}' unless defined(&M_SQRT2);
    eval 'sub MAXBEXP () { &DMAXEXP;}' unless defined(&MAXBEXP);
    eval 'sub MINBEXP () { &DMINEXP;}' unless defined(&MINBEXP);
    eval 'sub MAXPOWTWO () { &DMAXPOWTWO;}' unless defined(&MAXPOWTWO);
    if(defined(&__cplusplus)) {
    }
}
1;
