require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_VM_AS_H)) {
    eval 'sub _VM_AS_H () {1;}' unless defined(&_VM_AS_H);
    require 'sys/watchpoint.ph';
    require 'vm/seg.ph';
    require 'vm/faultcode.ph';
    require 'vm/hat.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub AS_PAGLCK () {0x80;}' unless defined(&AS_PAGLCK);
    eval 'sub AS_CLAIMGAP () {0x40;}' unless defined(&AS_CLAIMGAP);
    eval 'sub AS_UNMAPWAIT () {0x20;}' unless defined(&AS_UNMAPWAIT);
    eval 'sub AS_ISPGLCK {
        my($as) = @_;
	    eval q((($as)-> &a_flags &  &AS_PAGLCK));
    }' unless defined(&AS_ISPGLCK);
    eval 'sub AS_ISCLAIMGAP {
        my($as) = @_;
	    eval q((($as)-> &a_flags &  &AS_CLAIMGAP));
    }' unless defined(&AS_ISCLAIMGAP);
    eval 'sub AS_ISUNMAPWAIT {
        my($as) = @_;
	    eval q((($as)-> &a_flags &  &AS_UNMAPWAIT));
    }' unless defined(&AS_ISUNMAPWAIT);
    eval 'sub AS_SETPGLCK {
        my($as) = @_;
	    eval q((($as)-> &a_flags |=  &AS_PAGLCK));
    }' unless defined(&AS_SETPGLCK);
    eval 'sub AS_SETCLAIMGAP {
        my($as) = @_;
	    eval q((($as)-> &a_flags |=  &AS_CLAIMGAP));
    }' unless defined(&AS_SETCLAIMGAP);
    eval 'sub AS_SETUNMAPWAIT {
        my($as) = @_;
	    eval q((($as)-> &a_flags |=  &AS_UNMAPWAIT));
    }' unless defined(&AS_SETUNMAPWAIT);
    eval 'sub AS_CLRPGLCK {
        my($as) = @_;
	    eval q((($as)-> &a_flags &= ~ &AS_PAGLCK));
    }' unless defined(&AS_CLRPGLCK);
    eval 'sub AS_CLRCLAIMGAP {
        my($as) = @_;
	    eval q((($as)-> &a_flags &= ~ &AS_CLAIMGAP));
    }' unless defined(&AS_CLRCLAIMGAP);
    eval 'sub AS_CLRUNMAPWAIT {
        my($as) = @_;
	    eval q((($as)-> &a_flags &= ~ &AS_UNMAPWAIT));
    }' unless defined(&AS_CLRUNMAPWAIT);
    eval 'sub AS_TYPE_64BIT {
        my($as) = @_;
	    eval q(((-> &a_userlimit >  &UINT32_MAX) ? 1: 0));
    }' unless defined(&AS_TYPE_64BIT);
    eval 'sub AS_CAUSE_MEMUNLOCK {
        my($as) = @_;
	    eval q({  &if ( &AS_ISUNMAPWAIT($as) == 0)  &cv_broadcast( ($as->{a_cv}));  &AS_SETUNMAPWAIT($as);  &while ( &AS_ISUNMAPWAIT($as))  &cv_wait( ($as->{a_cv}),  ($as->{a_contents})); });
    }' unless defined(&AS_CAUSE_MEMUNLOCK);
    eval 'sub AS_LREP_LINKEDLIST () {0;}' unless defined(&AS_LREP_LINKEDLIST);
    eval 'sub AS_LREP_SKIPLIST () {1;}' unless defined(&AS_LREP_SKIPLIST);
    eval 'sub AS_FREE_EVENT () {0x1;}' unless defined(&AS_FREE_EVENT);
    eval 'sub AS_SETPROT_EVENT () {0x2;}' unless defined(&AS_SETPROT_EVENT);
    eval 'sub AS_UNMAP_EVENT () {0x4;}' unless defined(&AS_UNMAP_EVENT);
    eval 'sub AS_UNMAPWAIT_EVENT () { &AS_FREE_EVENT|  &AS_SETPROT_EVENT |  &AS_UNMAP_EVENT;}' unless defined(&AS_UNMAPWAIT_EVENT);
    eval 'sub AS_ALL_EVENT () { &AS_FREE_EVENT|  &AS_SETPROT_EVENT |  &AS_UNMAP_EVENT;}' unless defined(&AS_ALL_EVENT);
    eval("sub AS_CALLBACK_DELETED () { 0; }") unless defined(&AS_CALLBACK_DELETED);
    eval("sub AS_CALLBACK_NOTFOUND () { 1; }") unless defined(&AS_CALLBACK_NOTFOUND);
    eval("sub AS_CALLBACK_DELETE_DEFERRED () { 2; }") unless defined(&AS_CALLBACK_DELETE_DEFERRED);
    if(defined(&_KERNEL)) {
	eval 'sub AS_MUTATION_THRESH () {225;}' unless defined(&AS_MUTATION_THRESH);
	eval 'sub AS_SEGP {
	    my($as, $n) = @_;
    	    eval q((($as)-> &a_lrep ==  &AS_LREP_LINKEDLIST ? (($n). &list) : (($n). ($skiplist->{segs[0]}))));
	}' unless defined(&AS_SEGP);
	eval 'sub AH_DIR () {0x1;}' unless defined(&AH_DIR);
	eval 'sub AH_LO () {0x;}' unless defined(&AH_LO);
	eval 'sub AH_HI () {0x1;}' unless defined(&AH_HI);
	eval 'sub AH_CONTAIN () {0x2;}' unless defined(&AH_CONTAIN);
	eval 'sub AS_LOCK_ENTER {
	    my($as, $lock, $type) = @_;
    	    eval q( &rw_enter(($lock), ($type)));
	}' unless defined(&AS_LOCK_ENTER);
	eval 'sub AS_LOCK_EXIT {
	    my($as, $lock) = @_;
    	    eval q( &rw_exit(($lock)));
	}' unless defined(&AS_LOCK_EXIT);
	eval 'sub AS_LOCK_DESTROY {
	    my($as, $lock) = @_;
    	    eval q( &rw_destroy(($lock)));
	}' unless defined(&AS_LOCK_DESTROY);
	eval 'sub AS_LOCK_TRYENTER {
	    my($as, $lock, $type) = @_;
    	    eval q( &rw_tryenter(($lock), ($type)));
	}' unless defined(&AS_LOCK_TRYENTER);
	eval 'sub AS_LOCK_HELD {
	    my($as, $lock) = @_;
    	    eval q( &RW_LOCK_HELD(($lock)));
	}' unless defined(&AS_LOCK_HELD);
	eval 'sub AS_READ_HELD {
	    my($as, $lock) = @_;
    	    eval q( &RW_READ_HELD(($lock)));
	}' unless defined(&AS_READ_HELD);
	eval 'sub AS_WRITE_HELD {
	    my($as, $lock) = @_;
    	    eval q( &RW_WRITE_HELD(($lock)));
	}' unless defined(&AS_WRITE_HELD);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
