require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_VM_PAGE_H)) {
    eval 'sub _VM_PAGE_H () {1;}' unless defined(&_VM_PAGE_H);
    require 'vm/seg.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined( &_KERNEL) || defined( &_KMEMUSER)) {
	eval("sub SE_SHARED () { 0; }") unless defined(&SE_SHARED);
	eval("sub SE_EXCL () { 1; }") unless defined(&SE_EXCL);
	eval("sub P_RECLAIM () { 0; }") unless defined(&P_RECLAIM);
	eval("sub P_NO_RECLAIM () { 1; }") unless defined(&P_NO_RECLAIM);
    }
    if(defined(&DEBUG)) {
	eval 'sub VM_STATS () {1;}' unless defined(&VM_STATS);
    }
    if(defined(&VM_STATS)) {
	eval 'sub VM_STAT_ADD {
	    my($stat) = @_;
    	    eval q(($stat)++);
	}' unless defined(&VM_STAT_ADD);
    } else {
	eval 'sub VM_STAT_ADD {
	    my($stat) = @_;
    	    eval q();
	}' unless defined(&VM_STAT_ADD);
    }
    if(defined(&_KERNEL)) {
	eval 'sub page_struct_lock {
	    my($pp) = @_;
    	    eval q( &mutex_enter( &page_llock));
	}' unless defined(&page_struct_lock);
	eval 'sub page_struct_unlock {
	    my($pp) = @_;
    	    eval q( &mutex_exit( &page_llock));
	}' unless defined(&page_struct_unlock);
    }
    require 'sys/t_lock.ph';
    eval 'sub devpage () { &page;}' unless defined(&devpage);
    eval 'sub PAGE_HASHSZ () { &page_hashsz;}' unless defined(&PAGE_HASHSZ);
    eval 'sub PAGE_HASHAVELEN () {4;}' unless defined(&PAGE_HASHAVELEN);
    eval 'sub PAGE_HASHVPSHIFT () {6;}' unless defined(&PAGE_HASHVPSHIFT);
    eval 'sub PAGE_HASH_FUNC {
        my($vp, $off) = @_;
	    eval q((((( &uintptr_t)($off) >>  &PAGESHIFT) + (( &uintptr_t)($vp) >>  &PAGE_HASHVPSHIFT)) & ( &PAGE_HASHSZ - 1)));
    }' unless defined(&PAGE_HASH_FUNC);
    if(defined(&_KERNEL)) {
	eval 'sub PAGE_HASH_MUTEX {
	    my($index) = @_;
    	    eval q( $ph_mutex[($index) >>  &ph_mutex_shift]);
	}' unless defined(&PAGE_HASH_MUTEX);
	eval 'sub PG_EXCL () {0x1;}' unless defined(&PG_EXCL);
	eval 'sub PG_WAIT () {0x2;}' unless defined(&PG_WAIT);
	eval 'sub PG_PHYSCONTIG () {0x4;}' unless defined(&PG_PHYSCONTIG);
	eval 'sub PG_MATCH_COLOR () {0x8;}' unless defined(&PG_MATCH_COLOR);
	eval 'sub PG_NORELOC () {0x10;}' unless defined(&PG_NORELOC);
	eval 'sub PAGE_LOCKED {
	    my($pp) = @_;
    	    eval q((($pp)-> &p_selock != 0));
	}' unless defined(&PAGE_LOCKED);
	eval 'sub PAGE_SHARED {
	    my($pp) = @_;
    	    eval q((($pp)-> &p_selock > 0));
	}' unless defined(&PAGE_SHARED);
	eval 'sub PAGE_EXCL {
	    my($pp) = @_;
    	    eval q((($pp)-> &p_selock < 0));
	}' unless defined(&PAGE_EXCL);
	eval 'sub PAGE_LOCKED_SE {
	    my($pp, $se) = @_;
    	    eval q((($se) ==  &SE_EXCL ?  &PAGE_EXCL($pp) :  &PAGE_SHARED($pp)));
	}' unless defined(&PAGE_LOCKED_SE);
	eval 'sub PG_FREE_LIST () {1;}' unless defined(&PG_FREE_LIST);
	eval 'sub PG_CACHE_LIST () {2;}' unless defined(&PG_CACHE_LIST);
	eval 'sub PG_LIST_TAIL () {0;}' unless defined(&PG_LIST_TAIL);
	eval 'sub PG_LIST_HEAD () {1;}' unless defined(&PG_LIST_HEAD);
	eval 'sub page_next_raw {
	    my($PP) = @_;
    	    eval q( &page_nextn_raw(($PP), 1));
	}' unless defined(&page_next_raw);
    }
    eval 'sub PAGE_IO_INUSE () {0x1;}' unless defined(&PAGE_IO_INUSE);
    eval 'sub PAGE_IO_WANTED () {0x2;}' unless defined(&PAGE_IO_WANTED);
    eval 'sub PGREL_NOTREL () {0x1;}' unless defined(&PGREL_NOTREL);
    eval 'sub PGREL_CLEAN () {0x2;}' unless defined(&PGREL_CLEAN);
    eval 'sub PGREL_MOD () {0x3;}' unless defined(&PGREL_MOD);
    eval 'sub P_FREE () {0x80;}' unless defined(&P_FREE);
    eval 'sub P_NORELOC () {0x40;}' unless defined(&P_NORELOC);
    eval 'sub PP_ISFREE {
        my($pp) = @_;
	    eval q((($pp)-> &p_state &  &P_FREE));
    }' unless defined(&PP_ISFREE);
    eval 'sub PP_ISAGED {
        my($pp) = @_;
	    eval q(((($pp)-> &p_state &  &P_FREE)  && (($pp)-> &p_vnode ==  &NULL)));
    }' unless defined(&PP_ISAGED);
    eval 'sub PP_ISNORELOC {
        my($pp) = @_;
	    eval q((($pp)-> &p_state &  &P_NORELOC));
    }' unless defined(&PP_ISNORELOC);
    eval 'sub PP_SETFREE {
        my($pp) = @_;
	    eval q((($pp)-> &p_state |=  &P_FREE));
    }' unless defined(&PP_SETFREE);
    eval 'sub PP_SETAGED {
        my($pp) = @_;
	    eval q( &ASSERT( &PP_ISAGED($pp)));
    }' unless defined(&PP_SETAGED);
    eval 'sub PP_SETNORELOC {
        my($pp) = @_;
	    eval q((($pp)-> &p_state |=  &P_NORELOC));
    }' unless defined(&PP_SETNORELOC);
    eval 'sub PP_CLRFREE {
        my($pp) = @_;
	    eval q((($pp)-> &p_state &= ~ &P_FREE));
    }' unless defined(&PP_CLRFREE);
    eval 'sub PP_CLRAGED {
        my($pp) = @_;
	    eval q( &ASSERT(! &PP_ISAGED($pp)));
    }' unless defined(&PP_CLRAGED);
    eval 'sub PP_CLRNORELOC {
        my($pp) = @_;
	    eval q((($pp)-> &p_state &= ~ &P_NORELOC));
    }' unless defined(&PP_CLRNORELOC);
    if(defined(&__cplusplus)) {
    }
}
1;
